#include <iostream>
#include <array>
#include <vector>
#include <algorithm>

const int MAX_N = 20;

int n;
std::array<int, MAX_N> data;

void input_data() noexcept {
	std::cin >> n;
	for (int i = 0; i < n; ++i) {
		std::cin >> data[i];
	}
}

int solve() noexcept {
	int best_extremes = 0;
	for (int mask = 0; mask < (1 << n); ++mask) {
		int max = 0, min = n + 1;
		int extremes = 0;
		for (int i = 0; i < n; ++i)
			if (mask & (1 << i)) {
				if (data[i] > max) {
					max = data[i];
					++extremes;
				}
			} else
				if (data[i] < min) {
					min = data[i];
					++extremes;
				}

		best_extremes = std::max(extremes, best_extremes);
	}
	return best_extremes;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int t;
	std::cin >> t;
	for (int ti = 0; ti < t; ++ti) {
		input_data();
		std::cout << solve() << '\n';
	}
	return 0;
}
