#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>
#define int int64_t
#define double long double
#define MULTITASK
#define NO_INTERACTIVE
using namespace std;
using namespace __gnu_pbds;
void solve();
int32_t main() {
#ifdef NO_INTERACTIVE
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
#ifdef BIBIKOV
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
#endif
    int tt = 1;
#ifdef MULTITASK
    cin >> tt;
#endif
    while (tt--) {
        solve();
#ifdef MULTITASK
        cout << '\n';
#endif
    }
}






struct edge {
    int l, r, ind;
    bool operator<(const edge &e) const {
        if (r != e.r)
            return r < e.r;
        return false;
    }
};

#define SIZE (1 << 30)

class Tree {
public:
    struct node {
        int val, pr;
        node *l, *r;
        node() : val(0), pr(-1), l(nullptr), r(nullptr) {}
        void upd() {
            if (!l || !r)
                val = max(l ? l->val : 0, r ? r->val : 0), pr = max(l ? l->pr : -1, r ? r->pr : -1);
            else if (r->val < l->val)
                val = l->val, pr = l->pr;
            else
                val = r->val, pr = r->pr;
        }
    };

    void set(int h, int s, int pr) {
        set(root, -SIZE, SIZE, h, s, pr);
    }

    int mx(int hl, int hr) {
        return (root ? mx(root, -SIZE, SIZE, min(hl, hr), max(hl, hr)).first : 0);
    }

    int pr(int hl, int hr) {
        return (root ? mx(root, -SIZE, SIZE, min(hl, hr), max(hl, hr)).second : -1);
    }

private:
    node *root = nullptr;

    void set(node *&t, int l, int r, int h, int s, int pr) {
        if (!t)
            t = new node();
        if (l + 1 == r) {
            if (t->val < s)
                t->pr = pr, t->val = s;
        } else {
            int u = (l + r) >> 1;
            if (h < u)
                set(t->l, l, u, h, s, pr);
            else
                set(t->r, u, r, h, s, pr);
            t->upd();
        }
    }

    pair<int, int> mx(node *t, int l, int r, int hl, int hr) {
        if (hl <= l && r <= hr)
            return {t->val, t->pr};
        int u = (l + r) >> 1;
        pair<int, int> ans = {0, -1};
        if (hl < u && t->l)
            ans = max(ans, mx(t->l, l, u, hl, hr));
        if (u < hr && t->r)
            ans = max(ans, mx(t->r, u, r, hl, hr));
        return ans;
    }
};

set<int> init(int n, vector<edge> e, int m) {
    sort(e.begin(), e.end());
    Tree t;
    int rr = 0;
    for (int i = 0; i < n; i++) {
        int v = t.mx(0, e[i].l) + 1;
        t.set(e[i].r, v, i);
        if (m == v) {
            rr = i;
            break;
        }
    }
    set<int> ans;
    int pp = rr;
    rr = e[rr].r;
    while (pp != -1) {
        ans.insert(e[pp].ind);
        pp = t.pr(0, e[pp].l);
    }
    for (int j = 0; ans.size() < n / 2 && j < n; j++) {
        if (e[j].l <= rr)
            ans.insert(e[j].ind);
    }
    return ans;
}

int M(int n, vector<edge> e) {
    sort(e.begin(), e.end());
    Tree t;
    for (int i = 0; i < n; i++) {
        int v = t.mx(0, e[i].l) + 1;
        t.set(e[i].r, v, i);
    }
    return t.mx(-SIZE, SIZE);
}

void solve() {
    int n;
    cin >> n;
    vector<edge> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].l >> p[i].r;
        p[i].ind = i + 1;
    }
    int m = M(n, p);
    set<int> left = init(n, p, m / 2);
//    cout << m << '\n';
    for (int i : left)
        cout << i << ' ';
}
