#include <bits/stdc++.h>
using namespace std;

template<typename T> vector<T> permute(vector<T> a, vector<int> p) {
    int n = (int)a.size();
    vector<T> b(n);
    for (int i = 0; i < n; ++i) {
        b[p[i]] = a[i];
    }
    return b;
}

vector<int> invperm(vector<int> p) {
    int n = (int)p.size();
    vector<int> q(n);
    for (int i = 0; i < n; ++i) q[p[i]] = i;
    return q;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int,int>> a(n);
    for (auto &x : a) {
        cin >> x.first >> x.second;
        --x.first;
    }
    vector<int> mrlb;
    int m = 0;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) p[i] = i;
    sort(p.begin(), p.end(), [&](const int &x, const int &y) {
        return a[x].second < a[y].second;
    });
    vector<int> q = invperm(p);
    {
        a = permute(a, p);
        for (auto &x : a) {
            x.first = 1000000000 - x.first;
            x.second = 1000000000 - x.second;
            swap(x.first, x.second);
        }
        reverse(a.begin(), a.end());
        int crv = 0;
        for (auto &x : a) {
            if (x.first >= crv) {
                crv = x.second;
                mrlb.push_back(x.second);
                ++m;
            }
        }
        for (auto &x : a) {
            x.first = 1000000000 - x.first;
            x.second = 1000000000 - x.second;
            swap(x.first, x.second);
        }
        reverse(a.begin(), a.end());
    }
    for (auto &x : mrlb) x = 1000000000 - x;
    reverse(mrlb.begin(), mrlb.end());
    mrlb.push_back(1000000000);
    mrlb.push_back(1000000000);

    cout << endl;
    int crv = 0;
    int cc = 0;
    vector<vector<int>> quals(m);
    vector<int> lllb;
    vector<int> origs;
    for (int i = 0; i < n; ++i) {
        auto &x = a[i];
        if (x.first >= crv) {
            crv = x.second;
            lllb.push_back(x.second);
            origs.push_back(i);
        }
    }
    set<int> orset;
    for (auto &x : origs) orset.insert(x);
    lllb.push_back(1000000000);
    lllb.push_back(1000000000);

    for (int i = 0; i < n; ++i) {
        auto &x = a[i];
        int prllnum, nxrrnum;
        {
            int l = -1, r = m;
            while (r - l > 1) {
                int md = (l + r) >> 1;
                if (lllb[md] <= x.first) l = md;
                else r = md;
            }
            prllnum = r; //what number i can have counting from left; e.g. i can stand after l and be l+1=r
        }
        {
            int l = -1, r = m;
            while (r - l > 1) {
                int md = (l + r) >> 1;
                if (mrlb[md] >= x.second) r = md;
                else l = md;
            }
            nxrrnum = l; //i can stand before the beginning of what fills r->m, e.g. fill r-1 = l -> m
        }
        if (prllnum == nxrrnum) {
            quals[prllnum].push_back(i);
        }
    }
    int es = 0;
    for (int i = 0; i < m; i += 2) {
        es += (int)quals[i].size();
    }
    vector<int> ans;
    ans.reserve(n / 2);
    int bg = (es > n / 2);
    int rm = n / 2;
    for (int i = bg; i < m; i += 2) {
        for (auto &x : quals[i]) {
            ans.push_back(p[x]);
            --rm;
        }
    }
    for (int i = 1 - bg; i < m; i += 2) {
        for (auto &x : quals[i]) {
            if (rm > 0 && !orset.count(x)) {
                ans.push_back(p[x]);
                --rm;
            }
        }
    }
    for (auto &x : ans) cout << q[x] + 1 << ' ';
    cout << endl;
    return;
}

int main() {
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}
