#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

void solve() {
    int n, q;
    cin >> n >> q;
    ll X, Y, M;
    cin >> X >> Y >> M;
    vector<vector<int>> a(n);
    for (int i = 0; i < n - 1; ++i) {
        int s, t;
        cin >> s >> t;
        --s, --t;
        a[s].push_back(t);
        a[t].push_back(s);
    }
    vector<ll> lb(n);
    vector<ll> rb(n);
    for (int i = 0; i < n; ++i) {
        ll l, r;
        cin >> l >> r;
        lb[i] = l;
        rb[i] = r;
    }
    vector<ll> qs(q);
    for (auto &x: qs) cin >> x;
    vector<int> p(n);
    {
        vector<vector<int>> g(n);
        vector<bool> used(n);
        auto dfs = [&](int v, auto dfs) -> void {
            used[v] = true;
            for (int u: a[v]) {
                if (!used[u]) {
                    g[v].push_back(u);
                    p[u] = v;
                    dfs(u, dfs);
                }
            }
        };
        dfs(0, dfs);
        a = g;

    }

    vector<ll> s(n);
    ll minv, maxv;
    vector<bool> ts(n);
    {
        vector<ll> dpt(n);
        vector<ll> dpo(n); //dptake, dpoff

        for (int i = 0; i < n; ++i) s[i] = rb[i];
        auto dfs = [&](int v, auto dfs) -> void {
            ll gmax = 0;
            ll omax = 0;
            for (int u: a[v]) {
                dfs(u, dfs);
                gmax += max(dpt[u], dpo[u]);
                omax += dpo[u];
            }
            dpt[v] = omax + s[v];
            dpo[v] = gmax;
        };
        dfs(0, dfs);
        maxv = max(dpt[0], dpo[0]);
        auto tsp = [&](int v, bool at, auto tsp) -> void {
            if (at && dpt[v] > dpo[v]) {
                ts[v] = true;
                for (int u: a[v]) {
                    tsp(u, false, tsp);
                }
            } else {
                ts[v] = false;
                for (int u: a[v]) {
                    tsp(u, true, tsp);
                }
            }
        };
        tsp(0, true, tsp);
    }
    auto cert = [&]() -> ll {
        ll k = 0;
        for (ll i = 0; i < (ll) n; ++i) {
            k = k ^ ((X * (i + 1) + Y * s[i] % M * s[i] % M) % M);
        }
        return k;
    };
    vector<ll> kekcert(n + 1, -1);
    for (auto &x: s) x = 0;
    kekcert[0] = cert();
    {
        int pt = 0;
        for (int i = 1; i <= n; ++i) {
            while (pt < n && !ts[pt]) ++pt;
            if (pt >= n) break;
            ll k = kekcert[i - 1];
            {
                ll j = pt;
                k = k ^ (X * (j + 1) % M) ^ ((X * (j + 1) + Y % M) % M);
                kekcert[i] = k;
            }
            ++pt;
        }
    }
    for (int i = 0; i < q; ++i) {
        if (qs[i] <= n) {
            cout << kekcert[qs[i]] << ' ';
        }
        else cout << -1 << ' ';
    }
    cout << endl;
    while (true) {
        int ind;
        cin >> ind;
        if (ind == 0) break;
        --ind;
        if (qs[ind] <= n) {
            if (kekcert[qs[ind]] == -1) {
                cout << -1 << endl;
                continue;
            }
            vector<int> ans(n);
            int pt = 0;
            for (int i = 0; i < qs[ind]; ++i) {
                while (!ts[pt]) ++pt;
                ans[pt] = 1;
                ++pt;
            }
            for (auto &x : ans) cout << x << ' ';
            cout << endl;
        } else {
            cout << -1 << endl;
        }
    }
    return;
}

int main() {
    int t;
    cin >> t;
    while (t--) solve();
}