#include <bits/stdc++.h>

using namespace std;

struct node {
    node* l = nullptr;
    node* r = nullptr;
    int sum = 0;
};

inline int sum(node* a) {
    if (a == nullptr) return 0;
    return a->sum;
}

node* update(node* a, int l, int r, int i) {
    if (l > i || i > r) return a;
    if (a == nullptr) a = new node();
    if (l == r) {
        a->sum++;
        return a;
    }
    int m = (l + r) / 2;
    a->l = update(a->l, l, m, i);
    a->r = update(a->r, m + 1, r, i);
    a->sum = sum(a->l) + sum(a->r);
    return a;
}

inline node* left_son(node* a) {
    if (a == nullptr) return nullptr;
    return a->l;
}

inline node* right_son(node* a) {
    if (a == nullptr) return nullptr;
    return a->r;
}

int first0(node* a, int l, int r, int i) {
    if (sum(a) == r - l + 1 || r < i) return -1;
    if (l == r) return l;
    int m = (l + r) / 2;
    int lft = first0(left_son(a), l, m, i);
    if (lft != -1) return lft;
    return first0(right_son(a), m + 1, r, i);
}

inline void solve1() {
    int n, k;
    cin >> n >> k;
    vector <int> a(k);
    for (int i = 0; i < k; ++i) cin >> a[i];
    node* root = nullptr;
    reverse(a.begin(), a.end());
    vector <int> ans;
    for (int i : a) {
        root = update(root, 0, n, i);
        int ps = first0(root, 0, n, i);
        if (ps == -1) ps = first0(root, 0, n, 1);
        root = update(root, 0, n, ps);
        ans.push_back(ps);
    }
    sort(ans.begin(), ans.end());
    for (int i : ans) cout << i << " ";
    cout << endl;
}

inline void solve2() {
    int n, k;
    cin >> n >> k;
    vector <int> a(n);
    for (int i = 0; i < k; ++i) {
        int x;
        cin >> x;
        a[x - 1] = 1;
    }
    int cur = 0;
    vector <int> ans;
    for (int i = n - 1; i >= 0; --i) {
        if (a[i] == 1) cur++;
        else if (cur) {
            ans.push_back(i + 1);
            cur--;
            a[i] = 1;
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        if (a[i] == 0 && ans.size() < k) ans.push_back(i + 1);
    }
    sort(ans.begin(), ans.end());
    for (int i : ans) cout << i << " ";
    cout << endl;
}


signed main() {
    if (0) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    if (1) {
        int type;
        cin >> type;
        int t = 1;
        cin >> t;
        while (t--) {
            if (type == 1) solve1();
            else solve2();
        }
    }
    return 0;
}

/*
 2
 2
 2 1
 2
 5 2
 2 5

 */