#include <bits/stdc++.h>

using namespace std;

const int maxn = 2057;

int dp[2][257][257];

const int inf = 1e9 + 1329;

vector<pair<int, int>> tree(4 * maxn);

void upd(int qi, int newval, int i = 0, int l = 0, int r = maxn) {
    if (qi < l || r <= qi) return;
    if (r - l == 1) {
        tree[i] = {newval, l * (newval > 0)};
        return;
    }
    int m = (l + r) / 2;
    upd(qi, newval, 2 * i + 1, l, m);
    upd(qi, newval, 2 * i + 2, m, r);
    tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
}

pair<int, int> getmax(int ql, int qr, int i = 0, int l = 0, int r = maxn) {
    if (qr <= l || r <= ql) return {0, 0};
    if (ql <= l && r <= qr) {
        return tree[i];
    }
    int m = (l + r) / 2;
    return max(getmax(ql, qr, 2 * i + 1, l, m), getmax(ql, qr, 2 * i + 2, m, r));
}

void solve() {
    int n; cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    if (n > 1) {
        vector<int> where (n + 1, -1);
        for (int i = 0; i < n; ++i) {
            where[a[i]] = i;
        }
        vector<int> dp(n), pred(n, 0);
        int maxdp = 0;
        for (int i = 0; i < n; ++i) {
            pair<int, int> resp = getmax(0, a[i]);
            dp[i] = resp.first + 1;
            pred[i] = where[resp.second];
            upd(a[i], dp[i]);
            if (dp[i] > dp[maxdp]) maxdp = i;
        }
        for (int i = 0; i < n; ++i) {
            upd(a[i], 0);
        }
        vector<int> p, q;
        set<int> pset;
        while (maxdp != -1) {
            p.push_back(maxdp);
            pset.insert(maxdp);
            maxdp = pred[maxdp];
        }
        for (int i = 0; i < n; ++i) {
            if (!pset.count(i)) q.push_back(i);
        }
        sort(p.begin(), p.end());
        sort(q.begin(), q.end());
        int ans = 0;
        int pmax = 0;
        for (int i : p) {
            if (a[i] > pmax) {
                ans += 1;
                pmax = a[i];
            }
        }
        int qmin = n + 1;
        for (int i : q) {
            if (a[i] < qmin) {
                ans += 1;
                qmin = a[i];
            }
        }
        cout << ans << '\n';
        return;
    }
    for (int maxp = 0; maxp <= n + 1; ++maxp) {
        for (int minq = 0; minq <= n + 1; ++minq) {
            dp[0][maxp][minq] = 0;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int maxp = 0; maxp <= n + 1; ++maxp) { // max(p) >= maxp
            for (int minq = 0; minq <= n + 1; ++minq) { // min(q) <= minq
                dp[1][maxp][minq] = -inf;
                if (a[i] <= maxp) {
                    dp[1][maxp][minq] = max(dp[1][maxp][minq], max(dp[0][maxp][minq], 1 + dp[0][a[i] - 1][minq]));
                }
                if (a[i] >= minq) {
                    dp[1][maxp][minq] = max(dp[1][maxp][minq], max(dp[0][maxp][minq], 1 + dp[0][maxp][a[i] + 1]));
                }
                ans = max(ans, dp[1][maxp][minq]);
            }
        }
        for (int maxp = 1; maxp <= n + 1; ++maxp) {
            for (int minq = 0; minq <= n + 1; ++minq) {
                dp[1][maxp][minq] = max(dp[1][maxp][minq], dp[1][maxp - 1][minq]);
            }
        }
//        for (int maxp = n; maxp >= 0; --maxp) {
//            for (int minq = 0; minq <= n + 1; ++minq) {
//                dp[1][maxp][minq] = max(dp[1][maxp][minq], dp[1][maxp + 1][minq]);
//            }
//        }
//        for (int maxp = 0; maxp <= n + 1; ++maxp) {
//            for (int minq = 1; minq <= n + 1; ++minq) {
//                dp[1][maxp][minq] = max(dp[1][maxp][minq], dp[1][maxp][minq - 1]);
//            }
//        }
        for (int maxp = 0; maxp <= n + 1; ++maxp) {
            for (int minq = n; minq >= 0; --minq) {
                dp[1][maxp][minq] = max(dp[1][maxp][minq], dp[1][maxp][minq + 1]);
            }
        }
        swap(dp[0], dp[1]);
    }
    cout << ans << '\n';
}

signed main() {
    fill(tree.begin(), tree.end(), make_pair(0, 0));
    int t; cin >> t;
    while (t--) {
        solve();
    }
}