#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 2e5 + 1329;
int x, y, m;

int sum(int a, int b) {
    int c = a + b;
    if (c >= m) c -= m;
    return c;
}
int mul(int a, int b) {
    ll c = 1ll * a * b;
    if (c >= m) c %= m;
    return (int) c;
}
int sqr(int a) {
    return mul(a, a);
}
int certificate(int j, int aj) {
    return sum(mul(x, j), mul(y, sqr(aj)));
}

vector<int> g[maxn];
int c[maxn];
int l[maxn], r[maxn];

ll dp[maxn][2];
void dfs(int u, int p = -1) {
    dp[u][0] = 0;
    dp[u][1] = c[u];
    for (int v : g[u]) {
        if (v == p) continue;
        dfs(v, u);
        dp[u][0] += dp[v][1];
        dp[u][1] += dp[v][0];
    }
    if (dp[u][0] > dp[u][1]) {
        dp[u][1] = dp[u][0];
    }
} // answer lies in dp[root][1], cert[root][1]

void solve() {
    int n, q; cin >> n >> q;
    cin >> x >> y >> m;
    fill(g, g + n + 1, vector<int>());
    for (int i = 0; i < n - 1; ++i) {
        int s, f; cin >> s >> f;
        g[s].push_back(f);
        g[f].push_back(s);
    }
    ll sumd = 0;
    for (int u = 1; u <= n; ++u) {
        cin >> l[u] >> r[u];
        sumd += r[u] - l[u];
    }
    int Lv, Rv;
    {
        for (int u = 1; u <= n; ++u) c[u] = l[u];
        dfs(1);
        Lv = dp[1][1];
    }
    {
        for (int u = 1; u <= n; ++u) c[u] = r[u];
        dfs(1);
        Rv = dp[1][1];
    }
    vector<int> v(q);
    vector<int> ansd(q, -1);
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
        if (v[i] < Lv || Rv < v[i]) {
            cout << -1 << ' ';
            continue;
        }
        int Ld = -1, Rd = sumd;
        while (Ld + 1 < Rd) {
            int d = (Ld + Rd) / 2;

            for (int u = 1; u <= n; ++u) c[u] = l[u];
            for (int u = 1; u <= n; ++u) {
                if (d >= r[u] - l[u]) {
                    d -= (r[u] - l[u]);
                    c[u] = r[u];
                } else {
                    c[u] += d;
                    d = 0;
                    break;
                }
            }
            dfs(1);
            if (dp[1][1] >= v[i]) {
                Rd = d;
            } else {
                Ld = d;
            }
        }
        ansd[i] = Rd;
        {
            int d = Rd;
            for (int u = 1; u <= n; ++u) c[u] = l[u];
            for (int u = 1; u <= n; ++u) {
                if (d >= r[u] - l[u]) {
                    d -= (r[u] - l[u]);
                    c[u] = r[u];
                } else {
                    c[u] += d;
                    d = 0;
                    break;
                }
            }
            dfs(1);
            assert(dp[1][1] == v[i]);
            int ansc = 0;
            for (int u = 1; u <= n; ++u) {
                ansc ^= certificate(u, c[u]);
            }
            cout << ansc << ' ';
        }
    } cout << endl;
    while (true) {
        int i; cin >> i;
        if (i == 0) break;
        i -= 1;
        if (ansd[i] == -1) {
            cout << -1 << endl;
            continue;
        }
        int d = ansd[i];
        for (int u = 1; u <= n; ++u) c[u] = l[u];
        for (int u = 1; u <= n; ++u) {
            if (d >= r[u] - l[u]) {
                d -= (r[u] - l[u]);
                c[u] = r[u];
            } else {
                c[u] += d;
                d = 0;
                break;
            }
        }
        for (int u = 1; u <= n; ++u) {
            cout << c[u] << ' ';
        } cout << endl;
    }
}

signed main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}