#include <bits/stdc++.h>
#define pb(a) push_back(a)
#define all(a) begin(a), end(a)
typedef long long ll;
using namespace std;

class segtree{
    vector<ll> t;
    ll size;

    static constexpr ll ZERO=0;

    void set(ll i, ll v, ll x, ll lx, ll rx){
        if(rx-lx==1){
            t[x]=max(t[x], v);
            return;
        }
        ll m=(lx+rx)/2;
        if(i<m) set(i, v, 2*x+1, lx, m);
        else set(i, v, 2*x+2, m, rx);
        t[x]=max(t[2*x+1], t[2*x+2]);
    }

    ll func(ll l, ll r, ll x, ll lx, ll rx){
        if(rx<=l||r<=lx) return ZERO;
        if(l<=lx&&rx<=r) return t[x];
        ll m=(rx+lx)/2;
        return max(func(l, r, 2*x+1, lx, m), func(l, r, 2*x+2, m, rx));
    }
public:
    segtree(ll n){
        size=1;
        while(size<n) size*=2;
        t.assign(2*size-1, ZERO);
    }

    void set(ll i, ll v){
        set(i, v, 0, 0, size);
    }

    ll func(ll l, ll r){
        return func(l, r, 0, 0, size);
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t;
    cin>>t;
    while(t--){
        ll n;
        cin>>n;
        vector<pair<pair<ll, ll>, ll>> p(n);
        for(ll i=0;i<n;++i){
            cin>>p[i].first.first>>p[i].first.second;
            p[i].second=i;
        }
        sort(all(p), [](pair<pair<ll, ll>, ll> a, pair<pair<ll, ll>, ll> b){return a.first.second<b.first.second;});
        map<ll, ll> mp;
        ll j=0;
        for(ll i=0;i<n;++i) if(i==0||p[i].first.second!=p[i-1].first.second) mp[p[i].first.second]=j++;
        segtree tr(mp.size());
        for(auto &i:p){
            auto it=mp.lower_bound(i.first.first);
            ll x=tr.func(0, it->second);
            tr.set(mp[i.first.second], x+1);
        }
        ll m=tr.func(0, mp.size())/2;
        for(ll i=0;i<(1<<n);++i){
            if(__builtin_popcountll(i)!=n/2) continue;
            segtree tr1=mp.size();
            for(ll gg=0; gg < n; ++gg) if(((1 << gg) & i) != 0){
                auto it=mp.lower_bound(p[gg].first.first);
                ll x=tr1.func(0, it->second);
                tr1.set(mp[p[gg].first.second], x + 1);
            }
            ll k=tr1.func(0, mp.size());
            if(k==m){
                for(ll j=0;j<n;++j) if(((1<<j)&i)!=0) cout<<p[j].second+1<<' ';
                cout<<'\n';
                break;
            }
        }
    }
    return 0;
}
