#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

struct event {
	int l, r, i;
};
bool comp(event a, event b) {
	if (a.r == b.r && a.l == b.l) return a.i < b.i;
	else if (a.r == b.r) return a.l > b.r;
	return (a.r < b.r);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n;
		cin >> n;
		vector<event> mas(n);
		for (int i = 0; i < n; ++i) {
			cin >> mas[i].l >> mas[i].r;
			mas[i].i = i;
		}
		sort(mas.begin(), mas.end(), comp);
		int m = 0;
		int prevt = 0;
		for (int i = 0; i < n; ++i) {
			if (prevt < mas[i].l) {
				m++;
				prevt = mas[i].r;
			}
		}
		vector<int> last(n, 0);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				if (mas[i].l > mas[j].r && (last[i] == -1 || mas[j].r >= mas[last[i]].r))
					last[i] = j + 1;
			}
		}
		vector<vector<vector<bool>>> dp(n / 2 + 1, vector<vector<bool>>(m / 2 + 1, vector<bool>(n + 1, false)));
		vector<vector<vector<int>>> pref(n / 2 + 1, vector<vector<int>>(m / 2 + 1, vector<int>(n + 1, 0)));
		dp[0][0][0] = true;
		for (int i = 0; i <= n; ++i) {
			pref[0][0][i] = 1;
		}
		for (int k = 1; k <= n; ++k) {
		for (int i = 1; i <= n / 2; ++i) {
			for (int j = 1; j <= m / 2; ++j) {
				
					int z = last[k - 1];
					if (pref[i - 1][j - 1][z] > 0)
						dp[i][j][k] = true;
					if (pref[i - 1][j][k - 1] - pref[i - 1][j][z] > 0)
						dp[i][j][k] = true;
					pref[i][j][k] = pref[i][j][k - 1] + int(dp[i][j][k]);
				}
			}
		}
		int curi = n / 2, curj = m / 2, curk = -1;
		for (int k = 1; k <= n; ++k) {
			if (dp[curi][curj][k]) {
				curk = k;
				break;
			}
		}
		vector<int> ans;
		while (curi != 0 && curk != 0) {
			ans.push_back(mas[curk - 1].i + 1);
			int z = last[curk - 1];
			bool flag = false;
			for (int k = 0; k <= z; ++k) {
				if (dp[curi - 1][curj - 1][k]) {
					curi--;
					curj--;
					curk = k;
					flag = true;
					break;
				}
			}
			if (flag) continue;
			for (int k = z + 1; k < curk; ++k) {
				if (dp[curi - 1][curj][k]) {
					curi--;
					curk = k;
					break;
				}
			}
		}
		sort(ans.begin(), ans.end());
		for (int el : ans)
			cout << el << " ";
		if (curi != 0 || curj != 0 || curk != 0) {
			int x = 0;
			cout << 5 / x;
		}
		cout << "\n";
	}

	return 0;
}