#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

using ll = long long;

const ll INF = 1e9;

ll n;
vector<ll> a;

ll solve1() {
	ll result = 0;
	for (int mask = 1; mask < (1ll << n) - 1; ++mask) {
		ll ans = 0;
		ll q = 0, r = n + 1;
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				if (a[i] > q) {
					ans++;
					q = a[i];
				}
			}
			else {
				if (a[i] < r) {
					ans++;
					r = a[i];
				}
			}
		}
		result = max(result, ans);
	}
	return result;
}

ll solve2() {
	vector<ll> t = { 0, n + 1 };
	for (auto el : a)
		t.push_back(el);
	vector<vector<ll>> dp(n + 2, vector<ll>(n + 2, -INF));
	dp[0][1] = 0;
	for (int mx = 1; mx < n + 1; ++mx) {
		for (int d = 0; d <= mx * 2; ++d) {
			int i = d, j = mx;
			if (d >= mx) {
				i = mx, j = d - mx;
			}
			for (int x = max(i, j) + 1; x < t.size(); ++x) {
				if (t[i] < t[x])
					dp[x][j] = max(dp[x][j], dp[i][j] + 1);
			}
			for (int y = max(i, j) + 1; y < t.size(); ++y) {
				if (t[j] > t[y])
					dp[i][y] = max(dp[i][y], dp[i][j] + 1);
				else
					break;
			}
		}
	}
	ll answer = 0;
	for (int i = 2; i < dp.size(); ++i) {
		for (int j = 2; j < dp.size(); ++j) {
			answer = max(answer, dp[i][j]);
		}
	}
	return answer;
}

ll solve5() {
	ll cnt = 0;
	ll record = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i] > record) {
			record = a[i];
			cnt++;
		}
	}
	return min(n, cnt + 1);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t;
	cin >> t;
	while (t--) {
		cin >> n;
		a.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
		}
		cout << solve5() << "\n";
	}
}
