#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
using namespace std;

using ll = long long;

const ll INF = 1e9;

struct Segment {
	int l, r, ind;
};

int n;
vector<Segment> a;

int get_m(const vector<Segment>& t) {
	vector<ll> dp(t.size(), 0);
	dp[0] = 1;
	for (int i = 1; i < t.size(); ++i) {
		dp[i] = 1;
		for (int j = 0; j < i; ++j) {
			if (t[j].r < t[i].l) {
				dp[i] = max(dp[i], dp[j] + 1);
			}
		}
	}
	return *max_element(dp.begin(), dp.end());
}

void solve2() {
	sort(a.begin(), a.end(), [](const Segment& a, const Segment& b) {if (a.l != b.l) return a.l < b.l; if (a.r != b.r) return a.r < b.r; return a.ind < b.ind; });
	int m = get_m(a);
	for (int mask = 1; mask < (1 << n); ++mask) {
		vector<Segment> t;
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				t.push_back(a[i]);
			}
		}
		if (t.size() != n / 2)
			continue;
		int cm = get_m(t);
		if (cm == m / 2) {
			for (auto el : t) {
				cout << el.ind + 1 << " ";
			}
			cout << "\n";
			return;
		}
	}
}

void solve1() {
	for (int i = 0; i < n / 2; ++i) {
		cout << i + 1 << " ";
	}
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	cin >> t;
	while (t--) {
		cin >> n;
		a.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i].l >> a[i].r;
			a[i].ind = i;
		}
		solve1();
	}
}
