#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
using namespace std;

using ll = long long;

const ll INF = 1e9;

struct Query {
	ll k, a, b;
};

int n, q;
vector<ll> w;
int z;
vector<Query> queries;

void solve4() {
	ll amax = 0, bmax = 0;
	for (auto [k, a, b] : queries) {
		amax = max(a, amax);
		bmax = max(b, bmax);
	}
	set<pair<ll, ll >> dp;
	dp.insert({ 0, 0 });
	dp.insert({ w[0], 0 });
	dp.insert({ 0, w[0] });
	for (int i = 1; i < n; ++i) {
		set<pair<ll, ll>> pdp = dp;
		for (auto [a, b] : pdp) {
			if (a + w[i] <= amax)
				dp.insert({ a + w[i], b });
			if (b + w[i] <= bmax)
				dp.insert({ a, b + w[i] });
		}
	}
	vector<ll> ansdp(amax + 1, -1);
	for (ll a = 0; a <= amax; ++a) {
		while (dp.count({ a, ansdp[a] + 1 })) {
			if (a > 0 && ansdp[a] >= ansdp[a - 1])
				break;
			ansdp[a]++;
		}
	}
	for (auto [k, a, b] : queries) {
		if (ansdp[a] >= b) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
}

void solve1() {
	ll amax = 0, bmax = 0;
	for (auto [k, a, b] : queries) {
		amax = max(a, amax);
		bmax = max(b, bmax);
	}
	set<pair<ll, ll >> dp;
	dp.insert({ 0, 0 });
	dp.insert({ w[0], 0 });
	dp.insert({ 0, w[0] });
	for (int i = 1; i < n; ++i) {
		set<pair<ll, ll>> pdp = dp;
		for (auto [a, b] : pdp) {
			if (a + w[i] <= amax)
				dp.insert({ a + w[i], b });
			if (b + w[i] <= bmax)
				dp.insert({ a, b + w[i] });
		}
	}
	vector<ll> ansdp;
	while (true) {
		ll a = ansdp.size();
		ansdp.push_back(-1);
		while (dp.count({ a, ansdp[a] + 1 })) {
			if (a > 0 && ansdp[a] >= ansdp[a - 1])
				break;
			ansdp[a]++;
		}
		if (ansdp[a] == -1)
			break;
	}
	for (auto [k, a, b] : queries) {
		if (a < ansdp.size() && ansdp[a] >= b) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
}

int main() {
	int t = 1;
	// cin >> t;
	while (t--) {
		cin >> n >> q;
		w.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> w[i];
		}
		cin >> z;
		queries.resize(q);
		for (int i = 0; i < q; ++i) {
			cin >> queries[i].k >> queries[i].a >> queries[i].b;
		}
		solve1();
	}
}
