#include <iostream>
#include <vector>
#include <algorithm>
  
#define ALL(v) v.begin(), v.end()
#define int int64_t
  
using namespace std;
 
void unique_(vector<int>& v) {
    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
}
 
void mn_(int& x, int y) {
    x = min(x, y);
}
 
void mx_(int& x, int y) {
    x = max(x, y);
}
 
// finds >=
int getLeft(const vector<int>& a, int x) {
    int l = -1;
    int r = a.size();
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (a[m] < x) {
            l = m;
        } else {
            r = m;
        }
    }
    if (r == a.size()) {
        exit(0);
    }
    return a[r];
}
 
// finds <=
int getRight(const vector<int>& a, int x) {
    int l = -1;
    int r = a.size();
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (a[m] <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    if (l == -1) {
        exit(0);
    }
    return a[l];
}
 
/*
int getSforF(const vector<int>& a, int n, int f) {
    int left = *upper_bound(ALL(a), f - 1); // XXX not found
    int right = *lower_bound(ALL(a), f + n - 1);
    int ans = right - left + 1;
    cout << ">>" << f + n - 1 + 1 << ' ' << (int)(lower_bound(ALL(a), f + n - 1) - a.begin()) << '\n';
    // cout << ">>" << f + 1 << ' ' << f + n - 1 + 1 << ' ' << left + 1 << ' ' << right + 1 << ' ' << ans << '\n';
    return ans;
}
*/
 
// /*
int getSforF(const vector<int>& a, int n, int f) {
    int left = getLeft(a, f); 
    int right = getRight(a, f + n - 1);
    int ans = right - left + 1;
    // cout << ">>" << f + n - 1 + 1 << ' ' << (int)(lower_bound(ALL(a), f + n - 1) - a.begin()) << '\n';
    // cout << ">>" << f + 1 << ' ' << f + n - 1 + 1 << ' ' << left + 1 << ' ' << right + 1 << ' ' << ans << '\n';
    return ans;
}
// */
 
// @return s, k
pair<int, int> solveProj(const vector<int>& proj, int n) {
    /*
    cout << "PROJ: ";
    for (int x : proj) {
        cout << x + 1 << ' ';
    }
    cout << '\n';
    */
 
    vector<int> a;
    a.reserve(2 * proj.size());
    for (int i = 0; i < 2; ++i) {
        for (int x : proj) {
            a.push_back(x + i * n);
        }
    }
    /*
    cout << ">>>>  ";
    for (int x : a) {
        cout << x + 1 << ' ';
    }
    cout << '\n';
    */
 
    int bestS = 2e9;
    int bestK = 2e9;
    for (int f = 0; f < n; ++f) {
        int s = getSforF(a, n, f);
        int k = f;
        // cout << f + 1 << ' ' << s << '\n';
        if (s < bestS || (s == bestS && k < bestK)) {
            bestS = s;
            bestK = k;
        }
    }
    /*
    cout << '\n';
    cout << "BEST: " << bestS << ' '<< bestK << '\n';
    */
    return {bestS, bestK};
}
 
signed main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<int> iProj;
    vector<int> jProj;
    iProj.reserve(k);
    jProj.reserve(k);
    for (int l = 0; l < k; ++l) {
        int i, j;
        cin >> i >> j;
        --i;
        --j;
        iProj.push_back(i);
        jProj.push_back(j);
    }
    unique_(iProj);
    unique_(jProj);
 
    /*
    for (int i : iProj) {
        cout << i + 1 << '\n';
    }
 
    cout << "  ";
    for (int j : jProj) {
        cout << j + 1 << ' ';
    }
    */
 
    auto [si, ki] = solveProj(iProj, n); 
    auto [sj, kj] = solveProj(jProj, m); 
    cout << si * 1ll * sj << ' ' << ki + kj << '\n';
}
