#include <vector>
#include <iostream>
#include <cassert>
#include <algorithm>
#include <map>

#define ALL(v) v.begin(), v.end()
#define int int64_t

using namespace std;

int leqBinSearch(const vector<int>& a, int x) {
    int l = -1;
    int r = a.size();
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (a[m] <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

vector<vector<int>> getMasks(vector<int>& curr, int n) {
    if (curr.size() == n) {
        return {curr};
    }

    curr.push_back(0);
    vector<vector<int>> ans;
    for (int i = 0; i < 3; ++i) {
        curr.back() = i;
        auto vecs = getMasks(curr, n);
        for (const auto& v : vecs) {
            ans.push_back(v);
        }
    }
    curr.pop_back();
    return ans;
}

bool check(const vector<int>& w, int k, int a, int b) {
    // cout << "CHECK " << n << ' ' << a << ' ' << b << endl;
    vector<vector<int>> vals;
    try {
    vals.assign(a + 1, vector<int>(b + 1));
    vector<int> cur;
    auto masks = getMasks(cur, w.size());
    for (auto mask : masks) {
        int x = 0;
        int y = 0;
        for (int i = 0; i < w.size(); ++i) {
            if (mask[i] == 1 && w[i] <= k) {
                x += w[i];
            }
            if (mask[i] == 2 && w[i] <= k) {
                y += w[i];
            }
        }
        if (x < a + 1 && y < b + 1) {
            vals[x][y] = 1;
        }

        /*
        cout << "MASK ";
        for (int x : mask) {
            cout << x << ' ';
        }
        cout << ": " << x << '\t' << y << '\n';
        */
    }
    } catch(...)  {

    }

    for (int i = 0; i < a + 1; ++i) {
        for (int j = 0; j < b + 1; ++j) {
            if (!vals[i][j]) {
                // cout << "FAILED on " << i << ' ' << j << '\n';
                return false;
            }
        }
    }

    return true;
}

signed main() {
    int n, Q;
    cin >> n >> Q;
    vector<int> w(n);
    for (int& x : w) {
        cin >> x;
    }
    int z;
    cin >> z;
    sort(ALL(w));

    for (int q = 0; q < Q; ++q) {
        int k, a, b;
        cin >> k >> a >> b;

        // cout << "CHECK " << k << ' ' << a << ' ' << b << ' ';
        cout << (check(w, k, a, b) ? "Yes" : "No") << '\n';
    }
}
