#include <vector>
#include <iostream>
#include <cassert>
#include <algorithm>

#define ALL(v) v.begin(), v.end()
#define int int64_t

using namespace std;

int leqBinSearch(const vector<int>& a, int x) {
    int l = -1;
    int r = a.size();
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (a[m] <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

signed main() {
    int n, Q;
    cin >> n >> Q;
    vector<int> w(n);
    for (int& x : w) {
        cin >> x;
    }
    int z;
    cin >> z;
    sort(ALL(w));

    vector<__int128_t> dp(n);
    dp[0] = w[0];
    // cout << ">>" << dp[0] << ' ';
    for (int i = 1; i < n; ++i) {
        dp[i] = dp[i - 1] + (w[i] <= dp[i - 1] + 1 ? w[i] : 0);
        // cout << dp[i] << ' ';
    }
    // cout << '\n';

    for (int q = 0; q < Q; ++q) {
        int k, a, b;
        cin >> k >> a >> b;
        assert(b == 0);

        if (a == 0) {
            cout << "Yes\n";
            continue;
        }

        int i = leqBinSearch(w, a); // last allowed apple
        if (i == -1) {
            cout << "No\n";
        } else {
            cout << (dp[i] >= a ? "Yes" : "No") << '\n';
        }
    }
}
