#include <vector>
#include <iostream>
#include <cassert>
#include <algorithm>

#define ALL(v) v.begin(), v.end()
#define int int64_t

using namespace std;

int leqBinSearch(const vector<int>& a, int x) {
    int l = -1;
    int r = a.size();
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (a[m] <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

vector<vector<int>> getMasks(vector<int>& curr, int n) {
    if (curr.size() == n) {
        return {curr};
    }

    curr.push_back(0);
    vector<vector<int>> ans;
    for (int i = 0; i < 3; ++i) {
        curr.back() = i;
        auto vecs = getMasks(curr, n);
        for (auto&& v : vecs) {
            ans.emplace_back(v);
        }
    }
    curr.pop_back();
    return ans;
}

bool check(const vector<int>& w, int n, int a, int b) {
    // cout << "CHECK " << n << ' ' << a << ' ' << b << endl;
    vector<int> xs(a + 1);
    vector<int> ys(b + 1);
    vector<int> cur;
    auto masks = getMasks(cur, n);
    for (auto mask : masks) {
        int x = 0;
        int y = 0;
        for (int i = 0; i < n; ++i) {
            if (mask[i] == 1) {
                x += w[i];
            }
            if (mask[i] == 2) {
                y += w[i];
            }
        }
        if (x < a + 1) {
            xs[x] = 1;
        }
        if (y < b + 1) {
            ys[y] = 1;
        }
    }

    for (int i = 0; i < a + 1; ++i) {
        if (!xs[i]) {
            return false;
        }
    }

    for (int i = 0; i < b + 1; ++i) {
        if (!ys[i]) {
            return false;
        }
    }

    return true;
}

signed main() {
    int n, Q;
    cin >> n >> Q;
    vector<int> w(n);
    for (int& x : w) {
        cin >> x;
    }
    int z;
    cin >> z;
    sort(ALL(w));

    for (int q = 0; q < Q; ++q) {
        int k, a, b;
        cin >> k >> a >> b;

        if (a == 0) {
            cout << "Yes\n";
            continue;
        }

        int i = leqBinSearch(w, k); // last allowed apple
        if (i == -1) {
            cout << "No\n";
        } else {
            cout << (check(w, i + 1, a, b) ? "Yes" : "No") << '\n';
        }
    }
}
