#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int n;

struct Node
{
	pii ch{ -1, -1 };
	inline bool isleaf() const
	{
		return ch.first == -1;
	}
	int orient = 0;
	int ans = 0;
};

vector<Node> g;

void setorient(int u, int val)
{
	Node& cur = g[u];
	cur.orient = val;
	if (cur.isleaf())
		return;
	setorient(cur.ch.first, -1);
	setorient(cur.ch.second, 1);
}

int rec(int u, int k)
{
	if (k < 0)
		return 0;
	Node& cur = g[u];
	if (cur.isleaf())
		return cur.ans = 1;
	cur.ans = rec(cur.ch.first, k - (cur.orient > 0)) + rec(cur.ch.second, k - (cur.orient < 0));
	return cur.ans;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int k, q;
	cin >> n >> k >> q;
	g.resize(n);
	for (int i = 0; i < n; i++)
	{
		int c; cin >> c;
		if (!c)
			continue;
		int u, v; cin >> u >> v;
		u--; v--;
		Node& cur = g[i];
		cur.ch = { u, v };
	}
	setorient(0, 0);
	rec(0, k);
	for (int i = 0; i < q; i++)
	{
		int u; cin >> u; u--;
#ifdef _DEBUG
		cout << "; ";
#endif
		cout << g[u].ans << '\n';
	}
}