#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

struct seg
{
	int l, r;
	bool intersects(const seg& other) const
	{
		return other.r >= l || r >= other.l;
	}
	bool operator<(const seg& other) const
	{
		return make_pair(r, l) < make_pair(other.r, other.l);
	}
};

istream& operator>>(istream& in, seg& s)
{
	return in >> s.l >> s.r;
}

vector<int> solve()
{
	int n; cin >> n;
	vector<pair<seg, int>> v(n);
	for (int i = 0; i < n; i++)
	{
		auto& p = v[i];
		cin >> p.first;
		p.second = i;
	}
	sort(v.data(), v.data() + n);
	vector<int> dp(n);
	vector<int> p(n);
	for (int i = 0; i < n; i++)
	{
		seg& cur = v[i].first;
		int l = -1, r = n;
		while (r - l > 1)
		{
			int avg = (l + r) >> 1;
			if (v[avg].first.r < cur.l)
				l = avg;
			else
				r = avg;
		}
		if (l == -1)
			dp[i] = 1,
			p[i] = -1;
		else
			dp[i] = dp[l] + 1,
			p[i] = l;
	}
	int im = -1, m = 0;
	for (int i = n - 1; i >= 0; i--)
	{
		int c = dp[i];
		if (c > m)
		{
			m = c;
			im = i;
		}
	}
	int hm = m / 2;
	int leftmost = -1;
	for (int i = 0; i < n; i++)
		if (dp[i] > hm)
		{
			leftmost = i;
			break;
		}
	vector<int> ans;
	ans.reserve(n / 2);
	vector<bool> important(n);
	{
		int i = im;
		for (; i != -1; i = p[i])
			important[i] = true;
	}
	if (leftmost <= n / 2)
	{
		for (int i = 0; i < leftmost; i++)
			ans.push_back(v[i].second);
		if (ans.size() < n / 2)
		{
			for (int i = leftmost; ans.size() < n / 2; i++)
				if (!important[i])
					ans.push_back(v[i].second);
		}
	}
	else
	{
		for (int i = leftmost; i < n; i++)
			ans.push_back(v[i].second);
		if (ans.size() < n / 2)
		{
			for (int i = 0; ans.size() < n / 2; i++)
				if (!important[i])
					ans.push_back(v[i].second);
		}
	}
	vector<int> inv;
	inv.swap(ans);
	sort(inv.data(), inv.data() + inv.size());
	int j = 0;
	for (int i = 0; i < n; i++)
	{
		if (j < inv.size() && i == inv[j])
			j++;
		else
			ans.push_back(i + 1);
	}
	return ans;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t; cin >> t;
	for (; t; --t)
	{
		auto ans = solve();
		for (int i : ans)
			cout << i << ' ';
		cout << '\n';
	}
}