#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

struct query
{
	ll k, a, b;
	bool operator<(const query& other) const
	{
		return tie(k, a, b) < tie(other.k, other.a, other.b);
	}
};

istream& operator>>(istream& in, query& q)
{
	return in >> q.k >> q.a >> q.b;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q; cin >> n >> q;
	vector<ll> v(n);
	for (ll& i : v)
		cin >> i;
	int z; cin >> z;
	sort(v.data(), v.data() + n);
	set<pll> knap; knap.emplace(0, 0);
	vector<pair<query, int>> queries(q);
	for (int i = 0; i < q; i++)
	{
		cin >> queries[i].first;
		queries[i].second = i;
	}
	vector<ll> maxa; // [b];
	maxa.push_back(0);
	sort(queries.data(), queries.data() + q);
	int curpref = 0;
	vector<bool> ans(q);
	ll lim = n > 10 ? 301 : 1e18;
	for (auto& query : queries)
	{
		ll k = query.first.k, a = query.first.a, b = query.first.b;
		int ind = query.second;
		while (curpref < n && v[curpref] <= k)
		{
			ll cur = v[curpref];
			for (ll& i : maxa)
				if (cur <= i)
					i += cur;
			set<pll> newknap;
			for (auto& p : knap)
			{
				if (p.first + cur < lim)
					newknap.emplace(p.first + cur, p.second);
				if (p.second + cur < lim)
					newknap.emplace(p.first, p.second + cur);
				if (p.second < maxa.size() || p.first > maxa[p.second])
					newknap.insert(p);
			}
			newknap.swap(knap);
			curpref++;
			ll maxb = maxa.size() - 1;
			for (; knap.count({ 0, maxb + 1 }); maxb++);
			maxa.resize(maxb + 1);
			for (int b = maxb; b >= 0; b--)
			{
				ll& curmaxa = maxa[b];
				while (knap.count({ curmaxa + 1, b }))
					curmaxa++;
			}
		}
		if (b < maxa.size() && maxa[b] >= a)
			ans[ind] = true;
		else
			ans[ind] = false;
	}
	for (bool a : ans)
		cout << (a ? "Yes\n" : "No\n");
}