#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

struct tree {
	int n;
	vector<int> z;
	tree(int _n) {
		n = _n;
		z.resize(n * 4);
	}

	int poz, val;
	void upd0(int l, int r, int x){
		if (l + 1 == r) {
			z[x] = val;
			return;
		}
		int m = (l + r) / 2;
		if (m <= poz) {
			upd0(m, r, x * 2 + 1);
		}
		else {
			upd0(l, m, x * 2);
		}
		z[x] = z[x * 2] + z[x * 2 + 1];
	}
	void upd(int _poz, int _val) {
		poz = _poz;
		val = _val;
		upd0(0, n, 1);
	}

	int lq, rq;
	void get0(int l, int r, int x) {
		if (l>=lq && r<=rq) {
			z[0] += z[x];
			return;
		}
		int m = (l + r) / 2;
		if (m >lq) {
			get0(l, m, x * 2 );
		}
		if(m<rq) {
			get0(m, r, x * 2 +1);
		}
	}
	int get(int _lq, int _rq) {
		lq = _lq;
		rq = _rq;
		z[0] = 0;
		get0(0, n, 1);
		return z[0];
	}

};

signed main() {
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int>z(n);
		int ans0 = 0;
		for (auto& i : z) cin >> i;

		vector<int>v0(n + 5, -1e9);
		v0[0] = 1e9;
		for (int i = 0; i < n; i++) {
			int l = 0, r = n;
			while (l + 1 < r) {
				int m = (l + r) / 2;
				if (v0[m] > z[i])l = m;
				else r = m;
			}
			v0[r] = z[i];
		}
		if (v0[3] != 1e9 || n <= 4) {
			for (int i = 1; i < (1 << n) - 1; i++) {
				vector<int> q, r;
				for (int j = 0; j < n; j++) {
					int c = ((i >> j) % 2);
					if (c == 1) q.push_back(z[j]);
					else r.push_back(z[j]);
				}
				int m1 = -1, m2 = 1e9, ans = 0;
				for (auto& j : q) {
					if (j > m1) {
						ans++;
						m1 = j;
					}
				}
				for (auto& j : r) {
					if (j < m2) {
						ans++;
						m2 = j;
					}
				}
				ans0 = max(ans0, ans);
			}
			cout << ans0 << '\n';
		}
		else {
			tree tr(n);
			vector<int>v(n + 2, 1e9), pr(n + 2), st(n + 1);
			for (int i = 0; i < n; i++) st[z[i]] = i;
			v[0] = -1e9;
			for (int i = 0; i < n; i++) {
				int l = 0, r = n;
				while (l + 1 < r) {
					int m = (l + r) / 2;
					if (v[m] < z[i])l = m;
					else r = m;
				}
				if (!(v[r] != 1e9 && tr.get(z[i]-1, v[r]-1) == v[r] - z[i])) {
					v[r] = z[i];
					pr[z[i]] = v[l];
				}
				tr.upd(i, 1);
			}
			vector<int> q, r;
			int w = -1, siz = 0;;
			for (int i = 0; i < n + 2; i++) {
				if (v[i] == 1e9) {
					w = v[i - 1];
					siz = i - 1;
					break;
				}
			}
			while (w != -1e9) {
				q.push_back(w);
				w = pr[w];
			}
			reverse(q.begin(), q.end());
			set<int> s1, s2;
			for (auto& i : q) s1.insert(i);
			for (auto& i : z) {
				if (s1.count(i) == 0) {
					s2.insert(i);
					r.push_back(i);
				}
			}
			int c = 0;
			for (auto& i : r) {
				if (i == *(s2.begin()) && s2.size() != 1) {
					int l = -1, r = q.size();
					while (l + 1 < r) {
						int m = (l + r) / 2;
						if (st[i] > st[q[m]]) {
							r = m;
						}
						else l = m;
					}
					if (r == q.size() || i < q[r]) {
						s2.erase(i);
						i = -1;
					}
					else {
						c = 1;
						break;
					}
				}
				else break;
			}
			if (siz == n) cout << n << '\n';
			else if (c == 1) {
				cout << siz + 1 << '\n';
			}
			else if (r.size() == 1 || r[r.size() - 2] == -1) {
				cout << siz + 1 << '\n';
			}
			else cout << siz + 2 << '\n';
		}
	}

}