#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	ll _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


vector<ll> myEncode(const vector<ll>& v, const ll n) {
	set<ll> res;
	for (ll i = 0; i < v.size(); ++i) {
		for (ll k = 1; k < n * 2; ++k) {
			auto u = (v[i] + k) % n;
			if (!binary_search(v.begin(), v.end(), u) &&
				res.find(u) == res.end()) {
				res.insert(u);
				break;
			}
		}
	}
	vector<ll> buf;
	for (auto& t : res)
		buf.push_back(t);
	return buf;
}


vector<ll> myDecode(const vector<ll>& v, const ll n) {
	set<ll> res;
	for (ll i = 0; i < v.size(); ++i) {
		for (ll k = 1; k < n * 2; ++k) {
			auto u = (v[i] - k + n * 4) % n;
			if (!binary_search(v.begin(), v.end(), u) &&
				res.find(u) == res.end()) {
				res.insert(u);
				break;
			}
		}
	}
	vector<ll> buf;
	for (auto& t : res)
		buf.push_back(t);
	return buf;
}


void solve(istream& cin, ostream& cout) {
	ll type;
	cin >> type;

	ll q;
	cin >> q;
	while (q--) {
		ll n, k;
		cin >> n >> k;
		vector<ll> a(k);
		for (auto& t : a)
			cin >> t, --t;

		if (type == 1)
			a = myEncode(a, n);
		else
			a = myDecode(a, n);

		for (auto& t : a)
			cout << t + 1 << ' ';
		cout << endl;
	}
}