#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	ll _ = 1;
	cin >> _;
	while (_--)
		solve(cin, cout);
}


void solve(istream& cin, ostream& cout) {
	ll n;
	cin >> n;
	vector<ll> p(n);
	for (auto& t : p)
		cin >> t;

	ll res = 0;
	for (ll mask = 0; mask < (1ll << n); ++mask) {
		ll cnt = 0;
		ll record = -INF;
		ll antirecord = INF;

		for (ll i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				if (record < p[i])
					++cnt, record = p[i];
			}
			else {
				if (antirecord > p[i])
					++cnt, antirecord = p[i];
			}
		}
		res = max(res, cnt);
	}

	cout << res << '\n';
}