#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <numeric>

using namespace std;

//#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'
#define int long long

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' ';
#define debnl(x) cout << #x << '=' << x << endl;
#define print(a) {cout << #a << endl; for (auto x: a) cout << x << ' '; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define print(a)

#endif

typedef long long ll;
typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

void solve();

ll mod;

signed main() {
	fastIO();
	int T = 1LL;
	cin >> mod;
	cin >> T;
	while (T--) {
		solve();
	}
}

int my_popcount(int x) {
	int cnt = 0;
	while (x > 0) cnt += x % 2, x /= 2;
	return cnt;
}

int k, n, p;
vi used, cool;
vvi gr, rgr;
vi topsort, comp, comp_q, comp_cool;
vvi new_gr;

void g_clear() {
	used.clear(), cool.clear();
	gr.clear(), rgr.clear();
	topsort.clear(), comp.clear(), comp_q.clear(), comp_cool.clear();
	new_gr.clear();
}

void dfs(int mask) {
	if (used[mask]) {
		return;
	}
	used[mask] = 1LL;
	int new_mask = 0;
	int mex = (1LL << k);
	for (int i = 0; i < (1LL << k); i++) {
		if (!(mask & (1LL << i))) {
			mex = i;
			break;
		}
	}
	mex--;
	if (mex < 0) throw;
	for (int i = 0; i < (1LL << k); i++) {
		if ((mask & (1LL << i))) {
			new_mask |= (1LL << (i ^ mex));
		}
	}
	if (mask == new_mask) {
		debnl(mask);
		cool[mask] = mex + 1LL == p;
		return;
	}
	gr[mask].push_back(new_mask);
	rgr[new_mask].push_back(mask);
	dfs(new_mask);
}



void dfs_topsort(int mask) {
	debnl(mask);
	used[mask] = 1LL;
	for (auto new_mask : gr[mask]) {
		if (!used[new_mask]) dfs_topsort(new_mask);
	}
	topsort.push_back(mask);
}

void dfs_condense(int u) {
	deb("cond"); debnl(u);
	comp_cool[comp[u]] |= cool[u];
	comp_q[comp[u]]++;
	used[u] = 1LL;
	for (auto v : rgr[u]) {
		if (used[v]) {
			if (comp[v] != comp[u]) {
				new_gr[comp[v]].push_back(comp[u]);
			}
			continue;
		}
		comp[v] = comp[u];

		dfs_condense(v);
	}
}

void solve() {
	cin >> k >> n >> p;
	int q = (1LL << k);
	used = vi((1LL << q));
	gr = vvi((1LL << q));
	rgr = vvi((1LL << q));
	cool = vi((1LL << q));
	for (int mask = 0; mask < (1LL << q); mask++) {
		if (my_popcount(mask) != n || mask % 2 == 0) continue;
		//deb("sopsr"); debnl(mask);
		if (!used[mask]) dfs(mask);
	}
	for (int mask = 0; mask < (1LL << q); mask++) {
		if (my_popcount(mask) != n || mask % 2 == 0) continue;
		//deb("sopsr"); debnl(mask);
		debnl(mask);
		print(gr[mask]);
	}


	used = vi((1LL << q));

	for (int mask = 0; mask < (1LL << q); mask++) {
		//if (mask >= 9) continue;
		deb("for");  debnl(mask);
		if (my_popcount(mask) != n || mask % 2 == 0) continue;
		if (!used[mask]) dfs_topsort(mask);
	}
	reverse(all(topsort));
	used = vi((1LL << q));
	comp = vi(1LL << q);


	int cnt = 0;
	for (int i = 0; i < topsort.size(); i++) {
		int u = topsort[i];
		debnl(u);
		if (!used[u]) {
			comp[u] = cnt++;
			comp_q.push_back(0);
			comp_cool.push_back(0);
			new_gr.push_back({});
			dfs_condense(u);
		}
	}
	print(comp_cool);
	int answer = 0;

	for (int u = cnt - 1LL; u >= 0; u--) {
		for (auto v : new_gr[u]) {
			comp_cool[u] |= comp_cool[v];
		}
		answer += comp_cool[u] * (comp_q[u]);
		answer %= mod;
	}

	cout << answer << nl;

	g_clear();
}
