#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <algorithm>
#include <numeric>
#include <random>

using namespace std;

//#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' ';
#define debnl(x) cout << #x << '=' << x << endl;
#define print(a) {cout << #a << endl; for (auto x: a) cout << x << ' '; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define print(a)

#endif

typedef long long ll;
typedef pair<int, int> ii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

mt19937_64 rnd(10);

const int INF = 1e9 + 1;

void solve();

signed main() {
	fastIO();
	int T = 1;
	//cin >> T;
	while (T--) {
		solve();
	}
}



int n, k;

vvi gr;
vi dp, s, tin;
vi org;
vi ans;
int t = 0;

struct Query {
	int r, x, k, ind;

	bool operator<(const Query& oth) {
		return r < oth.r;
	}
};

void dfs(int u, int dir, int g) {
	s[u] = 1;
	tin[u] = min(t++, tin[u]);
	if (gr[u].size() == 0) {
		if (g == 1) org.push_back(dp[u]);
		return;
	}
	if (g == 1) org.push_back(k + 1);
	int v = gr[u][0], w = gr[u][1];
	dp[v] = min(dp[v], dp[u] + (dir != 0));
	dp[w] = min(dp[w], dp[u] + (dir != 1));
	dfs(v, 0, g);
	dfs(w, 1, g);

	s[u] += (s[v] + s[w]);
}

struct Fenwick {
	int n;
	vi f;

	Fenwick(int _n) {
		n = _n;
		f.resize(n);
	}

	int get(int i) {
		int ans = 0;
		while (i >= 0) {
			ans += f[i];
			i = (i & (i + 1)) - 1;
		}
		return ans;
	}

	void upd(int i) {
		while (i < n) {
			f[i]++;
			i = i | (i + 1);
		}
	}


};

void solve() {
	int q;
	cin >> n >> k >> q;
	dp = vi(n, INF);
	gr.resize(n);
	tin.resize(n, INF);
	s.resize(n);
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		if (k == 0) continue;
		int u, v;
		cin >> u >> v, u--, v--;
		gr[i].push_back(v);
		gr[i].push_back(u);
	}
	dp[0] = 0;
	dfs(0, 0, 0);
	dfs(0, 1, 1);

	vector<Query> qs;
	ans.resize(q);

	for (int i = 0; i < q; i++) {
		int u;
		cin >> u, u--;
		qs.push_back({ tin[u] + s[u] - 1, k, 1, i });
		qs.push_back({ tin[u] - 1, k, -1, i });
	}
		
	print(tin);
	print(s);
	print(org);
	sort(all(qs));

	Fenwick f(k + 2);
	int j = 0;
	for (int i = 0; i < 2 * q; i++) {
		while (j < n && j <= qs[i].r) {
			f.upd(org[j]);
			deb(j); debnl(org[j]);
			j++;
		}
		deb(qs[i].r);  deb(qs[i].ind); deb(qs[i].x); debnl(qs[i].k);
		debnl(f.get(qs[i].x));
		print(f.f);
		ans[qs[i].ind] += f.get(qs[i].x) * qs[i].k;
	}

	for (int i = 0; i < q; i++) {
		cout << ans[i] << ' ';
	}
}











