#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

std::vector<int> to;
std::set<int> a, b;

inline void slave1() {
    int n, k;
    std::cin >> n >> k;
    a.clear();
    for (int i = 0; i < k; i++) {
        int x;
        std::cin >> x;
        x--;
        a.insert(x);
    }
    to.resize(n);
    for (int i = 0; i < n; i++) {
        to[i] = (i + n - 1) % n;
    }
    b.clear();
    for (auto x : a) {
        int y = to[x];
        while (a.count(y) || b.count(y)) {
            y = to[y];
        }
        int next;
        for (int node = to[x]; node != y; node = next) {
            next = to[node];
            to[node] = to[y];
        }
        b.insert(y);
    }
    for (auto e : b) {
        std::cout << e + 1 << ' ';
    }
    std::cout << '\n';
}

inline void slave2() {
    int n, k;
    std::cin >> n >> k;
    a.clear();
    for (int i = 0; i < k; i++) {
        int x;
        std::cin >> x;
        x--;
        a.insert(x);
    }
    to.resize(n);
    for (int i = 0; i < n; i++) {
        to[i] = (i + 1) % n;
    }
    b.clear();
    for (auto x : a) {
        int y = to[x];
        while (a.count(y) || b.count(y)) {
            y = to[y];
        }
        int next;
        for (int node = to[x]; node != y; node = next) {
            next = to[node];
            to[node] = to[y];
        }
        b.insert(y);
    }
    for (auto e : b) {
        std::cout << e + 1 << ' ';
    }
    std::cout << '\n';
}

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int type;
    std::cin >> type;
    int t;
    std::cin >> t;
    if (type == 1) {
        while (t-- > 0) {
            slave1();
        }
    } else {
        while (t-- > 0) {
            slave2();
        }
    }
    return 0;
}