#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3")
#endif

typedef long long ll;

struct Graph {
    ll n;
    vector<pair<ll, ll>> adj;
    vector<ll> l, r, euler, sum;

    Graph(ll n) : n(n) {
        adj.assign(n, {-1, -1});
        l.resize(n);
        r.resize(n);
    }

    void dfs_euler(ll v) {
        l[v] = euler.size();
        euler.push_back(v);
        auto [left, right] = adj[v];
        if (left != -1 && right != -1) {
            dfs_euler(left);
            euler.push_back(v);
            dfs_euler(right);
            euler.push_back(v);
        }
        r[v] = euler.size();
    }

    void dfs_sum(ll v, ll last, ll k) { // last = 0 - left; 1 - right
        if (k < 0) {
            sum[v] = 0;
            return;
        }
        auto [left, right] = adj[v];
        if (left == -1 && right == -1) {
            sum[l[v]] = 1;
            return;
        }
        dfs_sum(left, 0, k - (last == 1));
        dfs_sum(right, 1, k - (last == 0));
    }
};

void solve() {
    ll n, k, q;
    cin >> n >> k >> q;
    Graph g(n);
    for (ll i = 0; i < n; i++) {
        ll t;
        cin >> t;
        if (t != 0) {
            ll l, r;
            cin >> l >> r;
            l--;
            r--;
            g.adj[i] = {l, r};
        }
    }
    g.dfs_euler(0);
    g.sum.resize(g.euler.size());
    g.dfs_sum(0, 0, k);
    g.dfs_sum(0, 1, k);
    vector<ll> pref_sum(g.euler.size() + 1, 0);
    pref_sum[0] = 0;
    for (ll i = 1; i <= g.euler.size(); i++) {
        pref_sum[i] += g.sum[i - 1] + pref_sum[i - 1];
    }
    for (ll i = 0; i < q; i++) {
        ll v;
        cin >> v;
        v--;
        cout << pref_sum[g.r[v]] - pref_sum[g.l[v]] << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
}
