#include <iostream>
#include <vector>
#include <random>
#include <chrono>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
typedef long long ll;
typedef long double ld;

ll INF = 2e18, L_INF = 2e9, mod = 1e9+7;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#define all(x) x.begin(), x.end()
#define forall(aaa, aaaa) for(auto& aaa: aaaa)

void print(vector < vector < ll >>& a) {
    forall(i, a) {
        forall(j, i) cout << max(j, -1ll) << '\t';
        cout << '\n';
    }
    cout << "-----------";
    cout << endl;
}

ll f(vector < ll >& a) {
    for (ll i = 0; i < a.size(); i++) {
        if (a[i] != i) return i;
    }
    return a.size();
}

bool nxt(vector < ll >&a, ll k) {
    ll n = a.size();
    for (ll i = n - 1; i > 0; i--) {
        if (a[i] == (1ll << k) - (n - i)) continue;

        a[i]++;
        i++;
        while (i < n) {
            a[i] = a[i - 1] + 1;
            i++;
        }
        return true;
    }
    return false;
}

void solve() {
    ll k, n, p;
    cin >> k >> n >> p;
    vector < ll > start(n);
    for (ll i = 0; i < n; i++) start[i] = i;
    ll cnt = 0;
    map < vector < ll >, ll > mp;
    do {
        set < vector < ll >> s;
        ll last = 0;
        vector < ll > now = start;
        while (true) {
            ll mx = f(now);
            if (mp.count(now)) {
                mx = mp[now];
                if (mx == p) cnt++;
                if (cnt == mod) cnt -= mod;
                forall(i, s) mp[i] = mx;
                break;
            }
            if (s.find(now) != s.end()) {
                if (mx == p) cnt++;
                if (cnt == mod) cnt -= mod;
                forall(i, s) mp[i] = mx;
                break;
            }

            s.insert(now);
            forall(i, now) i ^= mx - 1;
            sort(all(now));
        }
        n = n;
    } while (nxt(start, k));

    cout << cnt << '\n';
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1, k;
//    cin >> k;
    cin >> mod;
    cin >> T;
    while (T--) {
//        if (k == 1) solve1();
//        else solve2();
        solve();
    }
//    solve(3, 6, 2);
//    for (ll i = 1; i <= 8; i ++) {
//        for (ll j = 1; j <= 8; j++) {
//            cout << '3' << ' ' << i <<  ' ' << j << ' ';
//            solve(3, i, j);
//        }
//    }
    return 0;
}
