#include <iostream>
#include <random>
#include <chrono>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;
ll INF = 2e18, L_INF = 2e9, mod = 1e9+7;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forall(aa, aaa) for(auto& aa: aaa)

void print(vector < ll >&a) {
    forall(i, a) cout << i << ' ';
    cout << '\n';
}

struct point {
    ll x, fl, id;
    bool operator< (const point& other) {
        if (x == other.x) return fl < other.fl;
        return x < other.x;
    }
};

void solve() {
    ll n;
    cin >> n;
    vector < point > a(2 * n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i * 2].x >> a[i * 2 + 1].x;
        a[i * 2].fl = -1;
        a[i * 2 + 1].fl = 1;
        a[i * 2].id = a[i * 2 + 1].id = i;
    }

    sort(all(a));

    ll cnt = 0;
    for (ll i = 0; i < 2 * n; i++) {
        if (cnt == n / 2) break;
        if (a[i].id == a[i + 1].id) {
            cout << a[i].id + 1 << ' ';
            cnt++;
            i++;
        }
    }
    cout << '\n';
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
