#include <iostream>
#include <random>
#include <chrono>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;
ll INF = 2e18, L_INF = 2e9, mod = 1e9 + 7;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forall(aa, aaa) for(auto& aa: aaa)

void print(vector<ll> &a) {
    forall(i, a) cout << i << ' ';
    cout << '\n';
}

struct p{
    ll x, y, id;

    bool operator<(p& other) {
        if (y != other.y) return y < other.y;
        return x < other.x;
    }
};

void solve() {
    ll n, q, k;
    bool fl = true;
    cin >> n >> q;
    vector < ll > a(n);
    vector < vector < ll >> need(q, vector < ll > (3));
    forall(i, a) cin >> i;
    cin >> k;
    forall(i, need) {
        cin >> i[0] >> i[1] >> i[2];
        if (i[2]) fl = false;
    }
    sort(all(a));

    ll mx = 300;
    set < pair < ll, ll >> s;
    s.insert({0, 0});
    forall(i, a) {
        set < pair < ll, ll >> now = s;
        forall(j, now) {
            if (j.first + i <= mx) s.insert({j.first + i, j.second});
            if (j.second + i <= mx) s.insert({j.first, j.second + i});
        }
    }
    vector < vector < bool >> can(mx+1, vector < bool > (mx+1, false));

    for (ll i = 0; i <= mx; i++) {
        for (ll j = 0; j <= mx; j++) {
            can[i][j] = true;
            if (i && !can[i - 1][j]) can[i][j] = false;
            if (j && !can[i][j - 1]) can[i][j] = false;
            if (s.find({i, j}) == s.end()) can[i][j] = false;
        }
    }

    forall(i, need) {
        if (can[i[1]][i[2]]) cout << "Yes\n";
        else cout << "No\n";
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}