#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

//const int N = 5000;
//vector<int> p, pos;

vector<vector<int>> path;

void init(int n) {
    path.assign(n + 1, {});
    vector<vector<int>> kek(n + 1);
    for (int mask = 0; mask < (1 << n); ++mask) {
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                ++cnt;
            }
        }
        kek[cnt].emplace_back(mask);
    }
    for (int i = 1; i <= n / 2; ++i) {
        path[i] = kek[i];
        int m = sz(kek[i]);
        while (true) {
            bool ok = 1;
            shuffle(all(path[i]), rnd);
            for (int j = 0; j < m; ++j) {
                if ((path[i][j] & path[i][(j + 1) % m]) != 0) {
                    ok = 0;
                }
            }
            if (ok) {
                break;
            }
        }
    }
}

void encode() {
    int n, k;
    cin >> n >> k;
    init(n);
    vector<int> a(k);
    int mask = 0;
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        mask |= (1 << (a[i] - 1));
    }

    int ptr = 0;
    for (;; ++ptr) {
        if (path[k][ptr] == mask) {
            break;
        }
    }
    ptr = (ptr + 1) % sz(path[k]);

    int now = path[k][ptr];
    vector<int> b;
    for (int i = 0; i < n; ++i) {
        if (now & (1 << i)) {
            b.emplace_back(i + 1);
        }
    }
    sort(all(b));

    for (auto i : b) {
        cout << i << ' ';
    }
    cout << en;
}

void decode() {
    int n, k;
    cin >> n >> k;
    init(n);
    vector<int> a(k);
    int mask = 0;
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        mask |= (1 << (a[i] - 1));
    }

//    assert(match[mask] != -1);
    int ptr = 0;
    for (;; ++ptr) {
        if (path[k][ptr] == mask) {
            break;
        }
    }
    ptr = (ptr - 1 + sz(path[k])) % sz(path[k]);

    int now = path[k][ptr];
    vector<int> b;
    for (int i = 0; i < n; ++i) {
        if (now & (1 << i)) {
            b.emplace_back(i + 1);
        }
    }
    sort(all(b));

    for (auto i : b) {
        cout << i << ' ';
    }
    cout << en;
}

int main() {
    int tests = 1;
#ifdef THEEVILBID
    freopen("input.txt", "r", stdin);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    int type;
    cin >> type;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        if (type == 1) {
            encode();
        } else {
            decode();
        }
    }
    cout << endl;
    return 0;
}
