#include <iostream>
#include "vector"
#include "algorithm"

#define ll long long
#define all(x) (x).begin(), (x).end()

using namespace std;

vector<vector<int>> g;
vector<int> a;
vector<pair<int, int>> dp;

void dfs(int v, int p = -1) {
    dp[v] = {a[v], 0};
    for (auto u: g[v]) {
        if (u == p) continue;
        dfs(u, v);
        dp[v].first += dp[u].second;
        dp[v].second += max(dp[u].first, dp[u].second);
    }
}

vector<int> took;

void dfs2(int v, bool tookn, int p = -1) {
    if (tookn) {
        took.push_back(v);
        for (auto u: g[v]) {
            if (u == p) continue;
            dfs2(u, false, v);
        }
    } else {
        for (auto u: g[v]) {
            if (u == p) continue;
            if (dp[u].first > dp[u].second) {
                dfs2(u, true, v);
            } else {
                dfs2(u, false, v);
            }
        }
    }
}


void solve() {
    g.clear(); a.clear(); dp.clear(); took.clear();
    int n, q; cin >> n >> q;
    ll x, y, m; cin >> x >> y >> m;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u; cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> a[i];
    }
    dp.resize(n);
    dfs(0);
    int res = max(dp[0].first, dp[0].second);
    if (dp[0].first > dp[0].second) {
        dfs2(0, true);
    } else {
        dfs2(0, false);
    }
    sort(all(took));
    if (took.size() != res) {
        while (true) {};
    }
    vector<bool> psbl;
    vector<ll> hs(res + 1);
    ll h = 0;
    for (int i = 0; i < n; ++i) {
        h = (h ^ ((x * (i + 1)) % m));
    }
    hs[0] = h;
    for (int i = 1; i <= res; ++i) {
        hs[i] = hs[i - 1];
        hs[i] = (hs[i] ^ ((x * (took[i - 1] + 1)) % m));
        hs[i] = (hs[i] ^ (((x * (took[i - 1] + 1)) % m + y % m) % m));
    }
    vector<int> trs;
    while (q--) {
        int tr; cin >> tr;
        trs.push_back(tr);
        if (tr <= res) {
            cout << hs[tr] << ' ';
            psbl.push_back(true);
        } else {
            cout << -1 << ' ';
            psbl.push_back(false);
        }
    }
    cout << endl;
    int ask; cin >> ask;
    while (ask) {
        ask--;
        if (psbl[ask]) {
            vector<int> ex(n, 0);
            for (int i = 0; i < trs[ask]; ++i) {
                ex[took[i]] = 1;
            }
            for (auto el: ex) {
                cout << el << ' ';
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
        cin >> ask;
    }
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int test; cin >> test;
    while (test--) {
        solve();
    }
}
