#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define sz(x) int(size(x))
#define all(x) begin(x), end(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int h, w, n;
    cin >> h >> w >> n;

    vector<pii> pts(n);
    rep(i, 0, n) {
        cin >> pts[i].first >> pts[i].second;
        pts[i].first--, pts[i].second--;
    }

    auto ycmp = [](auto f, auto s) {
        return tie(f.second, f.first) < tie(s.second, s.first);
    };

    auto ypts = pts;
    std::sort(pts.begin(), pts.end());
    std::sort(ypts.begin(), ypts.end(), ycmp);

    auto calc_cnt_x = [&](int up, int down) { // [up, down)
        bool swapped = false;
        if (up > down) {
            swap(up, down);
            swapped = true;
        }

        int cnt = lower_bound(all(pts), pii{down, -1}) - lower_bound(all(pts), pii{up, -1});
        return swapped ? n - cnt : cnt;
    };

    auto calc_cnt_y = [&](int left, int right) { // [left, right)
        bool swapped = false;
        if (left > right) {
            swap(left, right);
            swapped = true;
        }

        auto itr = lower_bound(all(ypts), pii{-1, right}, ycmp);
        auto itl = lower_bound(all(ypts), pii{-1, left}, ycmp);

        int cnt = itr - itl;
        return swapped ? n - cnt : cnt;
    };

    auto f = [&](int r, int c, int height) -> pair<ll, int> {
        int lo = 0, hi = w;
        while (hi - lo > 1) {
            int mid = lo + (hi - lo) / 2;

            int cnt = calc_cnt_y(c, (c + mid) % w);
            if (cnt >= n) {
                hi = mid;
            } else {
                lo = mid;
            }
        }

        return {1LL * height * hi, max(0, height - (h - r)) + max(0, hi - (w - c))};
    };

    auto ans = pair<ll, int>{LLONG_MAX, INT_MAX};
    rep(up, 0, n) {
        auto u = pts[up].first;
        int lo = 0, hi = h;
        while (hi - lo > 1) {
            int mid = lo + (hi - lo) / 2;

            int cnt = calc_cnt_x(u, (u + mid) % h);
            if (cnt >= n) {
                hi = mid;
            } else {
                lo = mid;
            }
        }

        int height = hi;
        lo = 0, hi = n;
//        while (hi - lo > 3) {
//            int m1 = lo + (hi - lo) / 3, m2 = hi - (hi - lo) / 3;
//
//            if (f(u, pts[m1].second, height) > f(u, pts[m2].second, height)) {
//                lo = m1;
//            } else {
//                hi = m2;
//            }
//        }

        auto cur = pair<ll, int>{LLONG_MAX, INT_MAX};
        rep(i, lo, hi + 1) {
            cur = min(cur, f(u, pts[i].second, height));
        }
        ans = min(ans, cur);
    }
    cout << ans.first << ' ' << ans.second << '\n';
}