#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

void dfs(const vector<vi> &g, vector<vector<pii>> &leaves, vi &cnt, int v, int dir) {
    rep(i, 0, sz(g[v])) {
        int u = g[v][i];

        int inc = int(dir != -1 && i != dir);
        cnt[u] = cnt[v] + inc;
        dfs(g, leaves, cnt, u, i);

        vector<pii> old_leaves;
        old_leaves.swap(leaves[v]);

        leaves[v].resize(sz(old_leaves) + sz(leaves[u]));
        merge(all(old_leaves), all(leaves[u]), begin(leaves[v]));
    }
    if (g[v].empty()) {
        leaves[v] = {pii{cnt[v], v}};
    }
}

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int n, k, q;
    cin >> n >> k >> q;

    vector<vi> g(n);
    rep(i, 0, n) {
        int t;
        cin >> t;

        while (t--) {
            int v;
            cin >> v;
            g[i].push_back(v - 1);
        }
    }

    vector<vector<pii>> leaves(n);
    vi cnt(n, 0);
    dfs(g, leaves, cnt, 0, -1);

    vi ans(n);
    transform(all(leaves), begin(ans), [k](const vector<pii> &leaves) {
        return int(count_if(all(leaves), [k](const pii &a) {
            return a.first <= k;
        }));
    });

    while (q--) {
        int u;
        cin >> u;

        cout << ans[u - 1] << '\n';
    }
}