#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

struct cmp {
    bool operator()(const pii& a, const pii& b) const {
        return pii{a.first, -a.second} < pii{b.first, -b.second};
    }
};

int calc(const multiset<pii, cmp>& segs) {
    set<pii> small;
    for (auto [l, r]: segs) {
        while (!small.empty() && r <= small.rbegin()->second) {
            small.erase(*small.rbegin());
        }
        small.emplace(l, r);
    }

    vector<pii> small_segs = {all(small)};
    int m = 0, r = 0;
    for (auto [cl, cr]: small_segs) {
        if (cl > r) {
            r = cr;
            m += 1;
        }
    }

    return m;
}

void solve() {
    mt19937 rng(42);
    int n;
    cin >> n;

    vector<pii> segs(n);
    multiset<pii, cmp> ssegs;
    rep(i, 0, n) {
        cin >> segs[i].first >> segs[i].second;
        ssegs.insert(segs[i]);
    }

    int m = calc(ssegs);

    rep(mask, 0, 1 << n) {
        if (__builtin_popcount(mask) != n / 2) continue;
        multiset<pii, cmp> s;
        rep(i, 0, n) {
            if (mask & (1 << i))
                s.insert(segs[i]);
        }

        int cur_m = calc(s);
        if (cur_m == m / 2) {
            rep(i, 0, n) {
                if (mask & (1 << i)) {
                    cout << i + 1 << ' ';
                }
            }
            cout << '\n';
            return;
        }
    }
    assert(false);
}

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}