#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

void solve() {
    int n;
    cin >> n;

    vector<array<int, 3>> segs(n);
    rep(i, 0, n) {
        cin >> segs[i][0] >> segs[i][1];
        segs[i][2] = i;
    }

    sort(all(segs));

    vector<vi> dp(n + 1, vi(n, INT_MAX));
    vector<vi> p(n + 1, vi(n, -1));
    vi non(n);
    rep(i, 0, n) {
        rep(j, i + 1, n) {
            non[i] += segs[j][0] > segs[i][1];
        }
    }

    tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> rs;
    rep(i, 0, n) {
        dp[1][i] = rs.order_of_key(segs[i][0]);
        rs.insert(segs[i][1]);
    }
    rep(ans, 2, n + 1) {
        rep(i, 0, n) {
            int cost = 0;
            for (int j = i - 1; j >= 0; j--) {
                if (segs[j][1] < segs[i][0] && dp[ans - 1][j] != INT_MAX) {
                    if (dp[ans - 1][j] + cost < dp[ans][i]) {
                        dp[ans][i] = dp[ans - 1][j] + cost;
                        p[ans][i] = j;
                    }
                    cost += 1;
                }
            }
        }
    }

    int m = 0;
    rep(i, 0, n + 1) {
        if (std::count(dp[i].begin(), dp[i].end(), INT_MAX) != sz(dp[i])) {
            m = i;
        }
    }

    vector<bool> ban(n, false);
    int pos = -1;
    rep(i, 0, n) {
        if (dp[m / 2][i] != INT_MAX && (pos == -1 || dp[m / 2][i] + non[i] < dp[m / 2][pos] + non[pos])) {
            pos = i;
        }
    }

    rep(j, pos + 1, n) {
        ban[j] = segs[j][0] > segs[pos][1];
    }

    vi leave;
    int cur_ans = m / 2;
    while (pos != -1) {
        leave.push_back(segs[pos][2]);
        ban[pos] = true;
        int pre = p[cur_ans / 2][pos];
        rep(k, pre, pos) {
            if (segs[k][0] > segs[pre][1] && segs[k][1] < segs[pos][0]) ban[k] = true;
        }
        cur_ans -= 1;
        pos = pre;
    }

    rep(i, 0, n) {
        if (sz(leave) == n / 2) break;
        if (!ban[i]) leave.push_back(segs[i][2]);
    }
    for (auto el: leave) cout << el + 1 << ' ';
    cout << '\n';
}

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}