#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

int calc(const vector<array<int, 3>>& segs) {
    set<pii> small;
    for (auto [l, r, _]: segs) {
        while (!small.empty() && r <= small.rbegin()->second) {
            small.erase(*small.rbegin());
        }
        small.emplace(l, r);
    }

    vector<pii> small_segs = {all(small)};
    small_segs.resize(sz(small_segs) / 2);

    int m = 0, r = 0;
    for (auto [cl, cr]: small_segs) {
        if (cl > r) {
            r = cr;
            m += 1;
        }
    }

    return m;
}

void solve() {
    mt19937 rng(42);
    int n;
    cin >> n;

    vector<array<int, 3>> segs(n);
    rep(i, 0, n) {
        cin >> segs[i][0] >> segs[i][1];
        segs[i][2] = i;
    }

    sort(all(segs), [](const array<int, 3>& a, const array<int, 3>& b) {
        return tuple{a[0], -a[1], a[2]} < tuple{b[0], -b[1], b[2]};
    });

    int m = calc(segs);
    rep(_, 0, 300) {
        vi p(n);
        iota(all(p), 0);
        shuffle(all(p), rng);
        vector<array<int, 3>> s(n / 2);
        rep(i, 0, n / 2) {
            s[i] = segs[p[i]];
        }
        sort(all(s), [](const array<int, 3>& a, const array<int, 3>& b) {
            return tuple{a[0], -a[1], a[2]} < tuple{b[0], -b[1], b[2]};
        });

        if (calc(s) == m / 2) {
            rep(i, n / 2, n) {
                cout << segs[p[i]][2] + 1 << ' ';
            }
            cout << '\n';
            return;
        }
    }
}

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}