#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;

struct SegTree {
	int sz;
	vector<int> tree;
	vector<int> push;
	SegTree(int n){
		sz = 1;
		while (sz <= n) sz *= 2;
		tree.assign(2 * sz - 1, 0);
		push.assign(2 * sz - 1, 0);
	}
};

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int> p(n);
		for (int i = 0; i < n; ++i) {
			cin >> p[i];
			--p[i];
		}
		vector<vector<int>> dp(n + 1, vector<int>(n + 1, 0));
		for (int i = 0; i < n; ++i) {
			//p[i] is a record
			vector<vector<int>> pr = dp;
			for (int x = p[i] + 1; x <= n; ++x) {
				for (int y = 0; y <= n; ++y) {
					dp[x][y] = max(dp[x][y], pr[p[i]][y] + 1);
				}
			}
			//p[i] is an antirecord
			for (int x = 0; x <= n; ++x) {
				for (int y = 0; y <= p[i]; ++y) {
					dp[x][y] = max(dp[x][y], pr[x][p[i]] + 1);
				}
			}
			
			for (int x = 0; x <= p[i]; ++x) {
				for (int y = p[i] + 1; y <= n; ++y) {
					dp[x][y] = -1e9;
				}
			}
		}
		cout << dp[n][0] << "\n";
	}

	return 0;
}