#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;

struct SegTree {
	int sz;
	vector<int> tree;
	SegTree(int n) {
		sz = 1;
		while (sz <= n) sz *= 2;
		tree.assign(2 * sz - 1, 0);
	}
	void set(int i, int v) {
		i += sz - 1;
		tree[i] = max(tree[i], v);
		while (i > 0) {
			i = (i - 1) / 2;
			tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
		}
	}
	int get(int l, int r, int x, int lx, int rx) {
		if (l <= lx and rx <= r) return tree[x];
		if (rx <= l or r <= lx) return -1e9;
		return max(get(l, r, 2 * x + 1, lx, (lx + rx) / 2),
			get(l, r, 2 * x + 2, (lx + rx) / 2, rx));
	}
	int get(int l, int r) {
		return get(l, r, 0, 0, sz);
	}
};

int n;
int get(int x, int y, vector<SegTree>& hor, vector<SegTree>& ver, SegTree& sumtr) {
	if (x < y and sumtr.get(x, y) == 1) return -1e9;
	return max(hor[y].get(0, x + 1), ver[x].get(y, n + 1));
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		cin >> n;
		vector<int> p(n);
		for (int i = 0; i < n; ++i) {
			cin >> p[i];
			--p[i];
		}
		vector<SegTree> hor(n + 1, SegTree(n + 1)), ver(n + 1, SegTree(n + 1));
		vector<int> valx(n + 1), valy(n + 1);
		SegTree sumtr(n);
		for (int i = 0; i < n; ++i) {
			//p[i] is a record
			for (int y = 0; y <= n; ++y) {
				valy[y] = get(p[i], y, hor, ver, sumtr) + 1;
			}
			//p[i] is an antirecord
			for (int x = 0; x <= n; ++x) {
				valx[x] = get(x, p[i], hor, ver, sumtr) + 1;
			}

			for (int y = 0; y <= n; ++y) {
				hor[y].set(p[i] + 1, valy[y]);
			}
			for (int x = 0; x <= n; ++x) {
				ver[x].set(p[i], valx[x]);
			}

			sumtr.set(p[i], 1);
		}
		cout << get(n, 0, hor, ver, sumtr) << "\n";
	}

	return 0;
}