#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cmath>

typedef long long ll;
struct ask {
	ll k, a, b, ind;
};
bool operator<(const ask& a, const ask& b) {
	return a.k < b.k;
}
const int max_n = 5001;
bool dp[max_n][max_n];
bool best[max_n][max_n];
void add(int w) {
	for (int i = max_n - 1; i >= 0; --i) {
		for (int j = max_n - 1; j >= 0; --j) {
			if (i + w < max_n) {
				dp[i + w][j] = dp[i + w][j] || dp[i][j];
			}
			if (j + w < max_n) {
				dp[i][j + w] = dp[i][j + w] || dp[i][j];
			}
		}
	}
	for (int i = 0; i < max_n; ++i) {
		for (int j = 0; j < max_n; ++j) {
			bool c1 = (j == 0 || best[i][j - 1]);
			bool c2 = (i == 0 || best[i - 1][j]);
			best[i][j] = (c1 && c2 && dp[i][j]);
		}
	}
}
int main() {
	int n, q;
	std::cin >> n >> q;
	std::vector<ll> w(n);
	for (ll& i : w) {
		std::cin >> i;
	}
	std::sort(w.begin(), w.end());
	while (w.size() > 0 && w.back() > 5000) {
		w.pop_back();
	}
	std::vector<ask> req(q);
	ll z;
	std::cin >> z;
	int index = 0;
	for (ask& i : req) {
		std::cin >> i.k >> i.a >> i.b;
		i.ind = index++;
	}
	std::sort(req.begin(), req.end());
	dp[0][0] = 1;
	int l = 0;
	std::vector<bool> ans(q);
	for (ask i : req) {
		while (l < w.size() && w[l] <= i.k) {
			add(w[l]);
			++l;
		}
		ans[i.ind] = best[i.a][i.b];
	}
	for (bool i : ans) {
		if (i) {
			std::cout << "Yes\n";
		}
		else {
			std::cout << "No\n";
		}
	}
}