#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <random>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
const int SZ = 3e5;
mt19937 rd(100232103);

int get_best(vector<pair<int, int>>& vec, vector<bool>& used) {
	int n = vec.size();
	int cnt = 0, lst = 0;
	for (int i = 0; i < n; i++) {
		if (!used[i])
			continue;
		if (vec[i].first > lst) {
			lst = vec[i].second;
			cnt++;
		}
	}
	return cnt;
}

struct seg {
	int l, r, ind;
	seg(int l1 = 0, int r1 = 01, int ind1 = -1) : l(l1), r(r1), ind(ind1) {}
};

bool cmp(seg a, seg b) {
	return a.r < b.r;
}

vector<bool> used(SZ, 0);

struct cnm {
	int n;
	vector<int> pr, sz, mx;
	vector<bool> del;

	cnm(int n1) {
		n = n1;
		pr.assign(n, -1);
		sz.assign(n, 0);
		mx.assign(n, 0);
		del.assign(n, 0);
		for (int i = 0; i < n; i++) {
			pr[i] = i;
			mx[i] = i;
		}
	}

	int get_root(int v) {
		if (pr[v] == v)
			return v;
		return pr[v] = get_root(pr[v]);
	}

	void mer(int u, int v) {
		u = get_root(u);
		v = get_root(v);
		if (u == v)
			return;
		if (sz[u] > sz[v])
			swap(u, v);
		mx[v] = max(mx[v], mx[u]);
		sz[v] += sz[u];
		pr[u] = v;
	}
};

set<int> g[SZ];
vector<int> answer;
int pre[SZ], siz[SZ];

void dfs(int v, bool root = 0) {
	if (!root)
		answer.push_back(v);
	for (auto u : g[v])
		dfs(u);
}

void get_ans(int n, vector<seg> vec) {
	vector<int> st = {0};
	siz[0] = 0;
	vec.push_back(seg(0, 1e9 + 1, n));
	for (int i = 1; i <= n; i++) {
		int v = st.back();
		siz[i] = 0;
		pre[i] = -1;
		while (vec[i].l <= vec[v].l && vec[v].r <= vec[i].r) {
			g[i].insert(v);
			pre[v] = i;
			siz[i]++;
			st.pop_back();
			if (st.empty())
				break;
			v = st.back();
		}
		st.push_back(i);
	}

	set<pair<int, int>> del;
	int k = 0;
	cnm ans = cnm(n + 1);
	for (int i = 0; i <= n; i++) {
		if (pre[i] == -1 || siz[pre[i]] > 1)
			continue;
		ans.mer(i, pre[i]);
	}
	for (int i = 0; i <= n; i++)
		if (siz[i] == 0) {
			k++;
			del.insert({ ans.sz[ans.get_root(i)], ans.get_root(i) });
		}

	k = k / 2;
	int kol = n / 2;
	while (k > 0) {
		auto u = del.begin()->second;
		del.erase(del.begin());
		k--;

		u = ans.get_root(u);
		kol -= ans.sz[u];
		ans.del[u] = 1;
		int v = pre[ans.mx[u]];
		if (v == -1)
			continue;
		siz[v]--;
		g[v].erase(ans.mx[u]);
		if (siz[v] == 1) {
			int x = *g[v].begin();
			x = ans.get_root(x);
			del.erase({ ans.sz[x], x });
			ans.mer(x, v);
			x = ans.get_root(x);
			del.insert({ ans.sz[x], x });
		}
	}

	for (int i = 0; i <= n; i++) {
		if (siz[i] != 0 || kol == 0 || ans.del[ans.get_root(i)])
			continue;
		int v = i;
		while (kol > 0 && pre[v] != -1 && siz[pre[v]] <= 1) {
			g[pre[v]].erase(v);
		}
	}
	dfs(n);

	for (auto x : answer)
		cout << vec[x].ind + 1 << ' ';
	cout << endl;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	for (int q = 0; q < t; q++) {
		int n;
		cin >> n;
		vector<seg> vec(n, seg());
		for (int i = 0; i < n; i++) {
			cin >> vec[i].l >> vec[i].r;
			vec[i].ind = i;
		}
		sort(vec.begin(), vec.end(), cmp);

		bool tf = 1;
		for (int i = 1; i < n; i++) {
			if (vec[i].l > vec[i - 1].l && vec[i - 1].r > vec[i].l)
				tf = 0;
		}

		if (tf) {
			get_ans(n, vec);
			continue;
		}

		//
		vector<pair<int, int>> ind(n);
		vector<pair<int, int>> mas(n);
		vector<bool> used(n, 1);
		for (int i = 0; i < n; i++) {
			ind[i] = { i, vec[i].ind };
			mas[i] = { vec[i].l, vec[i].r };
		}
		int m = get_best(mas, used);
		tf = 1;
		while (tf) {
			shuffle(ind.begin(), ind.end(), rd);
			for (int i = 0; i < n; i++)
				used[i] = 0;
			for (int i = 0; i < n / 2; i++)
				used[ind[i].first] = 1;
			if (get_best(mas, used) == m / 2)
				tf = 0;
		}

		for (int i = 0; i < n / 2; i++)
			cout << ind[i].second + 1 << ' ';
		cout << endl;
	}
}