#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <random>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
const int SZ = 3e5;
mt19937 rd(100232103);

void rebuild(vector<vector<vector<bool>>>& dp, vector<vector<vector<bool>>>& ans, ll max_a, ll max_b, vector<ll>& w, int n) {
	dp[0][0][0] = 1;
	for (int i = 1; i <= n; i++) {
		for (ll a = 0; a < max_a; a++) {
			for (ll b = 0; b < max_b; b++) {
				dp[i][a][b] = dp[i - 1][a][b];
				if (a >= w[i])
					dp[i][a][b] = dp[i][a][b] | dp[i - 1][a - w[i]][b];
				if (b >= w[i])
					dp[i][a][b] = dp[i][a][b] | dp[i - 1][a][b - w[i]];
			}
		}
	}
	ans[0][0][0] = 1;
	for (int i = 1; i <= n; i++) {
		ans[i][0][0] = 1;
		for (int j = 1; j < max_a; j++) {
			ans[i][j][0] = ans[i][j - 1][0] & dp[i][j][0];
		}
		for (int j = 1; j < max_b; j++) {
			ans[i][0][j] = ans[i][0][j - 1] & dp[i][0][j];
		}
		for (int a = 1; a < max_a; a++) {
			for (int b = 1; b < max_b; b++)
				ans[i][a][b] = dp[i][a][b] & ans[i][a - 1][b] & ans[i][a][b - 1];
		}
	}
}

struct quest {
	ll k, a, b;
	quest(ll k1, ll a1, ll b1) : a(a1), b(b1), k(k1) {}
};

void tests(int n, int q, vector<ll> w, ll max_a, ll max_b) {
	vector<vector<vector<bool>>> dp;
	vector<vector<vector<bool>>> ans;

	vector<quest> qu(q, quest(0, 0, 0));

	ll z, v = 0;
	bool tf = 0;
	cin >> z;
	for (int i = 0; i < q; i++) {
		ll j, k, a, b, c, d;
		cin >> j >> c >> d;
		k = j - v * z;
		a = c - v * z;
		b = d - v * z;

		qu[i] = quest(k, a, b);

		if (!tf && n > 10 && a > 300) {
			max_a = 1e5 + 1;
			max_b = 1;
			dp = vector<vector<vector<bool>>>(n + 1, vector<vector<bool>>(max_a, vector<bool>(max_b, 0)));
			ans = vector<vector<vector<bool>>>(n + 1, vector<vector<bool>>(max_a, vector<bool>(max_b, 0)));
			rebuild(dp, ans, max_a, max_b, w, n);
			tf = 1;
		}
		if (!tf && n <= 10) {
			max_a = (1 << n) + 2;
			max_b = (1 << n) + 2;
			dp = vector<vector<vector<bool>>>(n + 1, vector<vector<bool>>(max_a, vector<bool>(max_b, 0)));
			ans = vector<vector<vector<bool>>>(n + 1, vector<vector<bool>>(max_a, vector<bool>(max_b, 0)));
			rebuild(dp, ans, max_a, max_b, w, n);
			tf = 1;
		}
	}
	if (!tf) {
		max_a = 300 + 1;
		max_b = 300 + 1;
		dp = vector<vector<vector<bool>>>(n + 1, vector<vector<bool>>(max_a, vector<bool>(max_b, 0)));
		ans = vector<vector<vector<bool>>>(n + 1, vector<vector<bool>>(max_a, vector<bool>(max_b, 0)));
		rebuild(dp, ans, max_a, max_b, w, n);
	}

	for (int i = 0; i < q; i++) {
		ll k = qu[i].k, a = qu[i].a, b = qu[i].b;
		int l = 0, r = n + 1;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (w[mid] <= k) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		if (a < max_a && b < max_b && ans[l][a][b]) {
			v++;
			cout << "Yes" << endl;
		}
		else {
			cout << "No" << endl;
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int n, q;
	cin >> n >> q;
	vector<ll> w(n + 1, 0);
	for (int i = 1; i <= n; i++)
		cin >> w[i];
	sort(w.begin(), w.end());
	tests(n, q, w, 0, 0);
}
