#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <cmath>

using namespace std;

typedef pair<int, int> pii;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()

const int INF = 1e9 + 179;

signed main()
{
	int h, w, k;
	cin >> h >> w >> k;
	vector<pii> pts(k);
	vector<int> x, y;
	for (int i = 0; i < k; i++) {
		cin >> pts[i].X >> pts[i].Y;
		pts[i].X--;
		pts[i].Y--;
		x.push_back(pts[i].X);
		y.push_back(pts[i].Y);
	}
	sort(All(x));
	sort(All(y));

	int min_dx = INF, opt_x = INF;
	int min_dy = INF, opt_y = INF;
	for (int i = 0; i < k; i++) {
		int r = x.back() - x[i];
		if (i > 0)
			r = max(r, h - (x[i] - x[i - 1]));
		pii dr1 = { (i == 0 ? -1 : x[i - 1]) + 1, x[i] };
		pii dr2 = { h - dr1.Y, h - dr1.X };
		int d = min(dr1.X, dr2.X);
		if (r < min_dx || (r == min_dx && d < opt_x)) {
			min_dx = r;
			opt_x = d;
		}
	}
	for (int i = 0; i < k; i++) {
		int r = y.back() - y[i];
		if (i > 0)
			r = max(r, w - (y[i] - y[i - 1]));
		pii dr1 = { (i == 0 ? -1 : y[i - 1]) + 1, y[i] };
		pii dr2 = { w - dr1.Y, w - dr1.X };
		int d = min(dr1.X, dr2.X);
		if (r < min_dy || (r == min_dy && d < opt_y)) {
			min_dy = r;
			opt_y = d;
		}
	}

	cout << 1ll * (min_dx + 1) * (min_dy + 1) << ' ' << abs(opt_x) + abs(opt_y) << '\n';
}