#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <numeric>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;

#define All(x) (x).begin(), (x).end()
#define X first
#define Y second

const ll N = 100 + 5;
const ll A = 300 + 5, B = 300 + 5;

bool dp[N][A][B];

void solve() {
	ll n, q;
	cin >> n >> q;
	vector<ll> w(n), ask_a(q), ask_b(q), ask_k(q);
	for (ll i = 0; i < n; i++)
		cin >> w[i];
	bool case0 = 1;
	ll z; cin >> z;
	for (ll i = 0; i < q; i++) {
		cin >> ask_k[i] >> ask_a[i] >> ask_b[i];
		case0 &= (ask_b[i] == 0);
	}
	sort(All(w));
	if (n <= 10 && q <= 10) {
		for (ll j = 0; j < q; j++) {
			ll k = ask_k[j], a = ask_a[j], b = ask_b[j];
			ll lim = upper_bound(All(w), k) - w.begin();
			set<pii> ans;
			for (ll mask1 = 0; mask1 < (1 << lim); mask1++) {
				for (ll mask2 = 0; mask2 < (1 << lim); mask2++) {
					if (mask1 & mask2) continue;
					ll cur1 = 0, cur2 = 0;
					for (ll i = 0; i < n; i++) {
						if (mask1 & (1 << i))
							cur1 += w[i];
						else if (mask2 & (1 << i))
							cur2 += w[i];
					}
					ans.insert(pii{ min(cur1, cur2), max(cur1, cur2) });
				}
			}
			bool ok = 1;
			for (ll x = 0; ok && x <= a; x++) {
				for (ll y = 0; ok && y <= b; y++) {
					ok &= (ans.count({ min(x, y), max(x, y) }));
				}
			}
			cout << (ok ? "Yes" : "No") << '\n';
		}
	}
	else if (case0) {
		vector<ll> pref(n + 1);
		pref[0] = 0;
		for (ll i = 1; i <= n; i++) {
			ll r = pref[i - 1];
			if (w[i] <= r + 1) {
				r += w[i];
			}
			pref[i] = r;
		}
		for(ll i = 0; i < q; i++){
			ll k = ask_k[i], a = ask_a[i], b = ask_b[i];
			ll lim = upper_bound(All(w), k) - w.begin();
			cout << (a <= pref[lim] ? "Yes" : "No") << '\n';
		}
	}
	else {
		dp[0][0][0] = 1;
		for (ll i = 1; i <= n; i++) {
			ll x = w[i - 1];
			for (ll a = 0; a < A; a++) {
				for (ll b = 0; b < B; b++) {
					dp[i][a][b] |= dp[i - 1][a][b];
					if (a - x >= 0)
						dp[i][a][b] |= dp[i - 1][a - x][b];
					if (b - x >= 0)
						dp[i][a][b] |= dp[i - 1][a][b - x];
				}
			}
		}
		for (ll i = 1; i <= n; i++) {
			for (ll a = 0; a < A; a++) {
				for (ll b = 0; b < B; b++) {
					dp[i][a][b] &= (a == 0 || dp[i][a - 1][b]);
					dp[i][a][b] &= (b == 0 || dp[i][a][b - 1]);
				}
			}
		}
		for (ll j = 0; j < q; j++) {
			ll k = ask_k[j], a = ask_a[j], b = ask_b[j];
			ll i = upper_bound(All(w), k) - w.begin() - 1;
			cout << (dp[i + 1][a][b] ? "Yes" : "No") << '\n';
		}
	}
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	solve();
}