#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>
#include <bitset>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int bit_i(int n, int i) {
	return (n >> i) & 1;
}

const int N = 1500;
bitset<N + 1> dp[N + 1];

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	{
		int z;
		cin >> z;
		assert(z == 0);
	}
	sort(a.begin(), a.end());
	vector<vector<tuple<int, int, int>>> Q(n + 1);
	for (int i = 0; i < m; ++i) {
		int k, x, y;
		cin >> k >> x >> y;
		assert(x <= N);
		assert(y <= N);
		int j = upper_bound(a.begin(), a.end(), k) - a.begin();
		Q[j].emplace_back(x, y, i);
	}
	vector<int> ans(m, 0);
	for (const tuple<int, int, int> &e : Q[0]) {
		if (get<0>(e) == 0 && get<1>(e) == 0) {
			ans[get<2>(e)] = 1;
		}
	}
	for (int i = 0; i <= N; ++i) {
		dp[i].reset();
	}
	dp[0][0] = 1;
	for (int i = 0; i < n; ++i) {
		for (int j = N; j >= 0; --j) {
			dp[j] |= (dp[j] << a[i]);
			if (j >= a[i]) {
				dp[j] |= dp[j - a[i]];
			}
		}
		for (const tuple<int, int, int> &e : Q[i + 1]) {
			int x, y, j;
			tie(x, y, j) = e;
			int ok = 1;
			for (int l = 0; l <= x; ++l) {
				if ((int) (dp[l] << (N - y) >> (N - y)).count() < y + 1) {
					ok = 0;
					break;
				}
			}
			ans[j] = ok;
		}
	}
	for (int i = 0; i < m; ++i) {
		if (ans[i]) {
			cout << "Yes" << endl;
		} else {
			cout << "No" << endl;
		}
	}
}

int32_t main() {
	int T = 1;
#ifdef LOCAL
	cin >> T;
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
	return 0;
}
