#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAL
//ifstream input("input");
//#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int bit_i(int n, int i) {
	return (n >> i) & 1;
}

vector<vector<int>> g;
vector<int> l, r;
vector<vector<int>> dp;

void dfs(int u, int p) {
	dp[u][0] = l[u];
	dp[u][1] = 0;
	for (const int &v : g[u]) {
		if (v != p) {
			dfs(v, u);
			dp[u][0] += dp[v][1];
			dp[u][1] += max(dp[v][0], dp[v][1]);
		}
	}
}

void solve() {
	g.clear();
	int n, m, x, y, mod;
	cin >> n >> m >> x >> y >> mod;
	g.resize(n);
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	l.resize(n);
	r.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> l[i] >> r[i];
	}
	dp.assign(n, vector<int>(2));
	dfs(0, -1);
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		ans ^= (x * (i + 1) + y * l[i] % mod * l[i]) % mod;
	}
	vector<int> qs(m);
	for (int i = 0; i < m; ++i) {
		cin >> qs[i];
		if (qs[i] == max(dp[0][0], dp[0][1])) {
			cout << ans << " ";
		} else {
			cout << -1 << " ";
		}
	}
	cout << endl << flush;
	while (1) {
		int i;
		cin >> i;
		--i;
		if (i == -1) {
			break;
		}
		if (qs[i] != max(dp[0][0], dp[0][1])) {
			cout << -1 << endl << flush;
			continue;
		}
		for (int j = 0; j < n; ++j) {
			cout << l[j] << " ";
		}
		cout << endl;
	}
}

int32_t main() {
	int T = 1;
	cin >> T;
#ifdef LOCAL
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
	return 0;
}
