#include <vector>
#include <iostream>
#include <algorithm>
#include <chrono>
#include <deque>
#include <cmath>
#include <map>
#include <set>

using namespace std;
typedef long long ll;
#define cout_ cout << "-------------------------\n";

ll mod = 1000000007;

#pragma region prints
void print(vector<ll>& vec)
{
	for (int i = 0; i < vec.size(); i++)
		cout << vec[i] << " ";
	cout << endl;
}

void print(vector<pair<ll, ll>>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i].first << " " << vec[i].second << endl;
	}
}
#pragma endregion


ll pow2(ll n, ll k)
{
	if (k == 0)
		return 1;
	if (k == 1)
		return n;
	if (k % 2 == 0)
	{
		ll a = pow2(n, k / 2);
		return a * a % mod;
	}
	else
		return pow2(n, k - 1) * n % mod;
}


int main()
{
	ll n, q;
	cin >> n >> q;

	vector<ll> w(n);
	for (int i = 0; i < n; i++)
		cin >> w[i];
	sort(w.begin(), w.end());
	//print(w);
	//cout_;
	ll Z;
	cin >> Z;
	ll k = 10e18;
	set<ll> sumA, sumB;
	map<pair<ll, ll>, bool> sum;
	ll end = 0;
	while (end < n && w[end] <= k)
		end++;
	ll n = end;
	//cout << end << endl;
	for (int i = 0; i < pow2(3, n); i++)
	{
		ll s1 = 0, s2 = 0;
		//cout << "----------" << i << endl;
		for (int j = 0; j < n; j++)
		{
			ll c = (i / pow2(3, j)) % 3;
			//cout << c;
			if (c == 1)
				s1 += w[j];
			if (c == 2)
				s2 += w[j];
		}
		//cout << endl;
		sumA.insert(s1);
		sumB.insert(s2);
		sum[{ s1, s2 }] = true;
		//cout << s1 << " " << s2 << endl;
	}

	while (q--)
	{
		ll a, b;
		cin >> k >> a >> b;
		if (k != 10e18)
			return 1;


		bool ans = true;
		for (int i = 0; i <= a; i++)
		{
			for (int j = 0; j <= b; j++)
			{
				if (!sum[{i, j}])
				{
					ans = false;
				}
			}
		}
		cout << (ans ? "YES\n" : "NO\n");
	}



}