#include <bits/stdc++.h>
using namespace std;
int mod;

int add(int a, int b) {
    int res = a + b;
    if (res >= mod) {
        res -= mod;
    }
    return res;
}

int times(int a, int b) {
    long long res = a * 1ll * b;
    if (res >= mod) {
        res %= mod;
    }
    return res;
}

const int maxn = 2e5;
vector<int> g[maxn];
long long dp[maxn][2];
int l[maxn], r[maxn];

void dfs(int v, int p) {
    dp[v][1] = l[v];
    for (const int& u : g[v]) {
        if (u != p) {
            dfs(u, v);
            dp[v][0] += max(dp[u][0], dp[u][1]);
            dp[v][1] += dp[u][0];
        }
    }
    // cerr << "v: " << v << ", dp: " << dp[v][0] << ' ' << dp[v][1] << '\n';
}

void solve() {
    int n, qNum;
    cin >> n >> qNum;
    int x, y;
    cin >> x >> y >> mod;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        dp[i][0] = dp[i][1] = 0;
    }
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
    }
    int certif = 0;
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        certif ^= add(times(x, i + 1), times(y, times(l[i], r[i])));
    }
    dfs(0, -1);
    vector<long long> val(qNum);
    for (int iter = 0; iter < qNum; ++iter) {
        cin >> val[iter];
        if (val[iter] != max(dp[0][0], dp[0][1])) {
            cout << -1;
        } else {
            cout << certif;
        }
        if (iter + 1 != qNum) {
            cout << ' ';
        }
    }
    cout << endl;
    int idx;
    cin >> idx;
    while (idx != 0) {
        --idx;
        if (val[idx] != max(dp[0][0], dp[0][1])) {
            cout << -1 << endl;
        } else {
            for (int i = 0; i < n; ++i) {
                cout << l[i] << ' ';
            }
            cout << endl;
        }
        cin >> idx;
    }
}

int main() {
    /*ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);*/

#ifdef LOCAL
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
