#include <iostream>
#include <iomanip>
#include <cmath>
#include <string>
#include <vector>
#include <cassert>
#include <algorithm>
#include <ctime>
#include <random>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

mt19937 gen(time(0));

const ll INF = 2e18;

void solve() {
	ll h, w, k;
	cin >> h >> w >> k;
	vector<pair<ll, ll>> a(k);
	vector<ll> b, b2, c2; // все клетки в строке h
	vector<ll> c; // все клетки в столбце w
	for (ll i = 0; i < k; i++) {
		cin >> a[i].first >> a[i].second;
		b.push_back(a[i].second);
		c.push_back(a[i].first);
	}
	ll min_dist_b = w - 1;
	sort(b.begin(), b.end());
	b.resize(unique(b.begin(), b.end()) - b.begin());
	ll max_cur_dist = -INF;
	for (ll i = 0; i < b.size(); i++) {
		ll cur_dist = b[(i + 1) % b.size()] - b[i] - 1;
		if (cur_dist < 0) {
			cur_dist += w;
		}
		max_cur_dist = max(max_cur_dist, cur_dist);
	}
	min_dist_b = min(min_dist_b, max_cur_dist);
	ll min_dist_c = h - 1;
	sort(c.begin(), c.end());
	c.resize(unique(c.begin(), c.end()) - c.begin());
	max_cur_dist = -INF;
	for (ll i = 0; i < c.size(); i++) {
		ll cur_dist = c[(i + 1) % c.size()] - c[i] - 1;
		if (cur_dist < 0) {
			cur_dist += h;
		}
		max_cur_dist = max(max_cur_dist, cur_dist);
	}
	min_dist_c = min(min_dist_c, max_cur_dist);
	ll ans1 = (w - min_dist_b) * (h - min_dist_c);
	ll min_w = (w - min_dist_b), min_h = (h - min_dist_c);
	cout << ans1 << " ";
	ll cnt_w = 0, cnt_h = 0, cnt_w2 = 0, cnt_h2 = 0;
	ll CUR;
	set<ll> B, B2, C, C2;
	for (ll elem : b) {
		B.insert(elem);
		B2.insert(elem);
	}
	for (ll elem : c) {
		C.insert(elem);
		C2.insert(elem);
	}
	while (true) {
		if (min_w == b.back() - b[0] + 1) {
			break;
		}
		CUR = w - (*B.rbegin()) + 1;
		cnt_w += CUR;
		//CUR = 1;
		/*for (ll& elem : b) {
			elem += CUR;
			if (elem > w) {
				elem -= w;
			}
		}
		sort(b.begin(), b.end());*/
		auto it = B.end(); it--;
		B.erase(it);
		B.insert(1 - cnt_w);
	}
	while (true) {
		if (min_w == b2.back() - b2[0] + 1) {
			break;
		}
		cnt_w2++;
		//CUR = b2[0];
		CUR = 1;
		for (ll& elem : b2) {
			elem -= CUR;
			if (elem < 1) {
				elem += w;
			}
		}
		sort(b2.begin(), b2.end());
	}

	while (true) {
		if (min_h == c.back() - c[0] + 1) {
			break;
		}
		cnt_h++;
		//CUR = h - c.back() + 1;
		CUR = 1;
		for (ll& elem : c) {
			elem += CUR;
			if (elem > h) {
				elem -= h;
			}
		}
		sort(c.begin(), c.end());
	}
	while (true) {
		if (min_h == c2.back() - c2[0] + 1) {
			break;
		}
		cnt_h2++;
		//CUR = c2[0];
		CUR = 1;
		for (ll& elem : c2) {
			elem -= CUR;
			if (elem < 1) {
				elem += h;
			}
		}
		sort(c2.begin(), c2.end());
	}
	cout << min(cnt_h, cnt_h2) + min(cnt_w, cnt_w2);
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	solve();
}