#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <random>
#include <ctime>
#include <set>

using namespace std;

typedef long long ll;

mt19937 gen(time(0));

struct Seg {
	ll l, r, ind;
};

bool operator<(Seg a, Seg b) {
	if (a.r != b.r)
		return a.r < b.r;
	return a.l < b.l;
}

vector<ll> cost;

bool cmp(ll i, ll j) {
	return cost[i] > cost[j];
}

void solve() {
	ll n, m;
	cin >> n;
	vector<Seg> segs(n);
	for (ll i = 0; i < n; i++) {
		cin >> segs[i].l >> segs[i].r;
		segs[i].ind = i;
	}
	sort(segs.begin(), segs.end());
	vector<ll> dp(n + 1, 0);
	for (ll i = 0; i < n; i++) {
		ll l = -1, r = n, mid, ind;
		while (l + 1 < r) {
			mid = (l + r) / 2;
			if (segs[mid].r < segs[i].l) { // отрезок хороший, можно брать
				l = mid;
			}
			else {
				r = mid;
			}
		}
		ind = l;
		dp[i + 1] = max(dp[i], dp[ind + 1] + 1);
	}
	m = dp[n];
	cost.assign(n, 1);
	vector<ll> Stack;
	for (ll i = 0; i < n; i++) {
		while (!Stack.empty() && segs[i].l <= segs[Stack.back()].l) {
			cost[i] += cost[Stack.back()];
			Stack.pop_back();
		}
		Stack.push_back(i);
	}
	vector<vector<ll>> can(n); // в конце can будет главный отрезок
	ll ind = 0;
	for (ll i = 0; i < n; i++) {
		while (!(segs[Stack[ind]].l <= segs[i].l && segs[i].r <= segs[Stack[ind]].r)) {
			ind++;
		}
		can[Stack[ind]].push_back(i);
	}
	sort(Stack.begin(), Stack.end(), cmp);
	ll m2 = m / 2;
	for (ll elem : Stack) {
		for (ll i = can[elem].size() - 1; i >= 0; i--) {
			if (m2 == 0) break;
			cout << segs[can[elem][i]].ind + 1 << " ";
			m2--;
		}
	}
	cout << "\n";
}

int main() {
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}