#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <random>
#include <ctime>
#include <set>

using namespace std;

typedef long long ll;

mt19937 gen(time(0));

struct Seg {
	ll l, r, ind;
};

bool operator<(Seg a, Seg b) {
	if (a.r != b.r)
		return a.r < b.r;
	return a.l < b.l;
}

vector<ll> cost;

bool cmp(ll i, ll j) {
	return cost[i] > cost[j];
}

vector<bool> used;

ll m2;

ll g(vector<Seg>& segs) {
	ll n = segs.size();
	vector<ll> dp(n + 1, 0);
	for (ll i = 0; i < n; i++) {
		ll l = -1, r = n, mid, ind;
		while (l + 1 < r) {
			mid = (l + r) / 2;
			if (segs[mid].r < segs[i].l) { // отрезок хороший, можно брать
				l = mid;
			}
			else {
				r = mid;
			}
		}
		ind = l;
		dp[i + 1] = max(dp[i], dp[ind + 1] + 1);
	}
	return dp[n];
}

ll f(vector<Seg>& segs) {
	ll n = segs.size();
	vector<ll> dp(n + 1, 0);
	vector<ll> p(n + 1, -1);
	vector<bool> give(n + 1, false);
	for (ll i = 0; i < n; i++) {
		ll l = -1, r = n, mid, ind;
		while (l + 1 < r) {
			mid = (l + r) / 2;
			if (segs[mid].r < segs[i].l) { // отрезок хороший, можно брать
				l = mid;
			}
			else {
				r = mid;
			}
		}
		ind = l;
		if (dp[i] > dp[ind + 1] + 1) {
			dp[i + 1] = dp[i];
			p[i + 1] = p[i];
			give[i + 1] = false;
		}
		else {
			dp[i + 1] = dp[ind + 1] + 1;
			p[i + 1] = ind + 1;
			give[i + 1] = true;
		}
	}
	ll CUR = n;
	while (CUR != -1) {
		if (give[CUR] && m2 > 0) { // уберём!
			used[CUR - 1] = false;
			m2--;
		}
		CUR = p[CUR];
	}
	return dp[n];
}

void h(vector<Seg>& segs) {

	ll n = segs.size();
	vector<ll> dp(n + 1, 0);
	vector<ll> p(n + 1, -1);
	vector<bool> give(n + 1, false);
	for (ll i = 0; i < n; i++) {
		ll l = -1, r = n, mid, ind;
		while (l + 1 < r) {
			mid = (l + r) / 2;
			if (segs[mid].r < segs[i].l) { // отрезок хороший, можно брать
				l = mid;
			}
			else {
				r = mid;
			}
		}
		ind = l;
		if (dp[i] > dp[ind + 1] + 1) {
			dp[i + 1] = dp[i];
			if (give[i]) {
				p[i + 1] = i;
			}
			else {
				p[i + 1] = p[i];
			}
			give[i + 1] = false;
		}
		else {
			dp[i + 1] = dp[ind + 1] + 1;
			p[i + 1] = ind + 1;
			give[i + 1] = true;
		}
	}
	ll CUR = n;
	give[0] = true;
	while (CUR != 0) {
		if (give[CUR] && m2 > 0) { // Возьмём!
			cout << segs[CUR - 1].ind + 1 << " ";
			used[CUR - 1] = false;
			m2--;
		}
		CUR = p[CUR];
	}
	for (ll i = 0; i < n; i++) {
		if (used[i] && m2) {
			cout << segs[i].ind + 1 << " ";
			m2--;
		}
	}
	return;
}

void solve() {
	ll n, m;
	cin >> n;
	used.assign(n, true);
	vector<Seg> segs(n), segs2;
	for (ll i = 0; i < n; i++) {
		cin >> segs[i].l >> segs[i].r;
		segs[i].ind = i;
	}
	sort(segs.begin(), segs.end());
	m = g(segs);
	m2 = m / 2; // сколько нужно удалить?
	ll Need_m = m / 2;
	ll New;
	while (m2) {
		f(segs); // удаляем
		segs2 = {};
		for (ll i = 0; i < segs.size(); i++) {
			if (used[i]) {
				segs2.push_back(segs[i]);
			}
		}
		segs = segs2;
		used.assign(segs.size(), true);
		New = g(segs);
		m2 = New - Need_m;
	}
	ll Cur_n = 0;
	for (ll i = 0; i < segs.size(); i++) {
		Cur_n += used[i];
	}
	m2 = n / 2;
	h(segs);
	cout << "\n";
}

int main() {
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}