#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

vector<pair<long long, long long>> g;
long long m;

struct el {
    long long x, t, id;
    el () {}
    el (long long x, long long t, long long id) {
        this->x = x;
        this->t = t;
        this->id = id;
    }
};

bool comp(el a, el b) {
    if (a.x == b.x) {
        return a.t < b.t;
    }
    return a.x < b.x;
}

long long check(vector<pair<long long, long long>> v) {
    set<long long> st;
    for (auto [a, b] : v) {
        st.insert(a);
        st.insert(b);
    }
    map<long long, long long> mp;
    long long id = 1;
    for (auto i : st) {
        mp[i] = id++;
    }
    for (int i = 0; i < v.size(); i++) {
        v[i].first = mp[v[i].first];
        v[i].second = mp[v[i].second];
    }
    vector<el> ev;
    for (int i = 0; i < v.size(); i++) {
        auto[a, b] = v[i];
        ev.push_back(el(a, -1, i));
        ev.push_back(el(b, 1, i));
    }
    sort(ev.begin(), ev.end(), comp);
    vector<long long> dp(id, 0);
    for (auto [x, t, id] : ev) {
        dp[x] = max(dp[x], dp[x - 1]);
        if (t == 1) {
            dp[x] = max(dp[x], dp[v[id].first - 1] + 1);
        }
    }
    /*for (auto i : dp) {
        cout << i << " ";
    } cout << endl;*/
    return dp[dp.size() - 1];
}

long long n;
vector<long long> res;
bool fl = false;

void rec(vector<pair<long long, long long>> &v, long long cur, long long mx, long long m, vector<long long> &id) {
    if (v.size() == n / 2) {
        long long t = check(v);
        if (t == m) {
            res = id;
            fl = true;
        }
        return;
    }
    for (int i = cur; i < mx; i++) {
        v.push_back(g[i]);
        id.push_back(i);
        rec(v, i + 1, mx, m, id);
        id.pop_back();
        v.pop_back();
        if (fl) {
            return;
        }
    }
}

void sol() {
    cin >> n;
    g.clear();
    g.resize(n);
    for (int i = 0; i < n; i++) {
        long long a, b;
        cin >> a >> b;
        g[i] = {a, b};
    }
    long long m = check(g) / 2;
    vector<pair<long long, long long>> v;
    vector<long long> tmp;
    fl = false;
    res.clear();
    rec(v, 0, n, m, tmp);
    for (auto i : res) {
        cout << i + 1 << " ";
    }

}

int main()
{
    long long t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        sol();
    }
    return 0;
}
