#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

vector<vector<long long>> gr;
vector<pair<long long, long long>> dp;
vector<long long> w;

void dfs(long long v, long long pr) {
    if (gr[v].size() == 1) {
        dp[v] = {w[v], 0};
    }
    long long cnt1 = 0, cnt2 = 0;
    for (auto u : gr[v]) {
        if (u != pr) {
            dfs(u, v);
            auto [a, b] = dp[u];
            cnt1 += max(a, b);
            cnt2 += b;
        }
    }
    dp[v] = {cnt2 + w[v], cnt1};
}

void sol() {
    long long n, q, x, y, m;
    cin >> n >> q >> x >> y >> m;
    gr.clear();
    gr.resize(n);
    dp.clear();
    dp.resize(n);
    w.clear();
    w.resize(n);
    for (int i = 0; i < n - 1; i++) {
        long long a, b;
        cin >> a >> b;
        a--;
        b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    for (int i = 0; i < n; i++) {
        long long l, r;
        cin >> l >> r;
        w[i] = l;
    }
    dfs(0, -1);
    long long res = 0;
    for (int i = 0; i < n; i++) {
        res = (   res ^ ((x * (i + 1) + y * w[i] * w[i]) % m )    );
    }
    long long t = max(dp[0].first, dp[0].second);
    long long id = -1;
    for (int i = 0; i < q; i++) {
        long long u;
        cin >> u;
        if (u != t) {
            cout << "-1 ";
        } else {
            cout << res << " ";
            id = i;
        }
    }
    cout << endl;
    long long c;
    cin >> c;
    while (c != 0) {
        c--;
        if (c == id) {
            for (auto j : w) {
                cout << j << " ";
            } cout << endl;
        } else {
            cout << "-1" << endl;
        }
        cin >> c;
    }
}

int main()
{
    long long t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        sol();
    }
    return 0;
}
