#include <bits/stdc++.h>

using namespace std;

#define int long long

/* consts */
const int inf = 1LL << 60;
const int mod = 100000007;

random_device rd;

/* output */
template<typename T1, typename T2>
ostream& operator<<(ostream& s, pair<T1,T2>& p) {
    s << "(" << p.first << ", " << p.second << ")";
    return s;
}

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T& x : a) s << x << " ";
    s << endl;
    return s;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& s, map<T1,T2>& m) {
    for (auto [k, v] : m) {
        s << k << " -> " << m << endl;
    }
    return s;
}

vector<int> nvup(vector<int>& a, int i, bool asc) {
    int mult = asc ? 1 : -1;
    int n = a.size();
    vector<int> dp(n, inf), ind(n, -1), prev(n, -1);
    dp[0] = mult * a[i];
    ind[0] = i;
    int len = 1;
    for (int j = i + 1; j < n; j++) {
        int k = lower_bound(dp.begin(), dp.end(), mult * a[j]) - dp.begin();
        //cout << dp << "\t" << k << endl;
        if (k != 0) {
            dp[k] = mult * a[j];
            ind[k] = j;
            prev[j] = ind[k - 1];
        }
        len = max(len, k + 1);
    }
    //cout << ind << prev;
    vector<int> ans;
    int cur = ind[len - 1];
    while (cur != -1) {
        ans.emplace_back(cur);
        cur = prev[cur];
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

vector<int> nvup(vector<int>& a, vector<int> indexes, bool asc) {
    if (indexes.size() == 0) return {};
    int mult = asc ? 1 : -1;
    int n = a.size();
    vector<int> dp(n, inf), ind(n, -1), prev(n, -1);
    int len = 1;
    dp[0] = mult * a[indexes[0]];
    ind[0] = indexes[0];
    for (int i = 1; i < indexes.size(); i++) {
        int j = indexes[i];
        int k = lower_bound(dp.begin(), dp.end(), mult * a[j]) - dp.begin();
        //cout << j << "  " << dp << ind << prev << "\t" << k << endl;
        dp[k] = mult * a[j];
        ind[k] = j;
        prev[j] = k > 0 ? ind[k - 1] : -1;
        len = max(len, k + 1);
    }
    //cout << ind << prev;
    vector<int> ans;
    int cur = ind[len - 1];
    while (cur != -1) {
        ans.emplace_back(cur);
        cur = prev[cur];
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int i = 0; i < n; i++) cin >> a[i];
        int ans = 0;

        vector<int> dp = nvup(a, 0, true);
        vector<int> indexes;
        int i = 0;
        for (int j = 0; j < n; j++) {
            if (i < dp.size() && dp[i] == j) {
                i++;
            } else {
                indexes.emplace_back(j);
            }
        }
        vector<int> dp2 = nvup(a, indexes, false);
        ans = max(ans, (int) dp.size() + (int) dp2.size());
        //cout << dp << indexes << dp2 << endl;

        dp = nvup(a, 0, false);
        indexes.clear();
        i = 0;
        for (int j = 0; j < n; j++) {
            if (i < dp.size() && dp[i] == j) {
                i++;
            } else {
                indexes.emplace_back(j);
            }
        }
        dp2 = nvup(a, indexes, true);
        ans = max(ans, (int) dp.size() + (int) dp2.size());
        //cout << dp << dp2 << endl;

        cout << ans << endl;
    }
}