#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
#include <deque>
#include <set>
#include <algorithm>
#define ll long long

const ll inf = 1e18;

using namespace std;

ll k;
vector<ll> x, y;

void read() {
	cin >> k;
	x = y = vector<ll>(k);
	for (ll i = 0; i < k; i++) {
		cin >> y[i] >> x[i];
	}
}

pair<ll, ll> getUp(ll h, vector<ll> a) {
	deque<ll> suf, pref;
	set<ll> q;
	for (ll i = 0; i < k; i++) {
		q.insert(a[i]);
	}
	for (auto& to : q) {
		suf.push_back(to);
	}
	ll cur = 0, minDist = suf.back() - suf.front();
	pair<ll, ll> ans = {minDist, cur};
	ll sum = 0;
	while ((ll)suf.size() >= 2) {
		sum -= suf.front() + sum;
		suf.pop_front();
		pref.push_back(h - sum);
		cur++;
		minDist = pref.back() - suf.front();
		ans = min(ans, { minDist, cur });
	}
	return ans;
}

pair<ll, ll> getDown(ll h, vector<ll> a) {
	deque<ll> suf, pref;
	set<ll> q;
	for (ll i = 0; i < k; i++) {
		q.insert(a[i]);
	}
	for (auto& to : q) {
		pref.push_back(to);
	}
	ll cur = 0, minDist = pref.back() - pref.front();
	pair<ll, ll> ans = { minDist, cur };
	ll sum = 0;
	while ((ll)pref.size() >= 2) {
		sum += h - (pref.back() + sum) + 1;
		pref.pop_back();
		suf.push_front(1 - sum);
		cur++;
		minDist = pref.back() - suf.front();
		ans = min(ans, { minDist, cur });
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	
	ll h, w;
	cin >> h >> w;
	read();
	pair<ll, ll> ans1 = min(getUp(h, y), getDown(h, y));
	pair<ll, ll> ans2 = min(getUp(w, x), getDown(w, x));
	cout << (ans1.first + 1) * (ans2.first + 1) << ' ' << ans1.second + ans2.second;

	return 0;
}