#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
#include <deque>
#include <set>
#include <algorithm>
#define ll long long

const ll inf = 1e18;

using namespace std;

void solve1() {
	ll n, k;
	cin >> n >> k;
	vector<ll> u(n, 0);
	for (ll i = 0; i < k; i++) {
		ll c;
		cin >> c;
		c--;
		u[c] = 1;
	}
	ll cnt = 0;
	for (ll i = 0; i < n; i++) {
		if (u[i] == 1) {
			cnt++;
		} else if (cnt > 0) {
			cnt--;
			u[i] = 2;
		}
	}
	if (cnt > 0) {
		for (ll i = 0; i < n && cnt > 0; i++) {
			if (u[i] == 0) {
				cnt--;
				u[i] = 2;
			}
		}
	}
	for (ll i = 0; i < n; i++) {
		if (u[i] == 2) {
			cout << i + 1 << ' ';
		}
	}
	cout << endl;
}

void solve2() {
	ll n, k;
	cin >> n >> k;
	vector<ll> u(n);
	for (ll i = 0; i < k; i++) {
		ll c;
		cin >> c;
		c--;
		u[c] = 2;
	}
	ll last = -1;
	for (ll i = 0; i < n; i++) {
		if (u[i] == 2) {
			for (ll j = i - 1; j >= -n; j--) {
				ll ind = (j + n) % n;
				if (u[ind] == 0) {
					u[ind] = 1;
					break;
				}
			}
		}
	}
	for (ll i = 0; i < n; i++) {
		if (u[i] == 1) {
			cout << i + 1 << ' ';
		}
	}
	cout << endl;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	
	ll a;
	cin >> a;
	ll m;
	cin >> m;
	while (m--) {
		if (a == 1) {
			solve1();
		} else {
			solve2();
		}
	}

	return 0;
}