#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#define ll long long

using namespace std;

ll n;
vector<pair<pair<ll, ll>, ll>> seg;
vector<ll> last;
vector<ll> f;
vector<vector<vector<bool>>> dp;
vector<vector<vector<ll>>> p;

void read() {
	cin >> n;
	seg = vector<pair<pair<ll, ll>, ll>>(n + 1);
	for (ll i = 1; i <= n; i++) {
		cin >> seg[i].first.second >> seg[i].first.first;
		seg[i].second = i;
	}
}

void buildLastF() {
	last = vector<ll>(n + 1, 0);
	f = vector<ll>(n + 1, -1);
	for (ll i = 1; i <= n; i++) {
		ll L = seg[i].first.second, R = seg[i].first.first;
		for (ll j = i - 1; j >= 0; j--) {
			ll l = seg[j].first.second, r = seg[j].first.first;
			if (r < L) {
				last[i] = j;
				break;
			}
		}
	}
}

void buildDp() {
	dp = vector<vector<vector<bool>>>(n + 1, vector<vector<bool>>(n + 1, vector<bool>(n + 1, 0)));
	p = vector<vector<vector<ll>>>(n + 1, vector<vector<ll>>(n + 1, vector<ll>(n + 1, -1)));
	dp[0][0][0] = 1;
	for (ll i = 1; i <= n; i++) {
		for (ll j = 0; j <= n; j++) {
			for (ll k = 0; k <= n; k++) {
				if (j - 1 >= 0 && dp[i - 1][j - 1][k] && seg[i - 1].first.first >= seg[i].first.second) {
					dp[i][j][k] = 1;
					p[i][j][k] = 0;
				}
				if (dp[i - 1][j][k]) {
					dp[i][j][k] = 1;
					p[i][j][k] = 1;
				}
				if (j - 1 >= 0 && k - 1 >= 0 && dp[last[i]][j - 1][k - 1]) {
					dp[i][j][k] = 1;
					p[i][j][k] = 2;
				}
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	ll t;
	cin >> t;
	while (t--) {
		read();
		sort(seg.begin(), seg.end());
		buildLastF();
		buildDp();
		ll pref = n, j = n / 2, k = 0;
		for (ll m = 0; m <= n; m++) {
			if (dp[n][n][m]) k = m;
		}
		k /= 2;
		vector<ll> ans;
		while (p[pref][j][k] != -1) {
			if (p[pref][j][k] == 0) {
				ans.push_back(seg[pref].second);
				pref--;
				j--;
			}
			if (p[pref][j][k] == 1) {
				pref--;
			} 
			if (p[pref][j][k] == 2) {
				ans.push_back(seg[pref].second);
				pref = last[pref];
				j--;
				k--;
			}
		}
		for (auto& to : ans) {
			cout << to << ' ';
		}
		cout << "\n";
	}

	return 0;
}