#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#define ll long long

using namespace std;

ll n;
vector<pair<pair<ll, ll>, ll>> seg;
vector<vector<vector<bool>>> dp;
vector<vector<vector<ll>>> p1, p2;

void read() {
	cin >> n;
	seg = vector<pair<pair<ll, ll>, ll>>(n + 1);
	for (ll i = 1; i <= n; i++) {
		cin >> seg[i].first.second >> seg[i].first.first;
		seg[i].second = i;
	}
}

void buildDp() {
	dp = vector<vector<vector<bool>>>(n + 1, vector<vector<bool>>(n + 1, vector<bool>(n + 1, 0)));
	p1 = vector<vector<vector<ll>>>(n + 1, vector<vector<ll>>(n + 1, vector<ll>(n + 1, -1)));
	p2 = vector<vector<vector<ll>>>(n + 1, vector<vector<ll>>(n + 1, vector<ll>(n + 1, -1)));
	dp[0][0][0] = 1;
	for (ll i = 1; i <= n; i++) {
		for (ll j = 0; j <= n; j++) {
			for (ll k = 0; k <= n; k++) {
				dp[i][j][k] = dp[i - 1][j][k];
				p1[i][j][k] = 0;
				p2[i][j][k] = 0;
				ll L = seg[i].first.second, R = seg[i].first.first;
				for (ll jj = i - 1; jj >= 0; jj--) {
					ll l = seg[jj].first.second, r = seg[jj].first.first;
					if (r < L) {
						if (j - 1 >= 0 && k - 1 >= 0 && dp[jj][j - 1][k - 1]) {
							dp[i][j][k] = dp[jj][j - 1][k - 1];
							p1[i][j][k] = 1;
							p2[i][j][k] = jj;
						}
					} else {
						if (j - 1 >= 0 && dp[jj][j - 1][k]) {
							dp[i][j][k] = dp[jj][j - 1][k];
							p1[i][j][k] = 2;
							p2[i][j][k] = jj;
						}
					}
				}
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	ll t;
	cin >> t;
	while (t--) {
		read();
		sort(seg.begin(), seg.end());
		buildDp();
		ll pref = n, j = n / 2, k = 0;
		for (ll m = 0; m <= n; m++) {
			if (dp[n][n][m]) k = m;
		}
		k /= 2;
		vector<ll> ans;
		while (p1[pref][j][k] != -1) {
			if (p1[pref][j][k] == 0) {
				pref--;
			}
			else if (p1[pref][j][k] == 1) {
				ans.push_back(seg[pref].second);
				pref = p2[pref][j][k];
				j--;
				k--;
			}
			else if (p1[pref][j][k] == 2) {
				ans.push_back(seg[pref].second);
				pref = p2[pref][j][k];
				j--;
			}
		}
		for (auto& to : ans) {
			cout << to << ' ';
		}
		cout << "\n";
	}

	return 0;
}