#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#define ll long long

using namespace std;

const ll inf = 1e18;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	ll n, q, z;
	cin >> n >> q;
	vector<ll> w(n + 1);
	for (ll i = 1; i <= n; i++) {
		cin >> w[i];
	}
	cin >> z;
	sort(w.begin(), w.end());
	vector<vector<vector<bool>>> dp(n + 1, vector<vector<bool>>(100001, vector<bool>(1, false)));
	dp[0][0][0] = true;
	for (ll i = 1; i <= n; i++) {
		for (ll a = 0; a <= 100000; a++) {
			for (ll b = 0; b <= 0; b++) {
				dp[i][a][b] = dp[i - 1][a][b];
				if (a - w[i] >= 0) {
					dp[i][a][b] = dp[i][a][b] || dp[i - 1][a - w[i]][b];
				}
				if (b - w[i] >= 0) {
					dp[i][a][b] = dp[i][a][b] || dp[i - 1][a][b - w[i]];
				}
			}
		}
	}
	vector<vector<ll>> res(n + 1, vector<ll>(100001));
	for (ll i = 0; i <= n; i++) {
		bool flag = 1;
		for (ll a = 0; a <= 100000; a++) {
			flag &= dp[i][a][0];
			res[i][a] = flag;
		}
	}
	ll v = 0;
	for (ll i = 1; i <= q; i++) {
		ll j, c, d;
		cin >> j >> c >> d;
		ll k = j - v * z;
		ll a = c - v * z;
		ll b = d - v * z;
		ll l = 0, r = n + 1;
		while (r - l > 1) {
			ll mid = (l + r) / 2;
			if (w[mid] <= k) l = mid;
			else r = mid;
		}
		ll ans = res[l][a];
		if (ans) {
			cout << "Yes\n";
			v += i;
		} else {
			cout << "No\n";
		}
	}

	return 0;
}