#include <iostream>
#include <bits/stdc++.h>
#include <random>
#define int long long

using namespace std;

mt19937_64 rnd(17112004);

const int inf = 1ll << 63;

struct Node {
    int val, pr, sz, ma;
    Node* l;
    Node* r;

    Node(int x) {
        pr = rnd();
        l = r = nullptr;
        sz = 1;
        ma = val = x;
    }
};

int get_sz(Node* t) {
    if (t == nullptr) {
        return 0;
    }
    return t->sz;
}

int get_ma(Node* t) {
    if (t == nullptr) return inf;
    return t->ma;
}

void upd(Node* t) {
    if (t == nullptr) return;
    t->sz = get_sz(t->l) + get_sz(t->r) + 1;
    t->ma = max(max(get_ma(t->l), get_ma(t->r)), t->val);
}

pair<Node*, Node*> split(Node* t, int x){
    if (t == nullptr) {
        return {nullptr, nullptr};
    }
    if (t->val < x) {
        auto n = split(t->r, x);
        t->r = n.first;
        upd(t);
        return {t, n.second};
    } else {
        auto n = split(t->l, x);
        t->l = n.second;
        upd(t);
        return {n.first, t};
    }
}

Node* merge(Node* l, Node* r) {
    if (l == nullptr) {
        return r;
    }
    if (r == nullptr) {
        return l;
    }
    if (l->pr > r->pr) {
        auto n = merge(l->r, r);
        l->r = n;
        upd(l);
        return l;
    } else {
        auto n = merge(l, r->l);
        r->l = n;
        upd(r);
        return r;
    }
}

void insert(Node* &t, int x) {
    auto n = split(t, x);
    t = merge(merge(n.first, new Node(x)), n.second);
}

int mi(Node* t, int x) {
    int ans = 0;
    while (t != nullptr) {
        if (t->val <= x) {
            ans += get_sz(t->l) + 1;
            t = t->r;
        } else {
            t = t->l;
        }
    }
    return ans;
}

void pereliv(Node* l, Node* &r) {
    if (l == nullptr) return;
    pereliv(l->l, r);
    pereliv(l->r, r);
    insert(r, l->val);
}

void dfs(int x, vector<pair<int, int>> &a, int p, int k, vector<Node*> &dd, int m, vector<int> &dist) {
    if (a[x].first == -1) {
        dd[x] = new Node(k);
    } else {
        if (p == 2) {
            dfs(a[x].first, a, 0, k, dd, m, dist);
            dfs(a[x].second, a, 1, k, dd, m, dist);
        } else if (p) {
            dfs(a[x].first, a, 0, k + 1, dd, m, dist);
            dfs(a[x].second, a, 1, k, dd, m, dist);
        } else {
            dfs(a[x].first, a, 0, k, dd, m, dist);
            dfs(a[x].second, a, 1, k + 1, dd, m, dist);
        }
        if (get_sz(dd[a[x].first]) > get_sz(dd[a[x].second])) {
            pereliv(dd[a[x].second], dd[a[x].first]);
            dd[x] = dd[a[x].first];
        } else {
            pereliv(dd[a[x].first], dd[a[x].second]);
            dd[x] = dd[a[x].second];
        }
    }
    dist[x] = mi(dd[x], m);
}

void solve() {
    int n, k, q;
    cin >> n >> k >> q;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        char t;
        cin >> t;
        if (t == '0') {
            a[i] = {-1, -1};
        } else {
            int x, y;
            cin >> x >> y;
            a[i] = {x - 1, y - 1};
        }
    }
    vector<Node*> dd(n, nullptr);
    vector<int> dist(n, 0);
    dfs(0, a, 2, 0, dd, k, dist);
    for (int i = 0; i < q; i++) {
        int x;
        cin >> x;
        cout << dist[x - 1] << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    while (t-->0) {
        solve();
    }
}
