#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl '\n'

typedef tree <int64_t, null_type, less <int64_t>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 1e18;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
//    cout.tie(0);
}

int R = 1;
vector <vector <int>> tr;

vector <int> upd(vector <int> &a, vector <int> &b){
    int i = 0, j = 0;
    vector <int> c;
    while (i < a.size() && j < b.size()){
        if (a[i] < b[j]) c.push_back(a[i]), i++;
        else c.push_back(b[j]), j++;
    }
    for (i; i < a.size(); i++){
        c.push_back(a[i]);
    }
    for (j; j < b.size(); j++){
        c.push_back(b[j]);
    }
    return c;
}

void build(){
    for (int i = R - 1; i > 0; i--){
        tr[i] = upd(tr[i * 2], tr[i * 2 + 1]);
    }
}

int get(int ql, int qr, int nl, int nr, int node, int l, int r){
    if (nl >= qr || ql >= nr) return 0;
    if (nl >= ql && nr <= qr) return lower_bound(tr[node].begin(), tr[node].end(), r) - upper_bound(tr[node].begin(), tr[node].end(), l);
    int nm = (nl + nr) / 2;
    return get(ql, qr, nl, nm, node * 2, l, r) + get(ql, qr, nm, nr, node * 2 + 1, l, r);
}

void height(int n){
    while (R < n) R *= 2;
}

bool cmp(vector <int> &a, vector <int> &b){
    return a[1] < b[1] || a[1] == b[1] && a[0] < b[0];
}

signed main() {
    Fast();
    int t;
    cin >> t;
    while (t--){
        int n;
        cin >> n;
        vector <vector <int>> p(n);
        vector <int> l(n), r(n);
        for (int i = 0; i < n; i++){
            cin >> l[i] >> r[i];
            p[i] = {l[i], r[i], i};
        }
        sort(l.begin(), l.end());
        sort(r.begin(), r.end());
        sort(p.begin(), p.end(), cmp);
        height(n);
        tr.resize(2 * R);
        int m = 0;
        int rg = 0;
        for (int i = 0; i < n; i++){
            if (rg < p[i][0]) rg = p[i][1], m++;
            tr[i + R].push_back(p[i][0]);
        }
        vector <vector <int>> dp(n, vector <int> (m / 2 + 1, INF));
        vector <vector <int>> par(n, vector <int> (m / 2 + 1));
        for (int i = 0; i < n; i++){
            for (int j = 0; j < min(m / 2, i); j++){
                if (j == 0){
                    dp[i][j] = i;
                    par[i][j] = -1;
                    continue;
                }
                for (int y = 0; y < i; y++){
                    int ind = lower_bound(r.begin(), r.end(), p[i][0]) - r.begin();
                    int cnt = dp[y][j - 1] + get(0, ind, 0, R, 1, p[y][1], p[i][0]);
                    if (dp[i][j] > cnt){
                        par[i][j] = y;
                        dp[i][j] = cnt;
                    }
                }
            }
        }
        int ind = -1;
        for (int i = 0; i < n; i++){
            if (dp[i][m / 2 - 1] + get(i + 1, n, 0, R, 1, p[i][1], INF) <= n / 2){
                ind = i;
            }
        }
        vector <int> g;
        int e = m / 2 - 1;
        while (ind != -1){
            g.push_back(ind);
            ind = par[ind][e];
            e--;
        }
        int c = g.size();
        for (int i = 0; i < n; i++){
            bool flag = false;
            for (int j = 0; j < c; j++){
                if (i == g[j]){
                    flag = false;
                    break;
                }
                if (p[i][0] <= p[g[j]][1] && p[g[j]][0] <= p[i][0] || p[g[j]][0] <= p[i][1] && p[i][0] <= p[g[j]][0]) flag = true;
            }
            if (flag && c < n / 2) g.push_back(i), c++;
        }
        for (auto i:g){
            cout << p[i][2] + 1 << " ";
        }
        cout << endl;
    }
    return 0;
}
