#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>

using namespace std;

typedef long long ll;
typedef long double dl;

ll bi(vector <ll>& a)
{
	ll n = a.size(), ma = 0, ans = 0;
	for (auto i : a)
	{
		if (i > ma)
		{
			ans++;
			ma = i;
		}
	}
	return ans;
}
ll le(vector <ll>& a)
{
	ll n = a.size(), mi = 1e18, ans = 0;
	for (auto i : a)
	{
		if (i < mi)
		{
			ans++;
			mi = i;
		}
	}
	return ans;
}
/*
ll ans = 0;
vector <ll> a = { 0 };
ll mex(vector <ll>& a)
{
	ll m = 0;
	for (auto i : a)
	{
		if (i == m - 1) continue;
		else if (i == m) m++;
		else return m;
	}
	return m;
}
void f(ll n, ll k, ll p)
{
	if (a.size() == n)
	{
		vector <ll> k = a;
		ll last = -1;
		while (1)
		{
			ll m = mex(a);
			vector <ll> s;
			for (auto i : a) s.push_back(i ^ (m - 1));
			sort(s.begin(), s.end());
			if (m == last)
			{
				if (m == p) ans++;
				a = k;
				return;
			}
			a = s;
			last = m;
		}
	}
	for (ll i = a.back() + 1; (1ll << k) - i >= n - a.size(); i++)
	{
		a.push_back(i);
		f(n, k, p);
		a.pop_back();
	}
}
*/

pair <ll, ll> cnt(ll l, ll r, ll mi, vector <ll>& a)
{
	ll cnt = 0;
	for (ll j = l; j <= r; j++)
	{
		if (a[j] < mi)
		{
			mi = a[j];
			cnt++;
		}
	}
	return {mi, cnt};
}
ll fast(ll n, vector <ll>& a)
{
	ll ans = 0;
	vector <vector <vector <ll>>> dp(n + 1, vector <vector <ll>>(n + 1, vector <ll>(n + 2, -1e18)));
	dp[1][a[0]][n + 1] = 1;
	for (ll i = 2; i <= n; i++)
	{
		auto [mi, cn] = cnt(0, i - 2, 1e18, a);
		dp[i][a[i - 1]][mi] = cn + 1;
		for (ll j = 1; j < i; j++)
		{
			for (ll mi = 1; mi <= n + 1; mi++)
			{
				auto [mii, cn] = cnt(j, i - 2, mi, a);
				for (ll ma = 1; ma < a[i - 1]; ma++)
				{
					dp[i][a[i - 1]][mii] = max(dp[i][a[i - 1]][mii], dp[j][ma][mi] + cn + 1);
					ans = max(ans, dp[i][a[i - 1]][mii]);
				}
			}
			for (ll mi = 1; mi <= n + 1; mi++)
			{
				auto [mii, cn] = cnt(j, i - 2, mi, a);
				for (ll ma = a[i - 1] + 1; ma <= n; ma++)
				{
					dp[i][ma][mii] = max(dp[i][ma][mii], dp[j][ma][mi] + cn);
					ans = max(ans, dp[i][ma][mii]);
				}
			}
		}
	}
	for (ll j = 1; j <= n; j++)
	{
		for (ll ma = 1; ma <= n; ma++)
		{
			for (ll mi = 1; mi <= n + 1; mi++)
			{
				ans = max(ans, dp[j][ma][mi] + cnt(j, n - 1, mi, a).second);
			}
		}
	}
	return ans;
}
ll slow (ll n, vector <ll>& a)
{
	ll ans = 0;
	for (ll i = 1; i < (1 << n) - 1; i++)
	{
		vector <ll> s, k;
		for (ll j = 0; j < n; j++)
		{
			if (i & (1 << j))
			{
				s.push_back(a[j]);
			}
			else
			{
				k.push_back(a[j]);
			}
		}
		ans = max(ans, bi(s) + le(k));
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	random_device rd;
	mt19937 gen(rd());
	
	/*
	while (1)
	{
		ll n = gen() % 10 + 2;
		vector <ll> a(n);
		for (ll i = 0; i < n; i++) a[i] = i + 1;
		shuffle(a.begin(), a.end(), gen);
		if (slow(n, a) != fast(n, a))
		{
			cout << n << "\n";
			for (auto i : a) cout << i << " ";
			cout << "\n";
			cout << slow(n, a) << " " << fast(n, a) << "\n";
			break;
		}
	}
	*/
	
	ll t;
	cin >> t;
	while (t--)
	{
		ll n;
		cin >> n;
		vector <ll> a(n);
		for (ll i = 0; i < n; i++) cin >> a[i];
		cout << fast(n, a) << "\n";
	}
	
	
	

	/*
	ll mod, t;
	cin >> mod >> t;
	while (t--)
	{
		ans = 0;
		ll k, n, p;
		cin >> k >> n >> p;
		f(n, k, p);
		cout << ans << "\n";
	}
	*/

	/*
	vector <ll> dp(n, 1e18), p1(n, -1);
	ll a1 = 0;
	for (ll i = 0; i < n; i++)
	{
		ll in = lower_bound(dp.begin(), dp.end(), a[i]) - dp.begin();
		if (dp[in] == 1e18) a1++;
		dp[in] = a[i];
		if (in == a1 - 1) p1[a[i] - 1] = a1;
	}
	reverse(a.begin(), a.end());
	vector <ll> dpr(n, 1e18), p2(n, -1);
	ll a2 = 0;
	for (ll i = 0; i < n; i++)
	{
		ll in = lower_bound(dpr.begin(), dpr.end(), a[i]) - dpr.begin();
		if (dpr[in] == 1e18) a2++;
		dpr[in] = a[i];
		if (in == a2 - 1) p2[a[i] - 1] = a2;
	}
	//cout << a1 << " " << a2 << " - dl\n";
	reverse(a.begin(), a.end());
	vector <vector <ll>> s1(n);
	for (ll i = 0; i < n; i++)
	{
		if (p1[i] != -1) s1[p1[i] - 1].push_back(a[i]);
	}
	vector <bool> pol1(n);
	for (ll i = 0; i < n; i++)
	{
		if (s1[i].size() == 1) pol1[s1[i][0] - 1] = true;
	}
	reverse(a.begin(), a.end());
	vector <vector <ll>> s2(n);
	for (ll i = 0; i < n; i++)
	{
		if (p2[i] != -1) s2[p2[i] - 1].push_back(a[i]);
	}
	vector <bool> pol2(n);
	for (ll i = 0; i < n; i++)
	{
		if (s2[i].size() == 1) pol2[s2[i][0] - 1] = true;
	}
	bool g = true;
	for (ll i = 0; i < n; i++)
	{
		bool h = false;
		for (auto j : s1[i])
		{
			if (!pol2[j - 1]) h = true;
		}
		if (!h) g = false;
	}
	for (ll i = 0; i < n; i++)
	{
		bool h = false;
		for (auto j : s2[i])
		{
			if (!pol1[j - 1]) h = true;
		}
		if (!h) g = false;
	}
	if (g) cout << a1 + a2 << "\n";
	else cout << a1 + a2 - 1 << "\n";
	*/

	/*ll t;
	cin >> t;
	if (t == 1)
	{
		ll m;
		cin >> m;
		while (m--)
		{
			ll n, k;
			cin >> n >> k;
			vector <ll> a(k);
			for (ll i = 0; i < k; i++) cin >> a[i];
			if (k == n / 2 && n % 2 == 0)
			{
				vector <bool> used(n);
				for (ll i = 0; i < k; i++) used[a[i] - 1] = true;
				for (ll i = 0; i < n; i++)
				{
					if (!used[i]) cout << i + 1 << " ";
				}
				cout << "\n";
				continue;
			}
			map <ll, ll> mp;
			for (auto i : a) mp[i]++;
			for (ll i = 1; i < n; i++)
			{
				for (ll j = 0; j < k; j++)
				{
					if (a[j] == 1) a[j] = n;
					else a[j]--;
				}
				bool g = true;
				for (auto j : a)
				{
					if (mp.find(j) != mp.end())
					{
						g = false;
						break;
					}
				}
				if (g)
				{
					sort(a.begin(), a.end());
					for (auto i : a) cout << i << " ";
					cout << "\n";
					break;
				}
			}
		}
	}
	else
	{
		ll m;
		cin >> m;
		while (m--)
		{
			ll n, k;
			cin >> n >> k;
			vector <ll> a(k);
			for (ll i = 0; i < k; i++) cin >> a[i];
			if (k == n / 2 && n % 2 == 0)
			{
				vector <bool> used(n);
				for (ll i = 0; i < k; i++) used[a[i] - 1] = true;
				for (ll i = 0; i < n; i++)
				{
					if (!used[i]) cout << i + 1 << " ";
				}
				cout << "\n";
				continue;
			}
			map <ll, ll> mp;
			for (auto i : a) mp[i]++;
			for (ll i = 1; i < n; i++)
			{
				for (ll j = 0; j < k; j++)
				{
					if (a[j] == n) a[j] = 1;
					else a[j]++;
				}
				bool g = true;
				for (auto j : a)
				{
					if (mp.find(j) != mp.end())
					{
						g = false;
						break;
					}
				}
				if (g)
				{
					sort(a.begin(), a.end());
					for (auto i : a) cout << i << " ";
					cout << "\n";
					break;
				}
			}
		}
	}
	*/

	return 0;
}
/*

C

1
8
5 8 2 6 3 1 4 7

4
5
4 1 2 3 5
10
3 8 10 4 1 2 7 9 5 6
3
1 2 3
6
4 2 5 1 6 3


B

1
2
2 1
1
5 2
1 4

2
2
5 2
2 3
2 1
2


*/