#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <unordered_map>
using namespace std;
typedef long long ll;

struct node
{
	ll l, r, in;
};
const int N = 2e5;
ll t[4 * N];
void build(ll v, ll tl, ll tr)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		build(2 * v, tl, tm);
		build(2 * v + 1, tm + 1, tr);
		t[v] = 0;
	}
}
void upd(ll v, ll tl, ll tr, ll pos, ll x)
{
	if (tl == tr) t[v] = x;
	else
	{
		ll tm = (tl + tr) / 2;
		if (pos <= tm) upd(2 * v, tl, tm, pos, x);
		else upd(2 * v + 1, tm + 1, tr, pos, x);
		t[v] = max(t[2 * v], t[2 * v + 1]);
	}
}
ll get(ll v, ll tl, ll tr, ll l, ll r)
{
	if (r < l) return 0;
	if (tl == l && tr == r) return t[v];
	ll tm = (tl + tr) / 2;
	return max(get(2 * v, tl, tm, l, min(tm, r)), get(2 * v + 1, tm + 1, tr, max(tm + 1, l), r));
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t;
	cin >> t;
	while (t--)
	{
		ll n;
		cin >> n;
		vector <ll> f;
		vector <node> a(n);
		for (ll i = 0; i < n; i++)
		{
			cin >> a[i].l >> a[i].r;
			a[i].in = i;
			f.push_back(a[i].l);
			f.push_back(a[i].r);
		}
		sort(f.begin(), f.end());
		map <ll, ll> mp;
		ll cnt = 0;
		mp[f[0]] = cnt++;
		for (ll i = 1; i < 2 * n; i++)
		{
			if (f[i] != f[i - 1])
			{
				mp[f[i]] = cnt++;
			}
		}
		for (ll i = 0; i < n; i++)
		{
			a[i].l = mp[a[i].l];
			a[i].r = mp[a[i].r];
		}
		vector <ll> dpl(n), dpr(n);
		sort(a.begin(), a.end(), [](node& l, node& r) 
			{
				if (l.r == r.r) return l.l < r.l;
				return l.r < r.r;
			});
		build(1, 0, cnt - 1);
		for (ll i = n - 1; i >= 0; i--)
		{
			dpl[a[i].in] = get(1, 0, cnt - 1, a[i].r + 1, cnt - 1) + 1;
			upd(1, 0, cnt - 1, a[i].l, dpl[a[i].in]);
		}

		sort(a.begin(), a.end(), [](node& l, node& r)
			{
				if (l.l == r.l) return l.r < r.r;
				return l.l < r.l;
			});
		build(1, 0, cnt - 1);
		for (ll i = 0; i < n; i++)
		{
			dpr[a[i].in] = get(1, 0, cnt - 1, 0, a[i].l - 1) + 1;
			upd(1, 0, cnt - 1, a[i].r, dpr[a[i].in]);
		}
		ll ma = 0;
		for (auto i : dpl) ma = max(ma, i);
		ll c1 = 0;
		for (auto i : dpl) if (i > ma / 2) c1++;
		ll c2 = 0;
		for (auto i : dpr) if (i > ma / 2) c2++;
		vector <ll> ans;
		if (c1 <= n / 2)
		{
			for (ll i = 0; i < n; i++)
			{
				if (dpl[i] <= ma / 2)
				{
					ans.push_back(i + 1);
					if (ans.size() == n / 2) break;
				}
			}
		}
		else if (c2 <= n / 2)
		{
			for (ll i = 0; i < n; i++)
			{
				if (dpr[i] <= ma / 2)
				{
					ans.push_back(i + 1);
					if (ans.size() == n / 2) break;
				}
			}
		}
		for (auto i : ans) cout << i << " ";
		cout << "\n";
	}

	return 0;
}
/*

2
8
12 14
1 3
2 4
1 10
5 6
7 9
8 10
11 13
6
1 2
2 4
1 2
1 4
5 7
6 8


*/