#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <unordered_map>
using namespace std;
typedef long long ll;

struct node
{
	ll l, r, in;
};
struct poli
{
	ll val, in;
};
const int N = 2e5;
poli t[4 * N];
void build(ll v, ll tl, ll tr)
{
	if (tl == tr) t[v] = { 0, -1 };
	else
	{
		ll tm = (tl + tr) / 2;
		build(2 * v, tl, tm);
		build(2 * v + 1, tm + 1, tr);
		t[v] = { 0, -1 };
	}
}
void upd(ll v, ll tl, ll tr, ll pos, ll x, ll ttt)
{
	if (tl == tr)
	{
		if (t[v].val < x)
		{
			t[v] = { x, ttt };
		}
	}
	else
	{
		ll tm = (tl + tr) / 2;
		if (pos <= tm) upd(2 * v, tl, tm, pos, x, ttt);
		else upd(2 * v + 1, tm + 1, tr, pos, x, ttt);
		if (t[2 * v].val > t[2 * v + 1].val) t[v] = t[2 * v];
		else t[v] = t[2 * v + 1];
	}
}
poli get(ll v, ll tl, ll tr, ll l, ll r)
{
	if (r < l) return { 0, -1 };
	if (tl == l && tr == r) return t[v];
	ll tm = (tl + tr) / 2;
	poli s1 = get(2 * v, tl, tm, l, min(tm, r));
	poli s2 = get(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
	if (s1.val > s2.val) return s1;
	return s2;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t;
	cin >> t;
	while (t--)
	{
		ll n;
		cin >> n;
		vector <ll> f;
		vector <node> a(n);
		for (ll i = 0; i < n; i++)
		{
			cin >> a[i].l >> a[i].r;
			a[i].in = i;
			f.push_back(a[i].l);
			f.push_back(a[i].r);
		}
		sort(f.begin(), f.end());
		map <ll, ll> mp;
		ll cnt = 0;
		mp[f[0]] = cnt++;
		for (ll i = 1; i < 2 * n; i++)
		{
			if (f[i] != f[i - 1])
			{
				mp[f[i]] = cnt++;
			}
		}
		for (ll i = 0; i < n; i++)
		{
			a[i].l = mp[a[i].l];
			a[i].r = mp[a[i].r];
		}
		vector <ll> dpl(n), dpr(n), pl(n), pr(n);
		sort(a.begin(), a.end(), [](node& l, node& r) 
			{
				if (l.r == r.r) return l.l < r.l;
				return l.r < r.r;
			});
		build(1, 0, cnt - 1);
		for (ll i = n - 1; i >= 0; i--)
		{
			poli v = get(1, 0, cnt - 1, a[i].r + 1, cnt - 1);
			dpl[a[i].in] = v.val + 1;
			pl[a[i].in] = v.in;
			upd(1, 0, cnt - 1, a[i].l, dpl[a[i].in], a[i].in);
		}

		sort(a.begin(), a.end(), [](node& l, node& r)
			{
				if (l.l == r.l) return l.r < r.r;
				return l.l < r.l;
			});
		build(1, 0, cnt - 1);
		for (ll i = 0; i < n; i++)
		{
			poli v = get(1, 0, cnt - 1, 0, a[i].l - 1);
			dpr[a[i].in] = v.val + 1;
			pr[a[i].in] = v.in;
			upd(1, 0, cnt - 1, a[i].r, dpr[a[i].in], a[i].in);
		}
		ll ma = 0;
		for (auto i : dpl) ma = max(ma, i);
		ll c1 = 0;
		for (auto i : dpl) if (i > ma / 2) c1++;
		ll c2 = 0;
		for (auto i : dpr) if (i > ma / 2) c2++;
		vector <ll> ans;
		vector <bool> used(n);
		if (c2 <= n / 2)
		{
			ll in = 0;
			for (ll i = 0; i < n; i++)
			{
				if (dpr[i] == ma / 2)
				{
					in = i;
					break;
				}
			}
			while (in != -1)
			{
				ans.push_back(in + 1);
				used[in] = true;
				in = pr[in];
			}
			for (ll i = 0; i < n; i++)
			{
				if (ans.size() == n / 2) break;
				if (!used[i] && dpr[i] <= ma / 2)
				{
					ans.push_back(i + 1);
					used[i] = true;
				}
			}
		}
		else
		{
			ll in = 0;
			for (ll i = 0; i < n; i++)
			{
				if (dpl[i] == ma / 2)
				{
					in = i;
					break;
				}
			}
			while (in != -1)
			{
				ans.push_back(in + 1);
				used[in] = true;
				in = pl[in];
			}
			for (ll i = 0; i < n; i++)
			{
				if (ans.size() == n / 2) break;
				if (!used[i] && dpl[i] <= ma / 2)
				{
					ans.push_back(i + 1);
					used[i] = true;
				}
			}
		}
		for (auto i : ans) cout << i << " ";
		cout << "\n";
	}

	return 0;
}
/*

2
8
12 14
1 3
2 4
1 10
5 6
7 9
8 10
11 13
6
1 2
2 4
1 2
1 4
5 7
6 8


*/