#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
const long long INF=(long long)(1e9+7);

int h,w,k;
set <pair<int,int>> table;

vector <int> Sr,Sc;
int main() {
    cin >> h >> w >> k;
    Sr.push_back(0);
    Sc.push_back(0);
    for (int i=0;i<k;i++) {
        int r,c;
        cin >> r >> c;
        Sr.push_back(--r);
        Sc.push_back(--c);
        Sr.push_back(r+h);
        Sc.push_back(c+w);
        Sr.push_back(r-h+1);
        Sc.push_back(c-w+1);
        table.insert({r,c});
    }

    sort(Sr.begin(),Sr.end());
    Sr.resize(unique(Sr.begin(),Sr.end())-Sr.begin());
    sort(Sc.begin(),Sc.end());
    Sc.resize(unique(Sc.begin(),Sc.end())-Sc.begin());

    long long minAns=INF*INF;
    long long secAns=-1;
    for (int i=0;i<Sr.size();i++) {
        if (0<=Sr[i] && Sr[i]<h) {
            for (int j=0;j<Sc.size();j++) {
                if (0<=Sc[j] && Sc[j]<w) {
                    int lasti=lower_bound(Sr.begin(),Sr.end(),Sr[i]+h)-Sr.begin(),
                    lastj=lower_bound(Sc.begin(),Sc.end(),Sc[j]+w)-Sc.begin();

                    int ri=lasti,rj=lastj,rsi=i,rsj=j;
                    for (int si=i;si<lasti;si++) {
                        for (int sj=j;sj<lastj;sj++) {
                            if (table.find({Sr[si]%h,Sc[sj]%w})!=table.end()) {
                                ri=min(ri,si);
                                rj=min(rj,sj);
                                rsi=max(rsi,si);
                                rsj=max(rsj,sj);
                            }
                        }
                    }
                    long long newAns=(long long)(Sr[rsi]-Sr[ri]+1)*(Sc[rsj]-Sc[rj]+1);
                    long long newSecAns=min(Sr[i],h-Sr[i])+min(Sc[j],w-Sc[j]);
                    if (newAns<minAns) {
                        minAns=newAns;
                        secAns=newSecAns;
                    } else if (newAns==minAns) {
                        secAns=min(secAns,newSecAns);
                    }
                }
            }
        }
    }
    cout << minAns << " " << secAns << "\n";
}
