#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <random>
#include <math.h>

using namespace std;

#define int long long
#define endl '\n'
#define all(v) v.begin(), v.end()
using ll = long long;

mt19937 rnd(777);

const int N = 500 + 9;
const ll INF = 1e18 + 9;

struct Seg {
	int l = 0, r = 0, ind = 0;
};
bool operator <(Seg a, Seg b) {
	return a.r < b.r;
}

int dp[N][N], p[N][N];
int used[N];
void solve() {
	int n;
	cin >> n;
	vector<Seg> seg(n);
	for (int i = 0; i < n; i++) {
		cin >> seg[i].l >> seg[i].r;
		seg[i].ind = i;
	}
	
	sort(all(seg));
	for (int i = 0; i <= n; i++) {
		used[i] = 0;
		for (int j = 0; j <= n; j++) {
			dp[i][j] = INF;
			p[i][j] = -1;
		}
	}
	for (int i = 0; i < n; i++) {
		dp[i][1] = i;
		p[i][1] = -1;
		for (int j = 0; j < i && seg[j].r < seg[i].l; j++) {
			int minval = 0;
			for (int k = j + 1; k < i; k++) {
				if (seg[k].l > seg[j].r)
					minval++;
			}
			for (int t = 2; t <= n; t++) {
				if (dp[j][t - 1] == INF)
					continue;

				if (dp[i][t] > dp[j][t - 1] + minval) {
					dp[i][t] = dp[j][t - 1] + minval;
					p[i][t] = j;
				}
			}
		}
	}
	int m = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= n; j++) {
			if (dp[i][j] != INF)
				m = max(m, j);
		}
	}
	if (m % 2) {
		cout << "NOOOOOOOO";
		return;
	}
	int ind = -1, t = m /2;
	for (int i = 0; i < n; i++) {
		int cnt = dp[i][m / 2];
		for (int j = i + 1; j < n; j++) {
			if (seg[j].l > seg[i].r)
				cnt++;
		}
		if (cnt <= n / 2) {
			ind = i;
			break;
		}
	}
	vector<int> v;
	while (ind != -1) {
		v.push_back(ind);
		ind = p[ind][t];
		t--;
	}
	reverse(all(v));
	int last = 0, j = 0;
	vector<int> del;
	for (auto i : v) {
		used[i] = 1;
		while (j < i) {
			if (seg[j].l > last) {
				del.push_back(j);
				used[j] = 2;
			}
			j++;
		}
		j++;
		last = seg[i].r;
	}
	while (j < n) {
		if (seg[j].l > last) {
			del.push_back(j);
			used[j] = 2;
		}
		j++;
	}
	for (int i = 0; i < n; i++) {
		if (!used[i] && del.size() < n / 2) {
			del.push_back(i);
			used[i] = 2;
		}
	}
	for (int i = 0; i < n; i++) {
		if (used[i] != 2) {
			cout << seg[i].ind + 1 << " ";
		}
	}
	cout << endl;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif

	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}