#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
#include <math.h>

using namespace std;

#define int long long
#define endl '\n'
#define all(v) v.begin(), v.end()
using ll = long long;
using ld = long double;

mt19937 rnd(777);

const int N = 300 + 9, N2 = 3e5 + 9, N3 = 1030, M = 1e5+ 9;
const ll INF = 1e18 + 9;

int a[N];
int dp[2][N][N];
int ans[N][N];

struct Q {
	int a, b, k, ind;
};

bool operator <(Q a, Q b) {
	return a.k < b.k;
}

int ansq[N2];

int  dp3[N2];
int dp4[N3][N3];

void solve(int n, vector<Q> q) {
	dp3[0] = 1;
	for (int i = 0; i < n; i++) {
		a[i] %= N2;
		for (int j = N2; j >= 0; j--) {

			if (a[i] <= j)
				dp3[j] = max(dp3[j], dp3[j - a[i]]);
			else {
				dp3[j] = max(dp3[j], dp3[j + M - a[i]]);
			}
		}
	}
	for (int i = 1; i < N2; i++) {
		dp3[i] = min(dp3[i], dp3[i - 1]);
	}
	for (int i = 0; i < q.size(); i++) {
		ansq[q[i].ind] = dp3[q[i].a];
	}
	for (int i = 0; i < q.size(); i++) {
		if (ansq[i])
			cout << "Yes\n";
		else
			cout << "No\n";
	}
}

int f = 1;

void rec(int i, int x, int y, int n, int k) {
	if (x >= N3 || y >= N3)
		return;
	if (i == n) {
		dp4[x][y] = 1;
		return;
	}

	rec(i + 1, x, y, n, k);
	if (a[i] > k)
		return;
	rec(i + 1, x + a[i], y, n, k);

	rec(i + 1, x, y + a[i], n, k);

}

void solve2(int n, vector<Q> q) {
	for (auto q : q) {
		for (int i = 0; i < N3; i++) {
			for (int j = 0; j < N3; j++) {
				dp4[i][j] = 0;
			}
		}
		if (q.a >= N3 || q.b >= N3) {
			cout << "No\n";
			continue;
		}

		rec(0, 0, 0, n, q.k);
		int f = 1;
		for (int i = 0; i <= q.a; i++) {
			for (int j = 0; j <= q.b; j++) {
				if (dp4[i][j] == 0) {
					f = 0;
					break;
				}
			}
		}
		if (f)
			cout << "Yes\n";
		else
			cout << "No\n";

	}
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif

	int n, m, z;
	cin >> n >> m;
	vector<int> val;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	sort(a, a + n);
	cin >> z;
	vector<Q> q(m);
	int f = 1;
	for (int i = 0; i < m; i++) {
		cin >> q[i].k >> q[i].a >> q[i].b;
		if (q[i].b)
			f = 0;
		q[i].ind = i;
	}
	if (n <= 10 && m <= 10) {
		solve2(n, q);
		return 0;
	}
	if (f) {
		solve(n, q);
		return 0;
	}
	for (int i = 0; i < m; i++) {
		q[i].k = upper_bound(a, a + n, q[i].k) - a - 1;
		if (q[i].k == -1 && q[i].a == 0 && q[i].b == 0)
			ansq[i] = 1;
	}
	sort(all(q));
	reverse(all(q));
	while (q.size() && q.back().k == -1)
		q.pop_back();
	dp[0][0][0] = 1;

	for (int t = 0; t < n; t++) {
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				dp[1][i][j] = dp[0][i][j];
				if (i >= a[t])
					dp[1][i][j] |= dp[0][i - a[t]][j];
				if (j >= a[t])
					dp[1][i][j] |= dp[0][i][j - a[t]];
			}
		}

		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				dp[0][i][j] = dp[1][i][j];
				if (!i && !j) {
					ans[i][j] = 1;
					continue;
				}
				if (i == 1)
					i = i;
				if (!j)
					ans[i][j] = ans[i - 1][j] && dp[0][i][j];
				else if (!i)
					ans[i][j] = ans[i][j - 1] && dp[0][i][j];
				else
					ans[i][j] = ans[i - 1][j] && ans[i][j - 1] && dp[0][i][j];
			}
		}
		while (q.size() && q.back().k == t) {
			ansq[q.back().ind] = ans[q.back().a][q.back().b];
			q.pop_back();
		}
	}
	for (int i = 0; i < m; i++) {
		if (ansq[i])
			cout << "Yes\n";
		else
			cout << "No\n";
	}
}