#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
#include <math.h>

using namespace std;

#define int long long
#define endl '\n'
#define all(v) v.begin(), v.end()
using ll = long long;
using ld = long double;

mt19937 rnd(777);

const int N = 1e6 + 9;
const ll INF = 1e18 + 9;

int dp[N][2];
int l[N], r[N];

vector<int> g[N];
int per[N];

void dfs(int v, int p) {
	dp[v][0] = 0;
	dp[v][1] = r[v];
	for (auto u : g[v]) {
		if (u == p)
			continue;
		dfs(u, v);
		dp[v][0] += dp[u][1];
		dp[v][1] += dp[u][0];
	}
	if (dp[v][1] > dp[v][0])
		per[v] = 1;
	dp[v][1] = max(dp[v][1], dp[v][0]);
}



int used[N];

void rec(int v, int p, int t) {
	if (t == 0) {
		for (auto u : g[v]) {
			if (u == p)
				continue;
			rec(u, v, 1);
		}
		return;
	}
	int t2 = 1;
	if (per[v]) {
		used[v] = 1;
		t2 = 0;
	}

	for (auto u : g[v]) {
		if (u == p)
			continue;
		rec(u, v, t2);
	}
}


int k[N], v[N];
int prefxor[N];
int pref[N], sufxor[N];

void solve() {
	int n, q;
	cin >> n >> q;

	for (int i = 0; i <= n; i++) {
		g[i].clear();
	}
	int x, y, m;
	cin >> x >> y >> m;
	for (int i = 0; i < n - 1; i++) {
		int v, u;
		cin >> v >> u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	int k0 = 0;
	int f = 1;
	for (int i = 1; i <= n; i++) {
		cin >> l[i] >> r[i];
		if (l[i] != r[i])
			f = 0;
		k0 ^= ((i * x + (y * r[i]) % m * r[i]) % m);
	}
	dfs(1, 0);
	int mxval = dp[1][1];
	

	if (f) {
		for (int i = 1; i <= q; i++) {
			int v;
			cin >> v;
			if (v != dp[1][1])
				k[i] = -1;
			else
				k[i] = k0;
			cout << k[i] << " ";
		}
		cout << endl;
		while (true) {
			int i;
			cin >> i;
			if (!i)
				break;
			if (k[i] == -1) {
				cout << -1 << endl;
			}
			else {
				for (int i = 1; i <= n; i++)
					cout << r[i] << " ";
				cout << endl;
			}
		}
		return;
	}
	rec(1, 0, 1);
	/*
	for (int i = 1; i <= n; i++)
		if (used[i])
			cout << i << " ";
	cout << endl << endl;
	*/
	for (int i = 1; i <= n; i++) {
		if (!used[i])
			r[i] = 0;
		prefxor[i] = prefxor[i - 1] ^ ((x * i + (y * r[i]) % m * r[i]) % m);
		pref[i] = pref[i - 1] + r[i];
	}
	sufxor[n + 1] = 0;
	for (int i = n; i >= 1; i--) {
		sufxor[i] = sufxor[i + 1] ^ ((x * i) % m);
	}
	
	for (int t = 1; t <= q; t++) {
		cin >> v[t];
		if (v[t] > mxval)
			k[t] = -1;
		else {

			int cnt = v[t];
			for (int i = 1; i <= n; i++) {
				if (cnt >= r[i]) {
					k[t] ^= ((x * i + (y * r[i]) % m * r[i]) % m);
					cnt -= r[i];
				}
				else {
					k[t] ^= ((x * i + (y * cnt) % m * cnt) % m);
					cnt = 0;
				}
			}
			

			/*
			int i = lower_bound(pref, pref + n + 1, v[t]) - pref;
			if (i == 0)
				i++;
			int val = v[t] - pref[i - 1];
			k[t] = prefxor[i - 1] ^ sufxor[i + 1] ^ ((x * i + (y * val) % m * val) % m);
			*/
		}
		cout << k[t] << " ";
	}
	cout << endl;

	while (true) {
		int i;
		cin >> i;
		if (!i)
			break;
		if (k[i] == -1) {
			cout << -1 << endl;
		}
		else {
			int cnt = v[i];
			for (int i = 1; i <= n; i++) {
				if (cnt >= r[i]) {
					cout << r[i] << " ";
					cnt -= r[i];
				}
				else {
					cout << cnt << " ";
					cnt = 0;
				}
			}
			cout << endl;
		}
	}
}


signed main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#else
	//cin.tie(0);
	//ios_base::sync_with_stdio(0);
#endif
		
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}