#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

void generate_sequences(int n, int i, int length, vector <int> current, vector <vector <int>> &result, int last) {
	if (i == length) {
		result.push_back(current);
		return;
	}

	for (int j = last + 1; j <= n; j++) {
		current.push_back(j);
		generate_sequences(n, i + 1, length, current, result, j);
		current.pop_back();
	}	
}

bool intersects(vector <int> &a, vector <int> &b) {
	unordered_set <int> seen;
	for (int x: a)
		seen.insert(x);

	for (int x: b) {
		if (seen.find(x) != seen.end()) {
			return true;
		}
	}

	return false;
}

void generate_encodings(vector <vector <int>>& sequences, vector <int> &encodings) {
	int total = sequences.size();

	vector <int> options (total);
	iota(options.begin(), options.end(), 0);

	for (int i = 0; i < total; i++) {
		vector <int> removed;
		while (!options.empty() && intersects(sequences[i], sequences[options.back()])) {
			removed.push_back(options.back());
			options.pop_back();
		}

		assert(!options.empty());

		encodings.push_back(options.back());	
		options.pop_back();

		for (int x: removed) {
			options.push_back(x);
		}
	}


}

void solve_run_1() {
	int n, k;
	cin >> n >> k;

	vector <int> current;
	vector <vector <int>> seqs;
	generate_sequences(n, 0, k, current, seqs, 0);

	vector <int> encodings;
	generate_encodings(seqs, encodings);

	vector <int> a(k);
	for (int &x: a) cin >> x;

	for (int i = 0; i < seqs.size(); i++) {
		if (seqs[i] == a) {
			for (int x: seqs[encodings[i]])
				cout << x << ' ';
			cout << '\n';
			return;
		}
	}
}

void solve_run_2() {
	int n, k;
	cin >> n >> k;

	vector <int> current;
	vector <vector <int>> seqs;
	generate_sequences(n, 0, k, current, seqs, 0);

	vector <int> encodings;
	generate_encodings(seqs, encodings);

	vector <int> a(k);
	for (int &x: a) cin >> x;

	for (int i = 0; i < seqs.size(); i++) {
		if (seqs[encodings[i]] == a) {
			for (int x: seqs[i])
				cout << x << ' ';
			cout << '\n';
			return;
		}
	}
}

signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	int run;
	cin >> run;

	int m;
	cin >> m;

	while (m--) {
		if (run == 1) {
			solve_run_1();
		} else {
			solve_run_2();
		}
	}
}