#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

struct Meeting {
	int l, r, id;
};

void solve() {
	int n;
	cin >> n;

	int meeting_id = 1;
	vector <Meeting> meetings(n);
	for (auto &me: meetings) {
		cin >> me.l >> me.r;
		me.id = meeting_id++;
	}

	sort(meetings.begin(), meetings.end(), [&] (auto lhs, auto rhs) {
		return lhs.r < rhs.r;
	});

	auto find_m = [&] (int mask) {
		vector <int> dp(n, 1);
		for (int i = 0; i < n; i++) {
			if (!(mask & (1 << i))) continue;
			for (int j = 0; j < i; j++) {
				if (!(mask & (1 << j))) continue;
				if (meetings[j].r < meetings[i].l) {
					dp[i] = max(dp[i], dp[j] + 1);
				}
			}
		}

		return *max_element(dp.begin(), dp.end());
	};

	int initial_m = find_m((1 << n) - 1);
	assert(initial_m % 2 == 0);

	for (int mask = 0; mask < (1 << n); mask++) {
		int count = 0;
		for (int i = 0; i < n; i++) {
			if (mask & (1 << i)) {
				count++;
			}
		}

		if (count != n / 2)
			continue;

		int new_m = find_m(mask);

		if (new_m == initial_m / 2) {
			for (int i = 0; i < n; i++) {
				if (mask & (1 << i)) {
					cout << meetings[i].id << ' ';
				}
			}

			cout << '\n';
			return;
		}
	}

	assert(false);
}

signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	int t;
	cin >> t;

	while (t--)
	solve();
}