#include "bits/stdc++.h"

using namespace std;


#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(x) cout << #x << " = " << (x) << endl;

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

struct Segment {
    int l, r, index;
    Segment () : l(0), r(0) {}
    Segment (int lx, int rx) : l(lx), r(rx) {}
    bool operator < (const Segment &other) {
        if (l == other.l) {
            return r > other.r;
        }
        return l < other.l;
    }
};

const int N = 4e5 + 10;

vector<int> g[N];

bool used[N];
int d[N];
int sz[N];
vector<int> t;

void dfs (int u, int p = -1) {
    used[u] = true;
    d[u] = 0;
    sz[u] = 1;
    for (auto v : g[u]) {
        if (v == p) continue;
        dfs(v, u);
        d[u] += d[v];
        sz[u] += sz[v];
    }
    if (d[u] == 0) d[u] = 1;
    t.push_back(u);
}

vector<int> zxc;

int can;
int leaf;
vector<int> Global;

bool borrow (int u, int p = -1) {
    bool child = true;
    bool Can = false;
    for (auto v : g[u]) {
        if (v == p) continue;
        auto ok = borrow(v, u);
        Can |= ok;
        child = false;
    }
    if (child && leaf > 0) {
        Global.push_back(u);
        leaf--;
    } else if (Can && can > 0) {
        can--;
        Global.push_back(u);
    }
    if (Can || child) return true;
    return false;
}

void solve() {
    int n;
    cin >> n;
    fill(used, used + n, false);
    Global.clear();
    zxc.clear();
    can = leaf = 0;
    vector<Segment> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i].l >> s[i].r;
        s[i].index = i;
        g[i].clear();
    }
    sort(all(s));
    vector<int> st;
    for (int i = 0; i < n; i++) {
        if (sz(st) == 0) {
            st.push_back(i);
            // конец
        } else {
            while (sz(st)) {
                if (s[i].l >= s[st.back()].r) {
                    st.pop_back();
                } else {
                    break;
                }
            }
            if (sz(st)) {
                g[st.back()].push_back(i);
            }
            st.push_back(i);
        }
    }
    vector<int> roots;
    vector<int> sizes;
    vector<int> cnt;
    int All = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            t.clear();
            dfs(i);
            roots.push_back(i);
            sizes.push_back(sz[i]);
            cnt.push_back(d[i]);
            All += d[i]; // кол во листьев
        }
    }
    vector<int> ind(sz(roots));
    iota(all(ind), 0ll);
    sort(all(ind), [&] (int a, int b) {
         return cnt[a] > cnt[b];
    });
    int MidN = n / 2, MidM = All / 2;
    can = MidN - MidM;
    leaf = MidM;
    for (int i = 0; i < sz(ind); i++) {
        int who = ind[i];
        borrow(roots[who]);
    }
    for (auto v : Global) {
        zxc.push_back(s[v].index);
    }
    sort(all(zxc));
    for (int i = 0; i < sz(zxc); i++) {
        cout << zxc[i] + 1 << " ";
    }
    cout << endl;
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}