#include <iostream>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 300000;

vector <int> c[MAXN];
int ni[MAXN];
int m;

int f(int x, int k, int n){
    return (x - 1 + k + n) % n + 1;
}
int d(int x, int y, int  n){
    if (x > y) swap(x, y);
    return min(y - x, n - y + x);
}

void Alice_1(){
    for (int _ = 0; _ < m; _++){
        vector <int> a = c[_];
        int n = ni[_];
        cout << a[0] % n + 1 << endl;
    }
}
void Bob_1(){
    for (int _ = 0; _ < m; _++){
        vector <int> a = c[_];
        int n = ni[_];
        cout << (a[0] == 1 ? n : a[0] - 1) << endl;
    }
}

void Alice_2(){
    for (int _ = 0; _ < m; _++){
        vector <int> a = c[_];
        int n = ni[_];
        vector <int> c;
        if (d(a[1], a[0], n) != 1) for (int i : a) c.push_back(f(i, 1, n));
        else for (int i : a) c.push_back(f(i, 2, n));
        sort(c.begin(), c.end());
        for (int i : c) cout << i << ' ';
        cout << endl;
    }
}
void Bob_2(){
    for (int _ = 0; _ < m; _++){
        vector <int> a = c[_];
        int n = ni[_];
        vector <int> c;
        if (d(a[1], a[0], n) != 1) for (int i : a) c.push_back(f(i, -1, n));
        else for (int i : a) c.push_back(f(i, -2, n));
        sort(c.begin(), c.end());
        for (int i : c) cout << i << ' ';
        cout << endl;
    }
}

void Alice_half(){
    for (int _ = 0; _ < m; _++){
        vector <int> a = c[_];
        int n = ni[_];
        vector <int> us(n + 1, 0);
        for (int  i : a) us[i] = 1;
        for (int i = 1; i <= n; i ++) if (us[i] == 0) cout << i << ' ';
        cout << endl;
    }
}
void Bob_half(){
    for (int _ = 0; _ < m; _++){
        vector <int> a = c[_];
        int n = ni[_];
        vector <int> us(n + 1, 0);
        for (int  i : a) us[i] = 1;
        for (int i = 1; i <= n; i ++) if (us[i] == 0) cout << i << ' ';
        cout << endl;
    }
}

void Alice_rare(){
    for (int _ = 0; _ < m; _++){
        vector <int> a = c[_];
        int n = ni[_];
        vector <int> c;
        for (int i : a) c.push_back(f(i, 1, n));
        sort(c.begin(), c.end());
        for (int i : c) cout << i << ' ';
        cout << endl;
    }
}
void Bob_rare(){
    for (int _ = 0; _ < m; _++){
        vector <int> a = c[_];
        int n = ni[_];
        vector <int> c;
        for (int i : a) c.push_back(f(i, -1, n));
        sort(c.begin(), c.end());
        for (int i : c) cout << i << ' ';
        cout << endl;
    }
}

void Alice_rhalf(){
    for (int _ = 0; _ < m; _++){
        vector <int> a = c[_];
        int n = ni[_];
        vector <int> c;
        for (int i : a) c.push_back(f(i, (n + 1) / 2, n));
        sort(c.begin(), c.end());
        for (int i : c) cout << i << ' ';
        cout << endl;
    }
}
void Bob_rhalf(){
    for (int _ = 0; _ < m; _++){
        vector <int> a = c[_];
        int n = ni[_];
        vector <int> c;
        for (int i : a) c.push_back(f(i, -((n + 1) / 2), n));
        sort(c.begin(), c.end());
        for (int i : c) cout << i << ' ';
        cout << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t; cin >> t;
     cin >> m;
    int mnk = 1000000, mxk = 0;
    int fl = 1;
    int fl2 = 1;
    int fl3 = 1;
    int fl4 = 1;
    for (int i = 0; i < m; i ++){
        cin >> ni[i];
        int ki; cin >> ki; c[i].resize(ki);
        for (int&j : c[i]) cin >> j;
        mnk = min(mnk, ki);
        mxk = max(mxk, ki);
        if (ki * 2 != ni[i]) fl = 0;
        if (c[i].back() > ni[i] - 1 && t == 1) fl2 = 0;
        for (int j = 1; j < ki; j ++){
            if (c[i][j] - c[i][j - 1] < 2) fl2 = 0;
        }
        for (int j : c[i]){
            if (j * 2 > ni[i] - 2) fl3 = 0;
            if (j <= (ni[i] + 1) / 2)fl4 = 0;
        }
    }
    if (mnk == 1 && mxk == 1){
        if (t == 1) Alice_1();
        if (t == 2) Bob_1();
        return 0;
    }
    if (mnk == 2 && mxk == 2){
        if (t == 1) Alice_2();
        if (t == 2) Bob_2();
        return 0;
    }
    if (fl){
        if (t == 1) Alice_half();
        if (t == 2) Bob_half();
        return 0;
    }
    if (fl2){
        if (t == 1) Alice_rare();
        if (t == 2) Bob_rare();
        return 0;
    }
    if ((t == 1 && fl3) || (t == 2 && fl4)){
        if (t == 1) Alice_rhalf();
        if (t == 2) Bob_rhalf();
        return 0;
    }
}
