#pragma GCC optimize("Ofast", "inline", "no-stack-processor")
#include <bits/stdc++.h>
using namespace std;

#define endl "\n"
//#define int long long
#define all(a) a.begin(), a.end()
#define uni(a) sort(all(a)); a.erase(unique(all(a)), a.end())
#define pii pair<int, int>
#define X first
#define Y second

using namespace std;

template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = b1;
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = b1;
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T> &a) {
    for (auto &it : a) {
        in << it << ' ';
    }
    return in;
}

int get_m(vector<pii> &a, int sz) {
    int n = sz;
    vector<int> dp(n, 0);
    vector<int> ask(n, -1);

    for (auto &it : a) {
        rmax(ask[it.Y], it.X);
    }

    for (int i = 1; i < n; i++) {
        if (ask[i] != -1) {
            dp[i] = max(dp[i - 1], dp[ask[i] - 1] + 1);
        } else {
            dp[i] = dp[i - 1];
        }
    }
    return dp.back();
}

struct query {
    int pos, len, ind;
};

const int MAXN = 1e5 + 1;
unordered_set<int> adj[MAXN];
unordered_set<int> leaves_my[MAXN];
int par[MAXN];
int depth[MAXN];
int predi[MAXN];

void dfs(int v, int d, int pred) {
    depth[v] = d;
    predi[v] = pred;

    if (adj[v].size() > 1) {
        pred = v;
    }

    if (adj[v].size() == 0) {
        leaves_my[pred].insert(v);
    }

    for (auto &it : adj[v]) {
        dfs(it, d + 1, pred);
    }
}

void solve() {
    int n;
    cin >> n;

    for (int i = 0; i <= n; i++) {
        adj[i].clear();
        leaves_my[i].clear();
    }
    vector<pii> a(n);
    vector<int> my;

    for (int i = 0; i < n; i++) {
        cin >> a[i].X >> a[i].Y;
        my.push_back(a[i].X);
        my.push_back(a[i].Y);
        my.push_back(a[i].X - 1);
        my.push_back(a[i].Y - 1);
    }
    uni(my);
    for (pii &it : a) {
        it.X = lower_bound(all(my), it.X) - my.begin();
        it.Y = lower_bound(all(my), it.Y) - my.begin();
    }

    int m = get_m(a, my.size());


    int root = n;
    par[root] = root;
    a.push_back({-1, 1e9 + 1});

    for (int j = 0; j < root; j++) {
        pii it = a[j];
        int beg = root;
        for (int i = 0; i < root; i++) {
            pii gh = a[i];
            if (i == j) {
                continue;
            }

            if (gh.X <= it.X && gh.Y >= it.Y) {
                if (gh.X == it.X && gh.Y == it.Y) {
                    if (i < j) {
                        beg = i;
                    }
                }
                if (a[beg].X < gh.X) {
                    beg = i;
                } else if (a[beg].X == gh.X && a[beg].Y > gh.Y) {
                    beg = i;
                }
            }
        }
        par[j] = beg;
    }

    for (int i = 0; i < n; i++) {
        adj[par[i]].insert(i);
    }

    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (adj[i].size() == 0) {
            cnt++;
        }
    }

    dfs(root, 0, root);
    set<pii> leaves;

    assert(m == cnt);
    int m1 = cnt / 2;

    for (int i = 0; i < n; i++) {
        if (adj[i].size() == 0) {
            leaves.insert({depth[i] - depth[predi[i]], i});
        }
    }

    vector<bool> deleted(n + 1, 0);
    int cnt2 = n / 2;

    while (m1 > 0) {
        int ind = -1;

        for (int i = 0; i < n; i++) {
            if (deleted[i]) {
                continue;
            }
            if (adj[i].size() == 0) {
                if (ind == -1) {
                    ind = i;
                }

                if (depth[i] - depth[predi[i]] < depth[ind] - depth[predi[ind]]) {
                    ind = i;
                }
            }
        }

        int v = ind;

        while (v != predi[ind]) {
            adj[par[v]].erase(v);
            cnt2--;
            deleted[v] = 1;
            v = par[v];
        }

        dfs(root, 0, root);
        m1--;
    }

    for (int i = 0; i < n; i++) {
        if (!deleted[i] && adj[i].size() == 0) {
            continue;
        }

        if (deleted[i]) {
            continue;
        }

        deleted[i] = 1;
        cnt2--;

        if (cnt2 <= 0) {
            break;
        }
    }

    assert(cnt2 == 0 && m1 == 0);
    for (int i = 0; i < n; i++) {
        if (!deleted[i]) {
            cout << i + 1 << ' ';
        }
    }
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}
