#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

struct DSUh {
	vector<int> pr;
	DSUh(int n) {
		for (int i = 0; i <= n; ++i)
			pr.push_back(i);
		pr[n] = 0;
	}

	int find(int v) {
		return pr[v] = (pr[v] == v ? v : find(pr[v]));
	}

	void merge(int v, int u) {
		v = find(v);
		u = find(u);
		pr[v] = u;
	}

	void set(int v) {
		merge(v, v + 1);
	}

};

struct DSUr {
	vector<int> pr;
	DSUr(int n) {
		for (int i = 0; i <= n; ++i)
			pr.push_back(i);
		pr[0] = n;
	}

	int find(int v) {
		return pr[v] = (pr[v] == v ? v : find(pr[v]));
	}

	void merge(int v, int u) {
		v = find(v);
		u = find(u);
		pr[v] = u;
	}

	void set(int v) {
		merge(v, v - 1);
	}

};

bool solveh1(int n, int k, vector<int>& c) {
	if (k != 1) return false;
	int x = c[0];
	if (x == n)
		cout << 1 << "\n";
	else
		cout << x + 1 << "\n";
	return true;
}

bool solveh2(int n, int k, vector<int>& c) {
	if (k != 2) return false;
	int x1 = c[0], x2 = c[1];
	vector<int> arr(5000 + 113);
	arr[x1 - 1] = 1;
	arr[x2 - 1] = 1;
	int sol1, sol2;
	int i = x1 - 1;
	while (true) {
		i = (i + 1) % n;
		if (arr[i] == 0) {
			sol1 = i + 1;
			arr[i] = 1;
			break;
		}
	}

	i = x2 - 1;
	while (true) {
		i = (i + 1) % n;
		if (arr[i] == 0) {
			sol2 = i + 1;
			arr[i] = 1;
			break;
		}
	}

	if (sol1 > sol2) swap(sol1, sol2);
	cout << sol1 << " " << sol2 << "\n";
	return true;
}

bool solveh3(int n, int k, vector<int>& c) {
	if (k * 2 != n) return false;
	vector<int> arr(n);
	for (int i = 0; i < k; ++i) {
		int x = c[i];
		arr[x - 1] = 1;
	}

	for (int i = 0; i < n; ++i) {
		if (arr[i] == 0)
			cout << i + 1 << " ";
	}
	cout << "\n";
	return true;
}

bool solveh5(int n, int k, vector<int>& c) {
	bool flag = (c[k - 1] != n);
	for (int i = 1; i < k; ++i)
		if (c[i] - c[i - 1] == 1)
			flag = false;
	if (!flag) return false;
	for (int i : c)
		cout << i + 1 << " ";
	cout << "\n";
	return true;
}

bool solveh6(int n, int k, vector<int>& c) {
	if (c[1] - c[0] > n / 2) return false;
	for (int i : c) {
		int x = (i + n / 2) % n;
		cout << (x == 0 ? n : x) << " ";
	}
	return true;
}

bool solvehn(int n, int k, vector<int>& c) {
	DSUh d(n);
	for (int i : c)
		d.set(i - 1);
	vector<int> sol;
	for (int i : c) {
		sol.push_back(d.find(i - 1) + 1);
		d.set(d.find(i - 1));
	}

	sort(sol.begin(), sol.end());
	for (int i : sol)
		cout << i << " ";
	cout << "\n";
	return true;
}

void solveh() {
	int n, k;
	cin >> n >> k;
	vector<int> arr(k);
	for (int& i : arr) cin >> i;
	if (solveh1(n, k, arr)) return;
	if (solveh2(n, k, arr)) return;
	if (solveh3(n, k, arr)) return;
	if (solveh5(n, k, arr)) return;
	if (solveh6(n, k, arr)) return;
	if (solvehn(n, k, arr)) return;
}

bool solver1(int n, int k, vector<int>& c) {
	if (k != 1) return false;
	int x = c[0];
	if (x == 1)
		cout << n << "\n";
	else
		cout << x - 1 << "\n";
	return true;
}

bool solver2(int n, int k, vector<int>& c) {
	if (k != 2) return false;
	int x1 = c[0], x2 = c[1];
	vector<int> arr(5000 + 113);
	arr[x1 - 1] = 1;
	arr[x2 - 1] = 1;
	int sol1, sol2;
	int i = x1 - 1;
	while (true) {
		i = (n + i - 1) % n;
		if (arr[i] == 0) {
			sol1 = i + 1;
			arr[i] = 1;
			break;
		}
	}

	i = x2 - 1;
	while (true) {
		i = (n + i - 1) % n;
		if (arr[i] == 0) {
			sol2 = i + 1;
			arr[i] = 1;
			break;
		}
	}
	if (sol1 > sol2) swap(sol1, sol2);
	cout << sol1 << " " << sol2 << "\n";
	return true;
}

bool solver5(int n, int k, vector<int>& c) {
	bool flag = (c[0] != 1);
	for (int i = 1; i < k; ++i)
		if (c[i] - c[i - 1] == 1)
			flag = false;
	if (!flag) return false;
	for (int i : c)
		cout << i - 1 << " ";
	cout << "\n";
	return true;
}

bool solver6(int n, int k, vector<int>& c) {
	if (c[1] - c[0] > n / 2) return false;
	for (int i : c) {
		int x = (n + i - n / 2) % n;
		cout << (x == 0 ? n : x) << " ";
	}
	cout << "\n";
	return true;
}


bool solvern(int n, int k, vector<int>& c) {
	DSUr d(n);
	for (int i : c)
		d.set(i);
	vector<int> sol;
	for (int i : c) {
		sol.push_back(d.find(i));
		d.set(d.find(i));
	}

	sort(sol.begin(), sol.end());
	for (int i : sol)
		cout << i << " ";
	cout << "\n";
	return true;
}


void solver() {
	int n, k;
	cin >> n >> k;
	vector<int> arr(k);
	for (int& i : arr) cin >> i;
	if (solver1(n, k, arr)) return;
	if (solver2(n, k, arr)) return;
	if (solveh3(n, k, arr)) return;
	if (solver5(n, k, arr)) return;
	if (solver6(n, k, arr)) return;
	if (solvern(n, k, arr)) return;
}

int main(){
	int T = 1, a;
	cin >> a >> T;
	while (T--)
		if (a == 1)
			solveh();
		else
			solver();
	return 0x0;
}
