#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define all(x) begin(x), end(x)
#define ll long long


struct node {
	int l = -1, r = -1;
	bool sz = 0;
	node() {};
};

int n;

void upd(int v, vector<node> &tree) {
	int a = 0, b = 0;
	if (tree[v].l != -1) a = tree[tree[v].l].sz;
	if (tree[v].r != -1) b = tree[tree[v].r].sz;
	tree[v].sz = a & b;
}

int seti(int v, int i, int tl, int tr, vector<node> &tree) {
	if (v == -1) {
		v = tree.size();
		tree.push_back(node());
	}
	//cout << v << ' ';
	if (tl + 1 == tr) {
		tree[v].sz = 1;
		return v;
	}
	int tm = (tl + tr) / 2;
	if (i < tm) {
		tree[v].l = seti(tree[v].l, i, tl, tm, tree);
	}
	else {
		tree[v].r = seti(tree[v].r, i, tm, tr, tree);
	}
	upd(v,tree);
	return v;
}

int getl(int v, int l, int tl, int tr, vector<node> &tree) {
	if (l == n) return n;
	if (v == -1) return tl;
	if (tree[v].sz == 1) return n;
	if (tl + 1 == tr) {
		return tl;
	}
	int tm = (tl + tr) / 2;
	
	if (tm <= l) {
		return getl(tree[v].r, l, tm, tr, tree);
	}
	else {
		int ret = getl(tree[v].l, l, tl, tm, tree);
		if (ret == n) return getl(tree[v].r, l, tm, tr, tree);
		return ret;
	}
}

int getr(int v, int r, int tl, int tr, vector<node>& tree) {
	if (r == n) return -1;
	if (v == -1) return tr - 1;
	if (tree[v].sz == 1) return -1;
	if (tl + 1 == tr) {
		return tl;
	}
	//cout << tl << ' ' << tr << "\n";
	
	int tm = (tl + tr) / 2;

	if (r < tm) {
		return getr(tree[v].l, r, tl, tm, tree);
	}
	else {
		int ret = getr(tree[v].r, r, tm, tr, tree);
		if (ret == -1) return getr(tree[v].l, r, tl, tm, tree);
		return ret;
	}
}


vector<int> first(vector<int>& a, int n, int k) {
	sort(all(a));
	vector<int> ret;
	vector<node> tree;
	tree.push_back(node());
	for (int i = 0; i < k; i++) {
		seti(0, a[i], 0, n, tree);
	}
	//cout << 'x';
	for (int i = 0; i < k; i++) {
		int ind = getl(0, (a[i] + 1) % n, 0, n, tree);
		if (ind == n) ind = getl(0, 0, 0, n, tree);
		//cout << ind << ' ' << n << "\n";
		ret.push_back(ind);
		seti(0, ind, 0, n, tree);
		//cout << 'x';
	}
	//cout << 'y';
	sort(all(ret));

	return ret;
}

vector<int> second(vector<int>& a, int n, int k) {
	sort(all(a));
	reverse(all(a));
	vector<int> ret;
	vector<node> tree;
	tree.push_back(node());
	for (int i = 0; i < k; i++) {
		seti(0, a[i], 0, n, tree);
	}

	for (int i = 0; i < k; i++) {
		int ind = getr(0, (a[i] + n- 1)%n , 0, n, tree);
		if (ind == -1) ind = getr(0, n - 1, 0, n, tree);
		//cout << ind << ' ';
		ret.push_back(ind);
		seti(0, ind, 0, n, tree);
	}
	sort(all(ret));
	return ret;
}

int main() {
	

	int type;
	cin >> type;

	int m, k;

	cin >> m;
	while (m--) {
		cin >> n >> k;
		vector<int> a(k);
		for (int i = 0; i < k; i++) {
			cin >> a[i];
			a[i]--;
		}
		vector<int> ret;
		if (type == 1) ret = first(a, n, k);
		else ret = second(a, n, k);

		for (int v : ret) cout << v + 1 << ' ';
		cout << endl;
	}
	

	

	return 0;
}