//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
using ll = long long;

int k;

vector<int> cnt;
vector<int> leaf;
vector<int> tree;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = cnt[leaf[l]] <= k;
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr){
    if (ql <= l && r <= qr){
        return tree[v];
    }
    if (ql >= r || l >= qr){
        return 0;
    }
    int m = (l + r) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

vector<int> l;
vector<int> r;
vector<pair<int, int>> edge;

void dfs(int v, int type) {
    if (l[v] != -1) {
        cnt[l[v]] = cnt[v] + (type == 1);
        dfs(l[v], 0);
        cnt[r[v]] = cnt[v] + (type == 0);
        dfs(r[v], 1);
        edge[v] = {edge[l[v]].first, edge[r[v]].second};
    } else{
        edge[v] = {leaf.size(), leaf.size()};
        leaf.push_back(v);
    }
}
int main(){
    int n, q;
    cin >> n >> k >> q;
    cnt.resize(n);
    l.assign(n, -1);
    r.assign(n, -1);
    edge.resize(n);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 2){
            cin >> l[i] >> r[i];
            l[i]--; r[i]--;
        }
    }
    cnt[0] = 0;
    dfs(0, -1);
    int m = leaf.size();
//    for (int i = 0; i < m; ++i) {
//        cout << leaf[i] << ' ';
//    }
//    cout << endl;
//    for (int i = 0; i < m; ++i) {
//        cout << cnt[leaf[i]] << ' ';
//    }
//    cout << endl;
    tree.resize(4 * m);
    build(0, 0, m);

    for (int i = 0; i < q; ++i) {
        int u;
        cin >> u;
        cout << get(0, 0, m, edge[u - 1].first, edge[u - 1].second + 1) << endl;
    }
}
