#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cassert>
#include <iomanip>
#include <cstdio>
#include <bitset>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <random>
#include <ctime>
//#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;

struct node {
	int x;
	node* l, * r;
	node(const int sz = 0) {
		l = r = nullptr;
		x = sz;
	}
};

struct tree {
	node* root = new node();
	int sz;
	void build(int n) {
		sz = 1;
		while (sz <= n)
			sz *= 2;
		root->x = sz;
	}
	void erase(node* v, int l, int r, int ql, int qr) {
		if (l >= qr || r <= ql)
			return;
		if (ql <= l && r <= qr) {
			assert(l == r - 1);
			v->x = 0;
			return;
		}
		if (!v->l)
			v->l = new node((r - l) / 2);
		if (!v->r)
			v->r = new node((r - l) / 2);
		int m = (l + r) / 2;
		erase(v->l, l, m, ql, qr);
		erase(v->r, m, r, ql, qr);
		v->x = v->l->x + v->r->x;
	}
	void erase(int x) {
		erase(root, 0, sz, x, x + 1);
	}

	int get(node* v, int l, int r, int x) {
		if (l == r - 1) {
			assert(l > x);
			return l;
		}
		if (!v->l)
			v->l = new node((r - l) / 2);
		if (!v->r)
			v->r = new node((r - l) / 2);

		int m = (l + r) / 2;
		if (l >= x && v->l->x) {
			return get(v->l, l, m, x);
		}
		else {
			return get(v->r, m, r, x - v->l->x);
		}
	}
	int lower_bound(int x) {
		return get(root, 0, sz, x);
	}
};

vector <int> get(int n, vector <int> x, int f = 0) {
	tree d;
	d.build(n);
	d.erase(0);
	for (auto& r : x)
		d.erase(r);
	vector <int> ans;
	for (auto& r : x) {
		int k = d.lower_bound(r);
		if (k <= n) {
			ans.push_back(k);
			d.erase(k);
		}
		else {
			ans.push_back(d.lower_bound(0));
			d.erase(d.lower_bound(0));
		}
	}
	sort(ans.begin(), ans.end());
	if (f)
		reverse(ans.begin(), ans.end());
	return ans;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif	
	int t;
	cin >> t;
	if (t == 1) {
		int m;
		cin >> m;
		while (m--) {
			int n, k;
			cin >> n >> k;
			vector <int> x(k);
			for (auto& r : x) {
				cin >> r;
			}
			for (auto& r : get(n, x))
				cout << r << ' ';
			cout << endl;
		}
	}
	else {
		int m;
		cin >> m;
		while (m--) {
			int n, k;
			cin >> n >> k;
			vector <int> x(k);
			for (auto& r : x) {
				cin >> r;
				r = n - r + 1;
			}
			for (auto& r : get(n, x, 1))
				cout << n - r + 1 << ' ';
			cout << endl;
		}
	}
}
