#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cassert>
#include <iomanip>
#include <cstdio>
#include <bitset>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <random>
#include <ctime>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;

struct fenw {
	vector <pair <int, int> > x;
	void build(int n) {
		x.resize(n + 1, { -1e9, -1 });
	}
	void add(int i, pair <int, int> mx) {
		for (; i < x.size(); i += i & -i)
			x[i] = max(x[i], mx);
	}
	pair <int, int> get(int i) {
		pair <int, int> ans = { -1e9, -1 };
		for (; i > 0; i -= i & -i) {
			ans = max(ans, x[i]);
		}
		return ans;
	}
};

int get(vector <int> x) {
	int n = x.size();
	vector <int> d(n), p(n);
	fenw a;
	a.build(n);
	for (int i = 0; i < n; i++) {
		auto q = a.get(x[i] - 1);
		d[i] = max(0, q.first) + 1;
		p[i] = q.second;
		a.add(x[i], { d[i], i });
	}
	vector <int> v;
	int ans = 0, ind = -1;
	for (int i = 0; i < n; i++) {
		if (ans < d[i]) {
			ans = d[i];
			ind = i;
		}
	}
	set <int> pos;
	while (ind != -1) {
		pos.insert(ind);
		ind = p[ind];
	}
	int mn = n + 1;
	for (int i = 0; i < n; i++) {
		if (mn > x[i] && !pos.count(i)) {
			mn = x[i];
			ans++;
		}
	}
	return ans;
}

void solve() {
	int n;
	cin >> n;
	vector <int> x(n);
	for (auto& r : x)
		cin >> r;
	int ans = get(x);
	reverse(x.begin(), x.end());
	cout << max(get(x), ans);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif  
	int t;
	cin >> t;
	while (t--) {
		solve();
		cout << endl;
	}
}