#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2")

#define ll int64_t
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define x first
#define y second

#define double ld
#define endl '\n'

using namespace std;

const int inf = 1e9;
const ll INF = 1e18;

const int maxn = 2e3;
int dp[maxn + 1][maxn + 1];

void solve() {
    int n;
    cin >> n;
    vector<int> p(n + 1);
    for (int i = 1; i <= n; ++i)
        cin >> p[i];

    for (int i = 0; i <= n; ++i) {
        for(int j = 0; j <= n; ++j) {
            dp[i][j] = -inf;
        }
    }

    dp[p[1]][0] = 1;
    dp[0][p[1]] = 1;

    set<pair<int, int>> s;

    vector<set<int>> a(n + 1);
    vector<set<int>> b(n + 1);

    auto add = [&](int u, int v) {
        s.insert({u, v});
        a[u].insert(v);
        a[v].insert(u);
    };

    auto remove = [&](int u, int v) {
        s.erase({u, v});
        a[u].erase(v);
        a[v].erase(u);
    };

    for (int i = 2; i <= n; ++i) {
        for (int p2 = 1; p2 <= n; ++p2) {
            if (p2 == p[i])
                continue;

            dp[p[i]][p2] = max(dp[p[i]][p2], dp[0][p2] + 1);
            add(p[i], p2);

            if (p[i] > p2) {
                dp[0][p[i]] = max(dp[0][p[i]], dp[0][p2] + 1);
                dp[0][p2] = -inf;
            }
        }

        for (int p1 = 1; p1 <= n; ++p1) {
            if (p1 == p[i])
                continue;

            dp[p1][p[i]] = max(dp[p1][p[i]], dp[p1][0] + 1);
            add(p1, p[i]);

            if (p[i] < p1) {
                dp[p[i]][0] = max(dp[p[i]][0], dp[p1][0] + 1);
                dp[p1][0] = -inf;
            }
        }


        for (int p2 = 1; p2 <= n; ++p2) {
            int val = dp[p[i]][p2] - 1;
            for (int p1 = p[i] + 1; p1 <= n; ++p1) {
                if (p2 == p[i])
                    continue;
                val = max(val, dp[p1][p2]);
            }
            dp[p[i]][p2] = val + 1;
        }

        for (auto [p1, p2] : s) {
            if (p1 == p[i] or p2 == p[i])
                continue;
            if (p[i] > p2) {
                dp[p1][p[i]] = max(dp[p1][p[i]], dp[p1][p2] + 1);
                add(p1, p[i]);
            }
            if (p[i] < p1) {
                dp[p[i]][p2] = max(dp[p[i]][p2], dp[p1][p2] + 1);
                add(p[i], p2);
            }
        }
        for (int p1 = 1; p1 <= n; ++p1) {
            for (int p2 = 1; p2 <= n; ++p2) {
                if (p1 == p2 or p1 == p[i] or p2 == p[i])
                    continue;
                if (p[i] > p2)
                    dp[p1][p[i]] = max(dp[p1][p[i]], dp[p1][p2] + 1);
            }
        }

        for (int x = p[i] + 1; x <= n; ++x) {
            while (a[x].size() > 0 and *a[x].begin() < p[i]) {
                dp[x][*a[x].begin()] = -inf;
                remove(x, *a[x].begin());
            }
        }
    }

    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    int t;
    cin >> t;
    while (t--)
        solve();

    return 0;
}