#include <iostream>
#include <vector>
#include <bitset>
using namespace std;
using ll = long long;

ll MOD = 1;
const int MAXM = 18;
bitset<1 << MAXM> used;
vector<int> redg[1 << MAXM];

int get_edge(int a) {
    int m = 0;
    while (a & (1 << m))
        ++m;
    --m;
    int ans = 0;
    for (int i = 0; (1 << i) <= a; ++i) {
        if (a & (1 << i))
            ans += 1 << (i ^ m);
    }
    return ans;
}

void solve() {
    int k, n, p;
    cin >> k >> n >> p;
    int m = (1 << k);
    vector<int> st;
    for (int x = 1; x < (1 << m); x += 2) {
        int e = get_edge(x);
        if (e == x && __builtin_popcount(x) == n) {
            bool isok = true;
            for (int i = 0; i < p && isok; ++i) {
                isok = (x & (1 << i)) > 0;
            }
            if ((x & (1 << p)) > 0)
                isok = false;
            if (isok) {
                used[x] = 1;
                st.push_back(x);
            }
        } else {
            redg[e].push_back(x);
        }
    }
    while (st.size()) {
        int v = st.back();
        st.pop_back();
        for (auto u : redg[v]) {
            used[u] = 1;
            st.push_back(u);
        }
    }
    cout << used.count() % MOD << '\n';
    for (int x = 0; x < (1 << m); ++x) {
        redg[x].clear();
        used[x] = 0;
    }
}

signed main() {
   cin >> MOD;
   int t;
   cin >> t;
   while (t--) {
        solve();
   }
}
