#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = 2e5 + 123;
vector<int> edg[MAXN];
pair<ll, ll> sg[MAXN];

pair<ll, ll> effect_dfs(int v, int rt, vector<ll>& a) {
    ll ans = 0;
    ll dif = a[v];
    for (auto u : edg[v]) {
        if (u == rt)
            continue;
        pair<ll, ll> p = effect_dfs(u, v, a);
        ans += p.first + p.second;
        dif -= p.second;
    }
    return {ans, max(dif, 0ll)};
}

ll get_effect(vector<ll> a) {
    pair<ll, ll> ans = effect_dfs(0, -1, a);
    return ans.first + ans.second;
}

ll get_hash(vector<ll> a, ll x, ll y, ll MOD) {
    ll ans = 0;
    for (int i = 0; i < a.size(); ++i) {
        ans ^= (x * (i + 1) + y * a[i] % MOD * a[i]) % MOD;
    }
    return ans;
}

ll delta_hash(int i, ll pval, ll nval, ll x, ll y, ll MOD) {
    ll ans = 0;
    ans ^= (x * (i + 1) + y * pval % MOD * pval) % MOD;
    ans ^= (x * (i + 1) + y * nval % MOD * nval) % MOD;
    return ans;
}

vector<ll> get_vals(int n, ll v) {
    vector<ll> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[i] = sg[i].first + min(v, sg[i].second - sg[i].first);
        v -= min(v, sg[i].second - sg[i].first);
    }
    return ans;
}
pair<ll, ll> effect_dfs_intoarr(int v, int rt, vector<ll>& a, vector<pair<ll, ll>>& ansarr) {
    ll ans = 0;
    ll dif = a[v];
    for (auto u : edg[v]) {
        if (u == rt)
            continue;
        pair<ll, ll> p = effect_dfs_intoarr(u, v, a, ansarr);
        ans += p.first + p.second;
        dif -= p.second;
    }
    ansarr[v] = {ans, max(dif, 0ll)};
    return ansarr[v];
}

void get_goodv(int v, int rt, vector<pair<ll, ll>>& effs, vector<int>& ans) {
    if (effs[v].second > 0) {
        ans.push_back(v);
        for (auto u : edg[v]) {
            if (u == rt)
                continue;
            effs[u].second = 0;
        }
    }
    for (auto u : edg[v]) {
        if (u == rt)
            continue;
        get_goodv(u, v, effs, ans);
    }
}

void solve_l0(int n, int q, ll x, ll y, ll MOD, vector<ll> qrs) {
    vector<ll> mxs(n);
    for (int i = 0; i < n; ++i)
        mxs[i] = sg[i].second;
    vector<pair<ll, ll>> effvals(n);
    effect_dfs_intoarr(0, 0, mxs, effvals);
    vector<int> vs;
    get_goodv(0, 0, effvals, vs);
    mxs.assign(n, 0);
    for (auto v : vs) {
        mxs[v] = sg[v].second;
    }
    for (int v = 0; v < n; ++v)
        sg[v].second = mxs[v];
    vector<ll> ans(q, -1);
    ll hash = get_hash(get_vals(n, 0), x, y, MOD);
    vector<ll> anshash(q, -1);
    vector<pair<ll, ll>> sqrs(q);
    for (int i = 0; i < q; ++i)
        sqrs[i] = {qrs[i], i};
    sort(sqrs.begin(), sqrs.end());
    vector<ll> a(n, 0);
    vector<int> stck = vs;
    ll ceff = 0;
    ll VALUE = 0;
    sort(stck.rbegin(), stck.rend());
    for (auto [eff, qi] : sqrs) {
        while (stck.size() && ceff < eff) {
            int v = stck.back();
            if (a[v] == sg[v].second) {
                stck.pop_back();
            }
            ll add = min(eff - ceff, sg[v].second - a[v]);
            hash ^= delta_hash(v, a[v], a[v] + add, x, y, MOD);
            a[v] += add;
            ceff += add;
            VALUE += add;
        }
        if (ceff < eff) {
        } else {
            ans[qi] = VALUE;
            anshash[qi] = hash;
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << anshash[i] << ' ';
    }
    cout << endl;
    int qi;
    while (cin >> qi) {
        --qi;
        if (qi == -1)
            return;
        if (ans[qi] == -1) {
            cout << "-1" << endl;
            continue;
        }
        vector<ll> out = get_vals(n, ans[qi]);
        for (auto x : out)
            cout << x << ' ';
        cout << endl;
    }
}

void solve(int n, int q) {
    ll x, y, MOD;
    cin >> x >> y >> MOD;
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        edg[u].push_back(v);
        edg[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        cin >> sg[i].first >> sg[i].second;
    }
    vector<ll> qrs(q);
    for (int i = 0; i < q; ++i)
        cin >> qrs[i];
    ll smdf = 0;
    for (int i = 0; i < n; ++i) {
        smdf += sg[i].second - sg[i].first;
    }
    ll mneff = get_effect(get_vals(n, 0));
    ll mxeff = get_effect(get_vals(n, smdf));
    if (mneff == 0) {
        solve_l0(n, q, x, y, MOD, qrs);
        return;
    }
    vector<ll> ans(q, -1);
    for (int qi = 0; qi < q; ++qi) {
        ll eff = qrs[qi];
        if (eff > mxeff || mneff > eff) {
            ans[qi] = -1;
            continue;
        }
        ll lb = -1, ub = smdf + 1;
        while (ub - lb > 1) {
            ll mb = (lb + ub) / 2;
            vector<ll> vals = get_vals(n, mb);
            ll ceff = get_effect(vals);
            // cout << mb << ": " << ceff << endl;
            if (eff == ceff) {
                ans[qi] = mb;
                break;
            } else if (ceff < eff) {
                lb = mb;
            } else {
                ub = mb;
            }
        }
    }
    vector<ll> hashes(q);
    for (int qi = 0; qi < q; ++qi) {
        if (ans[qi] == -1)
            hashes[qi] = -1;
        else {
            hashes[qi] = get_hash(get_vals(n, ans[qi]), x, y, MOD);
        }
    }
    for (int i = 0; i < q; ++i)
        cout << hashes[i] << ' ';
    cout << endl;
    int qi;
    while (cin >> qi) {
        --qi;
        if (qi == -1)
            return;
        if (ans[qi] == -1) {
            cout << "-1" << endl;
            continue;
        }
        vector<ll> out = get_vals(n, ans[qi]);
        for (auto x : out)
            cout << x << ' ';
        cout << endl;
    }
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        int n, q;
        cin >> n >> q;
        solve(n, q);
        for (int i = 0; i < n; ++i)
            edg[i].clear();
    }
}
