#include <bits/stdc++.h>

#define sz(a) int((a).size())

using namespace std;

typedef long long ll;

const int INF = 1e9;

struct SegmentTree {
    int n;
    vector<int> t;

    explicit SegmentTree(int size) {
        n = 1;
        while (n < size) {
            n *= 2;
        }
        t.assign(2 * n, -INF);
    }

    void push(int v) {
        if (t[v] == -INF) {
            t[v * 2] = t[v * 2 + 1] = -INF;
        }
    }

    void fill(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return;
        }
        if (ql <= l && r <= qr) {
            t[v] = -INF;
            return;
        }
        push(v);
        int m = (l + r) / 2;
        fill(v * 2, l, m, ql, qr);
        fill(v * 2 + 1, m, r, ql, qr);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    void set_val(int v, int l, int r, int pos, int val) {
        if (l + 1 == r) {
            t[v] = val;
            return;
        }
        push(v);
        int m = (l + r) / 2;
        if (pos < m) {
            set_val(v * 2, l, m, pos, val);
        } else {
            set_val(v * 2 + 1, m, r, pos, val);
        }
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int get_max(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return -INF;
        }
        if (ql <= l && r <= qr) {
            return t[v];
        }
        push(v);
        int m = (l + r) / 2;
        return max(get_max(v * 2, l, m, ql, qr), get_max(v * 2 + 1, m, r, ql, qr));
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<SegmentTree> dp_h(n + 2, SegmentTree(n + 2));
    vector<SegmentTree> dp_v(n + 2, SegmentTree(n + 2));

    int N = dp_h[0].n;

//    vector dp(n + 1, vector(n + 2, vector(n + 2, -INF)));
//    dp[0][0][n + 1] = 0;
    dp_h[n + 1].set_val(1, 0, N, 0, 0);
    dp_v[0].set_val(1, 0, N, n + 1, 0);

    for (int i = 0; i < n; ++i) {
//        for (int x = 0; x <= n + 1; ++x) {
//            for (int y = 0; y <= n + 1; ++y) {
//                cout << dp_v[x].get_max(1, 0, n + 2, y, y + 1) << ' ';
//            }
//            cout << '\n';
//        }
        for (int y = 0; y <= n + 1; ++y) {
            int val = dp_h[y].get_max(1, 0, N, 0, a[i]) + 1;
            dp_h[y].set_val(1, 0, N, a[i], val);
            dp_v[a[i]].set_val(1, 0, N, y, val);
//            for (int j = 0; j < a[i]; ++j) {
//                dp[i + 1][a[i]][y] = max(dp[i + 1][a[i]][y], dp[i][j][y] + 1);
//            }
        }
        for (int x = 0; x <= n + 1; ++x) {
            int val = dp_v[x].get_max(1, 0, N, a[i] + 1, n + 2) + 1;
            dp_h[a[i]].set_val(1, 0, N, x, val);
            dp_v[x].set_val(1, 0, N, a[i], val);
//            for (int j = 0; j < a[i]; ++j) {
//                dp[i + 1][a[i]][y] = max(dp[i + 1][a[i]][y], dp[i][j][y] + 1);
//            }
        }
        dp_h[a[i]].set_val(1, 0, N, a[i], -INF);
        dp_v[a[i]].set_val(1, 0, N, a[i], -INF);
        for (int x = 0; x < a[i]; ++x) {
            dp_v[x].fill(1, 0, N, a[i] + 1, n + 2);
        }
        for (int y = a[i] + 1; y <= n + 1; ++y) {
            dp_h[y].fill(1, 0, N, 0, a[i]);
        }
    }

    int ans = 0;
    for (int x = 1; x <= n; ++x) {
        ans = max(ans, dp_v[x].get_max(1, 0, N, 1, n + 1));
    }
    cout << ans << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}