#include <bits/stdc++.h>

using namespace std;

#define sz(a) int((a).size())

typedef long long ll;

struct Query {
    int k, a, b, idx;
};

const int A = 300, B = 300;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> ws(n);
    for (int i = 0; i < n; ++i) {
        cin >> ws[i];
    }

    int z;
    cin >> z;
    assert(z == 0);

    vector<Query> qs(q);
    for (int i = 0; i < q; ++i) {
        cin >> qs[i].k >> qs[i].a >> qs[i].b;
        qs[i].idx = i;
    }

    sort(ws.begin(), ws.end());
    sort(qs.begin(), qs.end(), [&] (auto a, auto b) {
        return a.k < b.k;
    });

    vector<bool> ans(q);

    vector dp(A + 1, vector(B + 1, false));
    dp[0][0] = true;

    int idx = 0;
    for (auto w : ws) {
        auto cur_res = dp;
        for (int i = 0; i <= A; ++i) {
            for (int j = 0; j <= B; ++j) {
                if (i != 0) {
                    cur_res[i][j] = cur_res[i][j] && cur_res[i - 1][j];
                }
                if (j != 0) {
                    cur_res[i][j] = cur_res[i][j] && cur_res[i][j - 1];
                }
            }
        }
        while (idx < q && qs[idx].k < w) {
            ans[qs[idx].idx] = cur_res[qs[idx].a][qs[idx].b];
            idx++;
        }
        for (int i = A; i >= 0; --i) {
            for (int j = B; j >= 0; --j) {
                if (i + w <= A) {
                    dp[i + w][j] = dp[i + w][j] || dp[i][j];
                }
                if (j + w <= B) {
                    dp[i][j + w] = dp[i][j + w] || dp[i][j];
                }
            }
        }
    }

    auto cur_res = dp;
    for (int i = 0; i <= A; ++i) {
        for (int j = 0; j <= B; ++j) {
            if (i != 0) {
                cur_res[i][j] = cur_res[i][j] && cur_res[i - 1][j];
            }
            if (j != 0) {
                cur_res[i][j] = cur_res[i][j] && cur_res[i][j - 1];
            }
        }
    }
    while (idx < q) {
        ans[qs[idx].idx] = cur_res[qs[idx].a][qs[idx].b];
        idx++;
    }

    for (auto el : ans) {
        cout << (el ? "Yes" : "No") << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    solve();

    return 0;
}