#include <bits/stdc++.h>

using namespace std;

#define sz(a) int((a).size())

typedef long long ll;

vector<vector<int>> gr;
vector<int> l, r;

vector<ll> dp0, dp1;

void dfs(int v, int pr) {
    dp0[v] = 0;
    dp1[v] = r[v];
    for (auto to : gr[v]) {
        if (to == pr) continue;
        dfs(to, v);
        dp1[v] += dp0[to];
        dp0[v] += max(dp0[to], dp1[to]);
    }
}

vector<bool> used;

void dfs1(int v, int pr, int type) {
    if (type == 0) {
        used[v] = false;
        for (auto to : gr[v]) {
            if (to == pr) continue;
            dfs1(to, v, 1);
        }
    } else {
        if (dp0[v] > dp1[v]) {
            used[v] = false;
            for (auto to : gr[v]) {
                if (to == pr) continue;
                dfs1(to, v, 1);
            }
        } else {
            used[v] = true;
            for (auto to : gr[v]) {
                if (to == pr) continue;
                dfs1(to, v, 0);
            }
        }
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    gr.assign(n, {});
    ll x, y, m;
    cin >> x >> y >> m;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    l.resize(n), r.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    dp0.resize(n), dp1.resize(n);
    dfs(0, -1);
    used.resize(n);
    dfs1(0, -1, 1);
    ll max_res = max(dp0[0], dp1[0]);
    vector<int> used_idx;
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            used_idx.push_back(i);
        }
    }
    vector<int> certificate(max_res + 1, 0);
    for (int i = 0; i < n; ++i) {
        certificate[0] ^= x * (i + 1) % m;
    }
    for (int i = 0; i < max_res; ++i) {
        certificate[i + 1] = certificate[i] ^ (x * (used_idx[i] + 1) % m) ^ ((x * (used_idx[i] + 1) + y) % m);
    }
    vector<ll> v(q);
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
    }
    for (int i = 0; i < q; ++i) {
        if (v[i] <= max_res) {
            cout << certificate[v[i]] << ' ';
        } else {
            cout << -1 << ' ';
        }
    }
    cout << endl;
    while (true) {
        int i;
        cin >> i;
        if (i == 0) break;
        if (v[i - 1] <= max_res) {
            vector<int> ans(n, 0);
            for (int j = 0; j < v[i - 1]; ++j) {
                ans[used_idx[j]] = 1;
            }
            for (int j = 0; j < n; ++j) {
                cout << ans[j] << ' ';
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    //    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}