#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define ff first
#define ss second

#pragma GCC target("avx2")
#pragma GCC optimize("O3,Ofast,unroll-loops")

bool check(vector<int> &a, deque<int> &b, int k) {
    int r = 0;
    for (int x : b) {
        while (r < k && a[r] < x) {
            ++r;
        }
        if (r < k && a[r] == x) {
            return false;
        }
    }
    return true;
}

vector<int> mtl6(1 << 6, -1);
vector<int> mtr6(1 << 6, -1);
vector<int> mtl7(1 << 7, -1);
vector<int> mtr7(1 << 7, -1);

void shifr(vector<int> &a, int n, int k) {
    if (k <= 2) {
        deque<int> b(a.begin(), a.end());
        while (true) {
            for (int &x : b) {
                ++x;
                if (x > n) {
                    x -= n;
                }
            }
            if (b.back() == 1) {
                b.pop_back();
                b.push_front(1);
            }
            if (check(a, b, k)) {
                for (int x : b) {
                    cout << x << ' ';
                }
                cout << '\n';
                return;
            }
        }
        return;
    } else {
        if (n <= 7) {
            int mask = 0;
            for (int x : a) {
                mask |= (1 << (x - 1));
            }
            int new_mask = -1;
            if (n == 6) {
                new_mask = mtl6[mask];
            } else {
                new_mask = mtl7[mask];
            }
            for (int i = 0; i < n; ++i) {
                if (new_mask & (1 << i)) {
                    cout << i + 1 << ' ';
                }
            }
            cout << '\n';
        }
    }
}

void deshifr(vector<int> &a, int n, int k) {
    if (k <= 2) {
        deque<int> b(a.begin(), a.end());
        while (true) {
            for (int &x : b) {
                --x;
                if (x == 0) {
                    x += n;
                }
            }
            if (b.front() == n) {
                b.pop_front();
                b.push_back(n);
            }
            if (check(a, b, k)) {
                for (int x : b) {
                    cout << x << ' ';
                }
                cout << '\n';
                return;
            }
        }
        return;
    }
}

bool kuhn(int v, vector<bool> &used, vector<int> &mtl, vector<int> &mtr, vector<vector<int> > &g) {
    if (used[v]) {
        return 0;
    }
    used[v] = true;
    for (int u : g[v]) {
        if (mtr[u] == -1 || kuhn(mtr[u], used, mtl, mtr, g)) {
            mtr[u] = v;
            mtl[v] = u;
            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    vector<vector<int> > g6(1 << 6);
    vector<vector<int> > g7(1 << 7);
    for (int mask = 0; mask < (1 << 6); ++mask) {
        for (int mask1 = 0; mask1 < (1 << 6); ++mask1) {
            if (__builtin_popcount(mask) + __builtin_popcount(mask1) == __builtin_popcount(mask | mask1) &&
                __builtin_popcount(mask) == __builtin_popcount(mask1)) {
                g6[mask].emplace_back(mask1);
            }
        }
    }
    for (int mask = 0; mask < (1 << 7); ++mask) {
        for (int mask1 = 0; mask1 < (1 << 7); ++mask1) {
            if (__builtin_popcount(mask) + __builtin_popcount(mask1) == __builtin_popcount(mask | mask1) &&
                __builtin_popcount(mask) == __builtin_popcount(mask1)) {
                g7[mask].emplace_back(mask1);
            }
        }
    }
    ///cout << "done" << endl;
    int cnt = 0;
    for (int v = 0; v < (1 << 6); ++v) {
        vector<bool> used(1 << 6, 0);
        cnt += kuhn(v, used, mtl6, mtr6, g6);
    }
    ///cout << "first: " << cnt << endl;
    ////cout << "first" << endl;
    cnt = 0;
    for (int v = 0; v < (1 << 7); ++v) {
        vector<bool> used(1 << 7, 0);
        cnt += kuhn(v, used, mtl7, mtr7, g7);
    }
    ///cout << "second: " << cnt << endl;
    int t;
    cin >> t;
    if (t == 1) {
        int q;
        cin >> q;
        while (q--) {
            int n, k;
            cin >> n >> k;
            vector<int> a(k);
            for (int &x : a) {
                cin >> x;
            }
            shifr(a, n, k);
        }
    } else {
        int q;
        cin >> q;
        while (q--) {
            int n, k;
            cin >> n >> k;
            vector<int> a(k);
            for (int &x : a) {
                cin >> x;
            }
            deshifr(a, n, k);
        }
    }
    return 0;
}


