#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()

struct seg {
    int l, r, id;
    seg(int _l = -1, int _r = -1, int i = -1) {
        l = _l;
        r = _r;
        id = i;
    }
};

bool operator<(const seg &a, const seg &b) {
    if (a.r == b.r) {
        if (a.l == b.l)
            return a.id < b.id;
        return a.l > b.l;
    }
    return a.r < b.r;
}

bool in(const seg& a, const seg& b) {
    return a.l >= b.l && a.r <= b.r;
}

void solve() {
    int n;
    cin >> n;
    vector <seg> a(n);
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        a[i] = seg(l, r, i);
    }
    sort(all(a));
    int m = 0;
    int last = 0;
    for (auto el: a) {
        if (el.l > last) {
            last = el.r;
            m++;
        }
    }
    if (m == n) {
        for (int i = 0; i < n / 2; ++i)
            cout << i + 1 << " ";
        cout << "\n";
        return;
    }
    int n1 = n / 2, m1 = m / 2;
    n1 -= m1;
    vector <seg> st, prev(n);
    vector <int> sz(n);
    for (auto cur: a) {
        while (!st.empty() && in(st.back(), cur)) {
            sz[cur.id]++;
            prev[st.back().id] = cur;
            st.pop_back();
        }
        st.push_back(cur);
    }
    vector <bool> bad(n);
    for (int i = 0; i < n; ++i) {
        //cout << i << " " << sz[i] << " " << n1 << endl;
        if (sz[i] > 0 && n1 != 0 && prev[i].id != -1) {
            bad[i] = true;
            n1--;
        } else if (sz[i] == 0 && sz[prev[i].id] > 1 && m1 > 0) {
            sz[prev[i].id]--;
            m1--;
            bad[i] = true;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!bad[i] && sz[i] > 0 && n1 > 0) {
            n1--;
            bad[i] = true;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!bad[i] && sz[i] == 0 && m1 > 0) {
            m1--;
            bad[i] = true;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!bad[i])
            cout << i + 1 << " ";
    }
    cout << "\n";
}

int main() {
    int t;
    cin >> t;
    while (t--)
        solve();
}
