#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using pii = pair <int, int>;
#define ff first
#define ss second

template <typename T1, typename T2>
void mnr(T1& a, const T2& b) {
    if (a > b) {
        a = b;
    }
}

template <typename T1, typename T2>
void mxr(T1& a, const T2& b) {
    if (a < b) {
        a = b;
    }
}

const int INF = 1e9;

class SegmentTree {
private:
    vector <int> d, p, t;
    int n;

    void upd(int i) {
        d[i] = max(d[2 * i], d[2 * i + 1]);
    }

    void upd(int i, int x) {
        t[i] = true;
        p[i] = d[i] = x;
    }

    void push(int i) {
        if (t[i]) {
            t[i] = 0;
            upd(2 * i, p[i]);
            upd(2 * i + 1, p[i]);
        }
    }

    int get(int ql, int qr, int l, int r, int i) {
        if (l >= qr || ql >= r) {
            return -INF;
        }
        if (l >= ql && r <= qr) {
            return d[i];
        }
        push(i);
        int m = (l + r) / 2;
        return max(
                get(ql, qr, l, m, 2 * i),
                get(ql, qr, m, r, 2 * i + 1)
                );
    }

    void upd(int ql, int qr, int x, int l, int r, int i) {
        if (l >= qr || ql >= r) {
            return;
        }
        if (l >= ql && r <= qr) {
            return upd(i, x);
        }
        push(i);
        int m = (l + r) / 2;
        upd(ql, qr, x, l, m, 2 * i);
        upd(ql, qr, x, m, r, 2 * i + 1);
        upd(i);
    }

public:
    explicit SegmentTree(int n1) {
        n = 1;
        while (n < n1) {
            n <<= 1;
        }
        d.resize(2 * n, -INF);
        p.resize(2 * n);
        t.resize(2 * n);
    }

    int get(int l, int r) {
        return get(l, r, 0, n, 1);
    }

    void upd(int l, int r, int x) {
        return upd(l, r, x, 0, n, 1);
    }
};

void solve() {
    int n;
    cin >> n;
    vector <int> p(n);
    for (auto &i : p) {
        cin >> i;
    }
    vector <SegmentTree*> stmn(n + 2);
    vector <SegmentTree*> stmx(n + 2);
    for (int i = 0; i < n + 2; ++i) {
        stmn[i] = new SegmentTree(n + 2);
        stmx[i] = new SegmentTree(n + 2);
    }
    auto upd = [&](int i, int j, int val) {
        stmn[i]->upd(j, j + 1, val);
        stmx[j]->upd(i, i + 1, val);
    };
    upd(n + 1, 0, 0);
    for (int i = 1; i <= n; ++i) {
        int val = p[i - 1];
        vector <int> vmn(n + 2), vmx(n + 2);
        for (int mn = 0; mn <= n + 1; ++mn) {
            vmn[mn] = stmn[mn]->get(0, val) + 1;
        }
        for (int mx = 0; mx <= n + 1; ++mx) {
            vmx[mx] = stmx[mx]->get(val + 1, n + 2) + 1;
        }
        for (int mn = 0; mn <= n + 1; ++mn) {
            upd(mn, val, vmn[mn]);
        }
        for (int mx = 0; mx <= n + 1; ++mx) {
            upd(val, mx, vmx[mx]);
        }
        for (int mn = val + 1; mn <= n + 1; ++mn) {
            stmn[mn]->upd(0, val, -INF);
        }
        for (int mx = 0; mx < val; ++mx) {
            stmx[mx]->upd(val + 1, n + 2, -INF);
        }
    }
    int res = 0;
    for (int i = 0; i <= n + 1; ++i) {
        mxr(res, stmn[i]->get(0, n + 2));
    }
    cout << res;
}

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}