#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using pii = pair<int, int>;
#define ff first
#define ss second

template<typename T1, typename T2>
void mnr(T1 &a, const T2 &b) {
    if (a > b) {
        a = b;
    }
}


template<typename T1, typename T2>
void mxr(T1 &a, const T2 &b) {
    if (a < b) {
        a = b;
    }
};

class DSU {
private:
    vector<int> p;
    vector<int> r;

public:
    int comp;

    explicit DSU(int n) : p(n), r(n), comp(n) {
        iota(all(p), 0);
    }

    int get(int a) {
        return (a == p[a] ? a : p[a] = get(p[a]));
    }

    void unite(int a, int b) {
        a = get(a), b = get(b);
        if (a == b) {
            return;
        }
        --comp;
        if (r[a] > r[b]) {
            swap(a, b);
        }
        p[a] = b;
        r[b] += (r[a] == r[b]);
    }
};

using Segment = tuple<int, int, int>;

struct Event {
    int x;
    int type;
    int id;
};

bool inter(Segment a, Segment b) {
    auto [l1, r1, id1] = a;
    auto [l2, r2, id2] = b;
    if (l1 > l2) {
        swap(l1, l2);
        swap(r1, r2);
    }
    return (l2 >= l1 && l2 <= r1);
}

void solve() {
    int n;
    cin >> n;
    vector<Segment> v(n);
    {
        int id = 0;
        for (auto &[l, r, i]: v) {
            cin >> l >> r;
            i = id++;
        }
    }
    sort(all(v), [](Segment a, Segment b) {
        if (get<1>(a) != get<1>(b)) {
            return get<1>(a) < get<1>(b);
        }
        return get<0>(a) > get<1>(b);
    });
    vector<int> xs;
    for (auto [l, r, id]: v) {
        xs.push_back(l);
        xs.push_back(r);
    }
    sort(all(xs));
    xs.resize(unique(all(xs)) - xs.begin());
    int m = sz(xs);
    unordered_map<int, int> conv;
    for (int i = 0; i < m; ++i) {
        conv[xs[i]] = i;
    }
    vector<vector<pii> > segsbyr(m + 1);
    int dddd = 0;
    for (auto [l, r, id]: v) {
        segsbyr[conv[r] + 1].emplace_back(conv[l] + 1, dddd++);
    }
    vector<int> dp(m + 1);
    vector<int> pr(m + 1, -1);
    for (int i = 1; i <= m; ++i) {
        dp[i] = dp[i - 1];
        for (auto [j, id]: segsbyr[i]) {
            if (dp[i] < dp[j - 1] + 1) {
                pr[i] = id;
                dp[i] = dp[j - 1] + 1;
            }
        }
    }
    int cur = m;
    vector<bool> t(n);
    cerr << dp.back() << "\n";
    while (cur) {
        if (pr[cur] != -1) {
            cerr << get<2>(v[pr[cur]]) << " ";
            t[pr[cur]] = true;
            cur = conv[get<0>(v[pr[cur]])];
        } else {
            --cur;
        }
    }
    vector <Event> events;
    for (auto [l, r, id] : v) {
        events.push_back({l, 1, id});
        events.push_back({r, -1, id});
    }
    sort(all(events), [](Event a, Event b) {
        if (a.x != b.x) {
            return a.x < b.x;
        }
        return (a.type > b.type);
    });
    set <int> gopened;
    set <int> bopened;
    vector<vector<int> > g(n);
    for (auto [x, type, id] : events) {
        if (type == 1) {
            if (t[id]) {
                gopened.insert(id);
            } else {
                bopened.insert(id);
            }
        } else {
            if (t[id]) {
                gopened.erase(id);
                for (auto id1 : bopened) {
                    g[id1].push_back(id);
                    g[id].push_back(id1);
                }
            } else {
                bopened.erase(id);
                for (auto id1 : gopened) {
                    g[id1].push_back(id);
                    g[id].push_back(id1);
                }
            }
        }
    }
    vector<int> gptr(n);
    vector<int> amount(n);
    for (int i = 0; i < n; ++i) {
        for (auto j: g[i]) {
            if (t[j]) {
                ++amount[i];
            }
        }
    }
    int M = dp.back();
    auto am0 = amount;
    mt19937 rnd(14488);
    for (int iter = 0; iter < 1; ++iter) {
        vector <int> order(n);
        iota(all(order), 0);
        shuffle(all(order), rnd);
        vector<int> res;
        vector<bool> del(n);
        amount = am0;
        for (int it = 0; it < M / 2; ++it) {
            int bsti = -1, bst = 1e9;
            for (auto i : order) {
                if (t[i] && !del[i]) {
                    int c = 0;
                    for (auto j: g[i]) {
                        if (amount[j] == 1) {
                            ++c;
                        }
                    }
                    if (c < bst) {
                        bst = c;
                        bsti = i;
                    }
                }
            }
            del[bsti] = true;
            res.push_back(bsti);
            for (auto j: g[bsti]) {
                --amount[j];
                if (!amount[j]) {
                    res.push_back(j);
                    del[j] = true;
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            if (!t[i] && !del[i]) {
                if (sz(res) < n / 2) {
                    res.push_back(i);
                }
            }
        }
        if (sz(res) == n / 2) {
            vector<int> pt(n, 1);
            for (auto i: res) {
                pt[get<2>(v[i])] = 0;
            }
            for (int i = 0; i < n; ++i) {
                if (pt[i]) {
                    cout << i + 1 << " ";
                }
            }
            return;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}