#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include "bits/stdc++.h"
#include <array>

using namespace std;
using ll = long long;
#define int int_fast16_t
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()

struct segtree {
	int size;
	vector<int> t;

	segtree(int n = 0) {
		size = 1;
		while (size <= n) size *= 2;
		t.resize(2 * size, -1);
	}

	int get(int l, int r) {
		int res = -1;
		for (l += size, r += size; l < r; l >>= 1, r >>= 1) {
			if (l & 1) res = max(res, t[l++]);
			if (r & 1) res = max(res, t[--r]);
		}
		return res;
	}

	void set(int pos, int v) {
		t[pos += size] = v;
		for (pos >>= 1; pos; pos >>= 1)
			t[pos] = max(t[pos << 1 | 1], t[pos << 1]);
	}
};

constexpr int N = 2005;

segtree stx[N], sty[N];
set<int> hx[N], hy[N];

inline void upd(int i, int j, int val) {
	stx[j].set(i, val);
	sty[i].set(j, val);

	if (val != -1) {
		hx[j].insert(i);
		hy[i].insert(j);
	} else {
		hx[j].erase(i);
		hy[i].erase(j);
	}
}

void solve_case() {
	int n; cin >> n;
	assert(n < 2000);
	vector<int> a(n);
	for (auto& x : a)
		cin >> x;

	for (int i = 0; i <= n + 1; i++) {
		stx[i] = sty[i] = segtree(n + 2);
		hx[i] = hy[i] = {};
	}

	upd(a[0], 0, 1);
	upd(n + 1, a[0], 1);

	for (int i = 1; i < n; i++) {
		vector<array<int, 3>> change;

		for (int mx = 0; mx <= n + 1; mx++) {
			int now = stx[mx].get(a[i] + 1, n + 3);

			if (a[i] > mx) {
				while (hx[mx].size() && *(--hx[mx].end()) > a[i]) {
					change.push_back({ *(--hx[mx].end()), mx, -1 });
					hx[mx].erase(--hx[mx].end());
				}
			}

			if (now != -1) {
				change.push_back(array<int, 3>{ a[i], mx, now + 1 });
			}
		}

		for (int mn = 0; mn <= n + 1; mn++) {
			int now = sty[mn].get(0, a[i]);

			if (a[i] < mn) {
				while (hy[mn].size() && *hy[mn].begin() < a[i]) {
					change.push_back({ mn, *hy[mn].begin(), -1 });
					hy[mn].erase(hy[mn].begin());
				}
			}

			if (now != -1) {
				change.push_back({ mn, a[i], now + 1 });
			}
		}

		for (auto& [x, y, v] : change)
			upd(x, y, v);
	}

	int ans = 0;
	for (int i = 0; i <= n + 1; i++)
		ans = max(ans, stx[i].get(0, n + 3));
	
	cout << ans << "\n";
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
	cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}