#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <random>

using namespace std;

#define int long long

int n, m;
vector<pair<int, int>> v;
vector<int> cur;

vector<int> ord;

bool found = false;

int mx_n;

int get_mx_set(vector<int> now) {
    vector<int> dp(mx_n, 0);
    vector<vector<int>> end(mx_n);
    for (int i = 0; i < now.size(); ++i) {
        int j = now[i];
        end[v[j].second].push_back(v[j].first);
    }
    for (int i = 0; i < mx_n; ++i) {
        for (auto l : end[i]) {
            int p = 0;
            if (l != 0) {
                p = dp[l - 1];
            }
            dp[i] = max(dp[i], p + 1);
        }
        if (i != 0) {
            dp[i] = max(dp[i], dp[i - 1]);
        }
    }
    return dp.back();
}

bool check() {
    return get_mx_set(cur) == m / 2;
}

void gen(int i, int taken) {
    if (found) return;
    if (taken == n / 2) {
        if (check()) {
            found = true;
            for (auto x : cur) {
                cout << ord[x] + 1 << " ";
            }
        }
        return;
    }
    cur.push_back(i);
    gen(i + 1, taken + 1);
    cur.pop_back();
    if (taken + (n - i - 1) >= n / 2) {
        gen(i + 1, taken);
    }
}

bool cmp(int a, int b) {
    return v[a].second < v[b].second;
}

void solve() {
    cin >> n;
    v.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    ord.resize(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), cmp);
    vector<pair<int, int>> vv(n);
    for (int i = 0; i < n; ++i) {
        vv[i] = v[ord[i]];
    }
    v = vv;
    vector<int> ww;
    for (auto i : v) {
        ww.push_back(i.first);
        ww.push_back(i.second);
    }
    sort(ww.begin(), ww.end());
    ww.resize(unique(ww.begin(), ww.end()) - ww.begin());
    for (auto &i : v) {
        i.first = lower_bound(ww.begin(), ww.end(), i.first) - ww.begin();
        i.second = lower_bound(ww.begin(), ww.end(), i.second) - ww.begin();
    }
    mx_n = ww.size();
    vector<int> pipi(n);
    iota(pipi.begin(), pipi.end(), 0);
    m = get_mx_set(pipi);
    found = false;
    gen(0, 0);
}

signed main() {
#ifdef BENTSA
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}
