#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <random>

using namespace std;

#define int long long

const int MAXN = 2e5;

int n, q;
int x, y, m;

vector<int> g[MAXN];

int l[MAXN], r[MAXN];

vector<int> qq;

void clear() {
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
}

int dp[MAXN][2];

void dfs(int v, int p) {
    dp[v][0] = 0;
    dp[v][1] = r[v];
    for (auto u : g[v]) {
        if (u == p) continue;
        dfs(u, v);
        dp[v][0] += max(dp[u][0], dp[u][1]);
        dp[v][1] += dp[u][0];
    }
}

void solve() {
    cin >> n >> q;
    clear();
    cin >> x >> y >> m;
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    qq.resize(q);
    for (int i = 0; i < q; ++i) {
        cin >> qq[i];
    }
    dfs(0, -1);
    int mx = max(dp[0][0], dp[0][1]);
    vector<int> ans(q);
    int kk = 0;
    for (int i = 0; i < n; ++i) {
        kk = kk^((x * (i + 1) + y * l[i] * l[i]) % m);
    }
    for (int i = 0; i < q; ++i) {
        if (qq[i] != mx) {
            ans[i] = -1;
        } else {
            ans[i] = kk;
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << " ";
    }
    cout << endl;
    cout.flush();
    while (true) {
        int i;
        cin >> i;
        if (i == 0) break;
        --i;
        if (ans[i] == -1) {
            cout << -1;
        } else {
            for (int j = 0; j < n; ++j) {
                cout << l[j] << " ";
            }
        }
        cout << endl;
        cout.flush();
    }
}

signed main() {
#ifdef BENTSA
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}