#include <iostream>
#include <vector>
#include <array>
#include <algorithm>
#include <set>

using namespace std;

struct Node {
    vector<long> other;
    long left;
    long right;
    long ind;
    Node *l;
    Node *r;

    Node(long _left, long _right, long _ind) {
        left = _left;
        right = _right;
        l = r = nullptr;
        ind = _ind;
    }
};

vector<array<long, 2>> in;
set<long> included;

void update(Node *curr) {
    long back = -1, front = 1e9 + 7;

    if (curr->l) {
        back = curr->l->right;
    }
    if (curr->r) {
        front = curr->r->left;
    }
    curr->other.clear();
    for (auto i: included) {
        if (in[i][0] > back && in[i][1] < front)
            curr->other.push_back(i);
    }
}

set<pair<long, Node *>> minn;

void del1(Node *curr) {
//    included.erase(curr->ind);
    for (auto u: curr->other)
        included.erase(u);
    if (curr->l) {
        curr->l->r = curr->r;
        minn.erase({long(curr->l->other.size()), curr->l});
        update(curr->l);
        minn.insert({long(curr->l->other.size()), curr->l});
    }
    if (curr->r) {
        curr->r->l = curr->l;
        minn.erase({long(curr->r->other.size()), curr->r});
        update(curr->r);
        minn.insert({long(curr->r->other.size()), curr->r});
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long t;
    cin >> t;
    for (long h = 0; h < t; ++h) {
        minn.clear(), in.clear(), included.clear();
        long n;
        cin >> n;
        vector<array<long, 3>> data;
        for (long i = 0; i < n; ++i) {
            long l, r;
            cin >> l >> r;
            data.push_back({l, r, i});
            in.push_back({l, r});
            included.insert(i);
        }
        sort(data.begin(), data.end());
        long last = -1;
        long m = 0;
        vector<Node *> data2;
        for (long i = 0; i < n; ++i) {
            if (data[i][0] > last) {
                last = data[i][1];
                Node *curr = new Node(data[i][0], data[i][1], data[i][2]);
                if (data2.size()) {
                    data2.back()->r = curr;
                    curr->l = data2.back();
                }
                data2.push_back(curr);
                ++m;
            }
        }
        for (long i = 0; i < data2.size(); ++i) {
            update(data2[i]);
            minn.insert({long((data2[i]->other).size()), data2[i]});
        }
        while (2 * minn.size() > m) {
            auto curr = *minn.begin();
            minn.erase(minn.begin());
            del1(curr.second);
        }
        set<long> answer;
        for (auto u: minn)
            answer.insert(u.second->ind);

        for (auto u: included) {
            if (answer.size() * 2 == n)
                break;
            answer.insert(u);
        }
        for (auto u: answer)
            cout << u + 1 << " ";
        cout << endl;
    }
    return 0;
}