#include <iostream>
#include <vector>
#include <array>
#include <algorithm>
#include <set>

using namespace std;
long a = 300, b = 300;


vector<vector<bool>> dp(a + 1, vector<bool>(b + 1, false));

void update(long long u) {
    vector<vector<bool>> dp_last = dp;

    for (long i = a; i >= 0; --i) {
        if (i - u < 0)
            break;
        for (long j = b; j >= 0; --j) {
            if (dp_last[i - u][j])
                dp[i][j] = dp_last[i - u][j];
        }
    }
    for (long i = a; i >= 0; --i) {
        for (long j = b; j >= 0; --j) {
            if (j - u < 0)
                break;
            if (dp_last[i][j - u])
                dp[i][j] = dp_last[i][j - u];
        }
    }
}

long long get_summ(long i1, long j1) {
    long long result = 0;
    for (long i = 0; i <= i1; ++i) {
        for (long j = 0; j <= j1; ++j) {
            if (dp[i][j]) {
                ++result;
            }
        }
    }
    return result;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long n, q;
    cin >> n >> q;
    vector<long long> w(n);
    for (long i = 0; i < n; ++i) {
        cin >> w[i];
    }
    long z;
    cin >> z;
    sort(w.begin(), w.end());
    dp[0][0] = true;
    vector<bool> answers(q, 0);
    vector<array<long, 4>> all_q;
    for (long i = 0; i < q; ++i) {
        long j, c, d;
        cin >> j >> c >> d;
        all_q.push_back({j, c, d, i});
    }
    sort(all_q.begin(), all_q.end());
    long curr = -1;
    for (long i = 0; i < q; ++i) {
        auto [j, c, d, ind] = all_q[i];
        while (curr + 1 < n && w[curr + 1] <= j) {
            ++curr;
            update(w[curr]);
        }
        if (get_summ(c, d) == (c + 1) * (d + 1))
            answers[ind] = 1;
    }
    for (auto u: answers) {
        if (u)
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }
    return 0;
}