#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;

vector<int> reverseLeft(deque<int>& a) {
  int n = size(a);
  vector<int> b(n);
  int l = 0;
  while (l < n) {
    if (a[l] == 1) return {};
    int at = -1;
    int cnt = 0;
    for (int r = l; r < n; ++r) {
      if (a[r]) {
        cnt += 1;
      }
      if (cnt * 2 == r - l + 1) {
        at = r;
        break;
      }
    }
    if (at == -1) {
      b[l] = a[l];
      ++l;
    } else {
      for (int i = l; i <= at; ++i) {
        b[i] = 1 - a[i];
      }
      l = at + 1;
    }
  }
  return b;
}

vector<int> reverseRight(deque<int>& a) {
  int n = size(a);
  vector<int> b(n);
  int r = n - 1;
  while (r >= 0) {
    if (a[r] == 1) return {};
    int at = -1;
    int cnt = 0;
    for (int l = r; l >= 0; --l) {
      if (a[l]) {
        cnt += 1;
      }
      if (cnt * 2 == r - l + 1) {
        at = l;
        break;
      }
    }
    if (at == -1) {
      b[r] = a[r];
      --r;
    } else {
      for (int i = at; i <= r; ++i) {
        b[i] = 1 - a[i];
      }
      r = at - 1;
    }
  }
  return b;
}

void code() {
  int n, k;
  cin >> n >> k;
  deque<int> a(n);
  for (int i = 0; i < k; ++i) {
    int x;
    cin >> x;
    a[x - 1] = 1;
  }
  int need = 0, cnt0 = 0, cnt1 = 0;
  for (int i = n - 1; i >= 0; --i) {
    if (a[i]) ++cnt1;
    else ++cnt0;
    need = max(need, cnt1 - cnt0);
  }
  int mov = 0;
  int cur = 0;
  while (cur < need) {
    if (a.front() == 1) --cur;
    else ++cur;
    a.push_back(a.front());
    a.pop_front();
    ++mov;
  }
  auto b = reverseRight(a);
  vector<int> res;
  for (int i = 0; i < n; ++i) {
    if (b[i]) {
      int cur = i + 1 + mov;
      while (cur > n) cur -= n;
      res.push_back(cur);
    }
  }
  sort(all(res));
  for (int x : res) cout << x << ' ';
  cout << endl;
}

void decode() {
  int n, k;
  cin >> n >> k;
  deque<int> a(n);
  for (int i = 0; i < k; ++i) {
    int x;
    cin >> x;
    a[x - 1] = 1;
  }
  int need = 0, cnt0 = 0, cnt1 = 0;
  for (int i = 0; i < n; ++i) {
    if (a[i]) ++cnt1;
    else ++cnt0;
    need = max(need, cnt1 - cnt0);
  }
  int mov = 0;
  int cur = 0;
  while (cur < need) {
    int v = a.back();
    if (v == 1) --cur;
    else ++cur;
    a.pop_back();
    a.push_front(v);
    ++mov;
  }
  auto b = reverseLeft(a);
  vector<int> res;
  for (int i = 0; i < n; ++i) {
    if (b[i]) {
      int cur = i + 1 - mov;
      while (cur < 1) cur += n;
      res.push_back(cur);
    }
  }
  sort(all(res));
  for (int x : res) cout << x << ' ';
  cout << endl;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int zap, tt;
  cin >> zap >> tt;
  if (zap == 1) {
    while (tt--) {
      code();
    }
  } else {
    while (tt--) {
      decode();
    }
  }
  return 0;
}