#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
using namespace std;
const int maxn = 2048;
struct stree {
    int tree[maxn * 2];

    int get(int l, int r) {
        l += maxn;
        r += maxn;
        int ans = 0;
        while (l < r) {
            if (l & 1) ans = max(ans, tree[l++]);
            if (r & 1) ans = max(ans, tree[--r]);
            l >>= 1;
            r >>= 1;
        }
        return ans;
    }

    void upd(int i, int x) {
        i += maxn;
        tree[i] = x;
        while (i > 1) {
            i >>= 1;
            tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
        }
    }
    stree() {
        fill(tree, tree + maxn * 2, -maxn);
    }
};

void solve1() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    vector<vector<int>> dp(n + 2, vector<int> (n + 2, -n));
    dp[n + 1][0] = 0;
    vector<stree> prefr(n + 2);
    vector<stree> sufc(n + 2);
    prefr[n + 1].upd(0, 0);
    sufc[0].upd(n + 1, 0);
    for (int q = 0; q < n; ++q) {
        for (int i = 0; i <= n + 1; ++i) {
            dp[i][a[q]] = prefr[i].get(0, a[q]) + 1;
            dp[a[q]][i] = sufc[i].get(a[q], n + 1) + 1;
        }
        for (int i = 0; i <= n + 1; ++i) {
            prefr[i].upd(a[q], dp[i][a[q]]);
            sufc[a[q]].upd(i, dp[i][a[q]]);
            sufc[i].upd(a[q], dp[a[q]][i]);
            prefr[a[q]].upd(i, dp[a[q]][i]);
        }
    }
    int ans = 0;
    for (int i = 0; i < n + 2; ++i) {
        ans = max(ans, *max_element(dp[i].begin(), dp[i].end()));
    }
    cout << ans << '\n';
}

int32_t main() {
    int t;
    cin >> t;
    while (t--) {
        solve1();
    }
}