#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
using namespace std;

void solve1() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    vector<vector<int>> dp(n + 2, vector<int> (n + 2, -n));
    vector<int> row(n + 2, 0);
    vector<int> col(n + 2, 0);
    vector<int> pref(n + 2, 0);
    vector<int> suf(n + 2, 0);
    int mrow = n + 1;
    int mcol = 0;
    auto getRow = [&] (int r, int c) {
        if (r == mrow) {
            return pref[c];
        } else {
            if (mcol <= c) {
                return dp[r][mcol];
            }
            return -n;
        }
    };
    auto getCol = [&] (int r, int c) {
        if (r == mcol) {
            return suf[c];
        } else {
            if (c <= mrow) {
                return dp[mrow][r];
            } else {
                return -n;
            }
        }
    };
    for (int q = 0; q < n; ++q) {
        for (int i = 0; i <= n + 1; ++i) {
            dp[i][a[q]] = getRow(i, a[q]) + 1;
            dp[a[q]][i] = getCol(i, a[q]) + 1;
        }
        mrow = a[q];
        mcol = a[q];
        pref[0] = dp[a[q]][0];
        suf[n + 1] = dp[n + 1][a[q]];
        for (int i = 1; i <= n + 1; ++i) {
            pref[i] = max(dp[a[q]][i], pref[i - 1]);
        }
        for (int i = n; i >= 0; --i) {
            suf[i] = max(dp[i][a[q]], suf[i + 1]);
        }
    }
    int ans = 0;
    for (int i = 0; i < n + 2; ++i) {
        ans = max(ans, *max_element(dp[i].begin(), dp[i].end()));
    }
    cout << ans << '\n';
}

int32_t main() {
    int t;
    cin >> t;
    while (t--) {
        solve1();
    }
}#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
using namespace std;

void solve1() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    vector<vector<int>> dp(n + 2, vector<int> (n + 2, -n));
    vector<int> row(n + 2, 0);
    vector<int> col(n + 2, 0);
    vector<int> pref(n + 2, 0);
    vector<int> suf(n + 2, 0);
    int mrow = n + 1;
    int mcol = 0;
    auto getRow = [&] (int r, int c) {
        if (r == mrow) {
            return pref[c];
        } else {
            if (mcol <= c) {
                return dp[r][mcol];
            }
            return -n;
        }
    };
    auto getCol = [&] (int r, int c) {
        if (r == mcol) {
            return suf[c];
        } else {
            if (c <= mcol) {
                return dp[c][mcol];
            } else {
                return -n;
            }
        }
    };
    for (int q = 0; q < n; ++q) {
        for (int i = 0; i <= n + 1; ++i) {
            dp[i][a[q]] = getRow(i, a[q]) + 1;
            dp[a[q]][i] = getCol(i, a[q]) + 1;
        }
        mrow = a[q];
        mcol = a[q];
        pref[0] = dp[a[q]][0];
        suf[n + 1] = dp[n + 1][a[q]];
        for (int i = 1; i <= n + 1; ++i) {
            pref[i] = max(dp[a[q]][i], pref[i - 1]);
        }
        for (int i = n; i >= 0; --i) {
            suf[i] = max(dp[i][a[q]], suf[i + 1]);
        }
    }
    int ans = 0;
    for (int i = 0; i < n + 2; ++i) {
        ans = max(ans, *max_element(dp[i].begin(), dp[i].end()));
    }
    cout << ans << '\n';
}

int32_t main() {
    int t;
    cin >> t;
    while (t--) {
        solve1();
    }
}