#include <iostream>
#include <algorithm>
#include <cassert>
#include <vector>
#include <set>
using namespace std;
#define int long long
bool ok(pair<int, int> a, pair<int, int> b) {
    return a.second < b.first || b.second < a.first;
}

int f(vector<pair<int, int>> a) {
    vector<int> dp(a.size(), 0);
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        dp[i] = 1;
        for (int j = 0; j < i; ++j) {
            if (a[j].second < a[i].first) {
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }
    }
    return *max_element(dp.begin(), dp.end());
}

const int inf =  1e9;

void solve() {
    int n;
    cin >> n;
    vector<pair<pair<int, int>, int>> segsp;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        segsp.push_back({ { l, r }, i });
    }
    vector<pair<int, int>> segs;
    sort(segsp.begin(), segsp.end());
    for (int i = 0; i < n; ++i) {
        p[i] = segsp[i].second;
        segs.push_back(segsp[i].first);
    }
    cerr << f(segs) << endl;
    int need = f(segs) / 2;
    set<int> all;
    for (int i = 0; i < n / 2; ++i) {
        vector<pair<int, int>> dp(segs.size(), { 0, 0 });
        vector<int> par(segs.size(), -1);
        for (int i = 0; i < segs.size(); ++i) {
            dp[i] = { 1, 1 };
            for (int j = 0; j < i; ++j) {
                if (segs[j].second < segs[i].first) {
                    if (dp[i].first < dp[j].first + 1) {
                        dp[i] = dp[j];
                        ++dp[i].first;
                        par[i] = j;
                    } else if (dp[i].first == dp[j].first + 1) {
                        dp[i].second += dp[j].second;
                    }
                }
            }
            dp[i].second = min(dp[i].second, inf);
        }
        vector<pair<int, int>> dp1(segs.size(),  { 0, 0 });
        for (int i = segs.size() - 1; i >= 0; --i) {
            dp1[i] = { 1, 1 };
            for (int j = i + 1; j < segs.size(); ++j) {
                if (segs[j].first > segs[i].second) {
                    if (dp1[i].first < dp1[j].first + 1) {
                        dp1[i] = dp1[j];
                        ++dp1[i].first;
                    } else if (dp1[i].first == dp1[j].first + 1) {
                        dp1[i].second += dp1[j].second;
                    }
                }
            }
            dp1[i].second = min(dp1[i].second, inf);
        }
        vector<pair<int, int>> res(segs.size());
        for (int i = 0; i < segs.size(); ++i) {
            res[i] = { dp[i].first + dp1[i].first, dp[i].second * dp1[i].second };
        }
        if (f(segs) > need) {
            int j = max_element(res.begin(), res.end()) - res.begin();
            segs.erase(segs.begin() + j);
            p.erase(p.begin() + j);
        } else {
            int ptr = max_element(dp.begin(), dp.end()) - dp.begin();
            while (ptr != -1) {
                all.insert(p[ptr]);
                ptr = par[ptr];
            }
            break;
        }
    }
    while (p.size() != n / 2) {
        for (int j = 0; j < p.size(); ++j) {
            if (!all.count(j)) {
                p.erase(p.begin() + j);
                segs.erase(segs.begin() + j);
                break;
            }
        }
    }
    assert(f(segs) <= need);
    cerr << f(segs) << endl;
    for (int i : p) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

int32_t main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}