#include <iostream>
#include <algorithm>
#include <cassert>
#include <vector>
using namespace std;

bool ok(pair<int, int> a, pair<int, int> b) {
    return a.second < b.first || b.second < a.first;
}

int f(vector<pair<int, int>> a) {
    sort(a.begin(), a.end());
    vector<int> dp(a.size(), 0);
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        dp[i] = 1;
        for (int j = 0; j < i; ++j) {
            if (a[j].second < a[i].first) {
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }
    }
    return *max_element(dp.begin(), dp.end());
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> segs;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) p[i] = i;
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        segs.push_back({ l, r });
    }
    cerr << f(segs) << endl;
    int need = f(segs) / 2;
    for (int i = 0; i < n / 2; ++i) {
        vector<int> cnt(segs.size(), 0);
        for (int i = 0; i < segs.size(); ++i) {
            for (int j = 0; j < segs.size(); ++j) {
                if (ok(segs[i], segs[j])) ++cnt[i];
            }
        }
        int j = max_element(cnt.begin(), cnt.end()) - cnt.begin();
        segs.erase(segs.begin() + j);
        p.erase(p.begin() + j);
    }
    assert(f(segs) <= need);
    for (int i : p) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}