#pragma GCC optimize ("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define assing assign
#define all(x) x.begin(), x.end()
#define int ll

int get(const vector<pair<int, int>>& a) {
    int n = a.size();

    vector<tuple<int, int, int>> ev;
    for (auto& [l, r] : a) {
        ev.push_back({l, l, r});
        ev.push_back({r, l, r});
    }
    sort(all(ev));

    vector<int> dp(2 * n);
    for (int i = 1; i < 2 * n; ++i) {
        auto [x, l, r] = ev[i];
        if (x == l)
            dp[i] = dp[i - 1];
        else
            dp[i] = max(dp[i - 1], dp[lower_bound(all(ev), make_tuple(l, l, r)) - ev.begin()] + 1);
    }
    return dp.back();
}

ld my_random() {
    return (ld)rand() / RAND_MAX;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (auto& [l, r] : a)
        cin >> l >> r;

    int m = get(a);

    vector<int> p(n);
    iota(all(p), 0);
    shuffle(all(p), default_random_engine(time(0)));
    vector<bool> used(n);
    for (int i = 0; i < n / 2; ++i)
        used[p[i]] = 1;

    auto build = [&](const vector<bool>& v)->vector<pair<int, int>> {
        vector<pair<int, int>> ans;
        for (int i = 0; i < n; ++i)
            if (v[i])
                ans.push_back(a[i]);
        return ans;
    };

    auto count = [&](const vector<bool>& v)->int {
        return abs(m / 2 - get(build(v)));
    };

    ld temp = 1;
    int t = 50000;
    while (t--) {
        if (count(used) == 0)
            break;

        temp *= 0.99;

        int x = rand() % (n / 2), y = rand() % (n / 2);
        int xi = 0;
        while (x > 0) {
            if (used[xi])
                --x;
            ++xi;
        }
        int yi = 0;
        while (y > 0) {
            if (!used[yi])
                --y;
            ++yi;
        }

        auto used1 = used;
        swap(used1[xi], used1[yi]);
        int cur = count(used), to = count(used1);
        if (cur > to || my_random() < exp((ld)(cur - to) / temp))
            used = used1;
    }

    for (int i = 0; i < n; ++i)
        if (used[i])
            cout << i + 1 << " ";
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t=  1;
    cin >> t;
    while (t--)
        solve();
}

/*
1
6
1 2
2 4
1 2
1 4
5 7
6 8
 */