#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

vector<int> tree;

int mx(int v, int l, int r, int ql, int qr) {
    if (ql == qr) {
        return 0;
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return tree[v];
    }
    return max(mx(v * 2 + 1, l, (l + r) / 2, ql, qr), mx(v * 2 + 2, (l + r) / 2, r, ql, qr));
}

void upd(int v, int l, int r, int i, int x) {
    if (l + 1 == r) {
        tree[v] = max(x, tree[v]);
        return;
    }
    if ((l + r) / 2 <= i) {
        upd(v * 2 + 2, (l + r) / 2, r, i, x);
    } else {
        upd(v * 2 + 1, l, (l + r) / 2, i, x);
    }
    tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
}

int get(vector<int> a, int M) {
    tree.assign(M * 4, 0);
    for (int i = 0; i < a.size(); ++i) {
        int res = mx(0, 0, M, 0, a[i]);
        ++res;
        upd(0, 0, M, a[i], res);
    }
    return *max_element(tree.begin(), tree.end());
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int res = get(a, n + 1);
    cout << min(n, res + 1) << "\n";
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}