#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

vector<vector<int>> dp;

void dfs(int v, vector<vector<int>> &gr, int p, vector<int> &a) {
    for (auto u: gr[v]) {
        if (u != p) {
            dfs(u, gr, v, a);
            dp[v][0] += max(dp[u][1], dp[u][0]);
            dp[v][1] += dp[u][0];
        }
    }
    dp[v][1] += a[v];
}

int get(vector<int> a, int x, int y, int m) {
    int n = a.size();
    int k = 0;
    for (int i = 0; i < n; ++i) {
        k ^= (x * (i + 1) + ((y * a[i]) % m) * a[i]) % m;
    }
    return k;
}

void solve() {
    int n, q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    vector<vector<int>> gr(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        cin >> b[i];
    }
    int k = 0;
    for (int i = 0; i < n; ++i) {
        k ^= (x * (i + 1) + ((y * a[i]) % m) * a[i]) % m;
    }
    dp.assign(n, vector<int>(2));
    dfs(0, gr, -1, a);
    int res1 = max(dp[0][0], dp[0][1]);
    dp.assign(n, vector<int>(2));
    dfs(0, gr, -1, b);
    int res2 = max(dp[0][0], dp[0][1]);
    vector<int> ans(q, -1);
    vector<vector<int>> ans1(q);
    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        if (v >= res1 && v <= res2) {
            vector<int> now = a;
            for (int j = 0; j < n; ++j) {
                dp.assign(n, vector<int>(2));
                dfs(0, gr, -1, now);
                int res = max(dp[0][0], dp[0][1]);
                while (res < v && now[j] < b[j]) {
                    ++now[j];
                    dp.assign(n, vector<int>(2));
                    dfs(0, gr, -1, now);
                    res = max(dp[0][0], dp[0][1]);
                }
            }
            ans1[i] = now;
            cout << get(now, x, y, m) << " ";
            cout.flush();
            ans[i] = get(now, x, y, m);
        } else {
            cout << -1 << " ";
            cout.flush();
        }
    }
    int i;
    cin >> i;
    while (i != 0) {
        --i;
        if (ans[i] == -1) {
            cout << -1 << endl;
        } else {
            for (auto j: ans1[i]) {
                cout << j << " ";
            }
            cout << endl;
        }
        cin >> i;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}