#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
vector<vector<int>> graph;
vector<int> ans;
vector<int> p;
vector<int> _sz;
vector<int> dp;
vector<bool> use;
int get(int x) {
    if (x == p[x]) {
        return x;
    } else {
        p[x] = get(p[x]);
        return p[x];
    }
}
void unite(int a, int b) {
    a = get(a);
    b = get(b);
    if (a != b) {
        if (_sz[a] < _sz[b]) {
            swap(a, b);
        }
        p[b] = a;
        _sz[a] += _sz[b];
    }
}
vector<bool> vis;
void dfs(int x) {
    vis[x] = true;
    for (auto &i : graph[x]) {
        if (!vis[i]) {
            dfs(i);
        }
        dp[x] = max(dp[x], dp[i]);
    }
    dp[x]++;
}
void dfs2(int x) {
    if (!use[x]) {
        return;
    }
    vis[x] = true;
    for (auto &i : graph[x]) {
        if (!vis[i]) {
            dfs(i);
        }
        dp[x] = max(dp[x], dp[i]);
    }
    dp[x]++;
}
bool comp(pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
    return a.first.first < b.first.first || (a.first.first == b.first.first && a.first.second < b.first.second);
}
int main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        dp.assign(n, 0);
        vis.assign(n, false);
        graph.assign(n, {});
        use.assign(n, false);
        vector<pair<pair<int, int>, int>> v(n);
        for (int i = 0; i < n; i++) {
            cin >> v[i].first.first >> v[i].first.second;
            v[i].second = i;
        }
        //sort(v.begin(), v.end(), comp);
        vector<pair<int, int>> minr(n);
        for (int i = n - 1; i >= 0; i--) {
            if (i == n - 1 || v[i].first.second < minr[i + 1].first) {
                minr[i] = {v[i].first.second, i};
            } else {
                minr[i] = minr[i + 1];
            }
        }
        for (int i = v.size() - 1; i >= 0; i--) {
            pair<pair<int, int>, int> pr = {{v[i].first.second + 1, v[i].first.second + 1}, 0};
            int l = lower_bound(v.begin() + i, v.end(), pr) - v.begin();
            if (l != n) {
                graph[i].push_back(minr[l].second);
            }
        }
        for (int i = 0; i < n; i++) {
            if (!vis[i]) {
                dfs(i);
            }
        }
        int bestone = -1;
        int bestlen = -1;
        vector<vector<int>> dpsort(n + 1);
        for (int i = 0; i < n; i++) {
            if (dp[i] > bestlen) {
                bestlen = dp[i];
                bestone = i;
            }
            dpsort[dp[i]].push_back(v[i].second);
        }
        int cur = 0;
        vector<int> ans;
        use[v[bestone].second] = true;
        cur++;
        ans.push_back(v[bestone].second + 1);
        while (graph[bestone].size() > 0) {
            bestone = graph[bestone][0];
            if (dp[bestone] > bestlen / 2) {
                use[v[bestone].second] = true;
                ans.push_back(v[bestone].second + 1);
                cur++;
            }
        }
        for (int i = n; i >= 1; i--) {
            for (auto &j : dpsort[i]) {
                if (cur == n / 2) {
                    break;
                }
                if (!use[j]) {
                    //cout << j << '\n';
                    ans.push_back(j + 1);
                    use[j] = true;
                    cur++;
                }
            }
            if (cur == n / 2) {
                break;
            }
        }
        vis.assign(n, false);
        for (int i = 0; i < n; i++) {
            dfs2(i);
        }
        bool answer = true;
        for (int i = 0; i < n; i++) {
            if (dp[i] > bestlen / 2) {
                answer = false;
            }
        }
        if (answer) {
            cout << -1 << '\n';
        } else {
            for (auto &i : ans) {
                cout << i << " ";
            }
            cout << '\n';
        }
    }
}
