#include <bits/stdc++.h>

#define int long long
#define sz(v) (int)v.size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pb push_back
#define eb emplace_back
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define vpi vector<pii>
#define ll long long
#define ld long double
#define For(i, n) for (int i = 0; i < n; i++)

using namespace std;

const int INF = 1e9 + 7;
const int INFLL = 1e18 + 3;

mt19937 rnd(time(0));


struct Fenwick {
    int n;
    vi s;
    Fenwick(int nn) {
        n = nn;
        s.resize(n);
    }
    int get_pref(int r) {
        int res = 0;
        for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
            res = max(res, s[i]);
        }
        return res;
    }
    void upd(int pos, int val) {
        for (int i = pos; i < n; i = (i | (i + 1))) {
            s[i] = max(s[i], val);
        }
    }
};


struct event {
    int x, id, type;
};
bool cmp(event & e1, event & e2) {
    if (e1.x == e2.x) {
        return e1.type < e2.type;
    } else {
        return e1.x < e2.x;
    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    string da = "YES\n", net = "NO\n", OK = "OK\n";

    int T;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        vpi seg(n);
        For(i, n) cin >> seg[i].first >> seg[i].second;
        vi compress;
        For(i, n) {
            compress.pb(seg[i].first);
            compress.pb(seg[i].second);
        }
        sort(all(compress));
        compress.erase(unique(all(compress)), compress.end());
        For(i, n) {
            seg[i].first = lower_bound(all(compress), seg[i].first) - compress.begin();
            seg[i].second = lower_bound(all(compress), seg[i].second) - compress.begin();
        }
        vector<event> vec;
        For(i, n) {
            vec.pb({seg[i].first, i, 0});
            vec.pb({seg[i].second, i, 1});
        }
        sort(all(vec), cmp);
        vi dp(n);
        Fenwick fen(2 * n + 1);
        For(i, sz(vec)) {
            if (vec[i].type == 1) {
                fen.upd(vec[i].x, dp[vec[i].id]);
            } else {
                dp[vec[i].id] = fen.get_pref(vec[i].x - 1) + 1;
            }
        }
        int m = *max_element(all(dp));
        if (m % 2 == 1) {
            exit(1);
        }
//        cout << m << endl;

        vi p(n);
        iota(all(p), 0);
        while (true) {
            random_shuffle(all(p));
            vi dp2(n);
            Fenwick fen2(2 * n + 1);
            vector<event> vec2;
            For(i, n / 2) {
                vec2.pb({seg[p[i]].first, p[i], 0});
                vec2.pb({seg[p[i]].second, p[i], 1});
            }
            sort(all(vec2), cmp);
            For(i, sz(vec2)) {
                if (vec2[i].type == 1) {
                    fen2.upd(vec2[i].x, dp2[vec2[i].id]);
                } else {
                    dp2[vec2[i].id] = fen2.get_pref(vec2[i].x - 1) + 1;
                }
            }
            int m2 = *max_element(all(dp2));
            if (m2 == m / 2) {
                For(i, n / 2) {
                    cout << p[i + n / 2] + 1 << ' ';
                }
                break;
            }
        }
        cout << endl;
    }
    return 1337 / 2286942;
}
