#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()

int max_nez(vector<pair<int, int>>& otr, vector<int>& zap) {
	int r = -1, ans = 0;
	for (int i = 0; i < (int)otr.size(); ++i) {
		if (zap[i]) {
			continue;
		}
		if (otr[i].second > r) {
			++ans;
			r = otr[i].first;
		}
	}
	return ans;
}

void solve() {
	int n; cin >> n;
	vector<pair<pair<int, int>, int>> otr_ws(n);
	for (int i = 0; i < n; ++i) {
		cin >> otr_ws[i].first.second >> otr_ws[i].first.first;
		otr_ws[i].second = i;
	}
	sort(all(otr_ws));
	vector<pair<int, int>> otr(n);
	for (int i = 0; i < n; ++i) {
		otr[i] = otr_ws[i].first;
	}
	vector<int> zap(n, 0);
	int m = max_nez(otr, zap);
	for (int mask = 0; mask < (1 << n); ++mask) {
		int hm = 0;
		for (int i = 0; i < n; ++i) {
			zap[i] = ((mask >> i) & 1);
			hm += zap[i];
		}
		if (hm * 2 == n) {
			int m_now = max_nez(otr, zap);
			if (m_now * 2 == m) {
				for (int i = 0; i < n; ++i) {
					if (zap[i]) {
						continue;
					}
					cout << otr_ws[i].second + 1 << ' ';
				}
				cout << '\n';
				return;
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}
