#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5 + 5;
array<int, 2> tree[8 * MAXN];
array<int, 3> segs[MAXN];
int dp[MAXN], p[MAXN], used[MAXN];
int T, N, M;
void update(int p, int l, int r, int i, int x, int y) {
    if (r - l == 1) {
        tree[p] = max(tree[p], {x, -y});
        return;
    }
    int m = (l + r) / 2;
    if (i < m) {
        update(2 * p + 1, l, m, i, x, y);
    } else {
        update(2 * p + 2, m, r, i, x, y);
    }
    tree[p] = max(tree[2 * p + 1], tree[2 * p + 2]);
}

array<int, 2> query(int p, int l, int r, int lq, int rq) {
    if (rq <= l or r <= lq) {
        return {0, 1};
    } else if (lq <= l and r <= rq) {
        return tree[p];
    } else {
        int m = (l + r) / 2;
        return max(query(2 * p + 1, l, m, lq, rq), query(2 * p + 2, m, r, lq, rq));
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> T;
    for (int t = 0; t < T; ++t) {
        cin >> N;
        
        vector<int> c;
        for (int i = 0; i < N; ++i) {
            cin >> segs[i][0] >> segs[i][1];
            segs[i][2] = i;
            c.push_back(segs[i][0]);
            c.push_back(segs[i][1]);
        }
        sort(c.begin(), c.end());
        c.erase(unique(c.begin(), c.end()), c.end());
        sort(segs, segs + N, [](auto x, auto y) {
            swap(x[0], x[1]);
            swap(y[0], y[1]);
            return x < y;
        });
        for (int i = 0; i < N; ++i) {
            segs[i][0] = (int)(lower_bound(c.begin(), c.end(), segs[i][0]) - c.begin());
            segs[i][1] = (int)(lower_bound(c.begin(), c.end(), segs[i][1]) - c.begin());
        }
        M = c.size();
        fill_n(tree, 4 * M, array<int, 2>{0, 1});
        for (int i = 0; i < N; ++i) {
            array<int, 2> q = query(0, 0, M, 0, segs[i][0]);
            dp[i] = q[0] + 1;
            p[i] = -q[1];
            update(0, 0, M, segs[i][1], dp[i], i);
        }
        int j = max_element(dp, dp + N) - dp;
        int m = dp[j];
        fill_n(used, N, 0);
        vector<int> maxco;
        while (j >= 0) {
            used[j] = 1;
            maxco.push_back(j);
            if (p[j] == -1) break;
            j = p[j];
        }
        reverse(maxco.begin(),maxco.end());
        maxco.resize(maxco.size() / 2);
        vector<int> res = maxco;
        int i = 0, kl = 0;
        while (i < maxco.size() and kl < N) {
            if (used[kl]) {
                kl++;
                continue;
            }
            while (i < maxco.size() and segs[maxco[i]][1] < segs[kl][0]) ++i;
            if (i != maxco.size() and segs[maxco[i]][0] < segs[kl][1]) res.push_back(kl);
            ++kl;
        }
        while (res.size() > N / 2) res.pop_back();
        for (auto &x : res) {
            cout << segs[x][2] + 1 << " ";
        }
        cout << "\n";
    }
    return 0;
}