#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;
struct Node {
	int sum = 0;
	int ls = -1, rs = -1;
};
vector <Node> tree;
int n, k;
int get(int ql, int qr, int v = 0, int l = 0, int r = n) {
	if (r <= ql || qr <= l) return 0;
	if (l >= ql && r <= qr) return tree[v].sum;
	if (tree[v].ls == -1) {
		tree.push_back(Node());
		tree[v].ls = tree.size() - 1;
	}
	if (tree[v].rs == -1) {
		tree.push_back(Node());
		tree[v].rs = tree.size() - 1;
	}
	return get(ql, qr, tree[v].ls, l, (l + r) / 2) + get(ql, qr, tree[v].rs, (l + r) / 2, r);
}
void upd(int ind, int v = 0, int l = 0, int r = n) {
	if (ind < l || ind >= r) return;
	if (l == r - 1) { tree[v].sum++; return; }
	if (tree[v].ls == -1) {
		tree.push_back(Node());
		tree[v].ls = tree.size() - 1;
	}
	upd(ind, tree[v].ls, l, (l + r) / 2);
	if (tree[v].rs == -1) {
		tree.push_back(Node());
		tree[v].rs = tree.size() - 1;
	}
	upd(ind, tree[v].rs, (l + r) / 2, r);
	tree[v].sum = tree[tree[v].ls].sum + tree[tree[v].rs].sum;
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t, q; cin >> t >> q;
	if (t == 1) {
		while (q--) {
			cin >> n >> k;
			tree.clear();
			tree.push_back(Node());
			vector <int> a(k);
			for (int i = 0; i < k; i++) cin >> a[i], a[i]--, upd(a[i]);
			vector <int> ans;
			for (int i = 0; i < k; i++) {
				int l = -1, r = a[i];
				while (l < r - 1) {
					int m = (l + r) / 2;
					if (get(m, a[i]) != a[i] - m) l = m;
					else r = m;
				}
				if (l == -1) {
					int l = a[i], r = n;
					while (l < r - 1) {
						int m = (l + r) / 2;
						if (get(m, n) != n - m) l = m;
						else r = m;
					}
					ans.push_back(l + 1);
					upd(l);
				}
				else {
					ans.push_back(l + 1);
					upd(l);
				}
			}
			sort(ans.begin(), ans.end());
			for (auto i : ans) cout << i << ' ';
			cout << endl;
		}
	}
	else {
		while (q--) {
			cin >> n >> k;
			tree.clear();
			tree.push_back(Node());
			vector <int> a(k);
			for (int i = 0; i < k; i++) cin >> a[i], a[i]--, upd(a[i]);
			vector <int> ans;
			for (int i = 0; i < k; i++) {
				int l = a[i], r = n;
				while (l < r - 1) {
					int m = (l + r) / 2;
					if (get(a[i] + 1, m + 1) != m - a[i]) r = m;
					else l = m;
				}
				if (r == n) {
					int l = -1, r = a[i];
					while (l < r - 1) {
						int m = (l + r) / 2;
						if (get(0, m + 1) != m + 1) r = m;
						else l = m;
					}
					ans.push_back(r + 1);
					upd(r);
				}
				else {
					ans.push_back(r + 1);
					upd(r);
				}
			}
			sort(ans.begin(), ans.end());
			for (auto i : ans) cout << i << ' ';
			cout << endl;
		}
	}
	return 0;
}