#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <random>
#include <map>
#include <set>
#include <cassert>
using namespace std;
#define int long long
#define pi pair<int, int>
#define vi vector<int> 
const int INF = 1e18 + 10;
vi st;
vi compr;
void upd(int v, int l, int r, int pos, int val) {
	if (l > pos || r < pos) return;
	if (l == pos && r == pos) {
		st[v] = min(st[v], val);
		return;
	}
	int mid = (l + r) / 2;
	upd(2 * v, l, mid, pos, val);
	upd(2 * v + 1, mid + 1, r, pos, val);
	st[v] = min(st[2 * v], st[2 * v + 1]);
}
int get(int v, int l, int r, int L, int R) {
	if (l > R || L > r) return INF;
	if (l >= L && R >= r) return st[v];
	int mid = (l + r) / 2;
	return min(get(2 * v, l, mid, L, R), get(2 * v + 1, mid + 1, r, L, R));
}
int gt(int num) {
	return lower_bound(compr.begin(), compr.end(), num) - compr.begin();
}
void solve() {
	int N = 0; cin >> N;
	compr.clear();
	vector<pair<pi, int>> sgs;
	for (int i = 0; i < N; ++i) {
		int l = 0, r = 0; cin >> l >> r;
		sgs.push_back({ {l, -r}, i });
		compr.push_back(l); compr.push_back(r);
	}
	sort(compr.begin(), compr.end());
	sort(sgs.begin(), sgs.end());
	for (int i = 0; i < N; ++i) sgs[i].first.second *= -1;
	for (int i = 0; i < N; ++i) {
		sgs[i].first.first = gt(sgs[i].first.first);
		sgs[i].first.second = gt(sgs[i].first.second);
	}
	vector<int> noncover;
	vector<int> cover;
	st.assign(8 * N, INF);
	for (int i = N - 1; i >= 0; --i) {
		if (get(1, 0, 2 * N - 1, sgs[i].first.first, sgs[i].first.second) <= sgs[i].first.second) noncover.push_back(sgs[i].second);
		else cover.push_back(sgs[i].second);
		upd(1, 0, 2 * N - 1, sgs[i].first.first, sgs[i].first.second);
	}
	vector<int> pck;
	for (int i = 0; i < cover.size() / 2; ++i) pck.push_back(cover[i] + 1);
	for (int i = 0; i < noncover.size() / 2; ++i) {
		pck.push_back(noncover[i] + 1);
	}
	for (auto x : pck) cout << x << " ";
	cout << "\n";
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int T = 1; cin >> T;
	for (int i = 0; i < T; ++i) {
		solve();
	}
	return 0;
}
