#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <random>
#include <map>
#include <set>
#include <cassert>
using namespace std;
#define int long long
#define pi pair<int, int>
#define vi vector<int> 
const int INF = 1e9 + 10;
vi st;
vi compr;
void upd(int v, int l, int r, int pos, int val) {
	if (l > pos || r < pos) return;
	if (l == pos && r == pos) {
		st[v] = min(st[v], val);
		return;
	}
	int mid = (l + r) / 2;
	upd(2 * v, l, mid, pos, val);
	upd(2 * v + 1, mid + 1, r, pos, val);
	st[v] = min(st[2 * v], st[2 * v + 1]);
}
int get(int v, int l, int r, int L, int R) {
	if (l > R || L > r) return INF;
	if (l >= L && R >= r) return st[v];
	int mid = (l + r) / 2;
	return min(get(2 * v, l, mid, L, R), get(2 * v + 1, mid + 1, r, L, R));
}
int gt(int num) {
	return lower_bound(compr.begin(), compr.end(), num) - compr.begin();
}
vector<vector<int>> g;
vector<int> h;
vector<vi> dp;
vector<vi> dp2;
vi l; vi r;
void DFS(int v, int p) {
	dp[v][1] = r[v];
	dp2[v][1] = l[v];
	for (auto x : g[v]) {
		if (x == p) continue;
		DFS(x, v);
		dp[v][1] += dp[x][0];
		dp[v][0] += max(dp[x][1], dp[x][0]);
		dp2[v][1] += dp2[x][0];
		dp2[v][0] += max(dp2[x][1], dp2[x][0]);
	}
}
void solve() {
	int N = 0; cin >> N;
	int Q = 0; cin >> Q;
	g.assign(N, vi());
	int x = 0, y = 0, m = 0; cin >> x >> y >> m;
	for (int i = 0; i < N - 1; ++i) {
		int u = 0, v = 0; cin >> u >> v;
		u--; v--;
		g[u].push_back(v); g[v].push_back(u);
	}
	l.assign(N, 0); r.assign(N, 0);
	int cval = 0;
	for (int i = 0; i < N; ++i) {
		cin >> l[i] >> r[i];
		int ad = (i + 1) * x + ((l[i] * l[i]) % m) * y; ad %= m;
		cval = cval ^ ad;
	}
	h.assign(N, 0);
	dp.assign(N, vector<int>(2, 0));
	dp2 = dp;
	DFS(0, -1);
	int eff = max(dp[0][0], dp[0][1]);
	int eff2 = max(dp2[0][1], dp2[0][0]);
	vi qq;
	for (int j = 0; j < Q; ++j) {
		int tmp = 0; cin >> tmp;
		qq.push_back(tmp);
	}
	for (auto x : qq) {
		if (x <= eff && x >= eff2) cout << cval << " ";
		else cout << "-1 ";
		cout << endl;
	}
	while (true) {
		int j = 0; cin >> j;
		if (j == 0) {
			cout << endl;
			break;
		}
		j--;
		if (qq[j] != eff) {
			cout << "-1" << endl;
			continue;
		}
		for (int i = 0; i < N; ++i) {
			cout << l[i] << " ";
		}
		cout << endl;
	}
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int T = 1; cin >> T;
	for (int i = 0; i < T; ++i) {
		solve();
	}
	return 0;
}
