#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <deque>

using namespace std;
typedef long long ll;

inline vector <int> code(int n, vector <int> a)
{
	int k = a.size();
	vector <int> ans;

	set <int> all;
	for (auto i : a) all.insert(i);

	int i = 1;

	for (auto j : a)
	{
		i = max(i, j + 1);
		while (true)
		{
			if (i > n) i = 1;
			if (all.count(i))
			{
				++i;
				continue;
			}
			ans.push_back(i);
			all.insert(i);
			++i;
			break;
		}
	}

	sort(ans.begin(), ans.end());
	return ans;
}


inline vector <int> decode(int n, vector <int> a)
{
	int k = a.size();
	set <int> all;
	vector <int> ans;
	for (auto i : a) all.insert(i);

	int more = 0;
	vector <int> ps;

	for (auto i : a)
	{
		if (i > 1) ps.push_back(i - 1);
		while (true)
		{
			if (ps.empty())
			{
				++more;
				break;
			}
			auto b = ps.back();
			ps.pop_back();
			if (all.count(b)) continue;
			ans.push_back(b);
			all.insert(b);
			if (b > 1) ps.push_back(b - 1);
			break;
		}
	}

	int i = n;

	while (more--)
	{
		while (all.count(i)) --i;
		ans.push_back(i);
		all.insert(i);
	}

	sort(ans.begin(), ans.end());
	return ans;
}

bool check(int n)
{
	set <vector <int>> all;
	for (int i = 1; i < (1 << n); ++i)
	{
		vector <int> to;
		for (int j = 0; j < n; ++j)
		{
			if ((i >> j) & 1) to.push_back(j + 1);
		}
		if (to.size() * 2 > n) continue;
		auto got = code(n, to);
		auto got2 = decode(n, got);
		if (got2 != to)
		{
			cout << "!";
		}
	}
	return true;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	
	//for (int i = 2; i < 10; ++i) check(i);

	int t;
	cin >> t;
	int m;
	cin >> m;
	while (m--)
	{
		vector <int> got;
		int n, k;
		cin >> n >> k;
		vector <int> a(k);
		for (int i = 0; i < k; ++i) cin >> a[i];
		if (t == 1) got = code(n, a);
		else got = decode(n, a);
		for (auto i : got) cout << i << ' ';
		cout << '\n';
	}
	cout << endl;

	return 0;
}