#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;
typedef long long ll;
#define endl '\n'
#define int long long

int n, q;
int w[300010];
int Z;
const int inf = 1e18 + 10;

int sum = 0;
vector <pair <int, int>> block;

bool solve(int k, int a, int b)
{
	if (a > b) swap(a, b);
	
	sum = 0;
	block.clear();
	for (int i = 1; i <= n; ++i)
	{
		if (w[i] > k) break;
		int mi;
		if (block.empty()) mi = sum / 2 + 1;
		else mi = sum - block.back().first + 2;
		if (w[i] <= mi)
		{
			sum += w[i];
			continue;
		}
		else
		{
			int f = sum - w[i] + 2;
			f = max(f, (int)0);
			assert((block.empty() || (block.back().first > f)));
			block.push_back({ f, sum });
			sum += w[i];
			continue;
		}
	}

	block.push_back({ -1, sum });
	int l = -1, r = block.size() - 1;

	while (l + 1 < r)
	{
		int mid = (l + r) >> 1;

		if (a >= block[mid].first) r = mid;
		else l = mid;
	}

	return block[r].second >= a + b;
}

int dp[300010];

bool solve1(int k, int a, int b)
{
	assert(!b);
	int l = 0, r = n + 1;
	while (l + 1 < r)
	{
		int mid = (l + r) >> 1;
		if (w[mid] <= k) l = mid;
		else r = mid;
	}
	return dp[l] >= a;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> q;

	for (int i = 1; i <= n; ++i)
	{
		cin >> w[i];
	}

	sort(w + 1, w + 1 + n);
	w[n + 1] = inf;

	for (int i = 1; i <= n; ++i)
	{
		dp[i] = (dp[i - 1] >= w[i] - 1) ? dp[i - 1] + w[i] : dp[i - 1];
	}

	cin >> Z;
	int v = 0;
	for (int _ = 0; _ < q; ++_)
	{
		int j, c, d;
		int k = 1e18, a = _, b = 0;
		cin >> j >> c >> d;
		k = j - v * Z, a = c - v * Z, b = d - v * Z;


		auto got1 = solve(k, a, b);
		/*auto got2 = solve1(k, a, b);
		if (got1 != got2)
		{
			cout << "";
			auto u = solve(k, a, b);
			auto v = solve1(k, a, b);
		}*/
		v += got1;
		cout << (got1 ? "Yes" : "No") << endl;
	}

	return 0;
}