#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
constexpr int INF = int(1e9) + 7;

template<typename T> inline bool smax(T&a, T b) {
  if (a < b) { a = b; return true; }
  return false;
}
template<typename T> inline bool smin(T&a, T b) {
  if (b < a) { a = b; return true; }
  return false;
}

int dfs1(int v, const vector<vector<int>> & g, vector<int> & h, vector<int> & par, int p=-1) {
  int lv = 0;
  for (int u : g[v]) {
    if (p == u) continue;
    par[u] = v;
    h[u] = h[v] + 1;
    lv += dfs1(u, g, h, par, v);
  }
  return max(1, lv);
}
void dfs2(int v, const vector<vector<int>> & g, vector<int> & cl, vector<int> & lv, int p=-1) {
  int cnt = 0;
  for (int u : g[v]) {
    if (p == u) continue;
    ++cnt;
  }
  lv[v] = cnt == 0;
  if (cnt > 1) {
    cl[v] = v;
  }
  for (int u : g[v]) {
    if (p == u) continue;
    cl[u] = cl[v];
    dfs2(u, g, cl, lv, v);
  }
}

void dfs3(int v, const vector<vector<int>> & g, vector<int> & rem, int p=-1) {
  for (int u : g[v]) {
    if (u == p) continue;
    dfs3(u, g, rem, v);
  }
  rem.push_back(v);

}

void Solve() {
  int n;
  cin >> n;
  vector<int> vals(n * 2);
  vector<int> ord(n);
  vector<int> l(n), r(n);
  {
    vector<pair<pair<int, int>, int>> x(n);
    for (int i = 0; i < n; ++i) {
      cin >> x[i].first.second >> x[i].first.first;
      x[i].second = i;
      vals[i * 2] = x[i].first.first;
      vals[i * 2 + 1] = x[i].first.second;
    }
    sort(vals.begin(), vals.end());
    vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
    sort(x.begin(), x.end());
    for (int i = 0; i < n; ++i) {
      tie(r[i], l[i]) = x[i].first;
      ord[i] = x[i].second;
      l[i] = lower_bound(vals.begin(), vals.end(), l[i]) - vals.begin();
      r[i] = lower_bound(vals.begin(), vals.end(), r[i]) - vals.begin();
    }
  }
//  int prev = -INF;
//  vector<int> opt;
//  for (int i = 0; i < n; ++i) {
//    if (l[i] <= prev) continue;
//    opt.push_back(i);
//    prev = r[i];
//  }
//  int tg = int(opt.size()) / 2;
  vector<vector<int>> g(n+1);
  vector<int> st, h(n+1), p(n+1);
  for (int i = 0; i < n; ++i) {
    while (!st.empty() && l[st.back()] > l[i]) {
      g[i].push_back(st.back());
      st.pop_back();
    }
    st.push_back(i);
  }
  for (int x : st)
    g[n].push_back(x);
  int m = dfs1(n, g, h, p);
  vector<int> cl(n+1), lv(n+1);
  int del = 0;
  for (int i = 0; i < m / 2; ++i) {
    dfs2(n, g, cl, lv);
    int mn = -1;
    for (int j = 0; j < n; ++j) {
      if (lv[j] && (mn == -1 || h[j] - h[cl[j]] < h[mn] - h[cl[mn]])) {
        mn = j;
      }
    }
    del += h[mn] - h[cl[mn]];
    int prev = mn;
    for (int i = 0; i < h[mn] - h[cl[mn]] - 1; ++i) prev = p[prev];
    for (int i = 0; i < (int)g[cl[mn]].size(); ++i) {
      int u = g[cl[mn]][i];
      if (u == prev)
        g[cl[mn]].erase(g[cl[mn]].begin() + i);
    }
  }
  for (; del < n/2;) {
    dfs2(n, g, cl, lv);
    int mx = -1;
    for (int j = 0; j < n; ++j) {
      if (lv[j] && (mx == -1 || h[j] - h[cl[j]] > h[mx] - h[cl[mx]])) {
        mx = j;
      }
    }
    int td = min((h[mx] - h[cl[mx]])-1, n / 2 - del);
    del += td;
    for (int i = 0; i < td; ++i)
      mx = p[mx];
    int nm = 0;
    if (g[mx][nm] == p[mx]) ++nm;
    g[mx].erase(g[mx].begin() + nm);
  }
  vector<int> ans;
  dfs3(n, g, ans);
  ans.pop_back();
  for (int x : ans)
    cout << ord[x] + 1 << ' ';
  cout << endl;

}

int main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  int T;
  cin >> T;
  while (T--) {
    Solve();
  }

  return 0;
}
