#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
constexpr int INF = int(1e9) + 7;

template<typename T> inline bool smax(T&a, T b) {
  if (a < b) { a = b; return true; }
  return false;
}
template<typename T> inline bool smin(T&a, T b) {
  if (b < a) { a = b; return true; }
  return false;
}

constexpr int N = int(1e5) + 3;
vector<int> g[N];
pair<ll, ll> dp[N];
int plan[N];

void dfs(int v, int p=-1) {
  dp[v] = { plan[v], 0 };
  for (int u : g[v]) {
    if (u == p) continue;
    dfs(u, v);
    dp[v].first += dp[u].second;
    dp[v].second += max(dp[u].first, dp[u].second);
  }
}

void Solve() {

  int n, q;
  cin >> n >> q;
  for (int i = 0; i < n; ++i)
    g[i].clear();
  int x, y, m;
  cin >> x >> y >> m;
  for (int i = 0; i < n-1; ++i) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    g[v].push_back(u);
    g[u].push_back(v);
  }
  int cert = 0;
  for (int i = 0; i < n; ++i) {
    cin >> plan[i] >> plan[i];
    int sq = plan[i] * 1ll * plan[i] % m;
    cert ^= (1ll * x * (i + 1) + 1ll * y * sq) % m;
  }
  vector<ll> v(n);
  for (int i = 0; i < q; ++i) {
    cin >> v[i];
  }
  dfs(0);
  ll opt = max(dp[0].first, dp[0].second);
  for (int i = 0; i < n; ++i) {
    if (opt == v[i])
      cout << cert << ' ';
    else
      cout << -1 << ' ';
  }
  cout << endl;
  while (true) {
    int z;
    cin >> z;
    if (z == 0) return;
    --z;
    if (v[z] == opt) {
      for (int i = 0; i < n; ++i) cout << plan[i] << ' ';
      cout << endl;
    } else {
      cout << -1 << endl;
    }
  }

}

int main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  int T;
  cin >> T;
  while (T--) {
    Solve();
  }

  return 0;
}
