#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

int calc(vector <int>& l, vector <int>& r) {
    int n = l.size();
    vector <int> ord(n);
    iota(all(ord), 0);
    sort(all(ord), [&](int i, int j) {
        return (l[i] == l[j] ? (r[i] == r[j] ? i < j : r[i] < r[j]) : l[i] < l[j]);
    });

    vector <int> dp(n, 1);
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < i; j++) {
            if (r[ord[j]] < l[ord[i]])
                dp[i] = max(dp[i], dp[j] + 1);
        }
    }
    return *max_element(all(dp));
}

struct DSU {
    vector <int> pr;
    vector <vector <int>> comp;

    DSU(int n) {
        pr.resize(n);
        iota(all(pr), 0);
        comp.resize(n);
        for (int i = 0; i < n; i++)
            comp[i].push_back(i);
    }

    int getPr(int v) {
        if (v == pr[v]) return v;
        pr[v] = getPr(pr[v]);
        return pr[v];
    }

    void unionSets(int u, int v) {
        u = getPr(u);
        v = getPr(v);

        if (u == v) return;

        if (comp[u].size() > comp[v].size()) {
            pr[v] = u;
            for (int& i : comp[v])
                comp[u].push_back(i);
            comp[v].clear();
        } else {
            pr[u] = v;
            for (int& i : comp[u])
                comp[v].push_back(i);
            comp[u].clear();
        }
    }
};

struct Query {
    int k, a, b, id;
};

void solve() {
    int n, q;
    cin >> n >> q;

    vector <int> w(n);
    for (int& i : w)
        cin >> i;

    sort(all(w));

    int z;
    cin >> z;

    vector <Query> query;
    for (int i = 0; i < q; i++) {
        int k, a, b;
        cin >> k >> a >> b;

        query.push_back({k, a, b, i});
    }

    sort(all(query), [&](Query i, Query j) {
        return i.k < j.k;
    });

    set <pair <int, int>> st;
    st.insert({0, 0});

    int cur = 0;
    int ind = 0;

    const int MAX = 300;

    auto addk = [&]() {
        cur++;
        while (ind < n && w[ind] <= cur) {
            set <pair <int, int>> nst;
            for (auto i: st) {
                if (i.first + w[ind] <= MAX) {
                    nst.insert({i.first + w[ind], i.second});
                }
                if (i.second + w[ind] <= MAX) {
                    nst.insert({i.first, i.second + w[ind]});
                }
            }
            for (auto i : nst)
                st.insert(i);
            ind++;
        }
    };

    vector <int> ans(q);
    for (int i = 0; i < q; i++) {
        while (cur < query[i].k && ind < n) {
            addk();
        }
        bool ok = true;
        for (int x = 0; x <= query[i].a; x++) {
            for (int y = 0; y <= query[i].b; y++) {
                if (!st.count({x, y})) {
                    ok = false;
                    break;
                }
            }
            if (!ok) break;
        }
        ans[query[i].id] = ok;
    }

    for (auto& i : ans) {
        cout << (i ? "Yes" : "No") << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}
