#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = (int)1e5 + 10;
const int mod = (int)1e9 + 7;

#define all(x) begin(x), end(x)
#define int ll

pair<ll, ll> get(ll h, ll w, ll k, vector<pair<ll, ll>> a) {
	set<ll> prX, prY;
	for (int i = 0; i < k; i++) {
		prX.insert(a[i].first);
		prY.insert(a[i].second);
	}
	prX.insert(0), prY.insert(0);
	ll lastX = *(--prX.end());
	ll lastY = *(--prY.end());
	ll ans = h * w, cnt = h * w;
	for (int i = 0; i < k; i++) {
		ll x = a[i].first, y = a[i].second;
		ll maxX = *(--prX.lower_bound(x));
		ll maxY = *(--prY.lower_bound(y));
		ll tmp = min(maxX, h + 1 - x) + min(maxY, w + 1 - y);
		ll width = w, height = h;
		if (maxX != 0) {
			height = (h + 1 - (x - maxX));
		} else {
			height = lastX - x + 1;
		}
		if (maxY != 0) {
			width = (w + 1 - (y - maxY));
		} else {
			width = lastY - y + 1;
		}
		ll area = width * height;
		if (area == ans) {
			cnt = min(cnt, tmp);
		} else if (area < ans) {
			ans = area;
			cnt = tmp;
		}
	}
	return { ans, cnt };
}

void solve() {
	ll h, w, k;
	cin >> h >> w >> k;
	vector<pair<ll, ll>> a(k), b(k), c(k), d(k);
	for (int i = 0; i < k; i++) {
		cin >> a[i].first >> a[i].second;
		b[i].first = h + 1 - a[i].first, b[i].second = a[i].second;
		c[i].first = a[i].first, c[i].second = w + 1 - a[i].second;
		d[i].first = h + 1 - a[i].first, d[i].second = w + 1 - a[i].second;
	}
	pair<ll, ll> res = get(h, w, k, a);
	res = min(res, get(h, w, k, b));
	res = min(res, get(h, w, k, c));
	res = min(res, get(h, w, k, d));
	if (res.first < 0) {
		exit(1);
	} else if (res.second < 0) {
		exit(1);
	}
	cout << res.first << " " << res.second << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}