#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <random>
#include <map>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

const int mxn = (int)210;
const int mod = (int)1e9 + 7;

#define all(x) begin(x), end(x)

int dp[mxn][mxn][mxn];

int stupid(int n, vector<int> a) {
	int ans = 0;
	for (int i = 0; i < (1 << n); i++) {
		int mask = i * 2;
		vector<int> f, s;
		for (int k = 1; k <= n; k++) {
			if (mask >> k & 1) {
				f.push_back(a[k]);
			} else {
				s.push_back(a[k]);
			}
		}
		int tmp = 0;
		int mx = 0, mn = n + 1;
		bool ok = 1;
		for (int k : f) {
			if (k > mx) {
				tmp++;
				mx = k;
			} else {
				ok = 0;
			}
		}
		for (int k : s) {
			if (k < mn) {
				tmp++;
				mn = k;
			}
		}
		if (ok) {
			ans = max(ans, tmp);
		}
	}
	return ans;
}

int solve(int n, vector<int> a) {
	for (int i = 0; i <= n + 1; i++) {
		for (int mx = 0; mx <= n + 1; mx++) {
			for (int mn = 0; mn <= n; mn++) {
				dp[i][mx][mn] = -1;
			}
		}
	}
	dp[0][0][n + 1] = 0;
	int ans = 0;
	for (int i = 0; i < n; i++) {
		int cur = a[i + 1];
		for (int mx = 0; mx <= n + 1; mx++) {
			for (int mn = 0; mn <= n + 1; mn++) {
				if (dp[i][mx][mn] == -1) continue;
				int nmx = (cur > mx ? cur : mx);
				int nmn = (cur < mn ? cur : mn);
				dp[i + 1][nmx][mn] = max(dp[i + 1][nmx][mn], dp[i][mx][mn] + (nmx > mx));
				dp[i + 1][mx][nmn] = max(dp[i + 1][mx][nmn], dp[i][mx][mn] + (nmn < mn));
			}
		}
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			ans = max(ans, dp[n][i][j]);
		}
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int> a(n + 1);
		for (int i = 1; i <= n; i++) {
			cin >> a[i];
		}
		cout << stupid(n, a) << '\n';
	}
	return 0;
}