#include <iostream>
#include <vector>
#include <iomanip>
#include <assert.h>
#include <map>
#include  <set>
#include  <random>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) begin(x), end(x)

const int maxn = (int)510;
int dp[maxn][maxn];
int ndp[maxn][maxn];
int pepo[maxn][maxn];

#define int ll
void solve() {
	int n, q;
	cin >> n >> q;
	vector<ll> a(n + 1), pr(n + 1), can(n + 1);
	for (int i = 0; i < n; i++) {
		cin >> a[i + 1];
	}
	sort(all(a));
	for (int i = 0; i < n; i++) {
		pr[i + 1] = pr[i] + a[i + 1];
	}
	dp[0][0] = 1;
	for (int i = 1; i <= n; i++) {
		ll add = a[i];
		for (int x = maxn - 1; x >= 0; x--) {
			for (int y = maxn - 1; y >= 0; y--) {
				if (x + add < maxn) {
					ndp[x + add][y] |= dp[x][y];
				}
				if (y + add < maxn) {
					ndp[x][y + add] |= dp[x][y];
				}
				ndp[x][y] |= dp[x][y];
			}
		}
		swap(dp, ndp);
	}
	for (int i = 0; i < maxn; i++) {
		for (int j = 0; j < maxn; j++) {
			pepo[i][j] = dp[i][j];
			if (i) pepo[i][j] &= pepo[i - 1][j];
			if (j) pepo[i][j] &= pepo[i][j - 1];
		}
	}
	int z;
	cin >> z;
	for (int i = 0; i < q; i++) {
		ll k, A, B;
		cin >> k >> A >> B;
		bool ok = pepo[A][B];
		if (ok) {
			cout << "Yes\n";
		} else {
			cout << "No\n";
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	while (t--) {
		solve();
	}
	return 0;
}