#include <iostream>
#include <vector>
#include <iomanip>
#include <assert.h>
#include <map>
#include  <set>
#include  <random>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) begin(x), end(x)

const int maxn = (int)2e5 + 10;
vector<int> g[maxn];
ll a[maxn];
ll dp[maxn][2];
#define int ll

void clear(int n) {
	for (int i = 0; i < n; i++) {
		g[i].clear();
		dp[i][0] = dp[i][1] = 0;
	}
}

void dfs(int v, int p = -1) {
	dp[v][1] = a[v];
	for (int u : g[v]) {
		if (u == p) continue;
		dfs(u, v);
		dp[v][0] += max(dp[u][0], dp[u][1]);
		dp[v][1] += dp[u][0];
	}
}

void solve() {
	int n, q;
	cin >> n >> q;
	ll x, y, m;
	cin >> x >> y >> m;
	for (int i = 0; i < n - 1; i++) {
		int v, u;
		cin >> v >> u;
		v--, u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	ll k = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i] >> a[i];
		k ^= (((x * (i + 1)) % m) + ((y * a[i] * a[i]) % m)) % m;
	}
	dfs(0);
	ll power = max(dp[0][0], dp[0][1]);
	vector<ll> ans;
	for (int i = 0; i < q; i++) {
		ll v;
		cin >> v;
		if (v == power) {
			ans.push_back(k);
		} else {
			ans.push_back(-1);
		}
	}
	for (auto& u : ans) {
		cout << u << " ";
	}
	cout << endl;
	while (1) {
		int i;
		cin >> i;
		if (i == 0) {
			return;
		}
		if (ans[i - 1] == -1) {
			cout << "-1" << endl;
		} else {
			for (int i = 0; i < n; i++) {
				cout << a[i] << " ";
			}
			cout << endl;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}