#include <bits/stdc++.h>
#define int long long

using namespace std;

template <typename Node>
struct SegTree {
    int n, h = 0;
    vector<Node> t;

    SegTree() {}

    SegTree(int n) {
        this->n = n;
        while ((1 << h) < n)
            h += 1;
        t.assign((1 << (h + 1)), Node::zero_el());
    }

    Node get(int v, int vl, int vr, int l, int r) {
        if (vl >= r || vr <= l)
            return Node::zero_el();
        if (l <= vl && vr <= r)
            return t[v];
        int vm = (vl + vr) / 2;
        return Node::merge(get(2 * v, vl, vm, l, r), get(2 * v + 1, vm, vr, l, r));
    }

    Node get(int l, int r) {
        return get(1, 0, (1 << h), l, r);
    }

    Node get() {
        return t[1];
    }

    void upd(int v, int vl, int vr, int i, Node val) {
        if (vl + 1 == vr) {
            t[v] = val;
            return;
        }
        int vm = (vl + vr) / 2;
        if (i < vm)
            upd(2 * v, vl, vm, i, val);
        else
            upd(2 * v + 1, vm, vr, i, val);
        t[v] = Node::merge(t[2 * v], t[2 * v + 1]);
    }

    void upd(int i, Node val) {
        return upd(1, 0, (1 << h), i, val);
    }
};

struct NodeMax {
    int mx = 0;

    static NodeMax zero_el() { return { 0 }; }

    static NodeMax merge(NodeMax a, NodeMax b) {
        return { max(a.mx, b.mx) };
    }
};

vector<pair<int, int>> ev;
int lim;
SegTree<NodeMax> st;
vector<int> taken;

bool calc(int fst = 0) {
    if (taken.size() == ev.size() / 2)
        return st.get().mx == lim;
    for (int i = fst; i < ev.size() - (ev.size() / 2 - taken.size()) + 1; ++i) {
        auto [li, ri] = ev[i];
        int preval = st.get(ri, ri + 1).mx;
        int nval = st.get(0, li).mx + 1;
        if (nval > lim)
            continue;
        if (nval > preval)
            st.upd(ri, { nval });
        taken.push_back(i);
        if (calc(i + 1))
            return true;
        taken.pop_back();
        if (nval > preval)
            st.upd(ri, { preval });
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    ev.resize(n);
    vector<int> ts;
    for (auto& [li, ri] : ev) {
        cin >> li >> ri;
        ts.push_back(li);
        ts.push_back(ri);
    }
    sort(ts.begin(), ts.end());
    ts.resize(unique(ts.begin(), ts.end()) - ts.begin());
    unordered_map<int, int> comp;
    for (int i = 0; i < ts.size(); ++i)
        comp[ts[i]] = i;
    for (auto& [li, ri] : ev) {
        li = comp[li];
        ri = comp[ri];
    }
    sort(ev.begin(), ev.end(), [&](const pair<int, int>& a, const pair<int, int>& b) {
        return tie(a.second, a.first) < tie(b.second, b.first);
        });
    taken.clear();
    st = SegTree<NodeMax>(ts.size());
    for (auto& [li, ri] : ev) {
        int preval = st.get(ri, ri + 1).mx;
        int nval = st.get(0, li).mx + 1;
        if (nval > preval)
            st.upd(ri, { nval });
    }
    lim = st.get().mx / 2;
    st = SegTree<NodeMax>(ts.size());
    taken.reserve(n / 2);
    calc();
    vector<int> used(n);
    for (auto el : taken)
        used[el] = 1;
    for (int i = 0; i < n;++i)
        if (!used[i])
            cout << i + 1 << ' ';
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc;
    cin >> tc;
    while (tc--)
        solve();
}