#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,popcnt")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;
typedef long long ll;
typedef unsigned long long uint;


template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int))
        end_char = ' ';
    for (const T& e :vec)
        out << e << end_char;
    return out;
}

template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
/*
 *
 */

ll MOD;

uint get_bit(uint mask, int i) {
    return (mask & (1 << i)) >> i;
}

void set_bit(uint& mask, int i) {
    mask |= (1 << i);
}

void print_mask(uint mask, int k) {
    for (int i = 0; i < k; ++i) {
        cout << get_bit(mask, i);
    }
}

//const int N = 201;
//pair<int, int> dp[N][N][N];

uint f(uint a, int k) {
    int m = __builtin_ctz(~a);
    uint b = 0;
    for (int i = 0; i < k; ++i) {
        if (get_bit(a, i))
            set_bit(b, i ^ (m - 1));
    }
    return b;
}

int mex(uint a) {
    return __builtin_ctz(~a);
}

int calc(vector<int>& q, vector<int>& r, int n) {
    int res = 0;
    int prev = 0;
    int i = 0;
    while (i < q.size()) {
        if (maxi(prev, q[i]))
            ++res;
        ++i;
    }
    i = 0;
    prev = n + 1;
    while (i < r.size()) {
        if (mini(prev, r[i]))
            ++res;
        ++i;
    }
    return res;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<int> q, r;
    q.push_back(a[0]);
    for (int i = 1; i < n; ++i) {
        if (q.back() < a[i])
            q.push_back(a[i]);
        else
            r.push_back(a[i]);
    }
    int res = calc(q, r, n);
    q.clear(); r.clear();
    r.push_back(a[0]);
    for (int i = 1; i < n; ++i) {
        if (r.back() > a[i])
            r.push_back(a[i]);
        else
            q.push_back(a[i]);
    }
    cout << res;
}

int main() {
     ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef DUDE
    freopen("input.in", "r", stdin);
#endif
    //cin >> MOD;
    int test;
    cin >> test;
    while (test--) {
        solve();
        cout << '\n';
    }
    return 0;
}
