#pragma GCC target("avx2,popcnt")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef unsigned int uint;

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int))
        end_char = ' ';
    for (const T& e :vec)
        out << e << end_char;
    return out;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */


int g_ind = 0;

struct Seg {
    int l = -1, r = -1, id = -1;
    bool del = false;

    friend istream &operator>>(istream &in, Seg &s) {
        in >> s.l >> s.r;
        s.id = g_ind++;
        return in;
    }

    friend ostream &operator<<(ostream &out, const Seg &s) {
        out << s.l << ' ' << s.r;
        return out;
    }

    bool operator < (const Seg& other) const {
        if (l != other.l)
            return l < other.l;
        return r < other.r;
    }
};

struct Event {
    int x, t, id;
    Event() :x(-1), t(-2), id(-1) {}
    Event(int _x, int _t, int _id): x(_x), t(_t), id(_id) {}
    bool operator < (const Event& other) const {
        if (x != other.x)
            return x < other.x;
        if (t != other.x)
            return t > other.t;
        return id < other.id;
    }
};

const int INF = 1e9;
vector<Event> evs;
set<int> opened;

uint get_bit(uint mask, int i) {
    return (mask & (1 << i)) >> i;
}

int calc_m(uint del) {
    int res = 0;
    opened.clear();
    for (const Event& e :evs) {
        if (get_bit(del, e.id) == 1)
            continue;
        if (e.t == 1) {
            opened.insert(e.id);
        }
        else {
            if (opened.find(e.id) == opened.end())
                continue;
            opened.clear();
            ++res;
        }
    }
    return res;
}


void solve() {
    int n;
    cin >> n;
    vector<Seg> segs(n);
    g_ind = 0;
    cin >> segs;
    if (n <= 20) {
        evs.clear();
        for (const Seg& s :segs) {
            if (s.del)
                continue;
            evs.emplace_back(s.l, 1, s.id);
            evs.emplace_back(s.r, -1, s.id);
        }
        sort(all(evs));
        int m = calc_m(0);
        for (uint mask = 0; mask < (1 << n); ++mask) {
            if (__builtin_popcount(mask) != n / 2) {
                continue;
            }
            int m2 = calc_m(mask);
            if (m2 * 2 == m) {
                for (int i = 0; i < n; ++i) {
                    if (get_bit(mask, i) == 0)
                        cout << i + 1 << ' ';
                }
                return;
            }
        }
    }
    else {
        cout << "it's wednesday my dudes";
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef DUDE
    freopen("input.in", "r", stdin);
#endif
    int test;
    cin >> test;
    while (test--) {
        solve();
        cout << '\n';
    }

//    for (int i = 0; i < N; ++i) {
//        for (int j = 0; j < N; ++j) {
//            perf[i][j] = 1e18 + 1;
//        }
//    }
//
//    int n, m;
//    cin >> n >> m;
//    vector<ll> a(n);
//    cin >> a;
//    sort(a.begin(), a.end());
//    int z;
//    cin >> z;
//    vector<Query> qs(m);
//    cin >> qs;
////    sort(all(qs));
//    dost[0][0] = true;
//    perf[0][0] = true;
//    vector<bool> res(m);
//    for (int i = 0; i < n; ++i) {
//        for (int x = N; x >= 0; --x) {
//            for (int y = N; y >= 0; --y) {
//                if (!dost[x][y])
//                    continue;
//                if (x + a[i] < N)
//                    dost[x + a[i]][y] = true;
//                if (y + a[i] < N)
//                    dost[x][y + a[i]] = true;
//            }
//        }
//
//        for (int y = 1; y < N; ++y) {
//            if (dost[0][y] && perf[0][y - 1])
//                mini(perf[0][y], a[i]);
//        }
//        for (int x = 1; x < N; ++x) {
//            if (dost[x][0] && perf[x - 1][0])
//                mini(perf[x][0], a[i]);
//            for (int y = 1; y < N; ++y) {
//                if (dost[x][y] && perf[x - 1][y] && perf[x][y - 1])
//                    mini(perf[x][y], a[i]);
//            }
//        }
//    }
//
//
//    for (Query q :qs) {
//        if (perf[q.a][q.b] <= q.k)
//            cout << "Yes\n";
//        else
//            cout << "No\n";
//    }
}
