#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long ll;

ll mod;

int get_mask(vector<int>&arr) {
	int mask = 0;
	for (auto i : arr) {
		if (i == 0)
			continue;
		mask |= (1 << (i - 1));
	}
	return mask;
}

int get_mex(vector<int>& arr) {
	for (int i = 1; i < arr.size(); i++) {
		if (arr[i] != arr[i - 1] + 1)
			return arr[i - 1] + 1;
	}
	return arr.back() + 1;
}

const int max_value = 8;

vector<vector<int>>used(16, vector<int>(1 << max_value));
vector<vector<int>>result(16, vector<int>(1 << max_value));
vector<int>mask_len(1 << max_value);
vector<vector<int>>ans(16, vector<int>(16));
vector<vector<pair<int, int>>>go(16, vector<pair<int, int>>(1 << max_value, { -1, -1 }));

bool check_cycle(int mex, int mask, int b_mex, int b_mask) {
	if (mex != b_mex)
		return false;
	if (b_mask == mask)
		return true;
	return check_cycle(go[mex][mask].first, go[mex][mask].second, b_mex, b_mask);
}

int dfs(int mex, int mask) {
	if (used[mex][mask] == 2)
		return result[mex][mask];
	int mex_to = go[mex][mask].first, mask_to = go[mex][mask].second;
	if (used[mex][mask] == 1) {
		used[mex][mask] = 2;
		if (check_cycle(mex_to, mask_to, mex, mask))
			return mex;
		return -1;
	}
	used[mex][mask] = 1;
	result[mex][mask] = dfs(mex_to, mask_to);
	if (result[mex][mask] != -1)
		ans[result[mex][mask]][mask_len[mask]]++;
	used[mex][mask] = 2;
	return result[mex][mask];
}

void solve() {
	int k, n, p;
	cin >> k >> n >> p;
	cout << ans[p - 1][n] << '\n';
}


int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	for (int mask = 0; mask < (1 << max_value); mask++) {
		vector<int>mn = { 0 };
		for (int i = 0; i < max_value; i++) {
			if((1<<i) & mask)
			mn.push_back(i + 1);
		}
		mask_len[mask] = mn.size() - 1;
		int mex0 = get_mex(mn) - 1;
		vector<int>mn1;
		mn1.reserve(mn.size());
		for (int i = 0; i < mn.size(); i++) {
			mn1.push_back(mn[0] ^ mex0);
		}
		sort(mn1.begin(), mn1.end());
		int mex1 = get_mex(mn1) - 1;
		int mask1 = get_mask(mn1);
		go[mex0][mask] = { mex1, mask1 };
	}

	for (int mex = 0; mex < 16; mex++) {
		for (int mask = 0; mask < (1 << max_value); mask++) {
			if (go[mex][mask].first != -1 && used[mex][mask] == 0)
				dfs(mex, mask);
		}
	}

	int t;
	cin >> mod >> t;
	while (t--) {
		solve();
	}
	return 0;
}