#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long ll;

vector<vector<int>>g;
vector<ll>r;
vector<vector<ll>>dp;
vector<vector<vector<pair<int, int>>>>go;
void dfs(int v = 0, int p = -1) {
	dp[1][v] = r[v];
	for (auto u : g[v]) {
		if (u == p)
			continue;
		dfs(u, v);
		dp[1][v] += dp[0][u], go[1][v].push_back({ u, 0 });
		if (dp[1][u] > dp[0][u])
			dp[0][v] += dp[1][u], go[0][v].push_back({ u, 1 });
		else
			dp[0][v] += dp[0][u], go[0][v].push_back({ u, 0 });
	}
}

vector<ll>inds;
void dfs1(int v, int type) {
	if (type == 1)
		inds.push_back(v);
	for (auto& x : go[type][v]) {
		dfs1(x.first, x.second);
	}
}

void solve() {
	g.clear();
	r.clear();
	dp.clear();
	go.clear();
	inds.clear();
	int n, q;
	cin >> n >> q;
	g.resize(n);
	ll x, y, m;
	cin >> x >> y >> m;
	for (int i = 0; i < n - 1; i++) {
		int v, u;
		cin >> v >> u;
		v--, u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	r.resize(n);
	for (int i = 0; i < n; i++) {
		int l;
		cin >> l >> r[i];
	}
	dp.resize(2, vector<ll>(n));
	go.resize(2, vector<vector<pair<int,int>>>(n));
	dfs();
	dfs1(0, (dp[0][0] > dp[1][0] ? 0 : 1));

	ll serf_not_in = 0, serf_all = 0;
	vector<bool>in(n);
	for (auto i : inds)
		in[i] = true;
	for (int i = 0; i < n; i++) {
		serf_all ^= (x * (i + 1)) % m;
		if (in[i])
			continue;
		serf_not_in ^= (x * (i + 1)) % m;
	}

	ll max_value = max(dp[1][0], dp[0][0]);
	vector<ll>pref(inds.size() + 1), serf(inds.size() + 1);
	vector<ll>suf(inds.size() + 1);
	for (int i = int(inds.size()) - 1; i >= 0; i--) {
		suf[i] = suf[i + 1];
		suf[i] ^= (x * (inds[i] + 1)) % m;
	}
	for (int i = 1; i <= inds.size(); i++) {
		serf[i] = serf[i - 1];
		pref[i] = pref[i - 1];
		ll a = r[inds[i - 1]];
		pref[i] += a;
		serf[i] ^= (x * (inds[i-1] + 1) % m + a * a % m * y % m) % m;
	}
	vector<ll>ans(q);
	vector<ll>req(q);
	for (int i = 0; i < q; i++) {
		ll v; cin >> v;
		req[i] = v;
		if (v == 0) {
			ans[i] = serf_all;
			continue;
		}
		if (v > max_value) {
			ans[i] = -1;
			continue;
		}
		int ind = upper_bound(pref.begin(), pref.end(), v) - pref.begin();
		ans[i] = serf_not_in;
		if (ind == pref.size())
			ans[i] ^= serf.back();
		else {
			ans[i] ^= serf[ind - 1];
			ll ost = v - pref[ind - 1];
			ans[i] ^= (x * (inds[ind - 1] + 1) % m + ost * ost % m * y % m) % m;
			ans[i] ^= suf[ind];
		}
	}
	for (auto i : ans)
		cout << i << ' ';
	cout << endl;
	int i;
	while (cin >> i) {
		i--;
		if (i == -1)
			return;
		if (ans[i] == -1) {
			cout << -1 << endl;
			continue;
		}
		vector<ll>out(n);
		ll v = req[i];
		for (int j = 0; v != 0; j++) {
			out[inds[j]] = min(v, r[inds[j]]);
			v-= min(v, r[inds[j]]);
		}
		for (auto el : out)
			cout << el << ' ';
		cout << endl;
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}