#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <bitset>
#include <chrono>
#include <algorithm>
#include <queue>
#include <deque>
#include <iomanip>
#include <string>

#define all(a) (a).begin(), (a).end()
#define v std::vector

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll Lg = 20;

std::mt19937 rnd(42);

void solve() {
	ll a, m;
	std::cin >> a >> m;
	if (a == 1) {
		for (int t = 0; t < m; ++t) {
			ll n, k;
			std::cin >> n >> k;
			v<ll> list(n, 0);
			for (int i = 0; i < k; ++i) {
				ll cnt;
				std::cin >> cnt;
				--cnt;
				list[cnt] = 1;
			}
			ll first = 0;
			for (int i = 0; i < n; ++i) {
				if (list[i] && !list[(i - 1 + n) % n]) {
					first = i;
					break;
				}
			}
			v<ll> wait;
			v<ll> ans;
			v<ll> used(n, 0);
			for (int i = first; !used[i]; i = (i + 1) % n) {
				used[i] = 1;
				if (list[i]) {
					wait.push_back(i);
				}
				else {
					if (!wait.empty()) {
						ans.push_back(i);
						wait.pop_back();
					}
				}
			}
			std::sort(all(ans));
			for (auto i : ans) {
				std::cout << i + 1 << ' ';
			}
			std::cout << '\n';
		}
	}
	else if (a == 2) {
		for (int t = 0; t < m; ++t) {
			ll n, k;
			std::cin >> n >> k;
			v<ll> list(n, 0);
			for (int i = 0; i < k; ++i) {
				ll cnt;
				std::cin >> cnt;
				--cnt;
				list[n - cnt - 1] = 1;
			}
			ll first = 0;
			for (int i = 0; i < n; ++i) {
				if (list[i] && !list[(i - 1 + n) % n]) {
					first = i;
					break;
				}
			}
			v<ll> wait;
			v<ll> ans;
			v<ll> used(n, 0);
			for (int i = first; !used[i]; i = (i + 1) % n) {
				used[i] = 1;
				if (list[i]) {
					wait.push_back(i);
				}
				else {
					if (!wait.empty()) {
						ans.push_back(n - i - 1);
						wait.pop_back();
					}
				}
			}
			std::sort(all(ans));
			for (auto i : ans) {
				std::cout << i + 1 << ' ';
			}
			std::cout << '\n';
		}
	}
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(10);
	ll t = 1;
	//std::cin >> t;
	while (t--) {
		solve();
	}
}