#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <string>
#include <iomanip>
#include <random>
#include <chrono>
#include <queue>
#include <deque>
#include <utility>

#define all(a) (a).begin(), (a).end()
#define v std::vector

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll Lg = 20;

std::mt19937 rnd(42);

struct node {
	ll l, r;
	ll num;
};

ll countM(v<node>& list) {
	ll n = list.size();
	v<ll> dp(n, 1);
	ll max = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
			if (list[i].l > list[j].r || list[i].r < list[j].l) {
				dp[i] = std::max(dp[i], dp[j] + 1);
			}
		}
		max = std::max(max, dp[i]);
	}
	return max;
}

void solve() {
	ll n;
	std::cin >> n;
	v<node> list(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> list[i].l >> list[i].r;
		list[i].num = i;
	}
	std::sort(all(list), [](node a, node b) {
		return a.r < b.r;
		});
	ll M = countM(list);
	ll ans = 0;
	v<v<v<v<ll>>>> dp(n, v<v<v<ll>>>(n / 2 + 1, v<v<ll>>(n / 2 + 1, v<ll>(n, 0))));
	for (int i = 0; i < n && !ans; ++i) {
		if (i == 0) {
			dp[i][1][1][i] |= (1ll << list[i].num);
			if (dp[i][1][1][i]) {
				if (1 == n / 2 && 1 == M / 2) {
					ans = dp[i][1][1][i];
				}
			}
			continue;
		}
		for (int now = 1; now <= n / 2 && !ans; ++now) {
			if (now == 1) {
				dp[i][now][now][i] |= (1ll << list[i].num);
				if (dp[i][now][now][i]) {
					if (now == n / 2 && now == M / 2) {
						ans = dp[i][now][now][i];
					}
				}
				continue;
			}
			for (int m = 1; m <= n / 2 && !ans; ++m) {
				for (int last = 0; last <= i && !ans; ++last) {
					if (last == i) {
						for (int prev = 0; prev <= i; ++prev) {
							if (list[prev].l > list[i].r || list[prev].r < list[i].l) {
								if (dp[i][now][m][last] == 0 && dp[i - 1][now - 1][m - 1][prev] != 0) {
									dp[i][now][m][last] = dp[i - 1][now - 1][m - 1][prev] | (1ll << list[i].num);
								}
							}
						}
					}
					else {
						if (dp[i][now][m][last] == 0 && dp[i - 1][now][m][last] != 0) {
							dp[i][now][m][last] = dp[i - 1][now][m][last];
						}
						for (int prev = 0; prev <= i; ++prev) {
							if (!(list[prev].l > list[i].r || list[prev].r < list[i].l)) {
								if (dp[i][now][m][last] == 0 && dp[i - 1][now - 1][m][prev] != 0) {
									dp[i][now][m][last] |= dp[i - 1][now - 1][m][prev] | (1ll << list[i].num);
								}
							}
						}
					}
					if (dp[i][now][m][last]) {
						if (now == n / 2 && m == M / 2) {
							ans = dp[i][now][m][last];
						}
					}
				}
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if ((1ll << i) & ans) {
			std::cout << i + 1 << ' ';
		}
	}
	std::cout << '\n';
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(10);
	ll t = 1;
	std::cin >> t;
	while (t--) {
		solve();
	}
}