#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <string>
#include <iomanip>
#include <random>
#include <chrono>
#include <queue>
#include <deque>
#include <utility>

#define all(a) (a).begin(), (a).end()
#define v std::vector

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll Lg = 20;

std::mt19937 rnd(42);

struct node {
	ll l, r;
	ll num;
};

ll countM(v<node>& list) {
	ll n = list.size();
	v<ll> dp(n, 1);
	ll max = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
			if (list[i].l > list[j].r || list[i].r < list[j].l) {
				dp[i] = std::max(dp[i], dp[j] + 1);
			}
		}
		max = std::max(max, dp[i]);
	}
	return max;
}

void solve() {
	ll n;
	std::cin >> n;
	v<node> list(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> list[i].l >> list[i].r;
		list[i].num = i;
	}
	std::sort(all(list), [](node a, node b) {
		return a.r < b.r;
		});
	ll M = countM(list);
	ll ans = 0;
	for (int i = 0; i < (1ll << n) && !ans; ++i) {
		v<node> tmp;
		for (int j = 0; j < n; ++j) {
			if ((1ll << j) & i) {
				tmp.push_back(list[j]);
			}
		}
		if (tmp.size() == n / 2) {
			ll m = countM(tmp);
			if (m == M / 2) {
				ans = i;
				break;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if ((1ll << i) & ans) {
			std::cout << list[i].num + 1 << ' ';
		}
	}
	std::cout << '\n';
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(10);
	ll t = 1;
	std::cin >> t;
	while (t--) {
		solve();
	}
}