#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ui unsigned int
#define mp make_pair
#define ff first
#define ss second
#define pii pair<int, int>
#define pil pair<int, long long>
#define pli pair<long long, int>
#define pll pair<long long, long long>
#define pb push_back
#define ppb pop_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define uset unordered_set
#define umap unordered_map

struct segtree {
    int tl, tr;
    int sum;

    segtree* l = nullptr;
    segtree* r = nullptr;

    segtree() {}

    segtree(int _l, int _r) {
        tl = _l;
        tr = _r;
    }

    void extend() {
        if (tr - tl == 1)
            return;
        if (l && r)
            return;
        int m = (tl + tr) / 2;
        if (!l)
            l = new segtree(tl, m);
        if (!r)
            r = new segtree(m, tr);
    }

    void add(int i, int v) {
        if (tr - tl == 1) {
            sum = v;
            return;
        }
        extend();
        int m = (tl + tr) / 2;
        if (i < m)
            l->add(i, v);
        else
            r->add(i, v);
        sum = l->sum + r->sum;
    }

    int get(int ql, int qr) {
        if (tl >= qr || tr <= ql)
            return -1;
        if (ql <= tl && tr <= qr)
            if (tr - tl == sum)
                return -1;
        if (tr - tl == 1)
            return tl;
        int p = -1;
        extend();
        if (l)
            p = l->get(ql, qr);
        if (p == -1)
            if (r)
                p = r->get(ql, qr);
        return p;
    }
};

segtree* st;
int sz;

void add(int i, int v) {
    st->add(i, v);
}

void init(int n) {
    sz = 1;
    while (sz < n)
        sz *= 2;
    st = new segtree(0, sz);
}

int get(int i, int n) {
    int p = st->get(i, n);
    if (p == -1)
        p = st->get(0, n);
    return p;
}

inline void solve1() {
    int n, k;
    cin >> n >> k;
    init(n);
    vector<int> a(k);
    vector<int> b(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
        a[i]--;
    }
    for (int i : a)
        add(i, 1);
    for (int i = 0; i < k; i++) {
        int j = get(a[i], n);
        add(j, 1);
        b[i] = j;
    }
    sort(all(b));
    for (int i : b)
        cout << i + 1 << ' ';
    cout << '\n';
}

inline void solve2() {
    int n, k;
    cin >> n >> k;
    init(n);
    vector<int> a(k);
    vector<int> b(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
        a[i]--;
    }
    for (int i : a)
        add(i, 1);
    for (int i = 0; i < k; i++) {
        int j = get(a[i], n);
        add(j, 1);
        b[i] = j;
    }
    sort(all(b));
    for (int i : b)
        cout << i + 1 << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int run;
    cin >> run;
    int tt = 1;
    cin >> tt;
    while (tt--) {
#ifdef DEBUG
        cout << "Test Case#\n";
#endif
        if (run == 1)
            solve1();
        else
            solve2();
    }
    return 0;
}