#include <bits/stdc++.h>
using namespace std;

struct fenwick {
    int n;
    vector<pair<int, int>> f;

    fenwick(int n) : n(n), f(n + 1, {0, -1}) {}

    void modify(int i, pair<int, int> v) {
        for (i++; i <= n; i += i & -i) {
            f[i] = max(f[i], v);
        }
    }

    pair<int, int> query(int r) {
        pair<int, int> ans = {0, -1};
        for (; r > 0; r -= r & -r) {
            ans = max(ans, f[r]);
        }
        return ans;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    vector<int> d;
    for (int v : l) {
        d.push_back(v);
    }
    for (int v : r) {
        d.push_back(v);
    }
    sort(d.begin(), d.end());
    d.resize(unique(d.begin(), d.end()) - d.begin());
    for (int &v : l) {
        v = lower_bound(d.begin(), d.end(), v) - d.begin();
    }
    for (int &v : r) {
        v = lower_bound(d.begin(), d.end(), v) - d.begin();
    }
    vector<int> order(n);
    iota(order.begin(), order.end(), 0);
    sort(order.begin(), order.end(), [&](int i, int j) {
        return (l[i] == l[j] ? r[i] < r[j] : l[i] < l[j]);
    });
    vector<int> dp(n), path(n);
    fenwick f(2 * n + 1);
    for (int i : order) {
        auto [value, position] = f.query(l[i]);
        dp[i] = value + 1;
        path[i] = position;
        f.modify(r[i], {dp[i], i});
    }
    int m = *max_element(dp.begin(), dp.end());
    assert(m % 2 == 0);
    vector<int> s(m);
    vector<bool> in_s(n, false);
    for (int i : order) {
        if (dp[i] == m) {
            int p = i;
            for (int j = 0; j < m; j++) {
                s[m - 1 - j] = p;
                in_s[p] = true;
                p = path[p];
            }
            break;
        }
    }
    sort(s.begin(), s.end(), [&](int i, int j) {
        return r[i] < r[j];
    });
    vector<int> s0, s1;
    for (int i = 0; i < m; i++) {
        if (i < m / 2) {
            s0.push_back(s[i]);
        } else {
            s1.push_back(s[i]);
        }
    }
    for (int i = 0; i < n; i++) {
        if (!in_s[i]) {
            if (l[i] <= r[s[m / 2 - 1]]) {
                s0.push_back(i);
            }
            if (r[i] >= l[s[m / 2]]) {
                s1.push_back(i);
            }
        }
    }
    if (s0.size() < s1.size()) {
        swap(s0, s1);
    }
    s0.resize(n / 2);
    sort(s0.begin(), s0.end());
    s0.resize(unique(s0.begin(), s0.end()) - s0.begin());
    assert(s0.size() == n / 2);
    for (int i = 0; i < n / 2; i++) {
        cout << s0[i] + 1 << " \n"[i + 1 == n / 2];
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}