#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define sz(x) (ll)(x.size())
const ll INF = LLONG_MAX;

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    ll cnt = 0;
    for (int i = 1; i < n; ++i) {
        if (a[i] < a[i - 1]) {
            ++cnt;
        }
    }
    cout << min(n, n - cnt + 1);
}

ll solve0(ll n, vector<ll> b) {
    vector<ll> a(n + 2);
    for (int i = 2; i <= n + 1; ++i) {
        a[i] = b[i - 2];
    }
    a[1] = INF;
    vector<vector<vector<ll>>> dp(n + 2, vector<vector<ll>>(n + 2, vector<ll>(n + 2)));
    ll ans = 0;
    for (int i = 2; i <= n + 1; ++i) {
        for (int j = 0; j < i; ++j) {
            for (int k = 0; k < i; ++k) {
                if (a[i] > a[j]) {
                    dp[i][i][k] = max(dp[i][i][k], dp[i - 1][j][k] + 1);
                }
                if (a[i] < a[k]) {
                    dp[i][j][i] = max(dp[i][j][i], dp[i - 1][j][k] + 1);
                }
                if (a[i] < a[j] || a[i] > a[k]) {
                    dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j][k]);
                }
            }
        }
    }
    for (int i = 0; i <= n + 1; ++i) {
        for (int j = 0; j <= n + 1; ++j) {
            for (int k = 0; k <= n + 1; ++k) {
                ans = max(ans, dp[i][j][k]);
            }
        }
    }
    return ans;
}

ll solve1(ll n, vector<ll> a) {
    ll ans = 0;
    for (int i = 0; i < (1ll << n); ++i) {
        vector<ll> q, r;
        for (int j = 0; j < n; ++j) {
            if (i & (1 << j)) {
                q.push_back(a[j]);
            } else {
                r.push_back(a[j]);
            }
        }
        ll cnt1 = 0, mx = -INF, mn = INF;
        for (int j = 0; j < sz(q); ++j) {
            if (q[j] > mx) {
                cnt1++;
                mx = q[j];
            }
        }
        for (int j = 0; j < sz(r); ++j) {
            if (r[j] < mn) {
                ++cnt1;
                mn = r[j];
            }
        }
        ans = max(ans, cnt1);
    }
    return ans;
}

void stress() {
    mt19937 rnd(time(0));
    while (true) {
        ll n = rnd() % 5 + 1;
        vector<ll> a(n);
        iota(a.begin(), a.end(), 1);
        random_shuffle(a.begin(), a.end());
        ll ans1 = solve0(n, a), ans2 = solve1(n, a);
        if (ans1 != ans2) {
            cout << n << '\n';
            for (int i : a) {
                cout << i << ' ';
            }
            cout << "fast: " << ans1 << "\nlong: " << ans2;
            break;
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    ll times = 1;
    cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
//    stress();
    return 0;
}
