#include <bits/stdc++.h>

using namespace std;

#define ssize(a) static_cast<ptrdiff_t>(size(a));
#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()

using i32 = int32_t;
using i64 = int64_t;
using f64 = double;
using f128 = long double;

template <typename T>
void chmin(T& a, const T& b) {
  if (b < a) a = b;
}
template <typename T>
void chmax(T& a, const T& b) {
  if (a < b) a = b;
}

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  i32 t;
  cin >> t;
  while (t--) solve();
  return 0;
}

void solve() {
  i32 n;
  cin >> n;
  vector<i32> p(n);
  for (auto& e : p) cin >> e;
  map<i32, map<i32, i32, greater<>>> max_record;
  map<i32, map<i32, i32>, greater<>> min_anti;
  max_record[0].emplace(n + 1, 0);
  min_anti[n + 1].emplace(0, 0);

  auto AddRecord = [&](i32 cur_record) {
    for (auto& [cur_anti, set_records] : min_anti) {
      auto it = set_records.upper_bound(cur_record);
      // Impossible to have such pair (record, anti_record)
      if (it == set_records.begin()) continue;
      it--;
      i32 best_score = it->second + 1;
      if (!(next(it)->second >= best_score && next(it)->first < cur_record)) {
        // Erase unnecessary pairs
        auto it2 = next(set_records.emplace(cur_record, best_score).first);
        while (it2 != set_records.end()) {
          if (it2->second > best_score) break;
          it2 = set_records.erase(it2);
        }
      }
      if (max_record[cur_record].empty() || max_record[cur_record].rbegin()->second < best_score)
        max_record[cur_record].emplace(cur_anti, best_score);
    }
  };
  auto AddAnti = [&](i32 cur_anti) {
    for (auto& [cur_record, set_anti] : max_record) {
      auto it = set_anti.upper_bound(cur_anti);
      // Impossible to have such pair (record, anti_record)
      if (it == set_anti.begin()) continue;
      it--;
      i32 best_score = it->second + 1;
      // Erase unnecessary pairs
      if (!(next(it)->second >= best_score && next(it)->first < cur_record)) {
        auto it2 = next(set_anti.emplace(cur_anti, best_score).first);
        while (it2 != set_anti.end()) {
          if (it2->second > best_score) break;
          it2 = set_anti.erase(it2);
        }
      }
      if (min_anti[cur_anti].empty() || min_anti[cur_anti].rbegin()->second < best_score)
        min_anti[cur_anti].emplace(cur_record, best_score);
    }
  };

  for (int i = 0; i < n; ++i) {
    AddRecord(p[i]);
    auto tmp = std::move(max_record[p[i]]);
    max_record.erase(p[i]);
    AddAnti(p[i]);
    max_record[p[i]] = std::move(tmp);
  }

  i32 ans = 0;
  for (auto& [_, set_records] : min_anti)
    chmax(ans, set_records.rbegin()->second);
  for (auto& [_, set_anti] : max_record)
    chmax(ans, set_anti.rbegin()->second);
  cout << ans << "\n";
}
