#include <bits/stdc++.h>

using namespace std;

#define ssize(a) static_cast<ptrdiff_t>(size(a))
#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()

using i32 = int32_t;
using i64 = int64_t;
using f64 = double;
using f128 = long double;

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}

void solve() {
  i32 n, k, q;
  cin >> n >> k >> q;
  vector<optional<pair<i32, i32>>> g(n);
  for (int i = 0; i < n; ++i) {
    i32 t;
    cin >> t;
    if (t == 0) {
      g[i] = nullopt;
    } else {
      i32 l, r;
      cin >> l >> r;
      l--, r--;
      g[i] = {l, r};
    }
  }
  vector<i32> turns(n);
  auto Dfs = [&](i32 u, i32 t, bool direction, auto&& Dfs) -> void {
    turns[u] = t;
    if (g[u].has_value()) {
      Dfs(g[u].value().first, t + direction, false, Dfs);
      Dfs(g[u].value().second, t + (!direction), true, Dfs);
    }
  };
  if (g[0].has_value()) {
    Dfs(g[0].value().first, 0, false, Dfs);
    Dfs(g[0].value().second, 0, true, Dfs);
  }
  vector<i32> subtree_good(n);
  auto Count = [&](i32 u, auto&& Count) -> void {
    if (!g[u].has_value()) {
      subtree_good[u] = turns[u] <= k;
      return;
    }
    subtree_good[u] =
        subtree_good[g[u].value().first] + subtree_good[g[u].value().second];
  };
  Count(0, Count);
  for (int i = 0; i < q; ++i) {
    i32 u;
    cin >> u;
    cout << subtree_good[u - 1] << "\n";
  }
}
