#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<vector<ll>> dp_min;
vector<vector<ll>> dp_max;
vector<vector<ll>> graph;
vector<pair<ll, ll>> limits;

void dfs_min(ll v=1, ll p=-1) {
    for (auto x : graph[v]) {
        if (x != p) {
            dfs_min(x, v);
        }
    }

    // 1 - берем v
    dp_min[v][1] = limits[v].first;
    for (auto x : graph[v]) {
        if (x != p) {
            dp_min[v][1] += dp_min[x][0];
        }
    }

    // 2 - не берем v
    dp_min[v][0] = 0;
    for (auto x : graph[v]) {
        if (x != p) {
            dp_min[v][0] += max(dp_min[x][0], dp_min[x][1]);
        }
    }
}

void dfs_max(ll v=1, ll p=-1) {
    for (auto x : graph[v]) {
        if (x != p) {
            dfs_max(x, v);
        }
    }

    // 1 - берем v
    dp_max[v][1] = limits[v].second;
    for (auto x : graph[v]) {
        if (x != p) {
            dp_max[v][1] += dp_max[x][0];
        }
    }

    // 2 - не берем v
    dp_max[v][0] = 0;
    for (auto x : graph[v]) {
        if (x != p) {
            dp_max[v][0] += max(dp_max[x][0], dp_max[x][1]);
        }
    }
}

void solve() {
    ll n, q;
    cin >> n >> q;
    ll x, y, m;
    cin >> x >> y >> m;

    graph.assign(n + 1, vector<ll>());
    limits.assign(n + 1, {0, 0});
    dp_min.assign(n + 1, vector<ll>(2, 0));
    dp_max.assign(n + 1, vector<ll>(2, 0));

    for (ll i = 0; i < n - 1; ++i) {
        ll a, b;
        cin >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    for (ll i = 1; i <= n; ++i) {
        cin >> limits[i].first >> limits[i].second;
    }

    dfs_min();
    dfs_max();

    vector<ll> need(q + 1);
    for (ll i = 1; i <= q; ++i) {
        cin >> need[i];

        ll left = max(dp_min[1][0], dp_min[1][1]);
        ll right = max(dp_max[1][0], dp_max[1][1]);

        if (left <= need[i] && need[i] <= right) {
            cout << 0 << " ";
        } else {
            cout << -1 << " ";
        }
    }
    cout << endl;

    ll null;
    cin >> null;
}

int main() {
    ll t;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}