#include <bits/stdc++.h>

#include <random>

#define int int_fast64_t
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define girlfriend friend

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

using namespace std;
mt19937 rnd(time(NULL));
const int inf = 1e18, MAXN = (int)2e4;
vector<int> tree(4*MAXN);

void build(int v, int tl, int tr) {
    if (tl == tr) {
        tree[v] = 0;
        return;
    }
    int tm = (tl+tr)/2;
    build(2*v, tl, tm);
    build(2*v+1, tm+1, tr);
    tree[v] = 0;
}

void upd(int v, int pos, int val, int tl, int tr) {
    if (tl == tr) {
        assign_max(tree[v], val);
        return;
    }
    int tm = (tl+tr)/2;
    if (pos <= tm) upd(2*v, pos, val, tl, tm);
    else upd(2*v+1, pos, val, tm+1, tr);
    tree[v] = max(tree[2*v], tree[2*v+1]);
}

int get_mx(int v, int l, int r, int tl, int tr) {
    if (l > tr || r < tl) return -inf;
    if (l <= tl && tr <= r) return tree[v];
    int tm = (tl+tr)/2;
    return max(get_mx(2*v, l, r, tl, tm), get_mx(2*v+1, l, r, tm+1, tr));
}

int stupid_solve(int n, vector<int> a) {
//    int n, res = 0; cin >> n;
//    vector<int> a(n); input(a);
    int res = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int mn = inf, mx = -inf, cur = 0;
        for (int i = 0; i<n; ++i) {
            if ((mask >> i)&1) {
                if (assign_max(mx, a[i])) {
                    cur++;
                }
            } else {
                if (assign_min(mn, a[i])) {
                    cur++;
                }
            }
        }
        assign_max(res, cur);
    }
    return res;
//    cout << res << '\n';
}

int solve(int n, vector<int> A) {
//    int n; cin >> n;
    build(1, 0, n);
    vector<int> a(n+1); //input(a, 1); a[0] = inf;
    a[0] = inf;
    for (int i = 1; i<=n; ++i) a[i] = A[i-1];
    vector<vector<int>> dp(n+1, vector<int> (n+1, -inf));
    int lst = 1, cur = 1;
    dp[1][0] = 1;
    for (int i = 2; i<=n; ++i) {
        dp[i][lst] = cur+1;
        if (a[lst] > a[i]) {
            lst = i;
            cur++;
        }
    }
    int res = 0;
    for (int i = 1; i<n; ++i) {
        for (int j = 0; j<i; ++j) {
            assign_max(res, dp[i][j]);
            int cur_mn = j, cur_res = dp[i][j];
            for (int i2 = i+1; i2<=n; ++i2) {
                if (a[i2] > a[i]) {
                    assign_max(dp[i2][cur_mn], cur_res+1);
                    if (a[cur_mn] > a[i2]) {
                        cur_res++;
                        cur_mn = i2;
                    }
                } else {
                    if (a[cur_mn] > a[i2]) {
                        cur_res++;
                        cur_mn = i2;
                    }
                }
            }
        }
    }
    for (int i = 1; i<=n; ++i) {
        for (int j = 0; j<i; ++j) {
            int add = 0, cur_mn = j;
            for (int i2 = i+1; i2<=n; ++i2) {
                if (a[i2] < a[cur_mn]) {
                    cur_mn = i2;
                    add++;
                }
            }
            assign_max(res, dp[i][j]+add);
        }
    }
//    cout << res << '\n';
    return res;
}
bool fl = false;

signed main() {
    if (fl) {
        while (true) {
            int n = rnd()%10+1;
            vector<int> a(n);
            iota(all(a), 1);
            shuffle(all(a), std::mt19937(std::random_device()()));
            int res1 = solve(n, a), res2 = stupid_solve(n, a);
            if (res1 != res2) {
                cout << n << endl;
                for (int i = 0; i<n; ++i) {
                    cout << a[i] << " ";
                }
                cout << endl;
                cout << res1 << " " << res2 << endl;
                break;
            }
        }
    } else {
        int t = 1; cin >> t;
        while (t--) {
            int n; cin >> n;
            vector<int> a(n); input(a);
            cout << solve(n, a) << endl;
        }
    }
    return 0;
}
