#ifndef DEBUG
#pragma GCC optimize(Ofast)
#pragma GCC target(avx,avx2)
#endif

#include <bits/extc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vb = vector<bool>;
using vvb = vector<vb>;
using vc = vector<char>;
using vvc = vector<vc>;

template<class T, class Y>
istream& operator>>(istream& s, pair<T, Y>& p) {
  return s >> p.first >> p.second;
}

template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (auto& e : v) s >> e;
  return s;
}

template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (const auto& e : v) s << e << ' ';
  return s;
}

template<class K, class V>
using umap = __gnu_pbds::gp_hash_table<K, V>;

void solve();
bool bsolve();

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif

  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(25);

//  solve();
  while (bsolve()) cout << endl;
}

bool bsolve() {
  ll h, w, k;
  if (!(cin >> h >> w >> k)) return false;

  vii a(k);
  cin >> a;

  set<ll> H, W;

  for (auto [x, y] : a) {
    H.insert(x);
    H.insert(x + h);
    W.insert(y);
    W.insert(y + w);
  }

  ll hmax = 0, wmax = 0;
  ll hcnt = 1e18, wcnt = 1e18;

  for (auto it = H.begin(); it != H.end(); ++it) {
    auto it2 = it;
    ++it2;
    if (it2 == H.end()) break;
    ll cur = *it2 - *it - 1;
    if (cur > hmax) {
      hmax = cur;
      hcnt = 1e18;
    }
    if (cur == hmax) {
      ll cnt = 0;
      ll i = *it, j = *it2;
      if (i > h && j > h) i -= h, j -= h;
      if (i <= h && j <= h) {
        cnt  = min(i, h + 1 - j);
      }
      hcnt = min(hcnt, cnt);
    }
  }
  for (auto it = W.begin(); it != W.end(); ++it) {
    auto it2 = it;
    ++it2;
    if (it2 == W.end()) break;
    ll cur = *it2 - *it - 1;
    if (cur > wmax) {
      wmax = cur;
      wcnt = 1e18;
    }
    if (cur == wmax) {
      ll cnt = 0;
      ll i = *it, j = *it2;
      if (i > w && j > w) i -= w, j -= w;
      if (i <= w && j <= w) {
        cnt  = min(i, w + 1 - j);
      }
      wcnt = min(wcnt, cnt);
    }
  }

  cout << (h - hmax) * (w - wmax) << ' ' << hcnt + wcnt << endl;

  return true;
}


//void solve() {
//
//}