#ifndef DEBUG
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <bits/extc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vb = vector<bool>;
using vvb = vector<vb>;
using vc = vector<char>;
using vvc = vector<vc>;

template<class T, class Y>
istream& operator>>(istream& s, pair<T, Y>& p) {
  return s >> p.first >> p.second;
}

template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (auto& e : v) s >> e;
  return s;
}

template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (const auto& e : v) s << e << ' ';
  return s;
}

template<class K, class V>
#if defined(DEBUG)
using umap = unordered_map<K, V>;
#else
using umap = __gnu_pbds::cc_hash_table<K, V>;
#endif

void solve();
bool bsolve();

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif

  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(25);

  ll t;
  cin >> t;

//  solve();
  while (bsolve());
}

#ifdef DEBUG
bool debug = true;
#else
bool debug = false;
#endif

bool bsolve() {
  ll n;
  if (!(cin >> n)) return false;
  vi a(n);
  cin >> a;

  if (n <= 200 && !debug) {

    vector<vvi> dp(n + 1, vvi(n + 2, vi(n + 2, -1e18)));
    dp[0][0][n + 1] = 0;
//  dp[0][]

    for (int i = 0; i < n; ++i) {
      for (ll mx = 0; mx <= n + 1; ++mx) {
        for (ll mn = 0; mn <= n + 1; ++mn) {
          if (a[i] > mx) {
            dp[i + 1][a[i]][mn] = max(
                dp[i + 1][a[i]][mn],
                dp[i][mx][mn] + 1
            );
          }
          if (a[i] < mn) {
            dp[i + 1][mx][a[i]] = max(
                dp[i + 1][mx][a[i]],
                dp[i][mx][mn] + 1
            );
          }
          if (a[i] >= mn || a[i] <= mx) {
            dp[i + 1][mx][mn] = max(
                dp[i + 1][mx][mn],
                dp[i][mx][mn]
            );
          }
        }
      }
    }

    ll best = 0;
    for (ll mx = 0; mx <= n + 1; ++mx) {
      for (ll mn = 0; mn <= mx; ++mn) {
        best = max(best, dp[n][mx][mn]);
      }
    }

    cout << best << endl;

  } else {
    ll bad = n;
    for (int i = 0; i < n - 1; ++i) {
      if (a[i] > a[i + 1]) {
        bad = i;
        break;
      }
    }

    if (bad == n) {
      cout << n << endl;
      return true;
    }

    ll ans = 0;
    ll x = lower_bound(a.begin(), a.begin() + bad + 1, a[bad + 1]) - a.begin();

    ans = max(ans, bad + 1);
    ans = max(ans, n - bad - 1);

    for (ll i = x - 1; i <= bad; ++i) {
      if (i < 0) {
        ans = max(ans, n - bad - 2 + 2);
        continue;
      }

      ll cur = 0;

      ll j = lower_bound(a.begin() + bad + 1, a.end(), a[i]) - a.begin();

      if (i < bad) {
        if (j == bad + 1) {
          j += 1;
        }
        cur += 2;
      }
      if (i == bad && j > bad + 1) {
        cur += 1;
      }

      cur += i + 1;
      cur += n - j;

      ans = max(ans, cur);
    }

    cout << ans << endl;
  }

  return true;
}



//void solve() {}