//#pragma GCC optimize("O3")
//#pragma GCC target("avx,avx2")
#include <iostream>
#include <random>
#include <vector>
#include <algorithm>
#include <cassert>
#include <numeric>
#include <tuple>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(228);

//#define int long long

class Fenwick {
private:
	vector <int> data;

public:
	Fenwick(int n) {
		data.assign(n, 0);
	}

	int get(int r) {
		int ans = 0;
		for (--r; r >= 0; r = (r & (r + 1)) - 1) {
			ans = max(ans, data[r]);
		}
		return ans;
	}

	void update(int pos, int val) {
		for (; pos < data.size(); ++pos) {
			data[pos] = max(val, data[pos]);
		}
	}
};

void solve() {
	int n; cin >> n;
	vector <int> v(n);
	for (auto& x : v) {
		cin >> x;
		--x;
	}
	/*int n = 6;
	vector <int> v(n); iota(all(v), 0);
	shuffle(all(v), rnd);*/

	int ans = 0;
	vector <vector <tuple <int, int, int>>> qs(n);
	for (int i = -1; i < n; ++i) {
		vector <int> st1, st2;
		for (int j = 0; j < n; ++j) {
			if (v[j] <= i) {
				if (!st1.empty() && v[st1.back()] > v[j]) {
					qs[j].push_back({ v[j], v[st1.back()], (int)st1.size() + (int)st2.size() + 1 });
					//ans = max(ans, (int)st1.size() + up[j][v[st1.back()]] + (int)st2.size() + down[j][v[j]] + 1);
				}

				if (st1.empty() || v[st1.back()] < v[j]) st1.push_back(j);
				
			}
			else {
				if (!st2.empty() && v[st2.back()] < v[j]) {
					qs[j].push_back({ v[st2.back()], v[j], (int)st1.size() + (int)st2.size() + 1 });
				}

				if (st2.empty() || v[st2.back()] > v[j]) st2.push_back(j);
				
			}
		}
		ans = max(ans, (int)st1.size() + (int)st2.size());
	}

	Fenwick tree1(n);
	Fenwick tree2(n);
	vector <int> vec1(n, 0), vec2(n, 0);
	for (int i = n - 1; i >= 0; --i) {
		auto x = v[i];
		sort(all(qs[i]));
		vector <int> mx1(n), mx2(n);
		int k = 0;
		for (int j = 0; j < n; ++j) {
			if (j > 0) mx1[j] = max(mx1[j - 1], vec1[j - 1]);
		}
		for (int j = 0; j < n; ++j) {
			if (j < n - 1) mx2[j] = max(mx2[j + 1], vec2[j + 1]);
		}
		for (auto [l, r, pl] : qs[i]) {
			ans = max(ans, pl + mx1[l] + mx2[r]);
		}
		vec1[x] = max(vec1[x], mx1[x] + 1);
		vec2[x] = max(vec2[x], mx2[x] + 1);
	}

	cout << ans;

	/*vector <vector <int>> dp(n + 2, vector <int>(n + 2, -1e9));
	dp[0][n + 1] = 0;
	for (int i = 0; i < n; ++i) {
		vector <vector <int>> dp1 = dp;
		for (int j = -1; j < v[i]; ++j) {
			for (int k = v[i] + 1; k <= n; ++k) {
				dp1[j + 1][k + 1] = -1e9;
			}
		}
		for (int j = -1; j < v[i]; ++j) {
			for (int k = -1; k <= n; ++k) {
				dp1[v[i] + 1][k + 1] = max(dp1[v[i] + 1][k + 1], dp[j + 1][k + 1] + 1);
			}
		}
		for (int j = -1; j <= n; ++j) {
			for (int k = v[i] + 1; k <= n; ++k) {
				dp1[j + 1][v[i] + 1] = max(dp1[j + 1][v[i] + 1], dp[j + 1][k + 1] + 1);
			}
		}
		dp = dp1;
	}

	int ans1 = 0;
	for (auto& vec : dp) for (auto& x : vec) ans1 = max(ans1, x);

	cout << ans << ' ' << ans1;
	if (ans != ans1) {
		for (auto x : v) cout << x + 1 << ' ';
	}*/
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	int32_t t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}