#include <iostream>
#include <random>
#include <vector>
#include <algorithm>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(228);

#define int long long

class Fenwick {
private:
	vector <int> data;

public:
	Fenwick(int n) {
		data.assign(n, 0);
	}

	int get(int r) {
		int ans = 0;
		for (--r; r >= 0; r = (r & (r + 1)) - 1) {
			ans += data[r];
		}
		return ans;
	}

	void update(int pos, int val) {
		for (; pos < data.size(); pos |= pos + 1) {
			data[pos] = max(data[pos], val);
		}
	}
};

void solve() {
	int n; cin >> n;
	vector <int> v(n);
	for (auto& x : v) {
		cin >> x;
		--x;
	}

	Fenwick tree(n);
	for (auto& x : v) {
		tree.update(x, tree.get(x) + 1);
	}
	int ans = tree.get(n);

	cout << min(n, ans + 2);
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	int32_t t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}