#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <functional>
#include <cassert>
#include <set>
#include <tuple>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(1337);

#define int long long

bool cmp(const tuple <int, int, int>& a, const tuple <int, int, int>& b) {
	if (get<1>(a) == get<1>(b)) return get<0>(a) < get<0>(b);
	return get<1>(a) < get<1>(b);
}

void solve() {
	int n; cin >> n;
	vector <tuple <int, int, int>> v(n);
	for (int i = 0; i < n; ++i) {
		cin >> get<0>(v[i]) >> get<1>(v[i]);
		get<2>(v[i]) = i;
	}

	sort(all(v), cmp);

	set <int> st;
	for (int i = 0; i < n; ++i) {
		st.insert(i);
	}

	vector <char> used(n, 0);
	vector <int> cnt(n, 0);
	auto get = [&]() {
		memset(used.data(), 0, used.size());
		cnt.assign(n, 0);
		int m = 0, pr = -1e18;
		for (auto i : st) {
			auto [a, b, ind] = v[i];
			if (a > pr) {
				++m;
				pr = b;
				used[i] = 1;
			}
			for (auto j : st) {
				auto [a1, b1, ind] = v[j];
				if (b1 < a || b < a1) {
					++cnt[i];
				}
			}
		}
		return m;
	};
	
	int m0 = get();
	int cm = m0;
	for (int i = 0; i < n; ++i) {
		if (cm == m0 / 2) {
			vector <int> del;
			for (auto ind : st) {
				if (!used[ind] && st.size() - del.size() > n / 2) {
					del.push_back(ind);
				}
			}
			for (auto x : del) {
				st.erase(x);
			}
			break;
		}
		else {
			int mx = -1;
			for (auto ind : st) {
				if (used[ind] && (mx == -1 || cnt[ind] > cnt[mx])) {
					mx = ind;
				}
			}
			st.erase(mx);
			cm = get();
		}
	}

	for (auto& x : st) {
		cout << get<2>(v[x]) + 1 << ' ';
	}
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}