#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <functional>
#include <cassert>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(1337);

#define int long long

void solve() {
	int n, q; cin >> n >> q;
	int x, y, m; cin >> x >> y >> m;
	vector <vector <int>> g(n);
	for (int i = 0; i < n - 1; ++i) {
		int u, v; cin >> u >> v;
		--u; --v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	vector <pair <int, int>> sg(n);
	for (auto& [f, s] : sg) cin >> f >> s;

	vector <int> dp0(n), dp1(n);
	function <void(int, int)> dfs = [&](int v, int pr) {
		dp1[v] += sg[v].second;
		for (auto& u : g[v]) {
			if (u != pr) {
				dfs(u, v);
				dp1[v] += dp0[u];
				dp0[v] += max(dp1[u], dp0[u]);
			}
		}
	};
	dfs(0, 0);

	vector <bool> vec(n, false);
	function <void(int, int, int)> dfs1 = [&](int v, int pr, int num) {
		vec[v] = (num && sg[v].second);
		for (auto& u : g[v]) {
			if (u != pr) {
				if (num == 1 || num == 0 && dp0[u] >= dp1[u]) {
					dfs1(u, v, 0);
				}
				else {
					dfs1(u, v, 1);
				}
			}
		}
	};
	dfs1(0, 0, (dp1[0] > dp0[0]));
	int eff = max(dp0[0], dp1[0]);

	vector <int> ps;
	for (int i = 0; i < n; ++i) {
		if (vec[i]) ps.push_back(i);
	}
	vector <int> sfk0(n + 1, 0);
	for (int i = n - 1; i >= 0; --i) {
		sfk0[i] = (sfk0[i + 1] ^ ((x * (i + 1)) % m));
	}
	vector <int> prk(ps.size() + 1);
	prk[0] = sfk0[n];
	for (int i = 1; i < prk.size(); ++i) {
		prk[i] = (prk[i - 1] ^ ((x * (ps[i - 1] + 1)) % m) ^ ((x * (ps[i - 1] + 1) + y) % m));
	}

	vector <int> qs(q);
	for (auto& x : qs) cin >> x;

	for (auto cv : qs) {
		if (cv < prk.size()) {
			/*int c = 0;
			int ck = 0;
			for (int j = 0; j < n; ++j) {
				if (vec[j] && c < cv && sg[j].second == 1) {
					++c;
					ck ^= ((x * (j + 1) + y) % m);
				}
				else {
					ck ^= ((x * (j + 1)) % m);
				}
			}*/
			cout << prk[cv] << ' ';
		}
		else cout << -1 << ' ';
	}
	cout << endl;

	int i; cin >> i;
	while (i != 0) {
		--i;
		if (qs[i] >= prk.size()) cout << -1 << endl;
		else {
			int c = 0;
			int ck = 0;
			for (int j = 0; j < n; ++j) {
				if (vec[j] && c < qs[i] && sg[j].second == 1) {
					cout << "1 ";
					++c;
					ck ^= ((x * (j + 1) + y) % m);
				}
				else {
					cout << "0 ";
					ck ^= ((x * (j + 1)) % m);
				}
			}
		}
		cin >> i;
	}
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t t = 1;
	cin >> t;
	while (t--) {
		solve();
		//cout << '\n';
	}
}