#include <bits/stdc++.h>
#define ff first
#define ss second
#define endl '\n'
#define all(x) x.begin(), x.end()

typedef long long ll;
using namespace std;

struct ST {
    int sz = 1;
    vector<pair<int, int>> tree;

    ST(int n) {
        while (sz <= n) {
            sz *= 2;
        }

        tree.resize(sz * 2);

        for (int i = 0; i < n; i++) {
            tree[i + sz] = {0, i};
        }
        for (int i = sz - 1; i > 0; i--) {
            tree[i] = tree[i * 2];
        }
    }

    void update(int v, int val) {
        v += sz;
        tree[v] = {val, v - sz};
        v /= 2;
        while (v > 0) {
            tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
            v /= 2;
        }
    }

    pair<int, int> get_max(int v, int tl, int tr, int l, int r) {
        if (l <= tl && tr <= r) return tree[v];

        if (r < tl || tr < l) return {0, -1};

        int m = (tl + tr) / 2;
        auto ls = get_max(v * 2, tl, m, l, r);
        auto rs = get_max(v * 2 + 1, m + 1, tr, l, r);

        return max(ls, rs);
    }
};

struct seg {
    int l, r, id;

    seg() {
        l = 0;
        r = 0;
        id = 0;
    }
};

bool cmp(seg a, seg b) {
    if (a.r != b.r) return a.r < b.r;

    return a.l < b.l;
}

struct seg2 {
    int x, id, term, t, l;

    seg2() {
        x = 0;
        term = 0;
        id = 0;
        t = 0;
    }
};

bool cmp2(seg2 a, seg2 b) {
    if (a.x != b.x) return a.x < b.x;

    if (a.t != b.t) return a.t > b.t;

    if (a.term != b.term) return a.term > b.term;

    return a.id < b.id;
}

void solve() {
    int n;
    cin >> n;

    vector<seg> e(n);
    vector<pair<int, int>> w(n);
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;

        seg u;
        u.l = a;
        u.r = b;
        u.id = i;

        e[i] = u;

        w[i] = {b, a};
    }
    sort(all(e), cmp);
    sort(all(w));

    ST st(n);

    vector<int> p(n, -1);
    for (int i = 0; i < n; i++) {
        pair<int, int> q = {e[i].l, 0};
        int id = lower_bound(all(w), q) - w.begin();

        int mx = 0;
        if (id != 0) {
            pair<int, int> e = st.get_max(1, 0, st.sz - 1, 0, id - 1);
            mx = e.ff, p[i] = e.ss;
        }

        st.update(i, mx + 1);
    }

    auto [m, f] = st.get_max(1, 0, st.sz - 1, 0, n - 1);

    vector<int> a;
    vector<bool> mnj(n);
    while (f != -1) {
        a.push_back(e[f].id);
        mnj[e[f].id] = 1;
        f = p[f];
    }

    vector<seg2> s(n * 2);
    for (int i = 0; i < n; i++) {
        seg2 u;
        u.id = e[i].id;
        u.term = mnj[u.id];


        u.x = e[i].l;
        u.t = 0;
        s[i * 2] = u;

        u.x = e[i].r;
        u.t = 1;
        s[i * 2 + 1] = u;
    }
    sort(all(s), cmp2);

    vector<int> ans;
    vector<int> take;
    vector<bool> ta(n);

    set<pair<int, int>> close;
    set<int> open;
    for (auto q : s) {

        //cout << q.x << " " << q.t << " " << q.id << " " << q.term << endl;
        if (q.term) {
            if (!q.t && !open.empty()) {
                if (ans.size() < m / 2) {
                    ans.push_back(q.id + 1);
                    ta[q.id] = 1;
                }
                while (!open.empty() && take.size() < n / 2 - m / 2) {
                    take.push_back(*open.begin() + 1);
                    open.erase(open.begin());
                }
            }

            else if (q.t && !close.empty() && close.lower_bound({q.l + 1, 0}) != close.end()) {
                if (ans.size() < m / 2 && !ta[q.id]) {
                    ans.push_back(q.id + 1);
                    ta[q.id] = 1;
                }

                while (!close.empty() && close.lower_bound({q.l + 1, 0}) != close.end() && take.size() < n / 2 - m / 2) {

                    take.push_back(  (*close.lower_bound({q.l + 1, 0})).ss + 1);
                    close.erase(close.lower_bound({q.l + 1, 0}));
                }
            }

        }

        else {
            //cout << q.id << endl;
            if (!q.t) {
                open.insert(q.id);
            }
            else {
                open.erase(q.id);
                close.insert({q.l, q.id});
            }
        }

        if (take.size() == n / 2 - m / 2) {
            break;
        }
    }

    while (ans.size() < m / 2) {
        while (ta[a.back()]) a.pop_back();
        ans.push_back(a.back() + 1);
        a.pop_back();
    }
    for (auto x : ans) cout << x << " ";
    for (auto x : take) cout << x << " ";
    cout << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
