#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <queue>
#include <map>
#include <unordered_map>

using namespace std;

const int MAXN = 2e3 + 7;
const int MAXNt = (1 << 11);

struct seg_tree {
	int dp[MAXN][2 * MAXNt];

	void upd(int id, int pos, int val) {
		int v = pos + MAXNt;
		dp[id][v] = val;
		v /= 2;
		while (v >= 1) {
			dp[id][v] = max(dp[id][2 * v], dp[id][2 * v + 1]);
			v /= 2;
		}
	}

	int get_max(int id, int l, int r) {
		int vl = l + MAXNt;
		int vr = r + MAXNt;
		int res = -1e9;
		while (vl <= vr) {
			if (vl & 1) {
				res = max(res, dp[id][vl]);
				vl++;
			}
			if ((vr & 1) == 0) {
				res = max(res, dp[id][vr]);
				vr--;
			}
			vl /= 2;
			vr /= 2;
		}
		return res;
	}
};

seg_tree dp0;
seg_tree dp1;

const int MAXNr = (1 << 18);
int st[2 * MAXNr];

void upd_pos(int pos, int val) {
	int v = pos + MAXNr;
	st[v] = val;
	v /= 2;
	while (v >= 1) {
		st[v] = st[2 * v] + st[2 * v + 1];
		v /= 2;
	}
}

int get_sum(int l, int r) {
	int vl = l + MAXNr;
	int vr = r + MAXNr;
	int res = 0;
	while (vl <= vr) {
		if (vl & 1) {
			res += st[vl];
			vl++;
		}
		if ((vr & 1) == 0) {
			res += st[vr];
			vr--;
		}
		vl /= 2;
		vr /= 2;
	}
	return res;
}


void solvekek(int n, vector <int> p) {
	vector <int> f(n, n);
	vector <int> st;
	for (int i = 0; i < n; i++) {
		while (st.size() && p[st.back()] < p[i]) {
			f[st.back()] = i;
			st.pop_back();
		}
		st.push_back(i);
	}
	vector <int> l;
	vector <int> a = { 0 };
	for (int i = 1; i < n; i++)
		if (p[i] > p[a.back()])
			a.push_back(i);
	if ((int)a.size() >= n - 1) {
		cout << n << "\n";
		return;
	}
	vector <bool> ina(n + 1, false);
	for (auto e : a)
		ina[e] = true;
	ina[n] = true;
	int temp = 0;
	int sz = (int)a.size();
	vector <int> prof;
	vector <int> c(n, 0);
	int ind = sz - 2;
	for (int i = n - 1; i >= 0; i--) {
		if (ina[i]) {
			prof.push_back(temp);
			temp = 0;
			ind--;
		}
		else {
			if (ina[f[i]])
				c[i] = 1;
			else
				c[i] = c[f[i]] + 1;
			if (ind == -1 || p[i] > p[a[ind]])
				temp = max(temp, c[i]);
		}
	}
	reverse(prof.begin(), prof.end());
	int ans = sz + 1;
	int mi = 1e9;
	for (int i = n - 1; i >= 0; i--) {
		if (!ina[i] && mi < p[i])
			ans = sz + 2;
		if (!ina[i])
			mi = min(mi, p[i]);
	}
	ind = sz - 1;
	for (int i = n - 1; i >= 0; i--) {
		if (!ina[i]) {
			upd_pos(p[i], 1);
		} 
		else {
			int cans = sz + prof[ind];
			int newchel = prof[ind];
			if (get_sum(1, p[i] - 1) > newchel)
				cans++;
			ans = max(ans, cans);
			ind--;
		}
	}
	cout << ans << "\n";
}

void solve() {
	int n;
	cin >> n;
	vector <int> p(n);
	for (int i = 0; i < n; i++)
		cin >> p[i];
	if (n > 2) {
		solvekek(n, p);
		return;
	}
	for (int i = 0; i <= n + 2; i++) {
		for (int j = 0; j <= n + 2; j++) {
			dp0.upd(i, j, -1e9);
			dp1.upd(i, j, -1e9);
		}
	}
	dp0.upd(p[0], n + 1, 1);
	dp0.upd(0, p[0], 1);
	dp1.upd(n + 1, p[0], 1);
	dp1.upd(p[0], 0, 1);
	vector <int> en(n + 1, n + 1);
	vector <int> st(n + 2, 0);
	for (int i = 1; i < n; i++) {
		vector <int> ndp1(n + 1);
		for (int j = 0; j <= n; j++)
			ndp1[j] = dp0.get_max(j, p[i], p[i]);
		for (int j = 0; j <= n; j++)
			ndp1[j] = max(ndp1[j], dp0.get_max(j, p[i] + 1, en[j]) + 1);
		vector <int> ndp2(n + 2);
		for (int j = 0; j <= n + 1; j++)
			ndp2[j] = dp0.get_max(p[i], j, j);
		for (int t = 0; t <= n + 1; t++)
			ndp2[t] = max(ndp2[t], dp1.get_max(t, st[t], p[i] - 1) + 1);

		for (int j = 0; j <= n; j++) {
			dp0.upd(j, p[i], ndp1[j]);
			dp1.upd(p[i], j, ndp1[j]);
		}
		for (int j = 0; j <= n + 1; j++) {
			dp0.upd(p[i], j, ndp2[j]);
			dp1.upd(j, p[i], ndp2[j]);
		}
		for (int j = 0; j < p[i]; j++)
			en[j] = min(en[j], p[i]);
		for (int t = p[i] + 1; t <= n + 1; t++)
			st[t] = max(st[t], p[i]);
	}
	int ans = 0;
	for (int i = 1; i <= n; i++)
		ans = max(ans, dp0.get_max(i, 1, n));
	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}