#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <random>
#include <unordered_map>

using namespace std;

bool comp(pair <pair <int, int>, int> v, pair <pair <int, int>, int> u) {
	if (v.first.second == u.first.second)
		return v.first.first < u.first.first;
	return v.first.second < u.first.second;
}

int calcm(vector <pair <pair <int, int>, int>>& a, vector <bool>& dead) {
	int sz = 0;
	int mar = -1e9;
	for (int i = 0; i < (int)a.size(); i++) {
		if (dead[i])
			continue;
		auto e = a[i];
		if (e.first.first > mar) {
			sz++;
			mar = e.first.second;
		}
	}
	return sz;
}

bool inter(pair <int, int> v, pair <int, int> u) {
	if (v.first > u.second || v.second < u.first)
		return false;
	return true;
}

void solve() {
	int n;
	cin >> n;
	vector <bool> dead(n, false);
	vector <pair <pair <int, int>, int>> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i].first.first >> a[i].first.second;
		a[i].second = i;
	}
	sort(a.begin(), a.end(), comp);
	int m0 = calcm(a, dead);
	for (int l = 0; l < n; l++) {
		int r = l + n / 2 - 1;
		dead.assign(n, false);
		for (int i = l; i <= r; i++)
			dead[i] = true;
		if (calcm(a, dead) == m0 / 2) {
			for (int i = 0; i < l; i++)
				cout << a[i].second + 1 << " ";
			for (int i = r + 1; i < n; i++)
				cout << a[i].second + 1 << " ";
			cout << "\n";
			return;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}