#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <random>
#include <unordered_map>

using namespace std;
#define int long long

const int MAXC = 5007;

bool dp[MAXC][MAXC];
bool f[MAXC][MAXC];

struct query {
	long long k, a, b;
	int id;
	query(long long a0, long long a1, long long a2, int ind) {
		k = a0;
		a = a1;
		b = a2;
		id = ind;
	}
};

bool comp(query v, query u) {
	return v.k < u.k;
}

void solve() {
	int n, q;
	cin >> n >> q;
	vector <long long> w(n);
	for (int i = 0; i < n; i++)
		cin >> w[i];
	sort(w.begin(), w.end());
	int z;
	cin >> z;
	vector <query> qu;
	for (int i = 0; i < q; i++) {
		long long k, a, b;
		cin >> k >> a >> b;
		qu.push_back(query(k, a, b, i));
	}
	sort(qu.begin(), qu.end(), comp);
	dp[0][0] = true;
	int id = 0;
	vector <bool> ans(q);
	for (auto e : qu) {
		while (id < n && w[id] <= e.k) {
			for (int a = MAXC - 2; a >= 0; a--) {
				for (int b = MAXC - 2; b >= 0; b--) {
					if (dp[a][b] && b + w[id] < MAXC)
						dp[a][b + w[id]] = true;
					if (dp[a][b] && a + w[id] < MAXC)
						dp[a + w[id]][b] = true;
				}
			}
			for (int i = 0; i < MAXC; i++) {
				for (int j = 0; j < MAXC; j++) {
					f[i][j] = true;
					for (int t1 = 0; t1 <= i; t1++)
						for (int t2 = 0; t2 <= j; t2++)
							f[i][j] &= dp[t1][t2];
				}
			}
			id++;
		}
		if (e.a < MAXC && e.b < MAXC)
			ans[e.id] = f[e.a][e.b];
	}
	for (auto e : ans) {
		if (e)
			cout << "Yes\n";
		else
			cout << "No\n";
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	//  cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}