#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <random>
#include <unordered_map>

using namespace std;

const int MAXN = 2e5 + 7;
vector <int> g[MAXN];
int l[MAXN];
int r[MAXN];

long long dp0[MAXN];
long long dp1[MAXN];

int res[MAXN];

void dfs(int v, int prev = -1) {
	dp1[v] = r[v];
	dp0[v] = 0;
	for (auto to : g[v]) {
		if (to == prev)
			continue;
		dfs(to, v);
	}
	for (auto to : g[v]) {
		if (to == prev)
			continue;
		dp0[v] += max(dp0[to], dp1[to]);
		dp1[v] += dp0[to];
	}
}

void dfs2(int v, int flag, int prev = -1) {
	if (flag == 0 || dp0[v] > dp1[v] || r[v] == 0) {
		res[v] = 0;
		for (auto to : g[v])
			if (to != prev)
				dfs2(to, 1, v);
	}
	else {
		res[v] = r[v];
		for (auto to : g[v])
			if (to != prev)
				dfs2(to, 0, v);
	}
}

void solve() {
	int n, q;
	cin >> n >> q;
	long long x, y, m;
	cin >> x >> y >> m;
	int v, u;
	for (int i = 0; i < n; i++)
		g[i].clear();
	for (int i = 0; i < n - 1; i++) {
		cin >> v >> u;
		v--; u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	vector <pair <long long, int>> query(q);
	vector <long long> q0(q);
	vector <int> ansq(q);
	for (int i = 0; i < q; i++) {
		cin >> query[i].first;
		q0[i] = query[i].first;
		query[i].second = i;
	}
	sort(query.rbegin(), query.rend());
	fill(dp0, dp0 + n, -1e18);
	fill(dp1, dp1 + n, -1e18);
	dfs(0);
	dfs2(0, 1);
	long long ans = max(dp0[0], dp1[0]);
	long long ans0 = ans;
	long long k = 0;
	vector <long long> res0(n, 0);
	for (int i = 0; i < n; i++)
		res0[i] = res[i];
	for (int i = 0; i < n; i++) {
		long long temp1 = (x * (i + 1)) % m;
		long long temp2 = ((y * res[i]) % m * 1ll * res[i]) % m;
		k ^= ((temp1 + temp2) % m);
	}
	int id = n - 1;
	for (auto e : query) {
		if (e.first > ans0) {
			ansq[e.second] = -1;
		}
		else {
			while (ans > e.first) {
				if (res[id] > l[id]) {
					long long temp1 = (x * (id + 1)) % m;
					long long temp2 = ((y * res[id]) % m * 1ll * res[id]) % m;
					k ^= ((temp1 + temp2) % m);
					long long take = min(1ll * res[id] - l[id], ans - e.first);
					res[id] -= take;
					temp2 = ((y * res[id]) % m * 1ll * res[id]) % m;
					k ^= ((temp1 + temp2) % m);
					ans -= take;
				}
				if (res[id] == l[id])
					id--;
			}
			ansq[e.second] = k;
		}
	}
	for (auto e : ansq)
		cout << e << " ";
	cout << endl;
	int c = 0;
	cin >> c;
	c--;
	while (c != -1) {
		if (q0[c] > ans0) {
			cout << -1 << endl;
		}
		else {
			ans = ans0;
			for (int i = 0; i < n; i++)
				res[i] = res0[i];
			long long need = q0[c];
			for (int i = 0; i < n && ans > need; i++) {
				long long take = min(ans - need, 1ll * res[i] - l[i]);
				res[i] -= take;
				ans -= take;
			}
			for (int i = 0; i < n; i++)
				cout << res[i] << " ";
			long long s = 0;
			for (int i = 0; i < n; i++)
				s += res[i];
			assert(s == need);
			cout << endl;
		}
		cin >> c;
		c--;
	}
	cout << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}