#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <random>
#include <unordered_map>

using namespace std;

const int MAXN = 2e5 + 7;
vector <int> g[MAXN];
int l[MAXN];
int r[MAXN];

long long dp0[MAXN];
long long dp1[MAXN];

int res[MAXN];

void dfs(int v, int prev = -1) {
	if (r[v] == 1)
		dp1[v] = 1;
	else
		dp1[v] = 0;
	dp0[v] = 0;
	for (auto to : g[v]) {
		if (to == prev)
			continue;
		dfs(to, v);
	}
	for (auto to : g[v]) {
		if (to == prev)
			continue;
		dp0[v] += max(dp0[to], dp1[to]);
		dp1[v] += dp0[to];
	}
}

void dfs2(int v, int flag, int prev = -1) {
	if (flag == 0 || dp0[v] > dp1[v] || r[v] == 0) {
		res[v] = 0;
		for (auto to : g[v])
			if (to != prev)
				dfs2(to, 1, v);
	}
	else {
		res[v] = 1;
		for (auto to : g[v])
			if (to != prev)
				dfs2(to, 0, v);
	}
}

void solve() {
	int n, q;
	cin >> n >> q;
	long long x, y, m;
	cin >> x >> y >> m;
	int v, u;
	for (int i = 0; i < n; i++)
		g[i].clear();
	for (int i = 0; i < n - 1; i++) {
		cin >> v >> u;
		v--; u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	vector <long long> query(q);
	for (int i = 0; i < q; i++)
		cin >> query[i];
	fill(dp0, dp0 + n, -1e18);
	fill(dp1, dp1 + n, -1e18);
	dfs(0);
	dfs2(0, 1);
	long long ans = max(dp0[0], dp1[0]);
	for (auto e : query) {
		if (e <= ans) {
			long long k = 0;
			int cnt = e;
			for (int i = 0; i < n; i++) {
				long long temp1 = (x * (i + 1)) % m;
				long long temp2 = 0;
				if (cnt) {
					temp2 = ((y * res[i]) % m * 1ll * res[i]) % m;
					if (res[i])
						cnt--;
				}
				k ^= ((temp1 + temp2) % m);
			}
			cout << k << " ";
		}
		else {
			cout << "-1 ";
		}
	}
	cout << endl;
	int c = 0;
	cin >> c;
	c--;
	while (c != -1) {
		if (query[c] > ans) {
			cout << -1 << endl;
		}
		else {
			int cnt = query[c];
			for (int i = 0; i < n; i++) {
				if (cnt)
					cout << res[i] << " ";
				else
					cout << "0 ";
				if (cnt && res[i] == 1)
					cnt--;
			}
			cout << endl;
		}
		cin >> c;
		c--;
	}
	cout << endl;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}