#include <iostream>
#include <vector>
#include <algorithm>

#define MAX(a, b) ((a) < (b) ? (b) : (a))
#define YN(ok) cout << (ok ? "Yes" : "No") << '\n';

using namespace std;

typedef vector <int> vb;
typedef vector <vb> vvb;
typedef vector <vvb> vvvb;

void printv(vector <int> &v) {
    cout << "[";
    for (int x : v) cout << x << ", ";
    cout << "]\n";
}

int u = 0, v = 0;

void next(vector <int> &w, vvvb &dp, int i, int x) {
    if (u > 300 || v > 300) return;
    if (dp[u][v][i] <= x) return;
    dp[u][v][i] = x;
    if (i == (int) w.size()) return;

    next(w, dp, i + 1, x);
    u += w[i];
    next(w, dp, i + 1, w[i]);
    u -= w[i];
    v += w[i];
    next(w, dp, i + 1, w[i]);
    v -= w[i];
}

void one() {
    int n, q, z;
    cin >> n >> q;
    vector <int> w(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    sort(w.begin(), w.end());

    cin >> z;

    vvvb dp(301, vvb(301, vb(n + 1, 1000000001)));
    next(w, dp, 0, 0);

    vvb ok(301, vb(301));
    for (int i = 0; i <= 300; ++i) {
        for (int j = 0; j <= 300; ++j) {
            ok[i][j] = dp[i][j][n];
            if (i != 0) ok[i][j] = MAX(ok[i][j], ok[i - 1][j]);
            if (j != 0) ok[i][j] = MAX(ok[i][j], ok[i][j - 1]);
        }
    }

    /*
    for (int i = 0; i <= 15; ++i) {
        for (int j = 0; j < 10; ++j) {
            cout << dp[i][j][n] << ' ';
        }
        cout << '\n';
    }
    */

    for (int i = 0; i < q; ++i) {
        long long k;
        int a, b;
        cin >> k >> a >> b;
        YN(ok[a][b] <= k);
    }
}

int main() {
    int t;
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        cin >> t;
    #else
        ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
        t = 1;
    #endif // LOCAL
    while (t--) {
        one();
        cout << endl;
    }
    return 0;
}



