#include <iostream>
#include <vector>

using namespace std;
using Graph = vector<vector<int>>;

const int INF = 1'000'000'007;

void fill_info(const Graph &childrens, int v, int cur, int status, vector<int> &values, vector<int> &tins, vector<int> &touts, vector<int> &tour) {
    tins[v] = tour.size();
    tour.push_back(v);
    if (childrens[v].empty()) {
        values[v] = cur;
        touts[v] = tour.size();
        return;
    }
    for (int i = 0; i < 2; i++) {
        int new_cur = cur;
        if (status != -1 && status != i) {
            new_cur++;
        }
        fill_info(childrens, childrens[v][i], new_cur, i, values, tins, touts, tour);
    }
    touts[v] = tour.size();
}

int main() {
    int n, k, q; cin >> n >> k >> q;
    Graph childrens(n);
    for (int i = 0; i < n; i++) {
        int t; cin >> t;
        if (t == 2) {
            int l, r; cin >> l >> r;
            l--; r--;
            childrens[i].push_back(l);
            childrens[i].push_back(r);
        }
    }
    vector<int> values(n, INF), tins(n), touts(n), tour;
    fill_info(childrens, 0, 0, -1, values, tins, touts, tour);
    for (int &v : tour) {
        v = (values[v] <= k ? 1 : 0);
    }
    vector<int> tour_pref_sums(n + 1);
    for (int i = 0; i < n; i++) {
        tour_pref_sums[i + 1] = tour_pref_sums[i] + tour[i];
    }
    while (q--) {
        int u; cin >> u; u--;
        cout << tour_pref_sums[touts[u]] - tour_pref_sums[tins[u]] << endl;
    }
}
