#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>

using namespace std;

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;

template<typename t> bool minravno(t& a, const t& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, const t& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k];
}

const int INF = 1e9 + 1;

si s;
int n, k, num;
int b;
vi ans;
struct node {
	int p0, p1;
	node* l, * r;
	node(int p0_, int p1_) {
		p0 = p0_;
		p1 = p1_;
		l = r = nullptr;
	}
};

int func(int a, int b) {
	if (num == 1)
		return max(a, b);
	else
		return min(a, b);
}

void update(node* v, int tl, int tr, int i, int x) {
	if (tr - tl == 1) {
		if (x == 1)
			v->p0 = b, v->p1 = i;
		else if (x == 0)
			v->p1 = b, v->p0 = i;
		else
			v->p0 = v->p1 = b;
	}
	else {
		int m = (tr + tl) / 2;
		if (!v->l)
			v->l = new node((num == 1 ? m - 1 : tl), (num == 1 ? -1 : INF));
		if (!v->r)
			v->r = new node((num == 1 ? tr - 1 : m), (num == 1 ? -1 : INF));
		if (i < m)
			update(v->l, tl, m, i, x);
		else
			update(v->r, m, tr, i, x);
		v->p0 = func(v->l->p0, v->r->p0);
		v->p1 = func(v->l->p1, v->r->p1);
	}
}

pair<int, int> get(node* v, int tl, int tr, int l, int r) {
	if (r <= tl || tr <= l)
		return { b, b };
	if (l <= tl && r >= tr)
		return { v->p0, v->p1 };
	int m = (tr + tl) / 2;
	if (!v->l)
		v->l = new node((num == 1 ? m - 1 : tl), (num == 1 ? -1 : INF));
	if (!v->r)
		v->r = new node((num == 1 ? tr - 1 : m), (num == 1 ? -1 : INF));
	auto [lp0, lp1] = get(v->l, tl, m, l, r);
	auto [rp0, rp1] = get(v->r, m, tr, l, r);
	return { func(lp0, rp0), func(lp1, rp1) };
}
node* root = nullptr;

void find_pair1(int i) {
	auto [r0, r1] = get(root, 0, n, 0, i);
	if (r0 == -1 && r1 == -1) {
		auto [t1, t2] = get(root, 0, n, i + 1, n);
		r0 = t1;
		r1 = t2;
		if (r1 > r0) {
			find_pair1(r1);
			find_pair1(i);
			return;
		}
		ans.push_back(r0);
		update(root, 0, n, i, 2);
		update(root, 0, n, r0, 2);
		s.erase(i);
		return;
	}
	if (r1 > r0) {
		find_pair1(r1);
		find_pair1(i);
		return;
	}
	ans.push_back(r0);
	update(root, 0, n, i, 2);
	update(root, 0, n, r0, 2);
	s.erase(i);
	return;
}

void find_pair2(int i) {
	auto [l0, l1] = get(root, 0, n, i + 1, n);
	if (l0 == INF && l1 == INF) {
		auto [t1, t2] = get(root, 0, n, 0, i);
		l0 = t1;
		l1 = t2;
		if (l1 < l0) {
			find_pair2(l1);
			find_pair2(i);
			return;
		}
		ans.push_back(l0);
		update(root, 0, n, i, 2);
		update(root, 0, n, l0, 2);
		s.erase(i);
		return;
	}
	if (l1 < l0) {
		find_pair2(l1);
		find_pair2(i);
		return;
	}
	ans.push_back(l0);
	update(root, 0, n, i, 2);
	update(root, 0, n, l0, 2);
	s.erase(i);
	return;
}

void solve1() {
	cin >> n >> k;
	s.clear();
	ans.clear();
	root = new node(-1, -1);
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
		x--;
		s.insert(x);
		update(root, 0, n, x, 1);
	}
	while (s.size()) {
		find_pair1(*s.begin());
	}
	sort(all(ans));
	for (auto i : ans)
		cout << i + 1 << ' ';
	cout << endl;
}

void solve2() {
	cin >> n >> k;
	s.clear();
	ans.clear();
	root = new node(INF, INF);
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
		x--;
		s.insert(x);
		update(root, 0, n, x, 1);
	}
	while (s.size()) {
		find_pair2(*s.begin());
	}
	sort(all(ans));
	for (auto i : ans)
		cout << i + 1 << ' ';
	cout << endl;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> num;
	if (num == 1)
		b = -1;
	else
		b = INF;
	int t;
	cin >> t;
	while (t--) {
		if (num == 1)
			solve1();
		else
			solve2();
	}

	return 0;
}