#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#include <chrono>
#include <random>
#include <bitset>

using namespace std;

mt19937 rnd(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<spi> vspi;
typedef vector<bool> vb;
typedef tuple<int, int, int> ti;
typedef set<ti> sti;

template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k];
}
template<typename t> bool minravno(t& a, const t& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, const t& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const int MAXN = 2e5 + 10, INF = 1e18;

vvi g;
int dp[MAXN][2];
vi a;

void dfs(int v, int p = -1) {
	dp[v][1] = a[v];
	dp[v][0] = 0;
	for (auto u : g[v]) {
		if (u != p) {
			dfs(u, v);
			dp[v][0] += max(dp[u][0], dp[u][1]);
			dp[v][1] += dp[u][0];
		}
	}
}

vi b;

void get(int v, int x, int p = -1) {
	if (x)
		b.push_back(v);
	for (auto u : g[v]) {
		if (u != p) {
			if (x)
				get(u, 0, v);
			else if (dp[u][1] > dp[u][0])
				get(u, 1, v);
			else
				get(u, 0, v);
		}
	}
}

void solve() {
	int n, q;
	cin >> n >> q;
	a.assign(n + 1, 0);
	g.assign(n + 1, {});
	b.clear();
	int x, y, m;
	cin >> x >> y >> m;
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	for (int i = 1; i <= n; ++i)
		cin >> a[i] >> a[i];
	dfs(1);
	if (dp[1][0] > dp[1][1])
		get(1, 0);
	else
		get(1, 1);
	vb check(n + 1);
	for (auto i : b)
		check[i] = true;
	int k = 0;
	for (int i = 1; i <= n; ++i)
		k ^= (x * i % m);
	vpi v;
	vi v1;
	for (int i = 0; i < q; ++i) {
		int x;
		cin >> x;
		v.push_back({ x, i });
		v1.push_back(x);
	}
	sort(all(v));
	vi ans(q, -1);
	int j = 0;
	int sm = 0;
	vi c(n + 1, 0);
	for (auto [need, i] : v) {
		while (sm < need && j < b.size()) {
			int val = min(need - sm, a[b[j]] - c[b[j]]);
			sm += val;
			k ^= ((x * b[j] % m + ((y * c[b[j]] % m) * c[b[j]] % m)) % m);
			c[b[j]] += val;
			k ^= ((x * b[j] % m + ((y * c[b[j]] % m) * c[b[j]] % m)) % m);
			if (a[b[j]] == c[b[j]])
				j++;
		}
		if (sm < need)
			ans[i] = -1;
		else
			ans[i] = k;
	}
	for (int i = 0; i < q; ++i)
		cout << ans[i] << ' ';
	cout << endl;
	int i;
	cin >> i;
	while (i) {
		i--;
		if (ans[i] == -1)
			cout << -1 << endl;
		else {
			int j = 0, sm = 0;
			vi c(n + 1, 0); 
			k = 0;
			for (int i = 1; i <= n; ++i)
				k ^= (x * i % m);
			int need = v1[i];
			while (sm < need && j < b.size()) {
				int val = min(need - sm, a[b[j]] - c[b[j]]);
				sm += val;
				k ^= ((x * b[j] % m + ((y * c[b[j]] % m) * c[b[j]] % m)) % m);
				c[b[j]] += val;
				k ^= ((x * b[j] % m + ((y * c[b[j]] % m) * c[b[j]] % m)) % m);
				if (a[b[j]] == c[b[j]])
					j++;
			}
			for (int i = 1; i <= n; ++i)
				cout << c[i] << ' ';
			cout << endl;
		}
		cin >> i;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}