#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int MAXN = 2e5 + 10;
bool leaf[MAXN];
vector<int> g[MAXN];

int tin[MAXN], tout[MAXN], cnt[MAXN], euler[MAXN];
int t = 0;
void dfs(int v, int cur = 0, int p = -1) {
    tin[v] = t;
    cnt[v] = cur;
    euler[t++] = v;
    if (!leaf[v]) {
        if (p == -1) {
            dfs(g[v][0], cur, 0);
            dfs(g[v][1], cur, 1);
        } else {
            dfs(g[v][0], cur + (p == 1), 0);
            dfs(g[v][1], cur + (p == 0), 1);
        }
    }
    tout[v] = t;
}


vector<int> tree[4 * MAXN];
void build(int x, int l, int r) {
    if (l + 1 == r) {
        int cur = euler[l];
        tree[x].push_back(leaf[cur] ? cnt[cur] : 1e9);
        return;
    }

    int m = (l + r) / 2;
    build(2 * x + 1, l, m);
    build(2 * x + 2, m, r);
    merge(all(tree[2 * x + 1]), all(tree[2 * x + 2]), back_inserter(tree[x]));
}

int get(int lq, int rq, int v, int x, int l, int r) {
    if (rq <= l || r <= lq) return 0;
    if (lq <= l && r <= rq) return upper_bound(all(tree[x]), v) - tree[x].begin();

    int m = (l + r) / 2;
    int a = get(lq, rq, v, 2 * x + 1, l, m);
    int b = get(lq, rq, v, 2 * x + 2, m, r);
    return a + b;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k, q;
    cin >> n >> k >> q;

    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 0) {
            leaf[i] = true;
        } else {
            int l, r;
            cin >> l >> r;
            l--; r--;
            g[i].push_back(l);
            g[i].push_back(r);
        }
    }
    dfs(0);
    build(0, 0, n);

    for (int i = 0; i < q; i++) {
        int u;
        cin >> u;
        u--;
        cout << get(tin[u], tout[u], k, 0, 0, n) << '\n';
    }

    return 0;
}