#include <bits/stdc++.h>
using namespace std;

pair<long long, long long> get_value(int x, vector<vector<int>>& dfsed_graph, vector<long long>& a, vector<bool>& ans) {
    long long c(0), d(0);
    for (auto i : dfsed_graph[x]) {
        pair<long long, long long> rest(get_value(i, dfsed_graph, a, ans));
        c += rest.first;
        d += max((long long)0, rest.second - rest.first);
    }
    if (d > a[x]) {
        ans[x] = false;
    } else {
        ans[x] = true;
    }
    return {c + d, c + max(d, a[x])};
}

void backtrack_value(int x, vector<vector<int>>& dfsed_graph, vector<bool>& ans, bool b, vector<bool>& res) {
    if (b) {
        b = ans[x];
    }
    res[x] = b;
    for (auto i : dfsed_graph[x]) {
        backtrack_value(i, dfsed_graph, ans, !b, res);
    }
}

int certificate(long long x, long long y, long long m, vector<long long>& a) {
    int cert(0);
    for (int i = 0; i < a.size(); i++) {
        cert ^= (x * (i + 1) + y * ((a[i] * a[i]) % m)) % m;
    }
    return cert;
}

void recertify(long long x, long long y, long long m, long long a, long long b, long long i, long long& cert) {
    cert ^= (x * (i + 1) + y * ((a * a) % m)) % m;
    cert ^= (x * (i + 1) + y * ((b * b) % m)) % m;
}

void dfs_graph(int x, int p, vector<vector<int>>& g, vector<vector<int>>& dfsed_graph) {
    for (auto i : g[x]) {
        if (i != p) {
            dfs_graph(i, x, g, dfsed_graph);
            dfsed_graph[x].push_back(i);
        }
    }
}

void f() {
    long long n, k, q, r;
    cin >> n >> k;
    long long m, x, y;
    cin >> x >> y >> m;
    vector<long long> L(n), R(n), A(n);
    vector<vector<int>> graph(n, vector<int>(0));
    for (int i = 0; i < n - 1; i++) {
        cin >> q >> r;
        q--;
        r--;
        graph[q].push_back(r);
        graph[r].push_back(q);
    }
    vector<vector<int>> dfsed_graph(n, vector<int>(0));
    dfs_graph(0, -1, graph, dfsed_graph);
    for (int i = 0; i < n; i++) {
        cin >> q >> r;
        L[i] = q;
        A[i] = q;
        R[i] = r;
    }
    vector<bool> ans(n, true);
    get_value(0, dfsed_graph, R, ans);
    vector<bool> bktrk(n, true);
    backtrack_value(0, dfsed_graph, ans, true, bktrk);
    vector<pair<long long, int>> plans{};
    for (int i = 0; i < n; i++) {
        if (!bktrk[i]) {
            R[i] = 0;
        }
    }
    for (int i = 0; i < k; i++) {
        cin >> q;
        plans.push_back({q, i});
    }
    long long prevperformance(0);
    A[0] = R[0];
    int kch(0);
    long long performance(R[0]);
    long long cert(certificate(x, y, m, A));
    sort(plans.begin(), plans.end());
    vector<int> certs(k);
    vector<pair<int, int>> answer(k);
    for (int i = 0; i < k; i++) {
        while (plans[i].first > performance) {
            kch++;
            if (kch >= n) {
                break;
            }
            A[kch] = R[kch];
            recertify(x, y, m, L[kch], R[kch], kch, cert);
            prevperformance = performance;
            performance += R[kch];
        }
        if ((kch >= n) || (plans[i].first < prevperformance)) {
            certs[plans[i].second] = -1;
        } else {
            long long cert2(cert);
            long long d(R[kch] + plans[i].first - performance);
            recertify(x, y, m, R[kch], d, kch, cert2);
            certs[plans[i].second] = cert2;
            answer[plans[i].second] = {kch, d};
        }
    }
    for (int i = 0; i < k; i++) {
        cout << certs[i] << " ";
    }
    cout << endl;
    while (true) {
        cin >> q;
        if (q == 0) {
            return;
        }
        q--;
        if (certs[q] == -1) {
            cout << -1 << endl;
        } else {
            for (int i = 0; i < n; i++) {
                if (i < answer[q].first) {
                    cout << R[i];
                } else if (i == answer[q].first) {
                    cout << answer[q].second;
                } else {
                    cout << L[i];
                }
                cout << " ";
            }
            cout << endl;
        }
    }
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        f();
    }
}
