#include<bits/stdc++.h>

#define ll long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define ld long double

using namespace std;

const int INF = 1e9;

mt19937 rnd(51);

int get_ans(vector<array<int, 3>> u) {
    sort(all(u));
    int n = u.size();
    vector<int> dp(n), par(n, -1);
    for (int i = 0; i < n; i++) {
        dp[i] = 1;
        for (int j = 0; j < i; j++) {
            if (u[j][1] < u[i][0]) {
                if (dp[j] + 1 > dp[i]) {
                    par[i] = j;
                    dp[i] = dp[j] + 1;
                }
            }
        }
    }
    return *max_element(all(dp));
}

vector<int> stupid_solve(int n, vector<array<int, 3>> u) {
    int m = get_ans(u);
    for (int mask = 0; mask < (1 << n); mask++) {
        if (__builtin_popcount(mask) != n / 2) continue;
        vector<array<int, 3>> s;
        vector<int> mas;
        for (int b = 0; b < n; b++) {
            if (mask & (1 << b)) {
                s.pb(u[b]);
                mas.pb(b);
            }
        }
        if (get_ans(s) == m / 2) {
            return mas;
        }
    }
    assert(0);
}

vector<int> get_mas(vector<array<int, 3>> u, int need) {
    sort(all(u));
    int n = u.size();
    vector<int> dp(n), par(n, -1);
    for (int i = 0; i < n; i++) {
        dp[i] = 1;
        for (int j = 0; j < i; j++) {
            if (u[j][1] < u[i][0]) {
                if (dp[j] + 1 > dp[i]) {
                    par[i] = j;
                    dp[i] = dp[j] + 1;
                }
            }
        }
    }
    int j = 0;
    for (int i = 0; i < n; i++) {
        if (dp[i] > dp[j]) {
            j = i;
        }
    }
    vector<bool> used(n);
    vector<int> mas;
    while (j >= 0) {
        mas.pb(u[j][2]);
        used[j] = 1;
        j = par[j];
    }
    for (int i = 0; i < n && mas.size() < need; i++) {
        if (!used[i]) {
            mas.pb(u[i][2]);
        }
    }
    return mas;
}

vector<int> smart_solve(int n, vector<array<int, 3>> u) {
    int m = get_ans(u);
    u.pb({-1, -1, -1});
    n++;
    sort(all(u), [&](array<int, 3> a, array<int, 3> b){return a[1] < b[1];});
    vector<vector<int>> dp(n, vector<int>(n + 1, INF)), par(n, vector<int>(n + 1, -1));
    dp[0][1] = 0;
    vector<int> val(n);
    vector<int> kek;
    for (int i = 1; i < n; i++) {
        assert(u[i - 1][1] <= u[i][1]);
        vector<int> mem;
        for (auto j : kek) {
            if (u[j][1] < u[i][1]) {
                for (int k = 0; k < i; k++) {
                    if (u[k][1] < u[j][0]) {
                        val[k]++;
                    }
                }
            } else {
                mem.pb(j);
            }
        }
        kek = mem;
        for (int k = 0; k < i; k++) {
            for (int j = 0; j <= n; j++) {
                if (dp[k][j] != INF) {
                    if (dp[i][j + 1] > dp[k][j] + val[k]) {
                        dp[i][j + 1] = dp[k][j] + val[k];
                        par[i][j + 1] = k;
                    }
                }
            }
        }
        kek.pb(i);
    }
    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = 0; j < n; j++) {
            if (u[j][0] > u[i][1]) {
                cnt++;
            }
        }
        if (dp[i][m / 2 + 1] + cnt <= n / 2) {
            int cur = i;
            vector<int> arr;
            for (int j = m / 2 + 1; j >= 1; j--) {
                arr.pb(cur);
                cur = par[cur][j];
            }
            reverse(all(arr));
            vector<bool> used(n);
            for (int j = 0; j + 1 < arr.size(); j++) {
                for (int k = 0; k < n; k++) {
                    if (u[arr[j]][1] < u[k][0] && u[k][1] < u[arr[j + 1]][1]) {
                        used[k] = 1;
                    }
                }
            }
            vector<array<int, 3>> s;
            for (int k = 1; k < n; k++) {
                if (u[k][0] > u[i][1]) continue;
                if (!used[k]) {
                    s.pb(u[k]);
                }
            }
            return get_mas(s, n / 2);
        }
    }
    assert(0);
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    while (0) {
        int n = rnd() % 6 + 1;
        if (n % 2 == 1) {
            continue;
        }
        vector<array<int, 3>> u;
        for (int i = 0; i < n; i++) {
            int l = rnd() % n, r = rnd() % n;
            if (l > r) swap(l, r);
            u.pb({l, r, i});
        }
        int m = get_ans(u);
        if (m % 2 == 1) continue;

    }
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<array<int, 3>> u(n);
        for (int i = 0; i < n; i++) {
            cin >> u[i][0] >> u[i][1];
            u[i][2] = i;
        }
        auto arr = smart_solve(n, u);
        for (auto to : arr) {
            cout << to + 1 << ' ';
        }
        cout << endl;
    }
    return 0;
}
