#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using vi = vector<int>;

const int maxN = 1e5 + 1;

struct Item {
    int x, id;
    bool open;
    Item(int x = 0, int id = 0, bool open = true) : x(x), id(id), open(open) {}
    bool operator<(const Item& other) const {
        return x < other.x || (x == other.x && open && !other.open);
    }
} a[2 * maxN];

bool used[maxN], in_path[maxN];
int test, n, l, r, cur, dp[maxN], cnt[maxN][2], pr[maxN];
vi gr[maxN], ans;

void dfs(int u) {
    cnt[u][0] = 1;
    cnt[u][1] = 0;
    for (int v : gr[u]) {
        dfs(v);
        cnt[u][0] += cnt[v][1];
        cnt[u][1] += cnt[v][0];
    }
}

void calc1(int u, bool flag) {
    if (flag && u != 0 && !used[u] && (int)ans.size() < n / 2) {
        ans.push_back(u);
        used[u] = true;
    }
    for (int v : gr[u])
        calc1(v, !flag);
}

void calc2(int u, bool flag) {
    if (flag && u != 0 && !used[u] && (int)ans.size() < n / 2 && !in_path[u]) {
        ans.push_back(u);
        used[u] = true;
    }
    for (int v : gr[u])
        calc2(v, !flag);
}

void solve() {
    for (int i = 0; i <= n; i++)
        gr[i].clear();
    fill(used, used + n + 1, false);
    fill(in_path, in_path + n + 1, false);
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> l >> r;
        a[2 * i] = Item(l, i + 1, true);
        a[2 * i + 1] = Item(r, i + 1, false);
    }
    sort(a, a + 2 * n);
    cur = 0;
    for (int i = 0; i < 2 * n; i++) {
        if (a[i].open) {
            gr[cur].push_back(a[i].id);
            dp[a[i].id] = dp[cur] + 1;
            pr[a[i].id] = cur;
        } else if (dp[cur] < dp[a[i].id]) {
            cur = a[i].id;
        }
    }
    while (cur != 0) {
        in_path[cur] = true;
        cur = pr[cur];
    }
    dfs(0);
    ans.clear();
    cnt[0][0]--;
    if (cnt[0][0] <= n / 2) {
        calc1(0, true);
        calc2(0, false);
    } else {
        calc1(0, false);
        calc2(0, true);
    }
    fill(used, used + n + 1, false);
    for (int x : ans)
        used[x] = true;
    ans.clear();
    for (int i = 1; i <= n; i++)
        if (!used[i])
            ans.push_back(i);
    for (int x : ans)
        cout << x << " ";
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> test;
    while (test--)
        solve();
    return 0;
}
