#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vi = vector<int>;
using vvi = vector<vi>;

const int A = 300, B = 300;
const string yes = "Yes\n", no = "No\n";

int dp[A + 1][B + 1];
void precalc(int n, const vll& w) {
    for (int i = 0; i <= A; ++i) {
        for (int j = 0; j <= B; ++j) {
            dp[i][j] = 0;
        }
    }

    dp[0][0] = 1;
    for (ll apple : w) {
        for (int i = A; i >= 0; --i) {
            for (int j = B; j >= 0; --j) {
                if (apple <= i) {
                    dp[i][j] = max(dp[i][j], dp[i - apple][j]);
                }
                if (apple <= j) {
                    dp[i][j] = max(dp[i][j], dp[i][j - apple]);
                }
            }
        }
    }

    for (int i = 0; i <= A; ++i) {
        for (int j = 0; j <= B; ++j) {
            if (i > 0) {
                dp[i][j] = min(dp[i - 1][j], dp[i][j]);
            }
            if (j > 0) {
                dp[i][j] = min(dp[i][j], dp[i][j - 1]);
            }
        }
    }
}

bool query(ll k, ll a, ll b) {
    return dp[a][b];
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, q, z;
    ll j, c, d;
    cin >> n >> q;
    vll w(n);
    for (ll& i : w) {
        cin >> i;
    }
    cin >> z;

    precalc(n, w);

    ll v = 0;
    for (int it = 1; it <= q; ++it) {
        cin >> j >> c >> d;
        ;
        if (query(j - v * z, c - v * z, d - v * z)) {
            v += it;
            cout << yes;
        } else {
            cout << no;
        }
    }

    return 0;
}
