#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vvll = vector<vll>;
using vi = vector<int>;
using vvi = vector<vi>;

const int A = 1e5, B = 0;
const string yes = "Yes\n", no = "No\n";

ostream& operator<<(ostream& out, const vi& v) {
    for (int i : v) {
        out << i << ' ';
    }
    return out;
}

void dfs(int v, int par, const vi& r, vvll& dp, const vvi& g) {
    dp[1][v] = r[v];
    for (int to : g[v]) {
        if (to != par) {
            dfs(to, v, r, dp, g);

            if (dp[1][to] >= dp[0][to]) {
                dp[0][v] += dp[1][to];
            } else {
                dp[0][v] += dp[0][to];
            }
            dp[1][v] += dp[0][to];
        }
    }
}

int mod(ll x, int m) {
    x %= m;
    return (x >= 0 ? x : x + m);
}

int f(int v, const vi& a, int x, int y, int m) {
    return (x * 1LL * (v + 1) + y * 1LL * (a[v] * 1LL * a[v] % m)) % m;
}

int cert(int v, int par, bool emp, const vi& r, const vvll& dp, const vvi& g, ll sum, vi& a, int x, int y, int m) {
    int res = 0;
    if (!emp && dp[1][v] >= sum) {
        a[v] = min(sum, (ll)r[v]);
        sum -= a[v];
        res ^= f(v, a, x, y, m);
        for (int to : g[v]) {
            if (to != par) {
                res ^= cert(to, v, true, r, dp, g, min(dp[0].at(to), sum), a, x, y, m);
                sum -= min(sum, dp[0].at(to));
            }
        }
    } else if (dp[0][v] >= sum) {
        a[v] = 0;
        res ^= f(v, a, x, y, m);
        for (int to : g[v]) {
            if (to != par) {
                res ^= cert(to, v, false, r, dp, g, min(max(dp[0].at(to), dp[1][to]), sum), a, x, y, m);
                sum -= min(max(dp[0].at(to), dp[1][to]), sum);
            }
        }
    } else {
        return -1;
    }
    return res;
}

//void ex5(int n, int v, const vi& l, const vi& r, vi& a) {
//    a.assign(n, 0);
//    if (l[0] <= v && v <= r[0]) {
//        a[0] = v;
//        return;
//    }
//
//    for (int i = 1; i < n; ++i) {
//        a[i] = l
//    }
//}

//void group5(int n, int q, int x, int y, int m, vvi& g, vi& l, vi& r, vi& v) {
//    ll suml = 0, sumr = 0;
//    for (int i = 1; i < n; ++i) {
//        suml += l[i];
//        sumr += r[i];
//    }
//    for (int i = 0; i < q; ++i) {
//        cout << cert(0, -1, false, r, dp, g, v[i], a, x, y, m) << ' ';
//    }
//    cout << endl;
//
//    int i;
//    while (cin >> i) {
//        --i;
//        if (i == -1) {
//            return;
//        }
//
//        ;
//        if (cert(0, -1, false, r, dp, g, v[i], a, x, y, m) != -1) {
//            cout << a << endl;
//        } else {
//            cout << -1 << endl;
//        }
//    }
//}

void solve() {
    int n, q;
    cin >> n >> q;
    int m, x, y;
    cin >> x >> y >> m;
    vvi g(n);
    for (int i = 0, s, f; i < n - 1; ++i) {
        cin >> s >> f;
        --s;
        --f;
        g[s].push_back(f);
        g[f].push_back(s);
    }
    vi l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    vi v(q);
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
    }

//    if (g[0].size() == n - 1) {
//        group5(n, q, x, y, m, g, l, r, v);
//        return;
//    }

    vvll dp(2, vll(n, 0));
    dfs(0, -1, r, dp, g);

    vi a(n);
    for (int i = 0; i < q; ++i) {
        cout << cert(0, -1, false, r, dp, g, v[i], a, x, y, m) << ' ';
    }
    cout << endl;

    return;
    int i;
    while (cin >> i) {
        --i;
        if (i == -1) {
            return;
        }

        if (cert(0, -1, false, r, dp, g, v[i], a, x, y, m) != -1) {
            cout << a << endl;
        } else {
            cout << -1 << endl;
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    for (; t; --t) {
        solve();
    }

    return 0;
}
