#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vvll = vector<vll>;
using vi = vector<int>;
using vvi = vector<vi>;

const int A = 1e5, B = 0;
const string yes = "Yes\n", no = "No\n";

ostream& operator<<(ostream& out, const vi& v) {
    for (int i : v) {
        out << i << ' ';
    }
    return out;
}

void dfs(int v, int par, const vi& r, vvll& dp, const vvi& g) {
    dp[1][v] = r[v];
    for (int to : g[v]) {
        if (to != par) {
            dfs(to, v, r, dp, g);

            if (dp[1][to] >= dp[0][to]) {
                dp[0][v] += dp[1][to];
            } else {
                dp[0][v] += dp[0][to];
            }
            dp[1][v] += dp[0][to];
        }
    }
}

int mod(ll x, int m) {
    x %= m;
    return (x >= 0 ? x : x + m);
}

int f(int v, const vi& a, int x, int y, int m) {
    return (x * 1LL * (v + 1) + y * 1LL * (a[v] * 1LL * a[v] % m)) % m;
}

//int cert(int v, int par, bool emp, const vi& r, const vvll& dp, const vvi& g, ll sum, vi& a, int x, int y, int m) {
//    int res = 0;
//    if (!emp && dp[1][v] == sum) {
//        a[v] = min(sum, (ll)r[v]);
//        sum -= a[v];
//        res ^= f(v, a, x, y, m);
//        for (int to : g[v]) {
//            if (to != par) {
//                res ^= cert(to, v, true, r, dp, g, min(dp[0].at(to), sum), a, x, y, m);
//                sum -= min(sum, dp[0].at(to));
//            }
//        }
//    } else if (dp[0][v] == sum) {
//        a[v] = 0;
//        res ^= f(v, a, x, y, m);
//        for (int to : g[v]) {
//            if (to != par) {
//                res ^= cert(to, v, false, r, dp, g, min(max(dp[0].at(to), dp[1][to]), sum), a, x, y, m);
//                sum -= min(max(dp[0].at(to), dp[1][to]), sum);
//            }
//        }
//    } else {
//        return -1;
//    }
//    cerr << v << ' ' << f(v, a, x, y, m) << '\n';
//    return res;
//}

void solve() {
    int n, q;
    cin >> n >> q;
    int m, x, y;
    cin >> x >> y >> m;
    vvi g(n);
    for (int i = 0, s, f; i < n - 1; ++i) {
        cin >> s >> f;
        --s;
        --f;
        g[s].push_back(f);
        g[f].push_back(s);
    }
    vi l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    vi v(q);
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
    }

    vvll dp(2, vll(n, 0));
    dfs(0, -1, r, dp, g);

    vi a(r);
    int cert = 0;
    for (int i = 0; i < n; ++i) {
        cert ^= f(i, a, x, y, m);
    }
    for (int i = 0; i < q; ++i) {
        cout << (v[i] == max(dp[0][0], dp[1][0]) ? cert : -1) << ' ';
    }
    cout << endl;

    int i;
    for (int _ = 0; _ <= q; ++_) {
        cin >> i;
        --i;
        if (i == -1) {
            break;
        }

        if (v[i] == max(dp[0][0], dp[1][0])) {
            cout << a << endl;
        } else {
            cout << -1 << endl;
        }
    }
}

int main() {
    int t;
    cin >> t;
    for (; t; --t) {
        solve();
    }

    return 0;
}
