#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

int n, m, k;

struct Point {
	int x, y;
};

struct Node {
	int maxX, maxY;
};

vector<Point> p;

vector<int> y;

map<int, vector<int> > indexes;

bool cmp(Point a, Point b) {
	if (a.x == b.x) {
		return a.y < b.y;
	}
	return a.x < b.x;
}

struct SegTree {
	vector<Node> tree;
	void build(int n) {
		int h = 1;
		while (h < n) {
			h *= 2;
		}
		tree.resize(h * 2);
		for (int i = 0; i < h * 2; i++) {
			tree[i].maxX = 0;
			tree[i].maxY = 0;
		}
	}
	void add(int ind) {
		int v = ind + tree.size() / 2;
		tree[v].maxX = p[ind].x;
		tree[v].maxY = p[ind].y;
		while (v > 1) {
			v /= 2;
			tree[v].maxY = max(tree[v * 2].maxY, tree[v * 2 + 1].maxY);
			tree[v].maxX = max(tree[v * 2].maxX, tree[v * 2 + 1].maxX);
		}
	}
	void del(int ind) {
		int v = ind + tree.size() / 2;
		tree[v].maxX = 0;
		tree[v].maxY = 0;
		while (v > 1) {
			v /= 2;
			tree[v].maxY = max(tree[v * 2].maxY, tree[v * 2 + 1].maxY);
			tree[v].maxX = max(tree[v * 2].maxX, tree[v * 2 + 1].maxX);
		}
	}
	int getX(int v, int l, int r, int L, int R) {
		if (L >= l && R <= r) {
			return tree[v].maxX;
		}
		if (L > r || R < l) {
			return 0;
		}
		return max(getX(v * 2, l, r, L, (L + R) / 2), getX(v * 2 + 1, l, r, (L + R) / 2 + 1, R));
	}
	int getY(int v, int l, int r, int L, int R) {
		if (L >= l && R <= r) {
			return tree[v].maxY;
		}
		if (L > r || R < l) {
			return 0;
		}
		return max(getY(v * 2, l, r, L, (L + R) / 2), getY(v * 2 + 1, l, r, (L + R) / 2 + 1, R));
	}
	pair<int, int> get(int l, int r) {
		pair<int, int> answ;
		answ.first = getX(1, l + 1, r + 1, 1, tree.size() / 2);
		answ.second = getY(1, l + 1, r + 1, 1, tree.size() / 2);
		return answ;
	}
};

SegTree ST;

long long ANSWER = 2e18;
int add = 0;

void solve() {
	for (int i = 0; i < p.size(); i++) {
		indexes[p[i].y].push_back(i);
		y.push_back(p[i].y);
	}
	sort(y.begin(), y.end());
	y.resize(unique(y.begin(), y.end()) - y.begin());
	int l = 0, r = 0;
	ST.build(p.size());
	for (auto ind : indexes[y[0]]) {
		ST.add(ind);
	}
	for (l; l < y.size(); l++) {
		while (r < y.size() - 1 && y[r + 1] - y[l] < n) {
			r++;
			for (auto ind : indexes[y[r]]) {
				ST.add(ind);
			}
		}
		for (auto ind : indexes[y[l]]) {
			if (p[ind].x > m || p[ind].y > n) {
				continue;
			}
			int L = ind, R = p.size();
			while (R - L > 1) {
				int mid = (L + R) / 2;
				if (p[mid].x - p[ind].x < m) {
					L = mid;
				}
				else {
					R = mid;
				}
			}
			auto res = ST.get(ind, L);
			long long X = res.first - p[ind].x + 1;
			long long Y = res.second - y[l] + 1;
			int cnt_dob = 0;
			if (res.first > m) {
				cnt_dob += res.first - m;
			}
			if (res.second > n) {
				cnt_dob += res.second - n;
			}
			if (ANSWER > X * Y || (ANSWER == X * Y && add > cnt_dob)) {
				//cout << X << " " << Y << " " << cnt_dob << "\n";
				add = cnt_dob;
				ANSWER = X * Y;
			}
		}
	}
}
vector<Point> p1;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	cin >> n >> m >> k;
	for (int i = 0; i < k; i++) {
		int x, y;
		cin >> y >> x;
		p.push_back({ x,y });
		p.push_back({ x + m,y });
		p.push_back({ x,y + n });
		p.push_back({ x + m, y + n });
		p1.push_back({ m - x + 1, y});
	}
	sort(p.begin(), p.end(), cmp);
	solve();
	indexes.clear();
	y.clear();
	p.clear();
	for (int i = 0; i < k; i++) {
		int x, y;
		x = p1[i].x;
		y = p1[i].y;
		p.push_back({ x,y });
		p.push_back({ x + m,y });
		p.push_back({ x,y + n });
		p.push_back({ x + m, y + n });
	}
	sort(p.begin(), p.end(), cmp);
	solve();
	cout << ANSWER << " " << add;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
