#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

const int N = 1e6 + 7;

#define int long long

struct Event {
	int l, r, ind;
};

vector<Event> events;

vector<int> sorted;

int dp[N], n;

vector<int> opt_useful[N], opt_useless[N], opt[N];
vector<Event> st[N];

map<int, int> pos;

bool del[N];

void solve() {
	cin >> n;
	sorted.clear();
	pos.clear();
	events.clear();
	for (int i = 0; i <= n * 7 + 5; i++) {
		opt[i].clear();
		opt_useful[i].clear();
		opt_useless[i].clear();
		st[i].clear();
		dp[i] = 0;
		del[i] = 0;
	}
	for (int i = 0; i < n; i++) {
		int l, r;
		cin >> l >> r;
		sorted.push_back(l);
		sorted.push_back(l - 1);
		sorted.push_back(r);
		events.push_back({ l,r,i });
	}
	sorted.push_back(0);
	sort(sorted.begin(), sorted.end());
	sorted.resize(unique(sorted.begin(), sorted.end()) - sorted.begin());
	for (int i = 0; i < sorted.size(); i++) {
		pos[sorted[i]] = i;
	}
	for (auto u : events) {
		st[pos[u.l]].push_back(u);
	}
	for (int i = 0; i < sorted.size() - 1; i++) {
		dp[i + 1] = max(dp[i + 1], dp[i]);
		for (auto u : st[i + 1]) {
			int j = pos[u.r];
			dp[j] = max(dp[j], dp[i] + 1);
		}
	}
	int m = dp[sorted.size() - 1];
	if (m % 2 != 0) {
		int h = 0;
		cout << 1 / h;
	}
	for (int i = 0; i < sorted.size(); i++) {
		for (auto u : st[i + 1]) {
			int j = pos[u.r];
			opt[dp[i] + 1].push_back(u.ind);
			if (dp[j] == dp[i] + 1) {
				opt_useful[dp[i] + 1].push_back(u.ind);
			}
			else {
				opt_useless[dp[i] + 1].push_back(u.ind);
			}
		}
	}
	int cnt = 0;
	for (int i = 1; i <= m / 2; i++) {
		cnt += opt[i].size();
	}
	for (int i = 0; i <= m; i++) {
		random_shuffle(opt_useful[i].begin(), opt_useful[i].end());
	}
	if (cnt <= n / 2) {
		cnt = 0;
		for (int i = 1; i <= m / 2; i++) {
			for (auto u : opt[i]) {
				del[u] = 1;
				cnt++;
			}
		}
		int j = m / 2 + 1;
		while (cnt < n / 2 && j <= m) {
			if (opt_useless[j].size() > 0) {
				del[opt_useless[j][opt_useless[j].size() - 1]] = 1;
				cnt++;
				opt_useless[j].pop_back();
			}
			else {
				j++;
			}
		}
		j = m / 2 + 1;
		while (cnt < n / 2 && j <= m) {
			if (opt_useful[j].size() > 1) {
				del[opt_useful[j][opt_useful[j].size() - 1]] = 1;
				cnt++;
				opt_useful[j].pop_back();
			}
			else {
				j++;
			}
		}
	}
	else {
		cnt = 0;
		for (int i = m / 2 + 1; i <= m; i++) {
			for (auto u : opt[i]) {
				del[u] = 1;
				cnt++;
			}
		}
		int j = 1;
		while (cnt < n / 2 && j <= m / 2) {
			if (opt_useless[j].size() > 0) {
				del[opt_useless[j][opt_useless[j].size() - 1]] = 1;
				cnt++;
				opt_useless[j].pop_back();
			}
			else {
				j++;
			}
		}
		j = 1;
		while (cnt < n / 2 && j <= m / 2) {
			if (opt_useful[j].size() > 1) {
				del[opt_useful[j][opt_useful[j].size() - 1]] = 1;
				cnt++;
				opt_useful[j].pop_back();
			}
			else {
				j++;
			}
		}
	}

	for (int i = 0; i <= sorted.size(); i++) {
		dp[i] = 0;
	}
	for (int i = 0; i < sorted.size() - 1; i++) {
		dp[i + 1] = max(dp[i + 1], dp[i]);
		for (auto u : st[i + 1]) {
			if (!del[u.ind]) {
				int j = pos[u.r];
				dp[j] = max(dp[j], dp[i] + 1);
			}
		}
	}

	if (dp[sorted.size() - 1] < m / 2) {
		int h = 0;
		cout << 1 / h;
	}

	for (int i = 0; i < n; i++) {
		if (!del[i]) {
			cout << i + 1 << " ";
		}
	}
	cout << "\n";
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	std::ios::sync_with_stdio(false);
	cin.tie(0);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}

}