#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <iostream>
typedef long long ll;
typedef long double ld;
using namespace std;
ll inf = 1e15;
struct segtree {
	struct node {
		ll mx, mn, p;
	};
	vector<node> tree;
	ll size = 1;
	void init(ll n) {
		while (size < n)size *= 2;
		tree.assign(size * 2 - 1, { -1, inf, 0 });
	}
	void comb(ll x) {
		tree[x].mx = max(tree[x * 2 + 1].mx, tree[x * 2 + 2].mx);
		tree[x].mn = min(tree[x * 2 + 1].mn, tree[x * 2 + 2].mn);
	}
	void build(vector<ll>& a, ll x, ll lx, ll rx) {
		if (rx - lx == 1) {
			if (lx < a.size()) {
				tree[x] = { a[lx], a[lx], 0 };
			}
			return;
		}
		ll m = (lx + rx) / 2;
		build(a, x * 2 + 1, lx, m);
		build(a, x * 2 + 2, m, rx);
		comb(x);
	}
	void build(vector<ll>& a) {
		build(a, 0, 0, size);
	}
	void push(ll x, ll lx, ll rx) {
		if (!tree[x].p || rx - lx == 1) return;
		ll x1 = x * 2 + 1;
		ll x2 = x * 2 + 2;
		tree[x1].mn += tree[x].p;
		tree[x1].mx += tree[x].p;
		tree[x1].p += tree[x].p;
		tree[x2].mn += tree[x].p;
		tree[x2].mx += tree[x].p;
		tree[x2].p += tree[x].p;
		tree[x].p = 0;
	}
	void upd(ll ind, ll val, ll val2, ll x, ll lx, ll rx) {
		push(x, lx, rx);
		if (rx - lx == 1) {
			tree[x] = { val, val2, 0 };
			return;
		}
		ll m = (lx + rx) / 2;
		if (ind < m) upd(ind, val, val2, x * 2 + 1, lx, m);
		else upd(ind, val, val2, x * 2 + 2, m, rx);
		comb(x);
	}
	void upd(ll ind, ll val, ll val2) {
		upd(ind, val, val2, 0, 0, size);
	}
	vector<ll> ind;
	void find(ll val, ll x, ll lx, ll rx) {
		push(x, lx, rx);
		if (tree[x].mn != val && tree[x].mx != val) return;
		if (rx - lx == 1) {
			ind.push_back(lx);
			return;
		}
		ll m = (lx + rx) / 2;
		find(val, x * 2 + 1, lx, m);
		find(val, x * 2 + 2, m, rx);
		comb(x);
	}
	void find(ll val) {
		ind.clear();
		find(val, 0, 0, size);
	}
};
int main(){
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	ll h, w, k;
	cin >> h >> w >> k;
	vector<ll> a1(k), a2(k);
	for (int i = 0; i < k; ++i) {
		cin >> a1[i] >> a2[i];
	}
	if (k == 1) {
		cout << "1 0";
		return 0;
	}
	segtree s, c;
	s.init(k);
	c.init(k);
	s.build(a1);
	c.build(a2);
	ll count = 0;
	while (1) {
		ll mn = s.tree[0].mn;
		ll mx = s.tree[0].mx;
		ll d1 = mx - mn + 1;
		ll d2 = mn + h - mx + 1;
		if (d2 >= d1) break;
		if (mn < h - mx + 1) {
			s.find(mn);
			s.tree[0].mn -= mn;
			s.tree[0].mx -= mn;
			s.tree[0].p -= mn;
			count += mn;
			for (auto& w2 : s.ind) {
				s.upd(w2, h, h);
			}
		}
		else {
			s.find(mx);
			s.tree[0].mn += (h - mx + 1);
			s.tree[0].mx += (h - mx + 1);
			s.tree[0].p += (h - mx + 1);
			count += (h - mx + 1);
			for (auto& w2 : s.ind) {
				s.upd(w2, 1, 1);
			}
		}
	}
	ll d1 = s.tree[0].mx - s.tree[0].mn + 1;
	while (1) {
		ll mn = c.tree[0].mn;
		ll mx = c.tree[0].mx;
		ll d1 = mx - mn + 1;
		ll d2 = mn + w - mx + 1;
		if (d2 >= d1) break;
		if (mn < w - mx + 1) {
			c.find(mn);
			c.tree[0].mn -= mn;
			c.tree[0].mx -= mn;
			c.tree[0].p -= mn;
			count += mn;
			for (auto& w2 : c.ind) {
				c.upd(w2, w, w);
			}
		}
		else {
			c.find(mx);
			c.tree[0].mn += (w - mx + 1);
			c.tree[0].mx += (w - mx + 1);
			c.tree[0].p += (w - mx + 1);
			count += (w - mx + 1);
			for (auto& w2 : c.ind) {
				c.upd(w2, 1, 1);
			}
		}
	}
	
	ll d2 = c.tree[0].mx - c.tree[0].mn + 1;
	cout << d2 * d1 << " " << count;
}
