#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <iostream>
typedef long long ll;
typedef long double ld;
using namespace std;
int ok = 0;

struct segtree {
	vector<ll> tree;
	ll size = 1;
	void init(ll n) {
		while (size < n) size *= 2;
		tree.assign(size * 2 - 1, 0);
	}
	void upd(ll ind, ll val, ll x, ll lx, ll rx) {
		if (rx - lx == 1) {
			tree[x] = val;
			return;
		}
		ll m = (lx + rx) / 2;
		if (ind < m) upd(ind, val, x * 2 + 1, lx, m);
		else upd(ind, val, x * 2 + 2, m, rx);
		tree[x] = max(tree[x * 2 + 1], tree[x * 2 + 2]);
	}
	void upd(ll ind, ll val) {
		upd(ind, val, 0, 0, size);
	}
	ll qry(ll l, ll r, ll x, ll lx, ll rx) {
		if (l >= rx || r <= lx) return 0;
		if (l <= lx && rx <= r) return tree[x];
		ll m = (lx + rx) / 2;
		return max(qry(l, r, x * 2 + 1, lx, m), qry(l, r, x * 2 + 2, m, rx));
	}
	ll qry(ll l, ll r) {
		return qry(l, r, 0, 0, size);
	}
};

void solve() {
	ll n;
	cin >> n;
	vector<ll> p(n);
	for (int i = 0; i < n; ++i) cin >> p[i];
	if (n <= 16 && ok) {
		ll mx = 0;
		for (ll mask = 0; mask < (1LL << n); ++mask) {
			ll last = -1;
			ll last2 = n + 1;
			ll ans = 0;
			for (int i = 0; i < n; ++i) {
				if (mask & (1LL << i)) {
					if (last < p[i]) {
						++ans;
						last = p[i];
					}
				}
				else {
					if (last2 > p[i]) {
						++ans;
						last2 = p[i];
					}
				}
			}
			mx = max(mx, ans);
		}
		cout << mx << '\n';
	}
	else {
		segtree st;
		st.init(n + 1);
		ll ans = 0;
		for (int i = 0; i < n; ++i) {
			ll mx = st.qry(0, p[i]);
			ans = max(ans, mx + 1);
			st.upd(p[i], mx + 1);
		}
		cout << min(n, ans + 2) << '\n';
	}
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	ll tc;
	cin >> tc;
	if (tc <= 120) ok = 1;
	while (tc--) {
		solve();
	}
}