#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl;
#else
#pragma GCC target("avx2")
#pragma GCC optimize("Ofast")
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define _ <<" "<<

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct event {
    int l, r, id;
};

bool operator<(const event &a, const event &b) {
    return tie(a.l, a.r) < tie(b.l, b.r);
}

int OPEN = 0, CLOSE = 1;

struct ev {
    int x, type, id;

    ev(int x, int t, int id) : x(x), type(t), id(id) {}
};

bool operator<(const ev &a, const ev &b) {
    return tie(a.x, a.type) < tie(b.x, b.type);
}

void solve() {
    int n;
    cin >> n;
    vector<event> events(n);
    vector<ev> evs;
    forn(i, n) {
        cin >> events[i].l >> events[i].r, events[i].id = i;
        evs.emplace_back(events[i].l, OPEN, i);
        evs.emplace_back(events[i].r, CLOSE, i);
    }
    sort(all(events)), sort(all(evs));
    bool ok = true;
    forn(i, n - 1) {
        if (events[i].r >= events[i + 1].l) {
            ok = false;
            break;
        }
    }
    if (ok) {
        forn(i, n / 2) cout << events[i].id + 1 << " ";
        cout << nl;
    } else {
        vector<int> tmp(n);
        int gmx = 0;
        for (auto &[x, t, id]: evs) {
            if (t == OPEN) tmp[id] = gmx;
            else gmx = max(gmx, tmp[id] + 1);
        }

        forn(mask, (1 << n)) {
            if (__builtin_popcount(mask) != n / 2) continue;
            int mx = 0;
            for (auto &[x, t, id]: evs) {
                if (mask & (1 << id)) {
                    if (t == OPEN) tmp[id] = mx;
                    else mx = max(mx, tmp[id] + 1);
                }
            }
            if (mx == gmx / 2) {
                forn(i, n) if (mask & (1 << i)) cout << i + 1 << " ";
                cout << nl;
                return;
            }
        }
    }
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
    cin >> t;
    while (t--) solve();
}