#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

typedef long long ll;

#define int ll

struct Coord
{
	int x;
	int y;
};

struct CmpX
{
	bool operator()(const Coord& c1, const Coord& c2) const
	{
		if (c1.x == c2.x)
			return c1.y < c2.y;
		return c1.x < c2.x;
	}
};

struct CmpY
{
	bool operator()(const Coord& c1, const Coord& c2) const
	{
		if (c1.y == c2.y)
			return c1.x < c2.x;
		return c1.y < c2.y;
	}
};

struct UnX
{
	bool operator()(const Coord& c1, const Coord& c2) const
	{
		return c1.x == c2.x;
	}
};

struct UnY
{
	bool operator()(const Coord& c1, const Coord& c2) const
	{
		return c1.y == c2.y;
	}
};

pair<int, int> computex(int h, vector<Coord>& imcx)
{
	int xactions = 0;
	int xmin = INT32_MAX;
	int tekst = imcx[0].x;
	int tekfn = imcx.back().x;
	for (int i = 0; i < imcx.size(); ++i)
	{
		if (tekfn - tekst < xmin)
		{
			xmin = tekfn - tekst;
			if (i == 0)
				xactions = 0;
			else
				xactions = imcx[i - 1].x;
		}
		if (i != imcx.size() - 1)
		{
			tekst = imcx[i + 1].x;
			tekfn = h + imcx[i].x;
		}
	}
	return { xmin, xactions };
}

pair<int, int> computey(int w, vector<Coord>& imcy)
{
	int yactions = 0;
	int ymin = INT32_MAX;
	int tekst = imcy[0].y;
	int tekfn = imcy.back().y;
	for (int i = 0; i < imcy.size(); ++i)
	{
		if (tekfn - tekst < ymin)
		{
			ymin = tekfn - tekst;
			if (i == 0)
				yactions = 0;
			else
				yactions = imcy[i - 1].y;
		}
		if (i != imcy.size() - 1)
		{
			tekst = imcy[i + 1].y;
			tekfn = w + imcy[i].y;
		}
	}
	return { ymin, yactions };
}

pair<ll, int> solve(int h, int w, int k, vector<Coord>& images)
{
	CmpX xc;
	CmpY yc;
	UnX unx;
	UnY uny;
	vector<Coord> imcx = images, imcy = images;
	sort(imcx.begin(), imcx.end(), xc);
	imcx.resize(unique(imcx.begin(), imcx.end(), unx) - imcx.begin());
	sort(imcy.begin(), imcy.end(), yc);
	imcy.resize(unique(imcy.begin(), imcy.end(), uny) - imcy.begin());
	pair<int, int> xres1 = computex(h, imcx);
	for (int i = 0; i < imcx.size(); ++i)
	{
		imcx[i].x = h + 1 - imcx[i].x;
	}
	reverse(imcx.begin(), imcx.end());
	pair<int, int> xres2 = computex(h, imcx);
	pair<int, int> yres1 = computey(w, imcy);
	for (int i = 0; i < imcy.size(); ++i)
	{
		imcy[i].y = w + 1 - imcy[i].y;
	}
	reverse(imcy.begin(), imcy.end());
	pair<int, int> yres2 = computey(w, imcy);
	pair<int, int> xres = min(xres1, xres2);
	pair<int, int> yres = min(yres1, yres2);
	int resactions = xres.second + yres.second;
	ll result = ll(xres.first + 1) * ll(yres.first + 1);
	return { result, resactions };
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int h, w, k;
	cin >> h >> w >> k;
	vector<Coord> images(k);
	for (int i = 0; i < k; ++i)
	{
		cin >> images[i].x >> images[i].y;
	}
	pair<ll, int> res = solve(h, w, k, images);
	cout << res.first << ' ' << res.second << '\n';
	return 0;
}
