#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_set>
#include <set>
#include <unordered_map>

using namespace std;

typedef long long ll;

class Tree
{
public:
	Tree(int n) : tree(n * 4) {}

	int getmin(int v, int l, int r, int ql, int qr)
	{
		if (ql >= r || qr <= l)
			return INT32_MAX;
		if (l >= ql && r <= qr)
			return tree[v].minn;
		int m = (l + r) / 2;
		return min(getmin(v * 2 + 1, l, m, ql, qr), getmin(v * 2 + 2, m, r, ql, qr));
	}

	int getmax(int v, int l, int r, int ql, int qr)
	{
		if (ql >= r || qr <= l)
			return INT32_MIN;
		if (l >= ql && r <= qr)
			return tree[v].maxx;
		int m = (l + r) / 2;
		return max(getmax(v * 2 + 1, l, m, ql, qr), getmax(v * 2 + 2, m, r, ql, qr));
	}

	void set(int v, int l, int r, int p, int val)
	{
		if (p >= r || p < l)
			return;
		if (l + 1 == r)
		{
			tree[v].maxx = val;
			tree[v].minn = val;
			return;
		}
		int m = (l + r) / 2;
		set(v * 2 + 1, l, m, p, val);
		set(v * 2 + 2, m, r, p, val);
		tree[v].maxx = max(tree[v * 2 + 1].maxx, tree[v * 2 + 2].maxx);
		tree[v].minn = min(tree[v * 2 + 1].minn, tree[v * 2 + 2].minn);
	}

private:
	struct Node
	{
		int maxx = 0;
		int minn = 0;
	};

	vector<Node> tree;
};

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int t;
	cin >> t;
	for (int test = 0; test < t; ++test)
	{
		int n;
		cin >> n;
		vector<int> a(n);
		for (int i = 0; i < n; ++i)
		{
			cin >> a[i];
		}
		vector<int> nvp(n);
		Tree tree(n + 1);
		for (int i = 0; i < n; ++i)
		{
			nvp[i] = tree.getmax(0, 0, n + 1, 0, a[i]) + 1;
			tree.set(0, 0, n + 1, a[i], nvp[i]);
		}
		if (nvp[n - 1] >= n - 1)
		{
			cout << n << '\n';
			continue;
		}
		cout << nvp[n - 1] + 2 << '\n';
	}
	return 0;
}
