#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

class Tree
{
public:
	Tree(int n) : tree(n * 4) {}

	int get(int v, int l, int r, int ql, int qr)
	{
		if (ql >= r || l >= qr)
			return 0;
		if (l >= ql && r <= qr)
			return tree[v].maxx;
		int m = (l + r) / 2;
		return max(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
	}

	void set(int v, int l, int r, int p, int val)
	{
		if (p >= r || p < l)
			return;
		if (l + 1 == r)
		{
			tree[v].maxx = val;
			return;
		}
		int m = (l + r) / 2;
		set(v * 2 + 1, l, m, p, val);
		set(v * 2 + 2, m, r, p, val);
		tree[v].maxx = max(tree[v * 2 + 1].maxx, tree[v * 2 + 2].maxx);
	}

private:
	struct Node
	{
		int maxx;
	};

	vector<Node> tree;
};

struct Segment
{
	int l;
	int r;
	int ind;

	bool operator<(const Segment& s) const
	{
		if (r == s.r)
			return l < s.l;
		return r < s.r;
	}
};

vector<int> allc;

int getnew(int x)
{
	return lower_bound(allc.begin(), allc.end(), x) - allc.begin();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int t;
	cin >> t;
	for (int test = 0; test < t; ++test)
	{
		int n;
		cin >> n;
		vector<Segment> a(n);
		allc.clear();
		for (int i = 0; i < n; ++i)
		{
			cin >> a[i].l >> a[i].r;
			a[i].ind = i;
			allc.push_back(a[i].l);
			allc.push_back(a[i].r);
		}
		sort(allc.begin(), allc.end());
		allc.resize(unique(allc.begin(), allc.end()) - allc.begin());
		for (int i = 0; i < n; ++i)
		{
			a[i].l = getnew(a[i].l);
			a[i].r = getnew(a[i].r);
		}
		Tree tree(allc.size());
		sort(a.begin(), a.end());
		vector<int> dp(n);
		int m = 0;
		for (int i = 0; i < n; ++i)
		{
			dp[i] = tree.get(0, 0, allc.size(), 0, a[i].l) + 1;
			m = max(m, dp[i]);
			tree.set(0, 0, allc.size(), a[i].r, dp[i]);
		}
		int cntlessm2 = 0;
		for (int i = 0; i < n; ++i)
		{
			if (dp[i] <= m / 2)
			{
				++cntlessm2;
			}
		}
		if (cntlessm2 <= n / 2)
		{
			vector<int> er;
			vector<bool> used(n);
			for (int i = 0; i < n; ++i)
			{
				if (dp[i] <= m / 2)
				{
					er.push_back(a[i].ind);
					used[i] = true;
				}
			}
			int lastr = -1;
			int mxsize = 0;
			for (int i = 0; i < n; ++i)
			{
				if (a[i].l > lastr && !used[i])
				{
					++mxsize;
					lastr = a[i].r;
					used[i] = true;
				}
			}
			int needed = n / 2 - er.size();
			for (int i = 0; i < n; ++i)
			{
				if (needed == 0)
					break;
				if (!used[i])
				{
					er.push_back(a[i].ind);
					--needed;
				}
			}
			if (mxsize != m / 2)
				throw(0);
			if (er.size() != n / 2)
				throw(0);
			vector<bool> ersd(n);
			for (int i = 0; i < er.size(); ++i)
			{
				ersd[er[i]] = true;
			}
			for (int i = 0; i < n; ++i)
			{
				if (!ersd[i])
					cout << i + 1 << ' ';
			}
			cout << '\n';
		}
		else
		{
			vector<int> er;
			vector<bool> used(n);
			for (int i = 0; i < n; ++i)
			{
				if (dp[i] > m / 2)
				{
					er.push_back(a[i].ind);
					used[i] = true;
				}
			}
			int lastr = -1;
			int mxsize = 0;
			for (int i = 0; i < n; ++i)
			{
				if (a[i].l > lastr && !used[i])
				{
					++mxsize;
					lastr = a[i].r;
					used[i] = true;
				}
			}
			int needed = n / 2 - er.size();
			for (int i = 0; i < n; ++i)
			{
				if (needed == 0)
					break;
				if (!used[i])
				{
					er.push_back(a[i].ind);
					--needed;
				}
			}
			if (mxsize != m / 2)
				throw(0);
			if (er.size() != n / 2)
				throw(0);
			vector<bool> ersd(n);
			for (int i = 0; i < er.size(); ++i)
			{
				ersd[er[i]] = true;
			}
			for (int i = 0; i < n; ++i)
			{
				if (!ersd[i])
					cout << i + 1 << ' ';
			}
			cout << '\n';
		}
	}
	return 0;
}
