#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>

using namespace std;

typedef long long ll;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, q;
	cin >> n >> q;
	vector<int> w(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> w[i];
	}
	sort(w.begin(), w.end());
	vector<bitset<1501>> smalldp(n + 1);
	vector<vector<bitset<1501>>> dp(n + 1, vector<bitset<1501>>(1501));
	int z;
	cin >> z;
	smalldp[0][0] = 1;
	for (int i = 1; i <= n; ++i)
	{
		smalldp[i] = smalldp[i - 1];
		smalldp[i] |= (smalldp[i - 1] << w[i - 1]);
	}
	for (int i = 0; i <= n; ++i)
	{
		smalldp[i] = ~smalldp[i];
	}
	vector<int> minbad(n + 1);
	for (int i = 0; i <= n; ++i)
	{
		minbad[i] = smalldp[i]._Find_first();
	}
	dp[0][0][0] = 1;
	for (int i = 1; i <= n; ++i)
	{
		for (int w1 = 0; w1 <= 1500; ++w1)
		{
			dp[i][w1] = dp[i - 1][w1];
			if (w[i - 1] <= w1)
				dp[i][w1] |= dp[i - 1][w1 - w[i - 1]];
			dp[i][w1] |= (dp[i - 1][w1] << w[i - 1]);
		}
	}
	for (int i = 0; i <= n; ++i)
	{
		for (int w1 = 0; w1 <= 1500; ++w1)
		{
			dp[i][w1] = ~dp[i][w1];
		}
	}
	vector<vector<int>> minbadarr(n + 1, vector<int>(1501, 1501));
	for (int i = 0; i <= n; ++i)
	{
		for (int w1 = 0; w1 <= 1500; ++w1)
		{
			minbadarr[i][w1] = dp[i][w1]._Find_first();
			if (w1 != 0)
				minbadarr[i][w1] = min(minbadarr[i][w1], minbadarr[i][w1 - 1]);
		}
	}
	for (int i = 0; i < q; ++i)
	{
		int k, a, b;
		cin >> k >> a >> b;
		int kind = upper_bound(w.begin(), w.end(), k) - w.begin();
		if (b < minbadarr[kind][a])
		{
			cout << "Yes\n";
		}
		else
		{
			cout << "No\n";
		}
	}
	return 0;
}
