#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <unordered_set>
#include <unordered_map>

using namespace std;

typedef long long ll;

class Problem
{
public:
	void solve()
	{
		int n, q;
		cin >> n >> q;
		cin >> x >> y >> m;
		graph.resize(n);
		for (int i = 0; i < n - 1; ++i)
		{
			int s, f;
			cin >> s >> f;
			graph[s - 1].push_back(f - 1);
			graph[f - 1].push_back(s - 1);
		}
		a.resize(n);
		moda.resize(n);
		for (int i = 0; i < n; ++i)
		{
			cin >> a[i].first >> a[i].second;
			moda[i] = a[i].first;
		}
		dp.resize(n);
		rec(0);
		vector<ll> v(q);
		for (int i = 0; i < q; ++i)
		{
			cin >> v[i];
			if (s.count(v[i]) != 0)
			{
				cout << s[v[i]] << ' ';
			}
			else
			{
				cout << -1 << ' ';
			}
		}
		cout << endl;
		while (true)
		{
			int ind;
			cin >> ind;
			if (ind == 0)
				break;
			--ind;
			if (s.count(v[ind]) != 0)
			{
				for (int j : sv[v[ind]])
				{
					cout << j << ' ';
				}
				cout << endl;
			}
			else
			{
				cout << -1 << endl;
			}
		}
	}
private:
	vector<vector<int>> graph;
	vector<pair<ll, ll>> dp;
	vector<pair<ll, ll>> a;
	vector<ll> moda;
	ll x, y, m;
	unordered_map<ll, ll> s;
	unordered_map<ll, vector<ll>> sv;

	void dfs(int me, int p)
	{
		dp[me].first = moda[me];
		dp[me].second = 0;
		for (int v : graph[me])
		{
			if (v == p)
				continue;
			dfs(v, me);
			dp[me].first += dp[v].second;
			dp[me].second += max(dp[v].first, dp[v].second);
		}
	}

	void rec(int i)
	{
		if (i == a.size())
		{
			dfs(0, -1);
			ll resdp = max(dp[0].first, dp[0].second);
			ll cert = 0;
			for (int j = 0; j < a.size(); ++j)
			{
				ll cxor = x * (ll(j) + 1);
				cxor %= m;
				ll tmp = moda[j] * moda[j];
				tmp %= m;
				tmp *= y;
				tmp %= m;
				cxor += tmp;
				cxor %= m;
				cert ^= cxor;
			}
			s[resdp] = cert;
			sv[resdp] = moda;
			return;
		}
		rec(i + 1);
		if (a[i].second - a[i].first < 1)
			return;
		++moda[i];
		rec(i + 1);
		if (a[i].second - a[i].first < 2)
			return;
		++moda[i];
		rec(i + 1);
	}
};

int main()
{
	int t;
	cin >> t;
	for (int test = 0; test < t; ++test)
	{
		Problem p;
		p.solve();
	}
	return 0;
}
