#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <array>

using namespace std;

#define int long long
#define sz(x) (int) ((x).size())
#define all(x) (x).begin(), (x).end()

const int inf = 1e9 + 7;

void solve() {
  int h, w, k;
  cin >> h >> w >> k;
  vector<array<int, 2>> a(k);
  for (int i = 0; i < k; i++) {
    for (auto &x : a[i]) {
      cin >> x;
      --x;
    }
  }

  sort(all(a));
  int hor_prv = -1;
  int hor = a[k - 1][0] - a[0][0] + 1, cnt_hor = 0;
  for (int i = 0; i < k; i++) {
    if (a[i][0] == a[0][0]) {
      continue;
    }
    if (a[i][0] != a[i - 1][0]) {
      hor_prv = a[i - 1][0];
    }
    int delta = a[i][0];
    int nval = (hor_prv - delta + h) % h + 1;
    int ncnt = min(hor_prv + 1, h - a[i][0]);
    if (nval < hor || (nval == hor && ncnt < cnt_hor)) {
      hor = nval;
      cnt_hor = ncnt;
    }
  }

  sort(all(a), [&] (const array<int, 2>& lhs, const array<int, 2>& rhs) {
    return make_pair(lhs[1], lhs[0]) < make_pair(rhs[1], rhs[0]);
  });

  int ver_prv = -1;
  int ver = a[k - 1][1] - a[0][1] + 1, cnt_ver = 0;
  for (int i = 0; i < k; i++) {
    if (a[i][1] == a[0][1]) {
      continue;
    }
    if (a[i][1] != a[i - 1][1]) {
      ver_prv = a[i - 1][1];
    }
    int delta = a[i][1];
    int nval = (ver_prv - delta + w) % w + 1;
    int ncnt = min(ver_prv + 1, w - a[i][1]);
    if (nval < ver || (nval == ver && ncnt < cnt_ver)) {
      ver = nval;
      cnt_ver = ncnt;
    }
  }

  cout << hor * ver << ' ' << cnt_ver + cnt_hor << '\n';
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  solve();
  return 0;
}
