#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <array>
#include <cassert>
#include <random>
#include <chrono>

using namespace std;

#define int long long
#define sz(x) (int) ((x).size())
#define all(x) (x).begin(), (x).end()

const int N = 7;

int sootv[N + 1][N + 1][1 << N];

int player;

void solve() {
  int n, k;
  cin >> n >> k;
  vector<int> a(k);
  for (auto &x: a) {
    cin >> x;
    --x;
  }
  bool subtask_5 = (a[k - 1] + 1) < n;
  for (int i = 1; i < n; i++) {
    subtask_5 &= (a[i] - a[i - 1]) >= 2;
  }
  vector<int> ans;
  if (n % 2 == 0 && k == n / 2) {
    vector<int> used(n);
    for (auto &x : a) {
      used[x] = 1;
    }
    for (int i = 0; i < n; i++) {
      if (!used[i]) {
        ans.push_back(i);
      }
    }
  } else if (k == 1) {
    if (player == 1) {
      ans.push_back((a[0] + 1) % n);
    } else {
      ans.push_back((a[0] - 1 + n) % n);
    }
  } else if (k == 2) {
    if (player == 1) {
      if (a[0] == (a[1] + 1) % n) {
        ans.push_back(a[0] + 1);
        ans.push_back(a[0] + 2);
      } else if (a[1] == (a[0] + 1) % n) {
        ans.push_back((a[1] + 1) % n);
        ans.push_back((a[1] + 2) % n);
      } else {
        ans.push_back((a[0] + 1) % n);
        ans.push_back((a[1] + 1) % n);
      }
    } else {
      if (a[0] == (a[1] + 1) % n) {
        ans.push_back((a[1] - 2 + n) % n);
        ans.push_back((a[1] - 1 + n) % n);
      } else if (a[1] == (a[0] + 1) % n) {
        ans.push_back((a[0] - 2 + n) % n);
        ans.push_back((a[0] - 1 + n) % n);
      } else {
        ans.push_back((a[0] - 1 + n) % n);
        ans.push_back((a[1] - 1 + n) % n);
      }
    }
  } else {
    if (player == 1) {
      for (auto &x : a) {
        ans.push_back((x + 1) % n);
      }
    } else {
      for (auto &x : a) {
        ans.push_back((x - 1 + 1) % n);
      }
    }
  }
  sort(all(ans));
  for (auto &x : ans) {
    cout << x + 1 << ' ';
  }
  cout << endl;
}

mt19937 rng(76575);

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);

//  for (int n = 2; n <= N; n++) {
//    for (int k = 1; k * 2 <= n; k++) {
//      for (int mask = 0; mask < 1 << n; mask++) {
//        sootv[n][k][mask] = -1;
//      }
//    }
//  }

//  for (int n = 2; n <= N; n++) {
//    for (int k = 3; k * 2 <= n; k++) {
//      vector<int> order1(1 << n), order2(1 << n);
//      iota(all(order1), 0);
//      while (1) {
//        for (int mask = 0; mask < 1 << n; mask++) {
//          sootv[n][k][mask] = -1;
//        }
//        shuffle(all(order1), rng);
//        order2 = order1;
//        shuffle(all(order2), rng);
//        bool good = true;
//        for (auto &mask : order1) {
//          if (__builtin_popcount(mask) != k || sootv[n][k][mask] != -1) {
//            continue;
//          }
//          for (auto &other_mask : order2) {
//            if (mask & other_mask) {
//              continue;
//            }
//            if (__builtin_popcount(other_mask) != k || sootv[n][k][other_mask] != -1) {
//              continue;
//            }
//            sootv[n][k][mask] = other_mask;
//            sootv[n][k][other_mask] = mask;
//            break;
//          }
//          good &= sootv[n][k][mask] != -1;
//        }
//        if (good) {
//          if (n == 7 && k == 3) {
//            for (int mask = 0; mask < 1 << n; mask++) {
//              cerr << sootv[n][k][mask] << ' ';
//            }
//            cerr << endl;
//          }
//          break;
//        }
//      }
//    }
//  }

  cin >> player;
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}
