#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <array>

using namespace std;

#define int long long
#define sz(x) (int) ((x).size())
#define all(x) (x).begin(), (x).end()

const int inf = 1e18;

void solve() {
  int n;
  cin >> n;
  vector<int> a(n), pos(n + 2, -1);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    pos[a[i]] = i;
  }

  vector dp(n + 2, vector<int> (n + 2, -inf));
  dp[a[0]][n + 1] = 1;
  dp[0][a[0]] = 1;
  for (int val1 = 0; val1 <= n; val1++) {
    for (int val2 = n + 1; val2 >= 1; val2--) {
      int id = max(pos[val1], pos[val2]);
      for (int j = id + 1; j < n; j++) {
        if (a[j] > val1) {
          dp[a[j]][val2] = max(dp[a[j]][val2], dp[val1][val2] + 1);
        }
        if (a[j] < val2) {
          dp[val1][a[j]] = max(dp[val1][a[j]], dp[val1][val2] + 1);
        }
        if (a[j] > val1 && a[j] < val2) {
          break;
        }
      }
    }
  }

//  vector dp(n, vector (n + 2, vector<int> (n + 2, -inf)));
//  dp[0][a[0]][n + 1] = 1;
//  dp[0][0][a[0]] = 1;
//  for (int i = 0; i + 1 < n; i++) {
//    for (int val1 = 0; val1 <= n; val1++) {
//      for (int val2 = 1; val2 <= n + 1; val2++) {
//        if (a[i + 1] > val1) {
//          dp[i + 1][a[i + 1]][val2] = max(dp[i + 1][a[i + 1]][val2], dp[i][val1][val2] + 1);
//        } else {
//          dp[i + 1][val1][val2] = max(dp[i + 1][val1][val2], dp[i][val1][val2]);
//        }
//        if (a[i + 1] < val2) {
//          dp[i + 1][val1][a[i + 1]] = max(dp[i + 1][val1][a[i + 1]], dp[i][val1][val2] + 1);
//        } else {
//          dp[i + 1][val1][val2] = max(dp[i + 1][val1][val2], dp[i][val1][val2]);
//        }
//      }
//    }
//  }

  int ans = -inf;
  for (int val1 = 0; val1 <= n + 1; val1++) {
    for (int val2 = 0; val2 <= n + 1; val2++) {
      ans = max(ans, dp[val1][val2]);
    }
  }

  cout << ans << '\n';
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}