#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <array>

using namespace std;

//#define int long long
#define sz(x) (int) ((x).size())
#define all(x) (x).begin(), (x).end()

const int inf = 1e9;

struct Tree {

 vector<int> tree, push;
 int s;

 Tree() {}

 Tree(int n) {
   s = 1;
   while (s < n) s *= 2;
   push.assign(2 * s + 1, -1);
   tree.assign(2 * s + 1, -inf);
 }

 void propagate(int x, int lx, int rx) {
  if (lx + 1 == rx || push[x] == -1) {
    return;
  }
  int p = push[x];
  tree[2 * x + 1] = tree[2 * x + 2] = push[2 * x + 1] = push[2 * x + 2] = p;
  push[x] = -1;
 }

 int get(int l, int r, int x, int lx, int rx) {
   if (lx >= r || rx <= l) {
     return -inf;
   }
   propagate(x, lx, rx);
   if (lx >= l && rx <= r) {
     return tree[x];
   }
   int m = (lx + rx) / 2;
   return max(get(l, r, 2 * x + 1, lx, m), get(l, r, 2 * x + 2, m, rx));
 }

 void upd(int l, int r, int val, int x, int lx, int rx) {
  if (lx >= r || rx <= l) {
    return;
  }
  propagate(x, lx, rx);
  if (lx >= l && rx <= r) {
    tree[x] = val;
    push[x] = val;
    return;
  }
  int m = (lx + rx) / 2;
  upd(l, r, val, 2 * x + 1, lx, m);
  upd(l, r, val, 2 * x + 2, m, rx);
  tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
 }

};

void solve() {
  int n;
  cin >> n;
  vector<int> a(n), pos(n + 2, -1);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    pos[a[i]] = i;
  }

  vector<Tree> st1(n + 2), st2(n + 2);
  vector dp(n + 2, vector<int> (n + 2, -inf));

  for (int i = 0; i < n + 2; i++) {
    st1[i] = Tree(n + 2);
    st2[i] = Tree(n + 2);
  }

  auto upd = [&] (int val1, int val2, int val) {
    if (val > dp[val1][val2]) {
      dp[val1][val2] = val;
      st1[val1].upd(val2, val2 + 1, val, 0, 0, st1[val1].s);
      st2[val2].upd(val1, val1 + 1, val, 0, 0, st2[val2].s);
    }
  };

  upd(a[0], n + 1, 1);
  upd(0, a[0], 1);
  for (int i = 1; i < n; i++) {
    { // dp[a[i]][val2]
      for (int val2 = n + 1; val2 >= 1; val2--) {
        if (val2 == a[i]) {
          continue;
        }
        // for (int val1 = 0; val1 < a[i]; val1++) {
        //   upd(a[i], val2, dp[val1][val2] + 1);
        // }
        upd(a[i], val2, st2[val2].get(0, a[i], 0, 0, st2[val2].s) + 1);
      }
    }
    { // dp[val1][a[i]]
      for (int val1 = 0; val1 <= n; val1++) {
        if (val1 == a[i]) {
          continue;
        }
        // for (int val2 = n + 1; val2 > a[i]; val2--) {
        //   upd(val1, a[i], dp[val1][val2] + 1);
        // }
        upd(val1, a[i], st1[val1].get(a[i] + 1, n + 2, 0, 0, st1[val1].s) + 1);
      }
    }
    for (int val1 = 0; val1 < a[i]; val1++) {
      st1[val1].upd(a[i] + 1, n + 2, -inf, 0, 0, st1[val1].s);
    }
    for (int val2 = a[i] + 1; val2 <= n + 1; val2++) {
      st2[val2].upd(0, a[i], -inf, 0, 0, st2[val2].s);
    }
  }

  int ans = -inf;
  for (int val1 = 0; val1 <= n + 1; val1++) {
    for (int val2 = 0; val2 <= n + 1; val2++) {
      ans = max(ans, dp[val1][val2]);
    }
  }

  cout << ans << '\n';
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}