#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <array>
#include <cassert>
#include <random>
#include <chrono>
#include <map>

using namespace std;

#define int long long
#define sz(x) (int) ((x).size())
#define all(x) (x).begin(), (x).end()

int mod;

const int K = 4;
const int MX = 64;
const int N = 1e5 + 5;

int f[N], rf[N];

int binpow(int a, int n) {
  int res = 1;
  while (n) {
    if (n % 2) {
      (res *= a) %= mod;
    }
    (a *= a) %= mod;
    n /= 2;
  }

  return res;
}

int C(int n, int k) {
  return f[n] * rf[n - k] % mod * rf[k] % mod;
}

int res[K + 1][MX][MX];

void solve() {
  int k, n, p;
  cin >> k >> n >> p;
  cout << res[k][n][p] << '\n';
//  int res = 0;
//  for (auto &mask : masks[k][p]) {
//    int bits = __builtin_popcount(mask);
//    if (bits == n) {
//      cerr << mask << ' ' << bits << endl;
//      res++;
////      (res += binpow(bits, n - bits)) %= mod;
//    }
//  }
//
//  cout << res << '\n';
}

int get_mex(const vector<int>& a) {
  int mex = 0;
  for (auto &x : a) {
    if (x == mex) {
      mex++;
    } else {
      return mex;
    }
  }
  return mex;
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cin >> mod;

//  f[0] = rf[0] = 1;
//  for (int i = 1; i < N; i++) {
//    f[i] = f[i - 1] * i % mod;
//    rf[i] = binpow(f[i], mod - 2);
//  }

  for (int k = 1; k <= K; k++) {
    int cnt = 1 << k;
    for (int mask = 1; mask < 1 << cnt; mask += 2) {
      vector<int> arr;
      for (int i = 0; i < cnt; i++) {
        if (mask >> i & 1) {
          arr.push_back(i);
        }
      }
      int cur_mex = get_mex(arr);
      int step_from = 0;
      int cur_step = 0;
      map<vector<int>, int> step_was;
      step_was[arr] = cur_step;
      while (1) {
        cur_step++;
        for (int i = 0; i < sz(arr); i++) {
          arr[i] ^= cur_mex - 1;
        }
        sort(all(arr));
        if (step_was.find(arr) != step_was.end()) {
          break;
        }
        step_was[arr] = cur_step;
        int new_mex = get_mex(arr);
        if (new_mex != cur_mex) {
          cur_mex = new_mex;
          step_from = cur_step;
        }
      }
      if (step_from <= step_was[arr]) {
//        if (k == 3) {
//          cerr << mask << ' ' << __builtin_popcount(mask) << ' ' << get_mex(arr) << endl;
//        }
        res[k][__builtin_popcount(mask)][get_mex(arr)]++;
      }
    }
  }

  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}