#include <iostream>
#include <vector>
#include <functional>
#include <set>
#include <array>
#include <cassert>
#include <algorithm>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

const int inf = 1e18;

void solve() {
  int n;
  cin >> n;
  vector<array<int, 2>> a(n);
  for (auto &[l, r] : a) {
    cin >> l >> r;
  }

  vector<int> p(n);
  for (int i = 0; i < n; i++) {
    p[i] = i;
  }
  sort(all(p), [&] (const int& i, const int& j) {
    return make_pair(a[i][1], a[i][0]) < make_pair(a[j][1], a[j][0]);
  });

  auto new_a = a;
  for (int i = 0; i < n; i++) {
    new_a[i] = a[p[i]];
  }
  a.swap(new_a);

  vector<int> ban(n);

  auto calc = [&] () {
    int cur_r = -1, res = 0;
    for (int i = 0; i < n; i++) {
      if (ban[i]) {
        continue;
      }
      auto [l, r] = a[i];
      if (l > cur_r) {
        cur_r = r;
        res++;
      }
    }
    return res;
  };

  int rem = n / 2;
  int need = calc() / 2;

  bool was = false;
  for (int i = 0; i + rem <= n; i++) {
    int L = i, R = i + rem - 1;
    for (int j = L; j <= R; j++) {
      ban[j] = 1;
    }
    if (calc() <= need) {
      int cur_r = -1;
      vector<int> pos;
      for (int j = 0; j < n; j++) {
        if (ban[j]) {
          continue;
        }
        auto [l, r] = a[j];
        if (l > cur_r) {
          cur_r = r;
          pos.push_back(j);
        }
      }
      rem = 0;
      int need_ost = need - calc();
      for (int j = 0; j < sz(pos); j++) {
        if (pos[j] >= L && pos[j] <= R && need_ost > 0) {
          need_ost--;
          ban[j] = 0;
          rem++;
        }
      }
      break;
    }
    fill(all(ban), 0);
  }

  vector<int> in(n);
  int cur_r = -1;
  for (int i = 0; i < n; i++) {
    if (ban[i]) {
      continue;
    }
    auto [l, r] = a[i];
    if (l > cur_r) {
      cur_r = r;
      in[i] = 1;
    }
  }

  for (int i = 0; i < n; i++) {
    if (!ban[i] && !in[i] && rem > 0) {
      rem -= 1;
      ban[i] = 1;
    }
    if (!ban[i]) {
      cout << p[i] + 1 << ' ';
    }
  }

  cout << '\n';

  assert(rem == 0);
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}