#include <iostream>
#include <vector>
#include <functional>
#include <set>
#include <array>
#include <cassert>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXA = 5005;
const int inf = 1e18;

void solve() {
  int n, q;
  cin >> n >> q;
  vector<int> ar(n);
  for (auto &x : ar) {
    cin >> x;
  }
  sort(all(ar));

  int ympa;
  cin >> ympa;

  vector<vector<int>> dp(n, vector<int> (MAXA, -inf));
  dp[0][ar[0]] = 0;
  dp[0][0] = (ar[0] == 1 ? 1 : 0);

  for (int i = 0; i + 1 < n; i++) {
    int val = ar[i + 1];
    for (int a = 0; a < MAXA; a++) {
      if (a + val < MAXA) {
        dp[i + 1][a + val] = max(dp[i + 1][a + val], dp[i][a]);
      }
      dp[i + 1][a] = max(dp[i + 1][a], (dp[i][a] + 1 - val >= 0 ? dp[i][a] + val : dp[i][a]));
    }
  }


  for (int w = 0; w < q; w++) {
    int k, a, b;
    cin >> k >> a >> b;
    int pos = upper_bound(all(ar), k) - ar.begin() - 1;
    if (pos < 0) {
      if (a == 0 && b == 0) {
        cout << "Yes\n";
      } else {
        cout << "No\n";
      }
    } else {
      bool good = true;
      for (int i = 0; i <= a; i++) {
        good &= dp[pos][i] >= b;
      }
      cout << (good ? "Yes\n" : "No\n");
    }
  }
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}