#include <iostream>
#include <vector>
#include <functional>
#include <set>
#include <array>
#include <cassert>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
  int n, q, x, y, m;
  cin >> n >> q >> x >> y >> m;

  vector<vector<int>> g(n);
  for (int w = 1; w < n; w++) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    g[u].push_back(v);
    g[v].push_back(u);
  }

  vector<int> l(n), r(n);
  for (int i = 0; i < n; i++) {
    cin >> l[i] >> r[i];
  }

  vector<int> que(q);
  for (int i = 0; i < q; i++) {
    cin >> que[i];
  }

  vector<vector<int>> dp(n, vector<int> (2));
  function<void(int, int)> dfs = [&] (int v, int p) {
    dp[v][1] = r[v];
    for (auto &u : g[v]) {
      if (u != p) {
        dfs(u, v);
        dp[v][1] += dp[u][0];
        dp[v][0] += max(dp[u][0], dp[u][1]);
      }
    }
  };
  dfs(0, -1);

  vector<int> a(n);
  function<void(int, int, int)> recover = [&] (int v, int p, int c) {
    if (c == -1) {
      c = (dp[v][1] > dp[v][0]);
    }
    if (c == 1) {
      a[v] = r[v];
    }
    for (auto &u : g[v]) {
      if (u != p) {
        if (c == 0) {
          if (dp[u][0] > dp[u][1]) {
            recover(u, v, 0);
          } else {
            recover(u, v, 1);
          }
        } else {
          recover(u, v, 0);
        }
      }
    }
  };
  recover(0, -1, -1);

  vector<int> id(n + 1, -1);
  for (int i = 0; i < q; i++) {
    id[que[i]] = i;
  }

  int cert = 0;
  vector<int> pos;
  for (int i = 0; i < n; i++) {
    cert ^= (x * (i + 1) + y * a[i] % m * a[i]) % m;
    if (a[i] != 0) {
      pos.push_back(i);
    }
  }

  vector<int> ans(q, -1);
  if (id[sz(pos)] != -1) {
    ans[id[sz(pos)]] = cert;
  }

  auto save = pos;
  do {
    int v = pos.back();
    pos.pop_back();
    cert ^= (x * (v + 1) + y * a[v] % m * a[v]) % m;
    a[v] = 0;
    cert ^= (x * (v + 1) + y * a[v] % m * a[v]) % m;
    if (id[sz(pos)] != -1) {
      ans[id[sz(pos)]] = cert;
    }
  } while (!pos.empty());

  for (auto &x : ans) {
    cout << x << ' ';
  }
  cout << endl;

  int ympa;
  cin >> ympa;
  while (ympa != 0) {
    --ympa;
    if (ans[ympa] != -1) {
      auto cur = save;
      while (sz(cur) != que[ympa]) {
        cur.pop_back();
      }
      vector<int> out(n);
      for (auto &i : cur) {
        out[i] = r[i];
      }
      for (auto &x : out) {
        cout << x << ' ';
      }
      cout << endl;
    } else {
      cout << -1 << endl;
    }
    cin >> ympa;
  }
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}