#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace  std;
#define int long long

vector<vector<int>> dp(301, vector<int> (301));
vector<vector<int>> good(301, vector<int> (301));

int t[1204][1204];

void add2(int p1, int p, int l, int r, int ind, vector<int> &c) {
    c.push_back(p);
    if (r - l == 1) {
        t[p1][p]++;
        return;
    }
    int m = (l + r) / 2;
    if (ind >= m) {
        add2(p1, 2 * p + 2, m, r, ind, c);
    } else {
        add2(p1, 2 * p + 1, l, m, ind, c);
    }
    t[p1][p] = t[p1][2 * p + 1] + t[p1][2 * p + 2];
}

void add1(int p, int l, int r, int ind1, int ind2, vector<int> &c) {
    if (r - l == 1) {
        add2(p, 0, 0, 301, ind2, c);
        return;
    }

    int m = (l + r) / 2;
    if (ind1 >= m) {
        add1(2 * p + 2, m, r, ind1, ind2, c);
    } else {
        add1(2 * p + 1, l, m, ind1, ind2, c);
    }
    for (auto p2 : c) {
        t[p][p2] = t[2 * p + 2][p2] + t[2 * p + 1][p2];
    }
}

int sum2(int p1, int p, int l, int r, int lq, int rq) {
    if (l >= rq || r <= lq) {
        return 0;
    }
    if (l >= lq && r <= rq) {
        return t[p1][p];
    }

    int m = (l + r) / 2;
    return sum2(p1, 2 * p + 1, l, m, lq, rq) + sum2(p1, 2 * p + 2, m, r, lq, rq);
}

int sum1(int p, int l, int r, int lq1, int rq1, int lq2, int rq2) {
    if (l >= rq1 || r <= lq1) {
        return 0;
    }
    if (l >= lq1 && r <= rq1) {
        return sum2(p, 0, 0, 301, lq2, rq2);
    }

    int m = (l + r) / 2;
    return sum1(2 * p + 1, l, m, lq1, rq1, lq2, rq2) + sum1(2 * p + 2, m, r, lq1, rq1, lq2, rq2);
}

void add(int *tr, int p, int l, int r, int ind) {
    if (r - l == 1) {
        tr[p]++;
        return;
    }
    int m = (l + r) / 2;
    if (ind >= m) {
        add(tr, 2 * p + 2, m, r, ind);
    } else {
        add(tr, 2 * p + 1, l, m, ind);
    }
    tr[p] = tr[2 * p + 1] + tr[2 * p + 2];
}

int sum(int *tr, int p, int l, int r, int lq, int rq) {
    if (l >= rq || r <= lq) {
        return 0;
    }
    if (l >= lq && r <= rq) {
        return tr[p];
    }
    int m = (l + r) / 2;
    return sum(tr, 2 * p + 1, l, m, lq, rq) + sum(tr, 2 * p + 2, m, r, lq, rq);
}


signed main() {
    int n, q;
    cin >> n >> q;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        if (w[i] > 300) {
            w[i] = 0;
        }
    }
    int z;
    cin >> z;

    sort(w.begin(), w.end());
    vector<vector<int>> bu(n + 1);
    vector<pair<int, int>> qs(q);

    for (int i = 0; i < q; i++) {
        int k, a, b;
        cin >> k >> a >> b;
        qs[i] = {a, b};
        bu[lower_bound(w.begin(), w.end(), k + 1) - w.begin()].push_back(i);
    }

    dp[0][0] = 1;
    good[0][0] = 1;
    add(t[0], 0, 0, 301, 0);
    vector<int> res(q);
    for (int i = 0; i < n; i++) {
        for (auto nn : bu[i]) {
            auto [a, b] = qs[nn];
            int ok = true;
            for (int x = 0; x <= a; x++) {
                if (sum(t[x], 0, 0, 301, 0, b + 1) != b + 1) {
                    ok = false;
                    break;
                }
            }
            res[nn] = ok;
        }
        for (int x = 300; x >= 0; x--) {
            for (int y = 300; y >= 0; y--) {
                if (!dp[x][y]) {
                    continue;
                }
                int nx = x + w[i];
                int ny = y + w[i];
                nx = min(nx, 300LL);
                ny = min(ny, 300LL);
                if (!dp[nx][y]) {
                    vector<int> c;
                    add(t[nx],0 , 0, 301, y);
                }

                dp[nx][y] |= dp[x][y];
                if (!dp[x][ny]) {
                    add(t[x], 0, 0, 301, ny);
                }
                dp[x][ny] |= dp[x][y];
            }
        }
    }
    for (auto nn : bu[n]) {
        auto [a, b] = qs[nn];
        int ok = true;
        for (int x = 0; x <= a; x++) {
            if (sum(t[x], 0, 0, 301, 0, b + 1) != b + 1) {
                ok = false;
                break;
            }
        }
        res[nn] = ok;
    }
    for (int i = 0; i < q; i++) {
        if (res[i]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}
