#include <bits/stdc++.h>

#define vc vector
#define pii pair <int, int>
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define int long long

using namespace std;

const int N = 2e5 + 1;

template <class T>
bool chmax (T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 8e18;

template <class T>
bool chmin (T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

struct segtree {
    struct node {
        int sum = 0, mn = inf;
        int md = inf;
        int l, r;
        int v1, v2;
    };
    vc <node> t; int n;
    segtree (int n): n(n) {}
    int create () {
        t.pb(node());
        return sz(t) - 1;
    }
    int push (int v) {
        if (t[v].md == inf)
            return v;
        if (v * 2 + 1 < sz(t)) {
            int l = create();
            int r = create();
            t[l] = t[t[v].v1];
            t[r] = t[t[v].v2];
            chmin(t[l].md, t[v].md);
            chmin(t[r].md, t[v].md);
        }
        int len = t[v].r - t[v].l;
        chmin(t[v].mn, t[v].md - t[v].r + 2);
        t[v].sum = len;
        return v;
    }
    void apply (int v) {
        int l = t[v].v1, r = t[v].v2;
        t[v].l = t[l].l;
        t[v].r = t[r].r;
        t[v].sum = t[l].sum + t[r].sum;
        t[v].mn = min(t[l].mn, t[r].mn);
    }
    int upd (int v, int tl, int tr, int l, int r, int x) {
        int v1 = create();
        t[v1] = t[v];
        push(v);
        if (tr <= l || r <= tl)
            return v;
        if (l <= tl && tr <= r) {
            t[v1].md = x;
            return push(v1);
        }
        int tm = (tl + tr) / 2;
        t[v1].v1 = upd(v << 1, tl, tm, l, r, x);
        t[v1].v2 = upd(v << 1 | 1, tm, tr, l, r, x);
        apply(v);
        return v1;
    }
    int get_min (int v, int tl, int tr, int l, int r) {
        if (tr <= l || r <= tl)
            return inf;
        push(v);
        if (l <= tl && tr <= r)
            return t[v].mn;
        int tm = (tl + tr) / 2;
        return min(get_min(t[v].v1, tl, tm, l, r), get_min(t[v].v2, tm, tr, l, r));
    }
    int get_sum (int v, int tl, int tr, int l, int r) {
        if (tr <= l || r <= tl)
            return 0;
        push(v);
        if (l <= tl && tr <= r)
            return t[v].sum;
        int tm = (tl + tr) / 2;
        return get_sum(t[v].v1, tl, tm, l, r) + get_sum(t[v].v2, tm, tr, l, r);
    }
    int build (int tl, int tr, vc <pii> &u) {
        int v = create();
        if (tr - tl == 1) {
            t[v].l = u[tl].fi;
            t[v].r = u[tr].se;
        } else {
            int tm = (tl + tr) / 2;
            t[v].v1 = build(tl, tm, u);
            t[v].v2 = build(tm, tr, u);
            apply(v);
        }
        return v;
    }
    int get_min (int root, int l, int r) {
        return get_min(root, 0, n, l, r + 1);
    }
    int get_sum (int root, int l, int r) {
        return get_sum(root, 0, n, l, r + 1);
    }
    int upd (int root, int l, int r, int x) {
        return upd(root, 0, n, l, r + 1, x);
    }
    int build (vc <pii> &u) {
        return build(0, n, u);
    }
};

const int C = 1e18;

void solve () {
    int n, q;
    cin >> n >> q;
    vc <int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    int Z; cin >> Z;
    sort(all(w));
    int cur = 1;
    map <int, int> bad_pairs;
    int sum = 0;
    vc <int> c;
    c.pb(0);
    int x = sz(c);
    for (int i = 0; i < x; ++i)
        c.pb(c[i] + 1);
    sum = 0;
    cur = 1;
    sort(all(c));
    c.resize(unique(all(c)) - c.begin());
    segtree t(sz(c));
    auto get = [&](int x) {
        return lower_bound(all(c), x) - c.begin();
    };
    c.pb(C);
    vc <pii> tt;
    for (int i = 0; i < sz(c) - 1; ++i) {
        tt.pb({c[i], c[i + 1]});
    }
    vc <int> ver(n + 1);
    vc <int> s(n), cr(n);
    ver[0] = t.build(tt);
    for (int i = 0; i < n; ++i) {
        {
            int l = sum - w[i] + 2;
            int r = w[i] - 1;
            if (l <= r) {
                ver[i + 1] = t.upd(ver[i], get(l), get(r), sum);
            } else {
                ver[i + 1] = ver[i];
            }
        }
        if (cur >= w[i])
            cur += w[i];
        sum += w[i];
        s[i] = sum;
        cr[i] = sum;
    }
    int vv = 0;
    int num = 1;
    while (q--) {
        vc <int> it(3);
        for (int i = 0; i < 3; ++i) {
            cin >> it[i];
            it[i] -= vv * Z;
        }
        int j = upper_bound(all(w), it[0]) - w.begin();
        int f = 1;
        if (j == 0) {
            f = (it[1] == 0 && it[2] == 0);
        } else {
            if (it[1] < cur) {
                int l = sum - it[2] + 1;
                int r = it[1];
                if (t.get_min(ver[j], get(0), get(it[1])) <= it[2]) {
                    f = 0;
                }
                if (l <= r) {
                    int sm = t.get_sum(ver[j], get(l), get(r));
                    if (sm != r - l + 1) {
                        f = 0;
                    }
                }
            } else
                f = 0;
        }
        if (f) {
            cout << "Yes\n";
            vv += num;
        } else {
            cout << "No\n";
        }
        num++;
    }
}
/*
8 3
17 1 3 2 100 5 6 1
0
6 15 3
9 4 4
5 15 3
 */

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
