#include <bits/stdc++.h>

#define vc vector
#define pii pair <int, int>
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define int long long

using namespace std;

const int N = 2e5 + 1;

template <class T>
bool chmax (T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 8e18;

template <class T>
bool chmin (T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

struct segtree {
    struct node {
        int sum = 0, mn = inf;
        int md = inf;
        int l, r;
    };
    vc <node> t; int n;
    segtree (int n): n(n) {
        t.resize(n * 4);
    }
    void push (int v) {
        if (t[v].md == inf)
            return;
        if (v * 2 + 1 < sz(t)) {
            chmin(t[v << 1].md, t[v].md);
            chmin(t[v << 1 | 1].md, t[v].md);
        }
        int len = t[v].r - t[v].l;
        chmin(t[v].mn, t[v].md - t[v].r + 2);
        t[v].sum = len;
    }
    void apply (int v) {
        t[v].l = t[v << 1].l;
        t[v].r = t[v << 1 | 1].r;
        t[v].sum = t[v << 1].sum + t[v << 1 | 1].sum;
        t[v].mn = min(t[v << 1].mn, t[v << 1 | 1].mn);
    }
    void upd (int v, int tl, int tr, int l, int r, int x) {
        push(v);
        if (tr <= l || r <= tl)
            return;
        if (l <= tl && tr <= r) {
            t[v].md = x;
            push(v);
            return;
        }
        int tm = (tl + tr) / 2;
        upd(v << 1, tl, tm, l, r, x);
        upd(v << 1 | 1, tm, tr, l, r, x);
        apply(v);
    }
    int get_min (int v, int tl, int tr, int l, int r) {
        if (tr <= l || r <= tl)
            return inf;
        push(v);
        if (l <= tl && tr <= r)
            return t[v].mn;
        int tm = (tl + tr) / 2;
        return min(get_min(v << 1, tl, tm, l, r), get_min(v << 1 | 1, tm, tr, l, r));
    }
    int get_sum (int v, int tl, int tr, int l, int r) {
        if (tr <= l || r <= tl)
            return 0;
        push(v);
        if (l <= tl && tr <= r)
            return t[v].sum;
        int tm = (tl + tr) / 2;
        return get_sum(v << 1, tl, tm, l, r) + get_sum(v << 1 | 1, tm, tr, l, r);
    }
    void upd1 (int v, int tl, int tr, int i, int l, int r) {
        if (tr - tl == 1) {
            t[v].l = l;
            t[v].r = r;
            return;
        }
        int tm = (tl + tr) / 2;
        if (i < tm)
            upd1(v << 1, tl, tm, i, l, r);
        else
            upd1(v << 1 | 1, tm, tr, i, l, r);
        apply(v);
    }
    int get_min (int l, int r) {
        return get_min(1, 0, n, l, r + 1);
    }
    int get_sum (int l, int r) {
        return get_sum(1, 0, n, l, r + 1);
    }
    void upd (int l, int r, int x) {
        upd(1, 0, n, l, r + 1, x);
    }
    void upd1 (int i, int l, int r) {
        upd1(1, 0, n, i, l, r);
    }
};

const int C = 1e18;

bool intersect (pii a, pii b) {
    return max(a.fi, b.fi) <= min(a.se, b.se);
}

void solve () {
    int n, q;
    cin >> n >> q;
    vc <int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    int Z; cin >> Z;
    sort(all(w));
    vc <vc <vc <int>>> quer(n);
    vc <int> ans(q * 2);
    for (int i = 0; i < q; ++i) {
        int a, b, k;
        cin >> k >> a >> b;
        {
            int j = upper_bound(all(w), k) - w.begin() - 1;
            if (j >= 0) {
                quer[j].pb({i * 2, a, b});
            } else {
                ans[i * 2] = (a == 0 && b == 0);
            }
        }
        k -= Z;
        a -= Z;
        b -= Z;
        if (k >= 0 && a >= 0 && b >= 0) {
            int j = upper_bound(all(w), k) - w.begin() - 1;
            if (j >= 0) {
                quer[j].pb({i * 2 + 1, a, b});
            } else {
                ans[i * 2 + 1] = (a == 0 && b == 0);
            }
        } else {
            ans[i * 2 + 1] = 0;
        }
    }
    int cur = 1;
    map <int, int> bad_pairs;
    int sum = 0;
    int col = 0;
    vc <vc <int>> segs;
    for (int i = 0; i < n; ++i) {
        {
            int l = sum - w[i] + 2;
            int r = w[i] - 1;
            if (l <= r) {
                segs.pb({l, r, sum});
                ++col;
            }
        }
        if (cur >= w[i])
            cur += w[i];
        sum += w[i];
        for (auto it : quer[i]) {
            int f = 1;
            if (it[1] < cur) {
                int l = sum - it[2] + 1;
                int r = it[1];
                for (auto it2 : segs) {
                    if (intersect({it2[0], it2[1]}, {0, it[1]}) && it2[2] <= it[2]) {
                        f = 0;
                        break;
                    }
                }
                if (l <= r) {
                    vc <pii> ss;
                    for (auto it2 : segs) {
                        if (intersect({it2[0], it2[1]}, {l, r})) {
                            ss.pb({max(it2[0], l), min(it2[1], r)});
                        }
                    }
                    sort(all(ss));
                    int mx = l;
                    int was = 0;
                    for (auto [x, y] : ss) {
                        if (x > mx) {
                            was = 1;
                        }
                        chmax(mx, y);
                    }
                    if (mx < r)
                        was = 1;
                    if (!was)
                        f = 0;
                }
            } else
                f = 0;
            ans[it[0]] = f;
        }
    }
    int v = 0;
    for (int i = 0; i < q; ++i) {
        if (ans[i * 2 + v]) {
            cout << "Yes\n";
            v = 1;
        } else {
            cout << "No\n";
            v = 0;
        }
    }
    assert(col <= 35);
}
/*
8 3
17 1 3 2 100 5 6 1
0
6 15 3
9 4 4
5 15 3
 */

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
