#include <bits/stdc++.h>

using namespace std;

struct MST {
	int n;
	vector<int> vec;

	struct node {
		int n;
		vector<int> vec;
		node() {};
		node(int x): n(1), vec({x}) {}
		node(node a, node b) {
			n = a.n + b.n;
			merge(a.vec.begin(), a.vec.end(), b.vec.begin(), b.vec.end(), back_inserter(vec));
		}
	};

	vector<node> mst;

	void build(int v, int l, int r) {
		if (r - l == 1) {
			mst[v] = node(vec[l]);
			return;
		}
		int m = (l + r) / 2;
		build(v * 2 + 1, l, m);
		build(v * 2 + 2, m, r);
		mst[v] = node(mst[v * 2 + 1], mst[v * 2 + 2]);
	}

	MST(int n, vector<int> vec): n(n), vec(vec) {
		mst.resize(n * 4);
	}

	bool is_here(int v, int l, int r, int ql, int qr, int a, int b) {
		if (qr <= l || r <= ql) return 0;
		if (ql <= l && r <= qr) {
			auto x = (lower_bound(mst[v].vec.begin(), mst[v].vec.end(), b));
			auto y = (upper_bound(mst[v].vec.begin(), mst[v].vec.end(), a));
			if (x != y) return 1;
			return 0;
		}
		int m = (l + r) / 2;
		return (is_here(v * 2 + 1, l, m, ql, qr, a, b) | is_here(v * 2 + 2, m, r, ql, qr, a, b));
	}
};

void solve() {
	int n;
	cin >> n;
	vector<int> vec(n);
	for (int &x: vec) cin >> x;
	MST mst(n, vec);
	vector<vector<int>> dp(n + 1, vector<int>(n + 1, -1e9));
	dp[0][n] = 1;
	dp[n][0] = 1;
	for (int i = 1; i < n; ++i) {
		int mxind = 0, mnind = 0;
		for (int j = 0; j < i; ++j) {
			if (vec[j] > vec[mxind]) mxind = j;
			if (vec[j] < vec[mnind]) mnind = j;
		}
		if (vec[i] > vec[mxind]) dp[i][n] = dp[mxind][n] + 1;
		if (vec[i] < vec[mnind]) dp[n][i] = dp[n][mnind] + 1;
		for (int j = 0; j < i; ++j) {
			for (int k = 0; k < i; ++k) {
				if (vec[k] < vec[i]) continue;
				bool ok = 1;
				if (vec[j] < vec[k]) {
					if (mst.is_here(0, 0, n, max(k, j) + 1, i, vec[j], vec[k])) ok = 0;
					// ok &= mst.is_here(0, 0, n, max(k, j) + 1, i, vec[j], vec[k]);
					// for (int t = max(k, j) + 1; t < i && ok; ++t) {
					// 	if (vec[t] > vec[j] && vec[t] < vec[k]) ok = 0;
					// }
				}
				if (ok) {
					dp[j][i] = max(dp[j][i], dp[j][k] + 1);
				}
			}
			bool ok = 1;
			for (int t = j + 1; t < i && ok; ++t) {
				if (vec[t] > vec[j]) ok = 0;
			}
			if (ok) dp[j][i] = max(dp[j][i], dp[j][n] + 1);  
		}
		for (int k = 0; k < i; ++k) {
			for (int j = 0; j < i; ++j) {
				if (vec[j] > vec[i]) continue;
				bool ok = 1;
				if (vec[j] < vec[k]) {
					if (mst.is_here(0, 0, n, max(k, j) + 1, i, vec[j], vec[k])) ok = 0;
					// for (int t = max(k, j) + 1; t < i && ok; ++t) {
					// 	if (vec[t] > vec[j] && vec[t] < vec[k]) ok = 0;
					// }	
				}
				if (ok) {
					dp[i][k] = max(dp[i][k], dp[j][k] + 1);
				}
			}
			bool ok = 1;
			for (int t = k + 1; t < i && ok; ++t) {
				if (vec[t] < vec[k]) ok = 0;
			}
			if (ok) dp[i][k] = max(dp[i][k], dp[n][k] + 1);
		}
	}
	int ans = 0;
	for (vector<int> v: dp) for (int x: v) ans = max(ans, x);
	cout << ans << endl;
}

int main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}