#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;
#define int long long
//#define endl '\n'
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()


vector<vector<int>> g;
vector<array<int, 2>> dp;
vector<pair<int, int>> b;

void dfs(int v, int p = -1) {
    dp[v][0] = 0;
    dp[v][1] = b[v].second == 1;
    for (int u : g[v]) {
        if (u == p) continue;
        dfs(u, v);
        dp[v][0] += max(dp[u][0], dp[u][1]);
        dp[v][1] += dp[u][0];
    }
}

vector<int> ans;

void res(int v, int cond = 1, int p = -1) {
    if (dp[v][0] <= dp[v][1] && cond == 1 && b[v].second == 1) {
        ans.push_back(v);
        for (int u : g[v]) {
            if (u == p) continue;
            res(u, 0, v);
        }
    } else {
        for (int u : g[v]) {
            if (u == p) continue;
            res(u, 1, v);
        }
    }
}

void solve() {
    int n, q; cin >> n >> q;
    int x, y, m; cin >> x >> y >> m;
    g.resize(n);
    dp.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v; cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    b.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i].first >> b[i].second;
    }
    dfs(0);
    res(0);
//    for (int e : ans) {
//        cout << e << ' ';
//    }
//    cout << endl;

    vector<int> calc(ans.size() + 1, 0);
    for (int i = 0; i < n; ++i) {
        calc[0] ^= ((i + 1) * x) % m;
    }
    for (int i = 0; i < ans.size(); ++i) {
        calc[i + 1] = calc[i];
        calc[i + 1] ^= ((ans[i] + 1) * x) % m;
        calc[i + 1] ^= ((ans[i] + 1) * x + y) % m;
    }


    vector<int> V(q);
    for (int i = 0; i < q; ++i) {
        cin >> V[i];
    }
    for (int i = 0; i < q; ++i) {
        if (V[i] > ans.size()) {
            cout << -1 << ' ';
        } else {
            cout << calc[V[i]] << ' ';
        }
    }
    cout << endl;
    cout.flush();
    int i; cin >> i;
    while (i) {
        i--;
        if (V[i] > ans.size()) {
            cout << -1 << endl;
        } else {
            vector<int> sas(n, 0);
            for (int j = 0; j < V[i]; ++j) {
                sas[ans[j]] = 1;
            }
            for (int e : sas) {
                cout << e << ' ';
            }
            cout << endl;
        }
        cout.flush();
        cin >> i;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(20);
    cout.setf(ios::fixed);
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
