#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

const int INF32 = 0x3f3f3f3f;
const int INF64 = 0x3f3f3f3f3f3f3f3f;

vector<pair<int, int>> seg;
vector<int> last;

int calc(int l, int r) {
    int n = r - l + 1;
    vector<int> dp(n);
    for (int i = l; i <= r; i++) {
        if (last[i] >= l) {
            dp[i - l] = max(dp[i - l - 1], dp[last[i] - l] + 1);
        } else {
            dp[i - l] = max(1LL, i == l ? 0 : dp[i - l - 1]);
        }
    }
    return dp.back();
}

void solve() {
    int n;
    cin >> n;
    seg.assign(n, {});
    last.assign(n, -1);
    for (int i = 0; i < n; i++) {
        cin >> seg[i].X >> seg[i].Y;
    }
    vector<pair<pair<int, int>, int>> seg_start(n);
    for (int i = 0; i < n; i++) {
        seg_start[i] = {seg[i], i};
    }
    sort(all(seg_start), [&](const pair<pair<int, int>, int> &a, const pair<pair<int, int>, int> &b) {
        return a.X.Y < b.X.Y || (a.X.Y == b.X.Y && a.X.X > b.X.X) || (a.X == b.X && a.Y < b.Y);
    });
    sort(all(seg), [&](const pair<int, int> &a, const pair<int, int> &b) {
        return a.Y < b.Y || (a.Y == b.Y && a.X > b.X);
    });
    for (int i = 0; i < n; i++) {
        last[i] = lower_bound(all(seg), pair<int, int>{INF64, seg[i].X}, [&](const pair<int, int> &a, const pair<int, int> &b) {
            return a.Y < b.Y || (a.Y == b.Y && a.X > b.X);
        }) - seg.begin() - 1;
    }
    int m = calc(0, n - 1);
    int l = 0, r = n / 2;
    int calc_l = calc(0, n / 2 - 1);
    int calc_r = calc(n / 2, n - 1);
    if (calc_l == m / 2) {
        for (int j = 0; j < n / 2; j++) {
            cout << seg_start[j].Y + 1 << ' ';
        }
        cout << '\n';
        return;
    }
    if (calc_r == m / 2) {
        for (int j = n / 2; j < n; j++) {
            cout << seg_start[j].Y + 1 << ' ';
        }
        cout << '\n';
        return;
    }
    while (l != r) {
        int mid = (l + r) / 2;
        int calc_mid = calc(mid, mid + n / 2 - 1);
        if (calc_mid == m) {
            for (int j = mid; j < mid + n / 2; j++) {
                cout << seg_start[j].Y + 1 << ' ';
            }
            cout << '\n';
            return;
        }
        if ((calc_mid - m / 2) * (calc_l - m / 2) < 0) {
            r = mid;
            calc_r = calc_mid;
        } else {
            l = mid;
            calc_l = calc_mid;
        }
    }
    for (int j = l; j < l + n / 2; j++) {
        cout << seg_start[j].Y + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) solve();
}