#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
using namespace std;

typedef int64_t ll;
typedef uint64_t ull;

const ll inf = 1234567891;
const ll M = 1e9 + 7;
const ll INF = 1e18 + 21;
const double PI = acos(-1);

struct node {
	ll x, y;
};

void solve() {
	ll h, w; int n;
	cin >> h >> w >> n;
	vector<node> a(n);
	for (auto& e : a) cin >> e.y >> e.x;
	set<ll> x, y;
	for (auto& e : a) {
		x.insert(e.x);
		y.insert(e.y);
	}
	for (int i = 0; i < n; ++i) {
		auto it = x.upper_bound(a[i].x);
		if (it != x.end() && (*it) - a[i].x == 1) {
			x.erase(a[i].x);
		}
		it = y.upper_bound(a[i].y);
		if (it != y.end() && (*it) - a[i].y == 1) {
			y.erase(a[i].y);
		}
	}
	ll left = 0, up = 0;
	for (auto& e : x) {
		auto it = x.upper_bound(e);
		if (it != x.end()) {
			ll dist = (*it) - e - 1;
			if (2 * dist + 2 >= w) {
				left = e;
			}
		}
	}
	for (auto& e : y) {
		auto it = y.upper_bound(e);
		if (it != y.end()) {
			ll dist = (*it) - e - 1;
			if (2 * dist + 2 >= h) {
				up = e;
			}
		}
	}
	x.clear();
	y.clear();
	for (auto& e : a) {
		x.insert(e.x);
		y.insert(e.y);
	}
	for (int i = 0; i < n; ++i) {
		auto it = x.lower_bound(a[i].x);
		if (it != x.begin()) {
			--it;
			if ((*it) - a[i].x == -1) {
				x.erase(a[i].x);
			}
		}
		it = y.lower_bound(a[i].y);
		if (it != y.begin()) {
			--it;
			if ((*it) - a[i].y == -1) {
				y.erase(a[i].y);
			}
		}
	}
	ll right = 0, down = 0;
	ll p = -1;
	for (auto& e : x) {
		if (p != -1) {
			ll dist = e - p - 1;
			if (2 * dist + 2 >= w) {
				right = w - e + 1;
			}
		}
		p = e;
	}
	p = -1;
	for (auto& e : y) {
		if (p != -1) {
			ll dist = e - p - 1;
			if (2 * dist + 2 >= h) {
				down = h - e + 1;
			}
		}
		p = e;
	}
	ll ans = 0;
	vector<ll> mvl, mvr;
	vector<ll> mvu, mvd;
	for (auto& e : a) {
		if (e.x <= left) {
			mvl.push_back(w - (left - e.x));
		} else {
			mvl.push_back(e.x - left);
		}
		if (e.x + right > w) {
			mvr.push_back(e.x + right - w);
		} else {
			mvr.push_back(e.x + right);
		}
		if (e.y <= up) {
			mvu.push_back(h - (up - e.y));
		} else {
			mvu.push_back(e.y - up);
		}
		if (e.y + down > h) {
			mvd.push_back(e.y + down - h);
		} else {
			mvd.push_back(e.y + down);
		}
	}
	ll sq = 0;
	ll diffl = *max_element(mvl.begin(), mvl.end()) - *min_element(mvl.begin(), mvl.end()) + 1;
	ll diffr = *max_element(mvr.begin(), mvr.end()) - *min_element(mvr.begin(), mvr.end()) + 1;
	if (diffl < diffr || (diffl == diffr && left < right)) {
		sq = diffl;
		ans = left;
	} else {
		sq = diffr;
		ans = right;
	}
	ll diffu = *max_element(mvu.begin(), mvu.end()) - *min_element(mvu.begin(), mvu.end()) + 1;
	ll diffd = *max_element(mvd.begin(), mvd.end()) - *min_element(mvd.begin(), mvd.end()) + 1;
	if (diffu < diffd || (diffu == diffd && up < down)) {
		sq *= diffu;
		ans += up;
	} else {
		sq *= diffd;
		ans += down;
	}
	cout << sq << ' ' << ans << '\n';
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0);

	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}