#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int k;
vector<vector<int>> g;
vector<int> turns;

vector<int> ans;

void dfs_turns(int v, int last = -1) {
	if (g[v].size() == 2) {
		turns[g[v][0]] = turns[v] + (last == 1);
		dfs_turns(g[v][0], 0);
		turns[g[v][1]] = turns[v] + (last == 0);
		dfs_turns(g[v][1], 1);
	}
}



int dfs_ans(int v) {
	int cnt = 0;
	if (g[v].size() == 2) {
		cnt += dfs_ans(g[v][0]);
		cnt += dfs_ans(g[v][1]);
	} else {
		cnt += (turns[v] <= k);
	}
	ans[v] = cnt;
	return cnt;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> k >> m;
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		if (t == 2) {
			int u, v;
			cin >> u >> v;
			--u; --v;
			g[i].push_back(u);
			g[i].push_back(v);
		}
	}

	turns.resize(n);
	dfs_turns(0);

	ans.resize(n);
	vector<int> q(m);
	for (int i = 0; i < m; ++i) {
		cin >> q[i];
		--q[i];
	}
	dfs_ans(0);

	for (auto x : q) {
		cout << ans[x] << " ";
	}
}
