#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-9;

struct DSU {
    vector<ll> p, sz;

    explicit DSU(ll n) {
        p.assign(n, 0);
        for (ll i = 0; i < n; i++) p[i] = i;
        sz.assign(n, 1);
    }

    ll get(ll v) {
        if (p[v] == v) return v;
        return p[v] = get(p[v]);
    }

    void merge(ll a, ll b) {
        a = get(a), b = get(b);
        if (a == b) return;

        if (sz[a] < sz[b]) swap(a, b);

        sz[a] += sz[b];
        p[b] = a;
    }
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll a, t;
    cin >> a >> t;

    if (a == 1) {
        while (t--) {
            ll n, k;
            cin >> n >> k;
            vector<bool> w(n);
            vector<ll> p(k);
            for (ll i = 0; i < k; i++) {
                cin >> p[i];
            }

            for (ll q : p) cout << q + 1 << " ";
            cout << "\n";
        }
    } else {
        while (t--) {
            ll n, k;
            cin >> n >> k;
            vector<bool> w(n);
            vector<ll> p(k);
            for (ll i = 0; i < k; i++) {
                cin >> p[i];
            }

            for (ll q : p) cout << q - 1 << " ";
            cout << "\n";
        }
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}