#include <iostream>
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector<vector<ll>> g;

vector<ll> ans, nxt, e;
vector<pair<ll, ll>> seg;

ll INF = 1e18;

void dfs(ll v, ll mx, ll sz) {
    ans[v] = 1;
    e[v] = seg[v].second;
    if (mx == 1) return;
    for (ll to : g[v]) {
        if (seg[to].second > sz) continue;
        if (ans[to] == -1) {
            dfs(to, mx - 1, sz);
        }
        if (ans[to] + 1 > ans[v] || ans[to] + 1 == ans[v] && e[to] > e[v]) {
            ans[v] = ans[to] + 1;
            nxt[v] = to;
            e[v] = e[to];
        }
    }
}


int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n;
        cin >> n;

        g.assign(n, {});
        e.assign(n, -INF);

        seg.assign(n, {});
        for (ll i = 0; i < n; i++) cin >> seg[i].first >> seg[i].second;

        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < n; j++) {

                if (seg[i].second < seg[j].first) {
                    g[i].push_back(j);
                }
            }
        }

        ans.assign(n, -1);
        nxt.assign(n, -1);
        for (ll i = 0; i < n; i++) {
            if (ans[i] == -1) {
                dfs(i, INF, INF);
            }
        }

        ll ind = max_element(ans.begin(), ans.end()) - ans.begin();
        ll m = ans[ind] / 2;

        bool ok = false;
        for (ll i = 0; i < n; i++) {
            ll L = 0, R = 1e9;
            while (R - L > 1) {
                ll mid = L + (R - L) / 2;
                ans.assign(n, -1);
                nxt.assign(n, -1);
                e.assign(n, -INF);
                dfs(i, m, mid);

                if (*max_element(ans.begin(), ans.end()) == m)
                    L = mid;
                else
                    R = mid;
            }

            ans.assign(n, -1);
            nxt.assign(n, -1);
            e.assign(n, -INF);
            dfs(i, m, L);


            ll start = std::max_element(ans.begin(), ans.end()) - ans.begin();
            if (ans[start] != m) continue;

            ll l = seg[i].first;
            ll r = L;

            vector<bool> used(n);
            ll v = start;

            vector<ll> out;
            for (ll j = 0; j < m; j++) {
                out.push_back(v);
                used[v] = true;
                v = nxt[v];
            }

            vector<ll> q;
            for (ll j = 0; j < n; j++) {
                if (!used[j] && l <= seg[j].first && seg[j].second <= r) {
                    q.push_back(j);
                }
            }

            for (ll j : q)
                if (out.size() < n / 2)
                    out.push_back(j);

            if (out.size() != n / 2) continue;
            for (ll w : out) cout << w + 1 << " ";
            cout << "\n";
            ok = true;
            break;
        }

        assert(ok);
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}