#include <algorithm>
#include <cassert>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

struct Seg {
    int first;
    int second;
    int i;
    Seg() {
        first = 0;
        second = 0;
        i = 0;
    }

    bool operator<(const Seg& other) const {
        return make_pair(first, second) < make_pair(other.first, other.second);
    }
};

vector<vector<int>> gr;
vector<int> szs;
vector<int> h;
vector<int> nearestupper;

void dfs0(int v, int p) {
    if (p != -1) {
        if (gr[p].size() > 1) {
            nearestupper[v] = p;
        } else {
            nearestupper[v] = nearestupper[p];
        }
    }
    for (int to : gr[v]) {
        if (to != p) {
            h[to] = h[v] + 1;
            dfs0(to, v);
        }
    }
}

void dfs(int v, int p) {
    if (gr[v].size() >= 1) {
        szs[v] = 1;
    }
    for (int to : gr[v]) {
        if (to != p) {
            dfs(to, v);
            szs[v] += szs[to];
        }
    }
    if (gr[v].size() >= 1 && szs[v] == 1) {
        szs[v] = 0;
    }
}

int getdst(int v, const vector<int>& pr) {
    int res = 0;
    while (v != -1 && gr[v].size() <= 1) {
        res++;
        v = pr[v];
    }
    return res;
}

void solve() {
    int n;
    cin >> n;

    vector<Seg> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].i = i;
    }

    sort(a.begin(), a.end(), [](const Seg& x, const Seg& y) {
        if (x.first != y.first) {
            return x.first < y.first;
        }
        return x.second > y.second;
    });

    gr.assign(n, vector<int>(0));

    vector<pair<int, pair<int, int>>> evs(2 * n);
    for (int i = 0; i < n; i++) {
        evs[2 * i].first = a[i].first;
        evs[2 * i].second = {i, 1};
        evs[2 * i + 1].first = a[i].second;
        evs[2 * i + 1].second = {i, -1};
    }

    sort(evs.begin(), evs.end(), [](const pair<int, pair<int, int>>& ev1, const pair<int, pair<int, int>>& ev2) {
        if (ev1.first != ev2.first) {
            return ev1.first < ev2.first;
        }
        return ev1.second.second < ev2.second.second;
    });

    set<Seg> sgs;
    vector<int> pr(n);

    for (auto el : evs) {
        int cind = el.second.first;
        int ctype = el.second.second;
        if (ctype == 1) {
            int cp = -1;
            if (!sgs.empty()) {
                cp = (--sgs.end())->i;
            }
            if (cp != -1) {
                gr[cp].emplace_back(cind);
                pr[cind] = cp;
            } else {
                pr[cind] = -1;
            }
            sgs.emplace(a[cind]);
        } else {
            sgs.erase(a[cind]);
        }
    }

    int m = 0;
    vector<int> leaves;
    for (int i = 0; i < n; i++) {
        if (gr[i].size() == 0) {
            m++;
            leaves.emplace_back(i);
        }
    }

    vector<bool> alive(n, true);
    int cm = m;
    int cn = n;
    for (int ep = 0; ep < m / 2; ep++) {
        int bestl = leaves[0];
        int bestdst = 1000000000;
        for (int i = 0; i < m; i++) {
            if (alive[leaves[i]]) {
                int cdst = getdst(leaves[i], pr);
                if (cdst < bestdst) {
                    bestdst = cdst;
                    bestl = leaves[i];
                }
            }
        }
        cm--;
        while (bestl != -1 && gr[bestl].size() <= 1) {
            alive[bestl] = false;
            cn--;
            bestl = pr[bestl];
        }
    }
    assert(cn >= n / 2);
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}