#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

struct Seg {
    int first;
    int second;
    int i;
    Seg() {
        first = 0;
        second = 0;
        i = 0;
    }

    bool operator<(const Seg& other) const {
        return make_pair(first, second) < make_pair(other.first, other.second);
    }
};

vector<set<int>> gr;

void solve() {
    int n;
    cin >> n;

    vector<Seg> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].i = i;
    }

    sort(a.begin(), a.end(), [](const Seg& x, const Seg& y) {
        if (x.first != y.first) {
            return x.first < y.first;
        }
        return x.second > y.second;
    });

    gr.assign(n, set<int>());

    vector<pair<int, pair<int, int>>> evs(2 * n);
    for (int i = 0; i < n; i++) {
        evs[2 * i].first = a[i].first;
        evs[2 * i].second = {i, 1};
        evs[2 * i + 1].first = a[i].second;
        evs[2 * i + 1].second = {i, -1};
    }

    sort(evs.begin(), evs.end(), [](const pair<int, pair<int, int>>& ev1, const pair<int, pair<int, int>>& ev2) {
        if (ev1.first != ev2.first) {
            return ev1.first < ev2.first;
        }
        return ev1.second.second < ev2.second.second;
    });

    set<Seg> sgs;
    vector<int> pr(n);

    for (auto el : evs) {
        int cind = el.second.first;
        int ctype = el.second.second;
        if (ctype == 1) {
            int cp = -1;
            if (!sgs.empty()) {
                cp = (--sgs.end())->i;
            }
            if (cp != -1) {
                gr[cp].insert(cind);
                pr[cind] = cp;
            } else {
                pr[cind] = -1;
            }
            sgs.emplace(a[cind]);
        } else {
            sgs.erase(a[cind]);
        }
    }

    set<pair<int, int>> lvs;
    vector<int> szs(n);
    int m = 0;
    for (int i = 0; i < n; i++) {
        if (gr[i].size() == 0) {
            m++;
            if (pr[i] != -1) {
                lvs.emplace(gr[pr[i]].size(), i);
                szs[i] = gr[pr[i]].size();
            } else {
                lvs.emplace(1000000000, i);
                szs[i] = 1000000000;
            }
        }
    }

    // cout << m << "\n";

    int nm = m / 2;
    int nn = n / 2;

    int cm = m;
    int cn = n;
    vector<bool> used(n, true);
    while (cm > nm) {
        auto [psz, i] = *lvs.begin();
        lvs.erase(lvs.begin());
        used[i] = false;
        cm--;
        cn--;
        if (pr[i] != -1) {
            gr[pr[i]].erase(i);
            if (gr[pr[i]].size() == 0) {
                cm++;
                int cp = pr[pr[i]];
                if (cp != -1) {
                    lvs.emplace(gr[cp].size(), pr[i]);
                    szs[pr[i]] = gr[cp].size();
                } else {
                    lvs.emplace(1000000000, pr[i]);
                    szs[pr[i]] = 1000000000;
                }
            } else if (gr[pr[i]].size() == 1) {
                auto cneib = *gr[pr[i]].begin();
                lvs.erase(make_pair(szs[cneib], cneib));
                szs[cneib] = 1;
                lvs.emplace(szs[cneib], cneib);
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (used[i] && gr[i].size() != 0 && cn > nn) {
            used[i] = false;
            cn--;
        }
    }

    for (int i = 0; i < n; i++) {
        if (used[i]) {
            cout << a[i].i + 1 << " ";
        }
    }
    cout << "\n";
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}