#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <queue>
#include <cassert>

#define all(x) x.begin(),x.end()

using namespace std;
using ll = long long;

vector<pair<ll, ll>> mrg(vector<pair<ll, ll>> a, vector<pair<ll, ll>> b) {
	vector<pair<ll, ll>> res(a.size() + b.size());
	merge(all(a), all(b), res.begin());
	int h = 0;
	int n = res.size();
	vector<pair<ll, ll>> ans;
	for (int i = n - 1; i >= 0; i--)
	{
		if (-res[i].second < h || (i != 0 && res[i] == res[i-1]))continue;
		h = -res[i].second;
		ans.push_back(res[i]);
	}
	reverse(all(ans));
	return ans;
}

vector<pair<ll, ll>> upd(vector<pair<ll, ll>> a, int wei) {
	vector<pair<ll, ll>> b = a;
	for (auto& i : b)
		if (i.first + 1 >= wei)i.first += wei;
	for (auto& i : a)
		if (-i.second + 1 >= wei)i.second -= wei;
	return mrg(a, b);
}
signed main() {
	int n, q = 100;
	cin >> n >> q;
	vector<ll> wei(n);
	for (auto& i : wei)cin >> i;

	vector<pair<ll, ll>> arr(1, { 0,0 });
	for (auto& i : wei)
		arr = upd(arr, i);

	int last = -1;
	for (auto& i : arr) {
		while (last < i.first) {
			for (int j = 0; j <= -i.second; j++)
				cerr << '#';
			cerr << '\n';
			last++;
		}
	}
	int z; cin >> z;
	assert(false);
	while (q--)
	{
		ll k, a, b;
		cin >> k >> a >> b;
		auto ps = *lower_bound(all(arr), make_pair(a,(ll)-2e18));
		cout << (-ps.second >= b ? "Yes" : "No") << endl;
	}
}