#pragma GCC optimize("Ofast,unroll-loops")
#include <iostream>
#include <vector>
//#define int long long
using namespace std;
using ll = long long;

constexpr int MAXN = 10005, INF = 20000;

inline short max(short a, short b) {
    if (a < b) return b;
    return a;
}

struct SegTree {
    vector<short> tree;
    void init(int sz) {
        tree.assign(2 * sz, -INF);
    }
    void update(int pos, short val) {
        tree[pos += tree.size() / 2] = val;
        for (pos /= 2; pos > 0; pos /= 2) {
            tree[pos] = max(tree[pos * 2], tree[pos * 2 + 1]);
        }
    }
    short get(int l, int r) {
        short mx = 0;
        for (l += tree.size() / 2, r += tree.size() / 2; l < r; l /= 2, r /= 2) {
            if (l & 1) {
                mx = max(mx, tree[l++]);
            }
            if (r & 1) {
                mx = max(mx, tree[--r]);
            }
        }
        return mx;
    }
};

SegTree sl[MAXN], sr[MAXN];

void do_update(int i, int j, int val) {
//    cerr << "SH " << i << ' ' << j << ' ' << val << '\n';
    sl[i].update(j, val);
    sr[j].update(i, val);
}

void update(int i, int j, int val) {
    do_update(i, j, val);
}

int still_valid[MAXN]; // [maxA][minB]

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    int tc;
    cin >> tc;
    while (tc --> 0) {
        int n;
        cin >> n;
        vector<int> vh;
        vh.reserve(n + 2);
        vh.push_back(0);
        vh.push_back(n + 1);
        for (int i = 0; i <= n + 1; ++i) {
            sl[i].init(n + 2);
            sr[i].init(n + 2);
            still_valid[i] = n + 1;
        }
        do_update(0, n + 1, 0);
        for (int i = 0; i < n; ++i) {
            int p;
            cin >> p;
            // p is left
            for (int j : vh) {
                // MAX_P = p, MIN_Q = j
                if (still_valid[p] >= j) {
                    update(p, j, sr[j].get(0, p) + 1);
                }
                if (still_valid[j] >= p) {
                    update(j, p, sl[j].get(p + 1, n + 2) + 1);
                }
            }
            vh.push_back(p);
            for (int mx = 0; mx < p; ++mx) {
                while (still_valid[mx] > p) {
                    do_update(mx, still_valid[mx], -INF);
                    --still_valid[mx];
                }
            }
//            cerr << '\n';
        }
        int ans = 0;
        for (int i = 0; i <= n + 1; ++i) {
            ans = max<int>(ans, sl[i].get(0, n + 2));
        }
        cout << ans << '\n';
    }
    return 0;
}
