#pragma GCC optimize("Ofast,unroll-loops")
#include <iostream>
#include <vector>
#pragma GCC target("tune=native")
//#define int long long
using namespace std;
using ll = long long;

constexpr int MAXN = 10005, INF = 20000;

inline short max(short a, short b) {
    if (a < b) return b;
    return a;
}

struct SegTree {
    vector<short> tree;
    inline void init(int sz) {
        tree.assign(sz + 1, -INF);
    }
    inline void update(int pos, short val) {
        for (pos += 1; pos < (int)tree.size(); pos += pos & -pos) {
            tree[pos] = max(tree[pos], val);
        }
    }
    inline short get(int r) {
        short mx = 0;
        for (; r >= 1; r -= r & -r) {
            mx = max(mx, tree[r]);
        }
        return mx;
    }
};

SegTree sl[MAXN], sr[MAXN];

void do_update(int n, int i, int j, int val) {
//    cerr << "SH " << i << ' ' << j << ' ' << val << '\n';
    sl[i].update(n + 1 - j, val);
    sr[j].update(i, val);
}

void update(int n, int i, int j, int val) {
    do_update(n, i, j, val);
}

int still_valid[MAXN]; // [maxA][minB]

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    int tc;
    cin >> tc;
    vector<int> vh;
    while (tc --> 0) {
        int n;
        cin >> n;
        vh.clear();
        vh.reserve(n + 2);
        vh.push_back(0);
        vh.push_back(n + 1);
        for (int i = 0; i <= n + 1; ++i) {
            sl[i].init(n + 2);
            sr[i].init(n + 2);
            still_valid[i] = n + 1;
        }
        do_update(n, 0, n + 1, 0);
        for (int i = 0; i < n; ++i) {
            int p;
            cin >> p;
            // p is left
            for (int j : vh) {
                // MAX_P = p, MIN_Q = j
                if (still_valid[p] >= j) {
                    update(n, p, j, sr[j].get(p) + 1);
                }
                if (still_valid[j] >= p) {
                    update(n, j, p, sl[j].get(n - p + 1) + 1);
                }
            }
            vh.push_back(p);
            for (int mx = 0; mx < p; ++mx) {
                while (still_valid[mx] > p) {
                    do_update(n, mx, still_valid[mx], -INF);
                    --still_valid[mx];
                }
            }
//            cerr << '\n';
        }
        int ans = 0;
        for (int i = 0; i <= n + 1; ++i) {
            ans = max(ans, sl[i].get(n + 2));
        }
        cout << ans << '\n';
//        for (int i = 0; i <= n + 1; /*++i) {
//            sl[i].tree.clear();
//            sr[i].tree.clear();
//        }*/
    }
    return 0;
}
