#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <numeric>
#include <cassert>

using namespace std;
using ll = long long;

void dfs(int v, int p, const vector<ll> &w, const vector<vector<int>> &g, vector<pair<ll, ll>> &out) {
    ll fst_sum = 0, snd_sum = 0;
    for (int ch : g[v]) {
        if (ch != p) {
            dfs(ch, v, w, g, out);

            snd_sum += out[ch].second;
            fst_sum += out[ch].first;
//            min_dlt = min(min_dlt, out[ch].first - out[ch].second);
        }
    }
    out[v].second = fst_sum;
    out[v].first = max(out[v].second, w[v] + snd_sum);
}

void solve() {
    int n, q;
    cin >> n >> q;
    ll x, y, m;
    cin >> x >> y >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int s, f;
        cin >> s >> f;
        --s, --f;
        g[s].push_back(f);
        g[f].push_back(s);
    }
    vector<ll> l(n);
    vector<ll> r(n);
    ll k = 0;
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        k ^= ((i + 1) * x + y * r[i] % m * r[i] % m) % m;
    }
    vector<ll> v(q);
    vector<ll> resp(q, -1);
    vector<ll> mask(q, -1);
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
    }
    for (int cm = 0; cm < 59049; ++cm) {
        vector<ll> ws(n);
        int tm = cm;
        ll lk = 0;
        for (int i = 0; i < n; ++i) {
            ws[i] = tm % (r[i] - l[i] + 1) + l[i];
            lk ^= ((i + 1) * x + y * ws[i] % m * ws[i] % m) % m;
            tm /= r[i] - l[i] + 1;
        }
        if (tm != 0) break;

        vector<pair<ll, ll>> out(n);
        dfs(0, 0, r, g, out);
        ll eff = out[0].first;
        for (int i = 0; i < q; ++i) {
            if (v[i] == eff) {
                resp[i] = lk;
                mask[i] = cm;
            }
        }
    }

    for (int i = 0; i < q; ++i) {
        cout << resp[i] << ' ';
    }
    cout << endl;
    int xx;
    cin >> xx;
    while (xx != 0) {
        if (resp[xx - 1] != -1) {
            int tm = mask[xx - 1];
            for (int i = 0; i < n; ++i) {
                cout << tm % (r[i] - l[i] + 1) + l[i] << ' ';
                tm /= r[i] - l[i] + 1;
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
        cin >> xx;
    }
}

int main() {
//#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    cin.tie(0)->sync_with_stdio(0);
    int t;
    cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}