#include <iostream>
#include <random>
#include <array>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);

    cin.tie(0);
    cout.tie(0);

    ll h, w, k;
    cin >> h >> w >> k;

    vector<pair<ll, ll>> cells_sorted_x(k);
    vector<pair<ll, ll>> cells_sorted_y(k);

    for (int i = 0; i < k; ++i) {
        ll x, y;
        cin >> y >> x;
        cells_sorted_x[i] = {x, y};
        cells_sorted_y[i] = {x, y};
    }

    sort(cells_sorted_x.begin(), cells_sorted_x.end(), [](pair<ll, ll> &a, pair<ll, ll> &b) {
        return a.first < b.first;
    });
    sort(cells_sorted_y.begin(), cells_sorted_y.end(), [](pair<ll, ll> &a, pair<ll, ll> &b) {
        return a.second < b.second;
    });

    // left-right move
    ll minimum_width = 1e10;
    ll minimum_width_move = -1;

    ll leftmost = 0;
    ll rightmost = k - 1;
    ll i = 0;

    while (true) {
        auto right = cells_sorted_x[rightmost];
        auto left = cells_sorted_x[leftmost];

        ll width = (right.first - left.first + w) % w + 1;

//        cout << i << " " << leftmost << " " << rightmost << " " << width << endl;

        // add check
        if (width < minimum_width) {
            minimum_width = width;
            minimum_width_move = i;
        }
        if (width == minimum_width) {
            if (min(minimum_width_move, w - minimum_width_move) > min(i, w - i)) {
                minimum_width = width;
                minimum_width_move = i;
            }
        }

        if (right.first == cells_sorted_x[0].first) {
            break;
        }

        leftmost = rightmost;
        while (cells_sorted_x[rightmost].first == right.first && rightmost != 0) {
            rightmost--;
        }

        i = w - right.first + 1;
    }

    // height
    ll minimum_height = 1e10;
    ll minimum_height_move = -1;

    ll topmost = 0;
    ll bottommost = k - 1;
    i = 0;

    while (true) {
        auto right = cells_sorted_y[bottommost];
        auto left = cells_sorted_y[topmost];

        ll width = (right.second - left.second + h) % h + 1;

//        cout << i << " " << topmost << " " << bottommost << " " << width << endl;

        // add check
        if (width < minimum_height) {
            minimum_height = width;
            minimum_height_move = i;
        }
        if (width == minimum_height) {
            if (min(minimum_height_move, h - minimum_height_move) > min(i, h - i)) {
                minimum_height = width;
                minimum_height_move = i;
            }
        }

        if (right.second == cells_sorted_y[0].second) {
            break;
        }

        topmost = bottommost;
        while (cells_sorted_y[bottommost].second == right.second && bottommost != 0) {
            bottommost--;
        }

        i = h - right.second + 1;
    }

    cout << minimum_height * minimum_width << " " << min(minimum_height_move, h - minimum_height_move) + min(minimum_width_move, w - minimum_width_move) << endl;

    return 0;
}