#include <iostream>
#include <random>
#include <array>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

int inv(int x, int n) {
    if (x == 1)
        return n;

    return x - 1;
}

ll move(ll x, ll offset, ll mod) {
    x -= 1;
    x = (x + offset + 2 * mod) % mod;

    return x + 1;
}

set<ll> encode(vector<ll> &seq, ll k, ll n) {
    set<ll> ans;

    if (k == 1) {
        ans.insert(seq[0] % n + 1);
        return ans;
    }
    if (n % 2 == 0 && k == n / 2) {
        ll start = 1;
        for (int j = 0; j < k; ++j) {
            for (ll f = start; f < seq[j]; ++f) {
                ans.insert(f);
            }

            start = seq[j] + 1;
        }

        for (ll f = start; f <= n; ++f) {
            ans.insert(f);
        }

        return ans;
    }
    if (k == 2) {
        if (seq[0] == 1 && seq[1] == n) {
            ans.insert(2);
            ans.insert(3);
        } else if (seq[0] + 1 == seq[1]) {
            ans.insert(move(seq[1], 1, n));
            ans.insert(move(seq[1], 2, n));
        } else {
            ans.insert(move(seq[0], 1, n));
            ans.insert(move(seq[1], 1, n));
        }

        return ans;
    }

    bool flag = true;

    for (int j = 0; j < k - 1; ++j) {
        if (seq[j] + 1 == seq[j + 1]) {
            flag = false;
            break;
        }
    }

    if (flag) {
        for (int j = 0; j < k; ++j) {
            ans.insert(seq[j] + 1);
        }
    } else {
        ll offset = seq[n - 1] - seq[0] + 1;

        for (auto i : seq) {
            ans.insert(move(i, offset, n));
        }
    }

    return ans;
}

set<ll> decode(vector<ll> &seq, ll k, ll n) {
    set<ll> ans;

    if (k == 1) {
        if (seq[0] == 1) ans.insert(n);
        else ans.insert(seq[0] - 1);

        return ans;
    }
    if (n % 2 == 0 && k == n / 2) {
        ll start = 1;
        for (ll j = 0; j < k; ++j) {
            for (ll f = start; f < seq[j]; ++f) {
                ans.insert(f);
            }

            start = seq[j] + 1;
        }

        for (ll f = start; f <= n; ++f) {
            ans.insert(f);
        }

        return ans;
    }
    if (k == 2) {
        if (seq[0] == 2 && seq[1] == 3) {
            ans.insert(1);
            ans.insert(n);
        } else if (seq[0] == 1 && seq[1] == 2) {
            ans.insert(n - 1);
            ans.insert(n);
        } else if (seq[0] + 1 == seq[1]) {
            ans.insert(seq[0] - 2);
            ans.insert(seq[0] - 1);
        } else if (seq[0] == 1 && seq[1] == n) {
            ans.insert(n - 2);
            ans.insert(n - 1);
        } else {
            ans.insert(move(seq[0], -1, n));
            ans.insert(move(seq[1], -1, n));
        }

        return ans;
    }

    bool flag = true;

    for (int j = 0; j < k - 1; ++j) {
        if (seq[j] + 1 == seq[j + 1]) {
            flag = false;
            break;
        }
    }

    if (flag) {
        for (int j = 0; j < k; ++j) {
            ans.insert(seq[j] - 1);
        }
    } else {
        ll offset = seq[n - 1] - seq[0] + 1;

        for (auto f : seq) {
            ans.insert(move(f, -offset, n));
        }
    }

    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);

    cin.tie(0);
    cout.tie(0);

    int a;
    cin >> a;

    if (a == 1) {
        int m;
        cin >> m;

        for (int i = 0; i < m; ++i) {
            int n, k;
            cin >> n >> k;

            vector<ll> seq(k);
            for (int j = 0; j < k; ++j) {
                cin >> seq[j];
            }

            set<ll> ans = encode(seq, k, n);

            for (auto f : ans) {
                cout << f << " ";
            }

            cout << endl;
        }
    } else {
        int m;
        cin >> m;

        for (int i = 0; i < m; ++i) {
            int n, k;
            cin >> n >> k;

            vector<ll> seq(k);
            for (int j = 0; j < k; ++j) {
                cin >> seq[j];
            }

            auto ans = decode(seq, k, n);

            for (auto f : ans) {
                cout << f << " ";
            }

            cout << endl;
        }
    }

    return 0;
}