//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcmt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef int ll;

const ll INF = 1'000'000'000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

struct segment_tree {
	vector<ll> tree;
	ll size, dp;
	segment_tree(ll n = 0) {
		size = 1;
		while (size < n) {
			size *= 2;
		}
		dp = 0;
		tree.resize(size * 2, -INF);
	}
	void set(ll x, ll y) {
		if (x < dp) {
			return;
		}
		x += size;
		while (x > 0) {
			assign_max(tree[x], y);
			x >>= 1;
		}
	}
	ll get(ll l, ll r) {
		assign_max(l, dp);
		if (l >= r) {
			return -INF;
		}
		l += size;
		r += size - 1;
		ll ans = max(tree[l], tree[r]);
		ll lal = l, lar = r;
		l >>= 1;
		r >>= 1;
		while (r != l) {
			if (!(lal & 1)) {
				assign_max(ans, tree[lal ^ 1]);
			}
			if (lar & 1) {
				assign_max(ans, tree[lar ^ 1]);
			}
			lal = l;
			lar = r;
			l >>= 1;
			r >>= 1;
		}
		return ans;
	}
	void die(ll x) {
		assign_max(dp, x + 1);
	}
};

ll solve(ll n, vector<ll> arr) {
	vector<vector<ll>> dp(n + 2, vector<ll>(n + 2, -INF));
	dp[0][n + 1] = 0;
	set<ll> have;
	have.insert(0);
	have.insert(n + 1);
	for (auto i : arr) {
		auto fit = have.lower_bound(i);
		auto it = fit;
		while (it != have.begin()) {
			it--;
			auto it2 = fit;
			while (it2 != have.begin()) {
				it2--;
				assign_max(dp[i][*it2], dp[*it][*it2] + 1);
			}
			it2 = fit;
			while (it2 != have.end()) {
				assign_max(dp[i][*it2], dp[*it][*it2] + 1);
				assign_max(dp[*it][i], dp[*it][*it2] + 1);
				dp[*it][*it2] = -INF;
				it2++;
			}
		}
		it = fit;
		while (it != have.end()) {
			auto it2 = fit;
			while (it2 != have.end()) {
				assign_max(dp[*it][i], dp[*it][*it2] + 1);
				it2++;
			}
			it++;
		}
		have.insert(i);
	}
	ll ans = 0;
	for (auto& i : dp) {
		for (auto& j : i) {
			assign_max(ans, j);
		}
	}
	return ans;
}

bool l = false;

int main() {
#ifdef LOCAL
	l = true;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		vector<ll> arr(n);
		for (ll i = 0; i < n; i++) {
			cin >> arr[i];
		}
		cout << solve(n, arr) << '\n';
	}
}
