//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcmt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MAXN = 1'000'001, K = 10;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

ll M;

ll binpow(ll a, ll b) {
	return (b == 0 ? 1 : square(binpow(a, b / 2)) % M * (b % 2 ? a : 1) % M);
}

ll inv(ll a) {
	return binpow(a, M - 2);
}

ll f[MAXN], invf[MAXN];

void precalc() {
	f[0] = 1;
	for (ll i = 1; i < MAXN; i++) {
		f[i] = f[i - 1] * i % M;
	}
	invf[MAXN - 1] = inv(f[MAXN - 1]);
	for (ll i = MAXN - 1; i > 0; i--) {
		invf[i - 1] = invf[i] * i % M;
	}
}

ll C(ll n, ll k) {
	return f[n] * invf[k] % M * invf[n - k] % M;
}

ll dp1[K + 1][K + 1][(1 << (K + 1)) + 1], dp2[K + 1][K + 1][(1 << (K + 1)) + 1];

void calc() {
	for (ll i = 0; i <= K; i++) {
		for (ll j = 0; j <= i; j++) {
			for (ll ce = (1 << j); ce <= (1 << i); ce++) {
				if (i == j) {
					dp1[i][j][ce] = (ce == (1 << i));
					dp2[i][j][ce] = (ce == (1 << i));
					continue;
				}
				if (i == j + 1) {
					if (ce < (1 << i)) {
						dp1[i][j][ce] = C((1 << (i - 1)) - 1 - (j > 0), ce - (1 << j));
						dp2[i][j][ce] = C((1 << (i - 1)) - 1 - (j > 0), ce - (1 << j)) * 2 % M;
					}
					continue;
				}
				if (i == 2 && j == 0 && ce == 3) {
					dp1[i][j][ce] = 3 % M;
					dp2[i][j][ce] = 4 % M;
					continue;
				}
				if (ce >= (1 << (i - 1)) + (1 << j)) {
					dp1[i][j][ce] = dp2[i - 1][j][ce - (1 << (i - 1))];
					dp2[i][j][ce] = dp2[i - 1][j][ce - (1 << (i - 1))] * 2 % M;
				}
				for (ll col = 0; col <= (1 << (i - 1)) && ce - col >= (1 << j); col++) {
					dp2[i][j][ce] += C(1 << (i - 1), col) * dp1[i - 1][j][ce - col] + C((1 << (i - 1)) - 1, col) * dp1[i - 1][j][ce - col];
					dp2[i][j][ce] %= M;
					dp1[i][j][ce] += C(1 << (i - 1), col) * dp1[i - 1][j][ce - col];
					dp1[i][j][ce] %= M;
				}
			}
		}
	}
}

ll mex(vector<ll>& arr) {
	vector<bool> be(arr.size() + 1, false);
	for (auto i : arr) {
		if (i < be.size()) {
			be[i] = true;
		}
	}
	for (ll i = 0;; i++) {
		if (!be[i]) {
			return i;
		}
	}
}

ll stupid(ll k, ll n, ll p) {
	ll s2 = 1;
	while (s2 < p) {
		s2 *= 2;
	}
	if (s2 != p) {
		return 0;
	}
	ll mx = (1 << k);
	ll ans = 0;
	for (ll i = 1; i < (1 << mx); i += 2) {
		vector<ll> am;
		vector<ll> now;
		for (ll j = 0; j < mx; j++) {
			if ((i >> j) & 1) {
				now.push_back(j);
			}
		}
		if (now.size() != n) {
			continue;
		}
		set<vector<ll>> have;
		vector<ll> old = now;
		while (have.find(now) == have.end()) {
			have.insert(now);
			am.push_back(mex(now));
			for (auto& i : now) {
				i ^= am.back() - 1;
			}
		}
		if (am.back() == p && (am.back() == 1 || am[am.size() - 1] == am[am.size() - 2])) {
			ans++;
			for (auto i : old) {
				cout << i << ' ';
			}
			cout << '\n';
		}
	}
	return ans % M;
}

ll solve(ll k, ll n, ll p) {
	ll x = 1, pp = 0;
	while (x < p) {
		x *= 2;
		pp++;
	}
	return (x != p ? 0 : dp1[k][pp][n]);
}

bool l = false;

int main() {
#ifdef LOCAL
	l = true;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> M;
	precalc();
	calc();
	if (!l) {
		ll t;
		cin >> t;
		while (t--) {
			ll k, n, p;
			cin >> k >> n >> p;
			cout << solve(k, n, p) << '\n';
		}
	} else {
		ll k = 3;
		for (ll n = 1; n <= (1 << k); n++) {
			for (ll p = 1; p <= (1 << k); p++) {
				if (solve(k, n, p) != stupid(k, n, p)) {
					cout << k << ' ' << n << ' ' << p << '\n';
					return 0;
				}
			}
		}
	}
}
