#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <ctime>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

vector<long long> gen(long long n, long long k, vector<long long> v)
{
	vector<long long> ans;
	vector<bool> st(n);
	for (long long i = 0; i < k; i++)
	{
		st[v[i] - 1] = true;
	}

	vector<bool> res(n);
	long long idx = 0;
	deque<long long> q;
	vector<bool> used(n);
	while (ans.size() != v.size())
	{
		if (st[idx])
		{
			if (!used[idx])
			{
				q.push_back(idx);
			}
		}
		else
		{
			if (!res[idx] && q.size())
			{
				res[idx] = true;
				ans.push_back(idx);
				used[q.front()] = true;
				q.pop_front();
			}
		}
		idx++;
		idx %= n;
	}
	sort(ans.begin(), ans.end());
	return ans;
}

vector<long long> gen2(long long n, long long k, vector<long long> v)
{
	set<long long> st;
	for (long long i = 0; i < k; i++)
	{
		v[i]--;
		st.insert(v[i]);
	}
	st.insert(n);

	set<long long> emp;
	if (v[0] != 0)
	{
		emp.insert(0);
	}
	for (long long i = 0; i < k - 1; i++)
	{
		if (v[i + 1] != v[i] + 1)
		{
			emp.insert(v[i] + 1);
		}
	}
	if (v.back() != n - 1)
	{
		emp.insert(v.back() + 1);
	}

	vector<long long> ans;
	for (long long i = 0; i < k; i++)
	{
		auto it = emp.lower_bound(v[i]);
		if (it == emp.end())
		{
			it = emp.begin();
		}

		long long add = *it;
		ans.push_back(add);
		emp.erase(add);
		add++;
		if (st.find(add) == st.end())
		{
			emp.insert(add);
		}
	}
	sort(ans.begin(), ans.end());
	return ans;
}

void solve1()
{
	int tst;
	cin >> tst;
	while (tst--)
	{
		long long n, k;
		vector<long long> v;
		cin >> n >> k;
		v.resize(k);
		for (long long i = 0; i < k; i++)
		{
			cin >> v[i];
		}
		vector<long long> res = gen2(n, k, v);
		for (auto& i : res)
		{
			cout << i + 1 << " ";
		}
		cout << "\n";
	}
	cout.flush();
}

vector<long long> regen(long long n, long long k, vector<long long> v)
{
	for (long long i = 0; i < k; i++)
	{
		v[i] = n - v[i] + 1;
	}
	sort(v.begin(), v.end());

	vector<long long> ans = gen(n, k, v);
	for (long long i = 0; i < k; i++)
	{
		ans[i] = n - ans[i] - 1;
	}
	sort(ans.begin(), ans.end());
	return ans;
}

void solve2()
{
	int tst;
	cin >> tst;
	while (tst--)
	{
		long long n, k;
		vector<long long> v;
		cin >> n >> k;
		v.resize(k);
		for (long long i = 0; i < k; i++)
		{
			cin >> v[i];
		}
		vector<long long> res = regen(n, k, v);
		for (auto& i : res)
		{
			cout << i + 1 << " ";
		}
		cout << "\n";
	}
	cout.flush();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	long long qt;
	cin >> qt;
	if (qt == 1)
	{
		solve1();
	}
	else
	{
		solve2();
	}

	return 0;
}

/*





















*/
