#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <ctime>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

struct seg
{
	long long l, r, idx;
};

vector<long long> get_cov(vector<seg> v)
{
	sort(v.begin(), v.end(),
		[](seg& x, seg& y)
		{
			return x.l < y.l;
		}
	);

	long long n = v.size();
	vector<long long> dp(n + 1), sf(n + 1, n), par(n + 1, -1);
	vector<vector<long long>> gr(n + 1), rgr(n + 1);
	long long mx = 0;
	for (long long i = n - 1; i > -1; i--)
	{
		long long left = 0, right = n;
		while (right - left > 1)
		{
			long long mid = (left + right) / 2;
			if (v[i].r < v[mid].l)
			{
				right = mid;
			}
			else
			{
				left = mid;
			}
		}

		par[i] = sf[right];
		dp[i] = dp[sf[right]] + 1;
		sf[i] = sf[i + 1];
		if (dp[i] > dp[sf[i]])
		{
			sf[i] = i;
		}

		for (long long j = right; j <= n; j++)
		{
			if (dp[j] == dp[i] - 1)
			{
				gr[i].push_back(j);
				rgr[j].push_back(i);
			}
		}
		mx = max(mx, dp[i]);
	}

	vector<long long> from(n + 1);
	from[n] = 1;
	for (long long i = n - 1; i > -1; i--)
	{
		for (auto& j : gr[i])
		{
			from[i] += from[j];
		}
	}

	vector<long long> to(n + 1);
	for (long long i = 0; i < n; i++)
	{
		if (dp[i] == mx)
		{
			to[i] = 1;
		}
	}

	for (long long i = 0; i < n; i++)
	{
		for (auto& j : rgr[i])
		{
			to[i] += to[j];
		}
	}

	vector<long long> order(n);
	iota(order.begin(), order.end(), 0);
	sort(order.begin(), order.end(),
		[&](long long x, long long y)
		{
			long double a1 = to[x], b1 = from[x], a2 = to[y], b2 = from[y];
			return a1 / a2 > b2 / b1;
		}
	);

	while (order.size() > mx)
	{
		order.pop_back();
	}
	for (long long i = 0; i < mx; i++)
	{
		order[i] = v[order[i]].idx;
	}
	return order;
}

void solve()
{
	long long n;
	vector<seg> v;
	cin >> n;
	v.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i].l >> v[i].r;
		v[i].idx = i;
	}
	bool dont_inter = true;
	for (long long i = 0; i < v.size() - 1; i++)
	{
		if (v[i + 1].l <= v[i].r)
		{
			dont_inter = false;
		}
	}
	if (dont_inter)
	{
		for (long long i = 0; i < n / 2; i++)
		{
			cout << i + 1 << "\n";
		}
		return;
	}

	vector<long long> cov = get_cov(v);
	long long nd = cov.size() / 2;
	vector<bool> del(n);
	while (cov.size() != nd)
	{
		for (long long i = 0; i < cov.size() - nd; i++)
		{
			del[cov[i]] = true;
		}
		vector<seg> nv;
		for (long long i = 0; i < v.size(); i++)
		{
			if (!del[v[i].idx])
			{
				nv.push_back(v[i]);
			}
		}
		swap(v, nv);
		for (long long i = 0; i < cov.size() - nd; i++)
		{
			del[cov[i]] = false;
		}
		cov = get_cov(v);
	}

	vector<bool> in_cov(n);
	for (auto& i : cov)
	{
		in_cov[i] = true;
	}

	vector<long long> ans = cov;
	for (auto& i : v)
	{
		if (ans.size() == n / 2)
		{
			break;
		}
		if (in_cov[i.idx])
		{
			continue;
		}

		ans.push_back(i.idx);
	}

	for (auto& i : ans)
	{
		cout << i + 1 << " ";
	}
	cout << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*





















*/