#pragma GCC optimize("03")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;

const int mxn = 1e9 + 7;
const ll inf = 1e18;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define pb push_back
#define endl '\n'
#define all(a) a.begin(), a.end()
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;
#define int ll


int n, q, x, y, m;
vector<vector<int>> g;
vector <int> l, r, dp0, dp1, l0, r0, l1, r1;
vector <pll> ask;

void clear() {
    g.clear(); l.clear(); r.clear(); ask.clear();
    dp0.clear(); dp1.clear();
    l0.clear(); r0.clear();
    l1.clear(); r1.clear();
}


void dfs (int i, int p) {
    l0[i] = r0[i] = 0;
    l1[i] = l[i]; r1[i] = r[i];
    for (auto j : g[i]) {
        if (p != j) {
            dfs(j, i);
            l0[i] += min(l0[j], l1[j]);
            r0[i] += max(r0[j], r1[j]);
            l1[i] += l0[j]; r1[i] += r0[j];
        }
    }
}


void solve() {
    cin >> n >> q >> x >> y >> m;
    g.resize(n); l.resize(n); r.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    l0.resize(n); r0.resize(n);
    l1.resize(n); r1.resize(n);
    ask.resize(q);
    for (int i = 0; i < q; ++i) {
        cin >> ask[i].first;
        ask[i].second = i;
    }
    dp0.resize(n); dp1.resize(n);
    dfs(0, -1);
    for (auto i : ask) {
        if (i.first >= l0[0] && i.first <= r0[0]) {
            cout << 0 << ' ';
        }
        else if (i.first >= l1[0] && i.first <= r1[0]) {
            cout << 0 << ' ';
        }
        else {
            cout << -1 << ' ';
        }
    }
    cout << endl; cout.flush();
    int c;
    cin >> c;
    clear();
}


signed main() {
    // Jisoo Jennie Rose Lisa
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}